<?php
include_once "sysfunc.php";

function addr_space($gateway_IP0, $subnet_mask0)
{
	if (!function_exists('mask_field'))  {
		function mask_field($dec_no, $mask)
		{
			// precondition: range of $dec_no 0 to 255, range of $mask {255,254,252,248,240,224,192,128,0}

			$i=8; $m=$mask;
			while (($i>0)&&($m%2==0)) {
				$m=(int)$m/2;
				$i--;
			}    
			$bitStr=str_pad(decbin($dec_no),8,'0',STR_PAD_LEFT);
			$bitStr=str_pad(substr($bitStr,0,$i),8,'0',STR_PAD_RIGHT);
			return (bindec($bitStr));
		}
	}

	$IP_fields=split("\.", $gateway_IP0, 4);
	$IP_masks=split("\.", $subnet_mask0, 4);

	$internal_IP0=mask_field($IP_fields[0],$IP_masks[0]);
	$i=1;
	while ($i<4) {
		$internal_IP0=$internal_IP0.".".mask_field($IP_fields[$i],$IP_masks[$i]);
		$i++;
	}
	return($internal_IP0);
}

class apache {
	
	//create_vhosts_conf
	function vhosts_conf_new($filepath) {
		$settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
		$internalNIC = $settingobj->getkey('internalNIC', 'gateway');
		$internalIP = $settingobj->getkey('gateway_IP', 'gateway');
		$internalMask = $settingobj->getkey('subnet_mask', 'gateway');
		$internalSubnet = addr_space($internalIP,$internalMask);
// 		$externalNIC = $settingobj->getkey('externalNIC', 'gateway');
		$payment_gateway_port = $settingobj->getkey('ssl_port', 'gateway');
		$ssl_enabled = $settingobj->getkey('rewrite_engine', 'gateway');
		$auth_port = $settingobj->getkey('auth_port', 'gateway');
		$redirect_port = $settingobj->getkey('redirect_port', 'gateway');
		$ssl_cert = $settingobj->getkey('ssl_cert', 'gateway');
		$internalAccess = $settingobj->getkey('access_from_internal', 'gateway');
		$externalAccess = $settingobj->getkey('access_from_external', 'gateway');
		$demo_mode = $settingobj->getkey('demo_mode', 'gateway');
// 		$externalIP = $settingobj->GetIPbyCName($externalNIC);
		// 05-08-2008 Chris: Workaround for support multibyte characters(eg. chinese SAR)
		$externalIP = $settingobj->QueryPublicIP();
		// $infobox_port = $settingobj->getkey('infobox_port', 'gateway');
		// $FSFO = $settingobj->getKey( 'mode', 'FSFO');		// 0 = none, 1: failover (main machine), 2: failover (backup machine), 3: load balancing
		
		$versionType = $settingobj->getKey('version', 'version');
		
		$dn = '';
		if (substr_count(strtolower($versionType), 'standard') > 0) {
			$dn = 'EaseGate.net';
		} else {
			$dn = $settingobj->getKey("gateway_domain", "gateway");
			if ($dn == '') {
				$dn = 'EaseGate.net';
			}
		}
		$showDomainUrl = $settingobj->getKey("show_domain_URL", "gateway");
		
		$_skipModifyApacheLog = $settingobj->getkey('_skip_modify_apache_log_level', 'gateway');
		
		$versionLanguage = $settingobj->getKey('versionLang', 'version');
		
		//$settingobj->release;
		
		//initialize path
		//$fspath=realpath("../");
		$fspath = $settingobj->getFsPath();
		$fspath = substr($fspath, 0, strlen($fspath)-1);
		
		$openssl_path= "$fspath\\www\\apache\\bin";
		$opensslcnf_path = "$fspath\\www\\apache\\conf";
				
		$admin_port = "5787";
		if (file_exists("$fspath\\www\\apache\\conf\\httpd-EaseGate.ini")) {
			
			$temp = $settingobj->ReadINI("EaseGate", "admin_port", "$fspath\\www\\apache\\conf\\httpd-EaseGate.ini");
			if($temp!="")
				$admin_port = $temp;
				
			/*
			$sys = new sysfunc();
			$sectionkey = $sys->readINI("$fspath\\www\\apache\\conf\\httpd-EaseGate.ini");
			if(array_key_exists("EaseGate", $sectionkey))
				if(array_key_exists("admin_port", $sectionkey["EaseGate"]))
					$admin_port = $sectionkey["EaseGate"]["admin_port"];
			$sys = null;
			*/
		}
		
		$settingobj = null;
		
		$fspath = str_replace("\\", "/", $fspath);
		
		if ($externalIP == "")
			return false;
		
		//$content -> httpd-egvhosts.conf
		global $content;
		require_once "vhostsConf.php";
		
		$line = explode("\r\n", $content);
		
		// 20080723 - Adjust line numbers
		//re-config httpd-EaseGate.conf
		//SSL
		if($ssl_enabled == "on") {
			//remark unnecessary line
			for($i = 129; $i < 143; $i++)
				$line[$i] = "#".$line[$i];
			
		} else {
			//remark unnecessary line
			$line[150] = "#".$line[150];
			for($i = 158; $i < 190; $i++)
				$line[$i] = "#".$line[$i];
			
			// 20080901 - Adjust line numbers
			// 20080721 - Adjust line numbers
			// 20071005 - Adjust line numbers
			// remark unnecessary line (Infobox port)
			for($i = 311; $i < 315; $i++)
				$line[$i] = "#".$line[$i];			
		}
		
		//create self-signup cert
		if($ssl_cert == 1) {
		
			$commonName="";
			// Check if put IP or domain into common name
			if (isset($showDomainUrl) && $showDomainUrl > 0) {
				$commonName = $dn;
			} else {
				$commonName = $internalIP;
			}
		
			openssl::editCnf("$opensslcnf_path\\openssl.cnf", $commonName);
			openssl::cert_new("$openssl_path\\openssl.exe", "$opensslcnf_path\\openssl.cnf", $opensslcnf_path );
		}
		
		// 20080723 - Adjust line number
		//Access control manager from internal network 
		if(strtolower($internalAccess) == "off" || strtolower($internalAccess) != "on")
			$line[90] = "#".$line[90];
		
		// 20080723 - Adjust line number
		//Access control manager from external network
		if(strtolower($externalAccess) == "off" || strtolower($externalAccess) != "on")
			$line[111] = "#".$line[111];
		else if(strtolower($externalAccess) == "on")
			$line[110] = "#".$line[110];
		
		//demo mode
		if(strtolower($demo_mode) == "off") {
    	    for($i=31; $i<34; $i++)
				$line[$i] = "#".$line[$i];	
		}
		
		// // Load Balancing (Configuration Manager [Status tab] through php to get user data which is logged in from other load balancing machine)
		// if ($FSFO != 3){
			for($i=400; $i<421; $i++)
				$line[$i] = "#".$line[$i];	
		// }
		
		// workaround for modify apache log level (less log output)
		if (isset($_skipModifyApacheLog) && $_skipModifyApacheLog == 1){
			// do not modify
			$line[6] = "#".$line[6];
			$line[8] = "#".$line[8];
		}
		else{
			// modify
			$subContent1 = "";
			$subContent2 = "";
			$subContent1 .="\r\n";
			$subContent1 .= "\t# VirtualHost access logfiles\r\n";
			$subContent2 .= "\tCustomLog \"logs/accessvh.log\" common env=vhlog\r\n";
			
			$line[15] = $line[15].$subContent1.$subContent2;
			$line[26] = $line[26].$subContent1.$subContent2;
			$line[46] = $line[46].$subContent1.$subContent2;
			$line[63] = $line[63].$subContent1.$subContent2;
			$line[75] = $line[75].$subContent1.$subContent2;
			$line[96] = $line[96].$subContent1.$subContent2;
			$line[117] = $line[117].$subContent1.$subContent2;
			if($ssl_enabled == "on"){
				$line[129] = $line[129].$subContent1."#".$subContent2;
				$line[172] = $line[172].$subContent1.$subContent2;
			}
			else{
				$line[129] = $line[129].$subContent1.$subContent2;
				$line[172] = $line[172].$subContent1."#".$subContent2;
			}
			$line[192] = $line[192].$subContent1.$subContent2;
			$line[220] = $line[220].$subContent1.$subContent2;
			$line[232] = $line[232].$subContent1.$subContent2;
			$line[249] = $line[249].$subContent1.$subContent2;
			$line[273] = $line[273].$subContent1.$subContent2;
			$line[288] = $line[288].$subContent1.$subContent2;
			$line[310] = $line[310].$subContent1.$subContent2;
			$line[346] = $line[346].$subContent1.$subContent2;
			$line[374] = $line[374].$subContent1.$subContent2;
			// if ($FSFO != 3)
				$line[402] = $line[402].$subContent1."#".$subContent2;
			// else
				// $line[402] = $line[402].$subContent1.$subContent2;
			$line[429] = $line[429].$subContent1.$subContent2;
			
		}
		
		if (!(isset($showDomainUrl) && $showDomainUrl > 0)){
			$line[456] = "#".$line[456];
			$line[495] = "#".$line[495];
		}
		
		if (strcasecmp($versionLanguage, "simplified chinese") == 0){
			// Simplified Chinese
			$line[550] = $line[550]."AddDefaultCharset utf-8 \r\n";
		}
		else{
			// default
			$line[550] = $line[550]."AddDefaultCharset ISO-8859-1 \r\n";
		}
			
		//*** keep in latest add
		//Access control manager from private network 
		if(strtolower($internalAccess) == "on" || strtolower($internalAccess) != "off"){
			$settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');

			$num_return_path = $settingobj->getKey('num_return_path', 'MNS');

			$tmp_num = '0'.trim($num_return_path);
			$num = (int)$tmp_num;

			$i = 0;
			while ($i < $num) {
				$return_path= "";
				$return_path = $settingobj->getKey("return_path$i", 'MNS');
				$strarray = split(' ', trim($return_path));
				$i++;
				$line[90] = $line[90]."\r\n\t\tAllow from ".$strarray[0]."/".$strarray[1]."";
			}
			
			$settingobj = null;
			
		}

		//re-config end
		
		
		$contentStr = implode("\r\n", $line);
		
		// make a copy
		if (file_exists($filepath)) {
			copy($filepath, $filepath.".bak"); // If the destination file already exists, it will be overwritten
		}
		
		$fh = fopen($filepath, "w");
		if($fh)
		{
			fwrite($fh, $contentStr);
			fclose($fh);
		}
		
		return true;
	}
	//create_vhosts_conf end
}

class openssl {
	
	function editCnf($filepath, $cn) {
		$content = file($filepath);
		//$content[$lineNo-1] = $replaceStr;
		
		$i = 0;
		$lineNumberON=0; // line contain "0.organizationName_default"
		$hvCN_default=false;
		foreach($content as $line) {
			$pos = strpos(trim(strtolower($line)), "commonname_default");
			
			if(!($pos === false))
				if($pos === 0) {
					$content[$i] = "commonName_default\t\t\t\t= $cn\r\n";
					$hvCN_default = true;
					break;
				}
				
			$posON = strpos(trim(strtolower($line)), "0.organizationname_default");
			if(!($posON === false))
				if($posON === 0) {
					$lineNumberON = $i;
				}
				
			$i++;	
		}
		
		// workaround for cnf file not contain "commonname_default", then using "0.organizationname_default"
		if ($hvCN_default == false){
			if ($lineNumberON > 0){
				$content[$lineNumberON] = $content[$lineNumberON]."commonName_default\t\t\t\t= $cn\r\n";
			}
		}
		
		$contentStr = implode("", $content);
		
		$fh = fopen($filepath, "w");
		if($fh)
		{
			fwrite($fh, $contentStr);
			fclose($fh);
		}
		
	}
	
	function cert_new($openssl_path, $cnffile_path, $cert_path) {
		$sys = new sysfunc();
		$cmd = "\"$openssl_path\" req -passout pass:patronsoftEaseGate -config \"$cnffile_path\" -new -out \"$cert_path\\my-server.csr\" -batch";
		//$sys->runCommand("\"$cmd\"");
		$sys->runCommand($cmd);
		$cmd = "\"$openssl_path\" rsa -passin pass:patronsoftEaseGate -in privkey.pem -out \"$cert_path\\my-server.key\"";
		//$sys->runCommand("\"$cmd\"");
		$sys->runCommand($cmd);
		$cmd = "\"$openssl_path\" x509 -in \"$cert_path\\my-server.csr\" -out \"$cert_path\\my-server.cert\" -req -signkey \"$cert_path\\my-server.key\" -days 1825";
		//$sys->runCommand("\"$cmd\"");
		$sys->runCommand($cmd);
		$sys = null;
	}
	
}

?>
