<?php
// security check
require_once "secureLogin.php";
require_once "cmvar.php";

function mac2long($mac)
{
	list($mac1,$mac2,$mac3,$mac4,$mac5,$mac6) = explode('-', $mac, 6);
	$mac = $mac6.$mac5.$mac4.$mac3.$mac2.$mac1;
	
	$mac_long = 0;
	$count = strlen($mac)-1;
	for($i=0; $i<=$count; $i++) {
		$mac_long += hexdec($mac[$count-$i]) * pow(16, $i);
	}
	return $mac_long;
}

function iplong($ip)
{
	list($ip1,$ip2,$ip3,$ip4) = explode('.', $ip, 4);
	$ip = sprintf("%02x%02x%02x%02x", $ip4,$ip3,$ip2,$ip1);
	
	$ip_long = 0;
	$count = strlen($ip)-1;
	for($i=0; $i<=$count; $i++) {
		$ip_long += hexdec($ip[$count-$i]) * pow(16, $i);
	}
	
	return $ip_long;
}

$settingobj = new COM('EGCONFIG.Cfgmgr') or die('c_Filter.php EGCONFIG.Cfgmgr Object cannot be created!');
$myObj = new COM("EGAUTH.Authserv") or die("c_Filter.php EGAUTH.Authserv Object cannot be created!");
$status = $settingobj->queryService();
$session_handling = $settingobj->getKey("session_handling", "gateway");

if( isset($c_Filter_save) && $c_Filter_save=="true" )
{
	$updated = false;
	
	//==================
	// spun: Original Black list logic 
	//==================
	//add mac filter entries
	if( isset($ser_filter_mac) ) {
		
		//$settingobj = new COM('EGCONFIG.Cfgmgr') or die('c_Filter.php EGCONFIG.Cfgmgr Object cannot be created!');
		$filter_path = realpath("..\\");
		$filter_path = $filter_path."\\config.ini";
		
		$filter_mac = unserialize($ser_filter_mac);
		
		$count = $settingobj->ReadINI("mac_filter", "mac_count", $filter_path);
		$count = $count==""? 0:$count;
		
		if($count==0)
			$settingobj->WriteINI("mac_filter", "mac_count", "0", $filter_path);
		
		//$count = 0;
		foreach($filter_mac as $mac) {
			$mac_long = mac2long($mac);
			$settingobj->WriteINI("mac_filter", "mac_$count", $mac_long, $filter_path);
			
			if($status=="STARTED")
				$myObj->AddFilter(0, $mac_long);
				
			$count++;
		}
		
		$settingobj->WriteINI("mac_filter", "mac_count", $count, $filter_path);
		
		//$settingobj = null;
		$updated=true;
		session_unregister('ser_filter_mac');	
	}
	
	//delete mac filter entries
	if( isset($ser_delete_mac) ) {
		$delete_mac = unserialize($ser_delete_mac);
		
		//$settingobj = new COM('EGCONFIG.Cfgmgr') or die('c_Filter.php EGCONFIG.Cfgmgr Object cannot be created!');
		$filter_path = realpath("..\\");
		$filter_path = $filter_path."\\config.ini";
		
		if(file_exists($filter_path)) {
			$count = $settingobj->ReadINI("mac_filter", "mac_count", $filter_path);
			$count = $count==""? 0:$count;
			$entry = array();
			for($i=0; $i<$count; $i++)
				$entry[$i] = $settingobj->ReadINI("mac_filter", "mac_$i", $filter_path);
			
			foreach($delete_mac as $pos) {
				if($status=="STARTED")
					$myObj->RemoveFilter(0, $entry[$pos]);
				
				$entry[$pos] = -1;
			}
			
			//unlink($filter_path);
			
			$settingobj->WriteINI("mac_filter", "mac_count", 0, $filter_path);
			$count = 0;
			foreach($entry as $mac_long) {
				if(	$mac_long!=-1 ) {
					$settingobj->WriteINI("mac_filter", "mac_$count", $mac_long, $filter_path);
					$count++;	
				}
			}
			$settingobj->WriteINI("mac_filter", "mac_count", $count, $filter_path);
		}
		
		$updated=true;
		session_unregister('ser_delete_mac');
	}
	
	//add ip filter entries
	if( isset($ser_filter_ip) ) {
		$filter_path = realpath("..\\");
		$filter_path = $filter_path."\\config.ini";
		
		$filter_ip = unserialize($ser_filter_ip);
		
		$count = $settingobj->ReadINI("ip_filter", "ip_count", $filter_path);
		$count = $count==""? 0:$count;
		
		if($count==0)
			$settingobj->WriteINI("ip_filter", "ip_count", "0", $filter_path);
		
		foreach($filter_ip as $ip) {
			$ip_long = iplong($ip);
			$settingobj->WriteINI("ip_filter", "ip_$count", $ip_long, $filter_path);
			
			if($status=="STARTED")
				$myObj->AddFilter(1, $ip_long);
				
			$count++;	
		}
		
		$settingobj->WriteINI("ip_filter", "ip_count", $count, $filter_path);
		
		$updated=true;
		session_unregister('ser_filter_ip');
	}
	
	//delete ip filter entries
	if( isset($ser_delete_ip) ) {
		$delete_ip = unserialize($ser_delete_ip);
		
		//$settingobj = new COM('EGCONFIG.Cfgmgr') or die('c_Filter.php EGCONFIG.Cfgmgr Object cannot be created!');
		$filter_path = realpath("..\\");
		$filter_path = $filter_path."\\config.ini";
		
		if(file_exists($filter_path)) {
			$count = $settingobj->ReadINI("ip_filter", "ip_count", $filter_path);
			$count = $count==""? 0:$count;
			$entry = array();
			for($i=0; $i<$count; $i++)
				$entry[$i] = $settingobj->ReadINI("ip_filter", "ip_$i", $filter_path);
			
			foreach($delete_ip as $pos) {
				if($status=="STARTED")
					$myObj->RemoveFilter(1, $entry[$pos]);
					
				$entry[$pos] = -1;
			}
			
			//unlink($filter_path);
			
			$settingobj->WriteINI("ip_filter", "ip_count", 0, $filter_path);
			$count = 0;
			foreach($entry as $ip_long) {
				if(	$ip_long!=-1 ) {
					$settingobj->WriteINI("ip_filter", "ip_$count", $ip_long, $filter_path);
					$count++;	
				}
			}
			$settingobj->WriteINI("ip_filter", "ip_count", $count, $filter_path);
		}
		
		$updated=true;
		session_unregister('ser_delete_ip');
	}
	
	if($updated) 
	{
		$_SESSION['message'] = 'All changes updated successfully.';
    	$_SESSION['error'] = '';
    	$_SESSION['errorlog'] = '';
    	echo "<script type='text/javascript'>parent.mid_right_bottom.location.reload();</script>";
	}
}

if( isset($c_Filter_cancel) && $c_Filter_cancel=="true" )
{
	session_unregister('ser_filter_mac');
	session_unregister('ser_delete_mac');
	session_unregister('ser_filter_ip');
	session_unregister('ser_delete_ip');
}

$settingobj = null;
$myObj = null;

?>
<script type="text/javascript">
function submit_filter_mac()
{
	oForm = document.c_Filter;
      
    var formValue = new Array(6);
    formValue[0] = oForm.filter_mac1.value;
    formValue[1] = oForm.filter_mac2.value;
    formValue[2] = oForm.filter_mac3.value;
    formValue[3] = oForm.filter_mac4.value;
    formValue[4] = oForm.filter_mac5.value;
    formValue[5] = oForm.filter_mac6.value;
    
    for(i=0; i<6; i++)
   		if(formValue[i]=="") {
   			alert('Invalid MAC address!');
   			return false;
		}
    
	oForm.filter_mac1.value = "";
    oForm.filter_mac2.value = "";
    oForm.filter_mac3.value = "";
    oForm.filter_mac4.value = "";
    oForm.filter_mac5.value = "";
    oForm.filter_mac6.value = "";
		
    mac = formValue.join("-");
    urlenStr = "mac="+mac;
    window.frames.frameFilter.location = "frameFilter.php?"+urlenStr;
  	
	return false;
}

function submit_filter_ip()
{
	oForm = document.c_Filter;
	
	var formValue = new Array(4);
    formValue[0] = oForm.filter_ip1.value;
    formValue[1] = oForm.filter_ip2.value;
    formValue[2] = oForm.filter_ip3.value;
    formValue[3] = oForm.filter_ip4.value;
    
    for(i=0; i<4; i++)
   		if(formValue[i]=="" || formValue[i]>255) {
   			alert('Invalid IP address!');
   			return false;
		}
    
	ip = formValue.join(".");
    urlenStr = "ip="+ip;
    window.frames.frameFilter.location = "frameFilter.php?"+urlenStr;
  
	return false;
}

function delete_entry(obj, action_url, id)
{   
	objEntry = obj.document.getElementsByName('entry');
	
    var j=0;
    var entry = new Array();
    var urlenStr = null;
    
    for (i=0; i<objEntry.length; i++) {
        if (objEntry[i].checked==true){
            entry[j]=i;
            j++;
        }
    }
        
   	urlenStr = entry.join(",");
    
    if(urlenStr == null || urlenStr == '' )
        return;
    
    obj.location = action_url+"?delete="+urlenStr;
    document.getElementById(id).style.display = '';
}

function save()
{
	document.c_Filter.c_Filter_save.value = "true";
}

function cancel()
{
	document.c_Filter.c_Filter_cancel.value = "true";
}

function selectAll(obj)
{
    for (i=0; i<obj.length; i++)
        obj[i].checked = (obj[i].disabled)?false:true;
            
    return false;
}

function selectClear(obj)
{   
    for (i=0; i<obj.length; i++)
        obj[i].checked = false;
        
    return false;
}
</script>

<link rel="stylesheet" href="setcfg.css" type="text/css" />

<form name="c_Filter" action="" method="post">
<!-- Header -->
<tr>
    <td width="400"><p class="indented">
		<img src="./images/smallbubble.gif" width="8" height="8">
        <img src="./images/blank.gif" width="10" height="6"><?=$session_handling==0?get_cm_var('setcfg_flt_mac'):get_cm_var('setcfg_flt_ip')?>
    </td>
</tr>
<!-- End Header -->

<!-- Filter body -->
<tr align="center">
	<td width="100%" colspan="4" align="center">  
    <br>
    
    <table>
    <tr>
    <td style="font-size: 0.9em;">
        <?=get_cm_var('setcfg_select_label')?>&nbsp;
        <a href="" title="<?=get_cm_var('setcfg_selectAll_desc')?>" onclick="return selectAll(self.frames.frameFilter.document.getElementsByName('entry'));"><font size="2" color="blue"><?=get_cm_var('setcfg_selectAll_button')?></font></a>&nbsp;
        <a href="" title="<?=get_cm_var('setcfg_selectClear_desc')?>" onclick="return selectClear(self.frames.frameFilter.document.getElementsByName('entry'));"><font size="2" color="blue"><?=get_cm_var('setcfg_selectClear_button')?></font></a>&nbsp;
        <input type="button" value="<?=get_cm_var('setcfg_delete_button')?>" title="<?=get_cm_var('setcfg_delete_button')?>" class="graphicBtn" onclick="delete_entry(self.frames.frameFilter, 'frameFilter.php', 'deleteTxt');" >&nbsp;&nbsp;
        <font id="deleteTxt" size="3" color="red" style="display: none" ><?=get_cm_var('setcfg_confirm_delete_txt')?></font>
    </td>
    </tr>
    
    <tr>
    <td>
    <iframe id="frameFilter" name="frameFilter" class="bordered_frame" frameborder="0" width="400" height="206" src="frameFilter.php" marginwidth="0" marginheight="0" scrolling="yes"></iframe>
    </td>
    </tr>
    
    <!-- MAC Filter -->
    <tr id="filter_mac" style="display: <?=$session_handling==0?'':'none'?>" >
    <td style="font-size: 0.9em;">
    <?=get_cm_var('setcfg_flt_mac_addr')?>
    <input class="IPtextbox" type="text" name="filter_mac1" maxlength="2" onKeyPress="return hexnumbersonly(this,event,'filter_mac2')" onChange="this.value=this.value.toUpperCase()" style="width:25px" > -
    <input class="IPtextbox" type="text" name="filter_mac2" maxlength="2" onKeyPress="return hexnumbersonly(this,event,'filter_mac3')" onChange="this.value=this.value.toUpperCase()" style="width:25px" > -
    <input class="IPtextbox" type="text" name="filter_mac3" maxlength="2" onKeyPress="return hexnumbersonly(this,event,'filter_mac4')" onChange="this.value=this.value.toUpperCase()" style="width:25px" > -
    <input class="IPtextbox" type="text" name="filter_mac4" maxlength="2" onKeyPress="return hexnumbersonly(this,event,'filter_mac5')" onChange="this.value=this.value.toUpperCase()" style="width:25px" > -
    <input class="IPtextbox" type="text" name="filter_mac5" maxlength="2" onKeyPress="return hexnumbersonly(this,event,'filter_mac6')" onChange="this.value=this.value.toUpperCase()" style="width:25px" > -
    <input class="IPtextbox" type="text" name="filter_mac6" maxlength="2" onKeyPress="return hexnumbersonly(this,event)" onChange="this.value=this.value.toUpperCase()" style="width:25px" >
  	<input type="button" value="<?=get_cm_var('setcfg_add_button')?>" title="<?=get_cm_var('setcfg_add_button')?>" class="graphicBtn" style="margin-left: 15px;" onclick="return submit_filter_mac();">
  	</td>
    </tr>
    
    <!-- IP Filter -->
    <tr id="filter_ip" style="display: <?=$session_handling==1?'':'none'?>" >
    <td style="font-size: 0.9em;">
    <?=get_cm_var('setcfg_flt_ip_addr')?>
    <input class="IPtextbox" type="text" name="filter_ip1" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'filter_ip2')">.
    <input class="IPtextbox" type="text" name="filter_ip2" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'filter_ip3')">.
    <input class="IPtextbox" type="text" name="filter_ip3" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'filter_ip4')">.
    <input class="IPtextbox" type="text" name="filter_ip4" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'filter_ip1')">
  	<input type="button" value="<?=get_cm_var('setcfg_add_button')?>" title="<?=get_cm_var('setcfg_add_button')?>" class="graphicBtn" style="margin-left: 15px;" onclick="return submit_filter_ip();">
  	</td>
    </tr>
    
    </table>
    
    <br>
    </td>
</tr>
<?

	gen_sep();

?>
<tr>
<td width="100%" colspan="9" valign="top">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
    <tr valign="middle">
        <td width="50%" style="text-align: right">
            <input type="hidden" name="c_Filter_save" value="false">
            <input type="image" name="save_button" alt="Save" id="save_button" src="./images/save.gif" align="top" onclick="save();">
        </td>
        <td width="20"><img src="./images/blank.gif" align="top" width="20" height="50"></td>
        <td width="50%" style="text-align: left;">
            <input type="hidden" name="c_Filter_cancel" value="false">
            <input type="image" src="./images/cancel.gif" alt="Cancel" id="cancel_button" align="top" onclick="cancel();">
        </td>
    </tr>
    </table>
</td>
</tr>
<!-- End Save & Cancel -->
<form>
