<?php
  // security check
  require_once "secureLogin.php";
  require_once "cmvar.php";
  
  //NAT Save
  if(isset($c_Nat_save) && $c_Nat_save=="true") {
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('c_Nat.php EGCONFIG.Cfgmgr Object cannot be created!');
      
    if(isset($nat_enabled)) {
      $settingobj->setKey($nat_enabled, 'Enable', 'NAT');
    }
	
	// 20100622 - Save chosen module
	if (isset($nat_module)) {
		$settingobj->setKey($nat_module, 'module', 'NAT');
	}
    
    if(isset($nat_option))
      $settingobj->setKey($nat_option, 'Type', 'NAT');
  	
    //NAT Port Forwarding
    //Add entries
    if(isset($ser_ipport_array)) {
	  $ipport_array = unserialize($ser_ipport_array);
	  $internalPort_array = unserialize($ser_internalPort_array);
	  $externalPort_array = unserialize($ser_externalPort_array);
	  $proto_array = unserialize($ser_proto_array);
	  
	  $NAT_portmap_count = $settingobj->getKey('NAT_portmap_count', 'NAT');
        
      for($i=0; $i<count($ipport_array); $i++) {
        $pos=$NAT_portmap_count+$i;
     
        $portmap = "$proto_array[$i]:$ipport_array[$i]:$internalPort_array[$i]:$externalPort_array[$i]";
        $settingobj->setKey($portmap,'NAT_portmap_'.$pos, 'NAT');
      }
        
      $settingobj->setKey($NAT_portmap_count+count($ipport_array),'NAT_portmap_Count', 'NAT');
    }
    
    //delete entries
    if(isset($ser_ipport_delete_array)) {
      $ipport_delete_array = unserialize($ser_ipport_delete_array);
      
      $NAT_portmap_count = $settingobj->getKey('NAT_portmap_count', 'NAT');
        
      for ($i=0; $i<$NAT_portmap_count; $i++) {
        $portmap_array[$i] = $settingobj->getKey('NAT_portmap_'.$i, 'NAT');
      }
        
      for($i=0; $i<count($ipport_delete_array); $i++) {
        $portmap_array[$ipport_delete_array[$i]] = "";
      }
        
      $pos=0;
      for ($i=0; $i<$NAT_portmap_count; $i++) {	    
        if($portmap_array[$i] != "") {
          $settingobj->setKey($portmap_array[$i],'NAT_portmap_'.$pos, 'NAT');
          $pos++;
        }
      }
        
      $settingobj->setKey($NAT_portmap_count-count($ipport_delete_array),'NAT_portmap_count', 'NAT');
    }
    
    session_unregister('ser_ipport_array');
  	session_unregister('ser_internalPort_array');
  	session_unregister('ser_externalPort_array');
  	session_unregister('ser_proto_array');
  	session_unregister('ser_ipport_delete_array');
    
    
    //$settingobj->Release();
    $settingobj=null;
  }
  
  if(isset($c_Nat_save) && $c_Nat_save=="true") {
	$_SESSION['message'] = 'All changes will take effect when you start EaseGate&reg next time.';
    $_SESSION['error'] = '';
    $_SESSION['errorlog'] = '';
    echo "<script type='text/javascript'>parent.mid_right_bottom.location.reload();</script>";
  }
  //NAT Save End

  //Cancel
  if(isset($c_Nat_cancel) && $c_Nat_cancel=="true") {    
    session_unregister('ser_ipport_array');
  	session_unregister('ser_internalPort_array');
  	session_unregister('ser_externalPort_array');
  	session_unregister('ser_proto_array');
  	session_unregister('ser_ipport_delete_array');
  }
  
  
  $settingobj = new COM('EGCONFIG.Cfgmgr') or die('c_Nat.php EGCONFIG.Cfgmgr Object cannot be created!');
  $NAT_enabled = $settingobj->getKey('Enable', 'NAT');
  
  // 20100622 - Get module setting
  $natModule = $settingobj->getKey('module', 'NAT');
  
  $NAT_type = $settingobj->getKey('Type', 'NAT');
  $NATcount = $settingobj->getKey('NAT_AddrR_Count', 'NAT');
  $ProxyARP_enabled = $settingobj->getKey('ip_num', 'proxyARP');
  
  if ($NAT_enabled==1) {
    $eNAT_checked = "checked";
    $dNAT_checked = "";
  } else {
    $eNAT_checked = "";
    $dNAT_checked = "checked";    
  }
  
	// Special
	// 20101019
	$nat_module_win_disabled = '';
	if ((int)($settingobj->getKey('MsiNTProductType', 'misc')) == 1) {
		$versionNt = $settingobj->getKey('VersionNT', 'misc');
		if ((int)$versionNt >= 600) {
			$nat_module_win_disabled = 'disabled';
		}
	}
  
  //$settingobj->Release();
  $settingobj=null;
?>
<link rel="stylesheet" href="setcfg.css" type="text/css" />

<script type="text/javascript" src="./javascript/nat.js"></script>

<form name="c_Nat" action="" method="post">
<!-- NAT Header -->
<tr>
    <td width="400"><p class="indented">
        <img src="./images/smallbubble.gif" width="8" height="8">
        <img src="./images/blank.gif" width="10" height="6"><?=get_cm_var('setcfg_nat_NAT')?>
    </td>
    <td width="50"><img src="./images/blank.gif" width="3" height="3"></td>
    <td width="300" class="normal">
    <input type="radio" name="nat_enabled" value="1" onclick="SwitchNAT(this)" <?=$eNAT_checked?> <?=($ProxyARP_enabled>0)?"disabled":""?> ><?=get_cm_var('setcfg_nat_enabled')?>
    <input type="radio" name="nat_enabled" value="0" onclick="SwitchNAT(this)" <?=$dNAT_checked?> <?=($ProxyARP_enabled>0)?"disabled":""?> ><?=get_cm_var('setcfg_nat_disabled')?>
    </td>
</tr>

<tr id="NatModuleRowSep" style="display: <?=($NAT_enabled==1)?'':'none'?>;"><td width="100%" colspan="9">
	<p style="margin-top: 1px; margin-bottom: 1px"><img src="./images/hline-sep-green.gif" width="100%" height="1"></p>
</td></tr>
<tr id="NatModuleRow" style="display: <?=($NAT_enabled==1)?'':'none'?>;">
	<td width="400"><p class="indented">
		<img src="./images/blank.gif" width="8" height="8">
		<img src="./images/blank.gif" width="10" height="6"><?=get_cm_var('setcfg_nat_module_text')?>
	</p></td>
	<td width="50"><img src="./images/blank.gif" width="3" height="3"></td>
	<td width="300" class="normal">
		<input type="radio" name="nat_module" value="0" onclick="NATModuleOpt(this)" <?=$natModule==0? "checked":""?> <?=$nat_module_win_disabled?>><?=get_cm_var('setcfg_nat_module_win')?><br>
		<input type="radio" name="nat_module" value="1" onclick="NATModuleOpt(this)" <?=$natModule==1? "checked":""?> ><?=get_cm_var('setcfg_nat_module_fsnat')?>
	</td>
</tr>

<tr id="NatRadioButtonsSep" style="display: <?=($NAT_enabled==1)?'':'none'?>;"><td width="100%" colspan="9">
	<p style="margin-top: 1px; margin-bottom: 1px"><img src="./images/hline-sep-green.gif" width="100%" height="1"></p>
</td></tr>
<tr id="NatRadioButtons" style="display: <?=($NAT_enabled==1)?'':'none'?>;">
	<td width="400"><p class="indented">
		<img src="./images/blank.gif" width="8" height="8">
		<img src="./images/blank.gif" width="10" height="6"><?=get_cm_var('setcfg_nat_option_text')?>
	</p></td>
	<td width="50"><img src="./images/blank.gif" width="3" height="3"></td>
	<td width="300" class="normal">
		<input type="radio" name="nat_option" value="0" onclick="NatOption(this)" <?=$NAT_type==0? "checked" : ""?> ><?=get_cm_var('setcfg_nat_none')?><br>
		<input type="radio" name="nat_option" value="2" onclick="NatOption(this)" <?=$NAT_type==2? "checked" : ""?> ><?=get_cm_var('setcfg_nat_port_mapping')?>
	</td>
</tr>

<!-- NAT Port Forwarding -->
<tr id="NatPortMapping" align="center" style="display: <?=($NAT_enabled==1)&&($NAT_type==2)?'':'none'?>" >
    <td width="100%" colspan="4" align="left">  
    <br>
    <table>
    <tr>
    <td style="font-size: 0.9em;">
        <?=get_cm_var('setcfg_select_label')?>&nbsp;
        <a href="" title="<?=get_cm_var('setcfg_selectAll_desc')?>" onclick="return selectAll(self.frames.framePortMap.document.getElementsByName('entry'));"><font size="2" color="blue"><?=get_cm_var('setcfg_selectAll_button')?></font></a>&nbsp;
        <a href="" title="<?=get_cm_var('setcfg_selectClear_desc')?>" onclick="return selectClear(self.frames.framePortMap.document.getElementsByName('entry'));"><font size="2" color="blue"><?=get_cm_var('setcfg_selectClear_button')?></font></a>&nbsp;
        <input type="button" value="<?=get_cm_var('setcfg_delete_button')?>" title="<?=get_cm_var('setcfg_delete_button')?>" class="graphicBtn" onclick="deletePortMap()" >&nbsp;&nbsp;<font id="NAT_portmap_deleteTxt" size="3" color="red" style="display: none"><?=get_cm_var('setcfg_confirm_delete_txt')?></font>
    </td>
    </tr>
    
    <tr>
    <td>
    <!-- 20080314 - Remove scrolling limitation -->
    <iframe id="framePortMap" name="framePortMap" class="bordered_frame" frameborder="0" width="400" height="206" src="framePortMap.php" marginwidth="0" marginheight="0"></iframe>
    </td>
    
    <td valign="bottom" nowrap>
    <!--<form action="" name="formNAT" method="post" align="left" onsubmit="">-->
    	<font class="captionbig"><?=get_cm_var('setcfg_nat_external_port')?></font>
    	<input class="Porttextbox" type="text" name="NAT_external_port" value="" size="10" maxlength="5" onKeyPress="return numbersonly(this)" >
    	<br>
    	<font class="captionbig"><?=get_cm_var('setcfg_nat_internal_ip')?></font>
        <input class="IPtextbox" type="text" name="NAT_port_ip1" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'NAT_port_ip2')" >.
        <input class="IPtextbox" type="text" name="NAT_port_ip2" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'NAT_port_ip3')" >.
        <input class="IPtextbox" type="text" name="NAT_port_ip3" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'NAT_port_ip4')" >.
        <input class="IPtextbox" type="text" name="NAT_port_ip4" value="" maxlength="3" onKeyPress="return numbersonly(this,event,'NAT_port_ip1')" >
    	<br>
        <font class="captionbig"><?=get_cm_var('setcfg_nat_internal_port')?></font>
    	<input class="Porttextbox" type="text" name="NAT_internal_port" value="" size="10" maxlength="5" onKeyPress="return numbersonly(this)" >
    	<br>
    	<font class="captionbig"><?=get_cm_var('setcfg_nat_protocol')?></font>
    	<input type="checkbox" name="NAT_proto_tcp" value="tcp" ><font class="normal"><?=get_cm_var('setcfg_nat_tcp')?></font>
    	<input type="checkbox" name="NAT_proto_udp" value="udp" ><font class="normal"><?=get_cm_var('setcfg_nat_udp')?></font>
        <input type="button" value="<?=get_cm_var('setcfg_add_button')?>" title="<?=get_cm_var('setcfg_add_button')?>" class="graphicBtn" style="margin-left: 15px;" onclick="return addPortMap();" >
    </td>
    </tr>
    </table>
    <br>
    </td>

</tr>

<!-- end of NAT -->
<tr><td width="100%" colspan="9">
<p style="margin-top: 1px; margin-bottom: 1px"><img src="./images/hline-sep-green.gif" width="100%" height="1"></p>
</td></tr>

<!-- Save & Cancel -->
<tr>
<td width="100%" colspan="9" valign="top">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
    <tr valign="middle">
        <td width="50%" style="text-align: right">
            <input type="hidden" name="c_Nat_save" value="false">
            <input type="image" name="save_button" alt="Save" id="save_button" src="./images/save.gif" align="top" onclick="document.c_Nat.c_Nat_save.value='true';">
        </td>
        <td width="20"><img src="./images/blank.gif" align="top" width="20" height="50"></td>
        <td width="50%" style="text-align: left;">
            <input type="hidden" name="c_Nat_cancel" value="false">
            <input type="image" src="./images/cancel.gif" alt="Cancel" align="top" onclick="document.c_Nat.c_Nat_cancel.value='true';">
        </td>
    </tr>
    </table>
</td>
</tr>
<!-- End Save & Cancel -->
</form>