<?

/****************************************************************************
**
** Warning : This file is used by EaseGate API (egapi.exe). Please do not modify.
**
*****************************************************************************/

// Turn off all error reporting
// error_reporting(0);

include_once '..\\authserv\\common_functions.php';
include_once "..\\local\\transaction.php";
include_once "..\\cfgmgr\\egAPI.php";

// echo "PHP-------------\n";

$settingObj = new COM("EGCONFIG.Cfgmgr") or die("callAPI.php EGCONFIG.Cfgmgr Object cannot be created!");

if ($argc <=1){
	echo "ERROR: Invalid argument \n";
	$settingObj=null;
	exit();
}

$fields = array();
$functionName="";

foreach($argv as $k => $v){

	// echo $k."=".$v."\n";
	
	if ($k == 0){
		// ignore first argument (path+filename)
		continue;
	}
	else if ($k == 1){
		// function name
		$functionName = $v;
		continue;
	}

	$tmpkey="";
	$tmpVal="";
	
	// checking format: key=val
	if (stristr($v,"=") == NULL){
		echo "ERROR: Input incorrect function paramter format\\n";
		$settingObj=null;
		exit();
	}
	
	list($tmpkey, $tmpVal) = split('=', $v);

	if (strcasecmp($tmpkey,"username") == 0 ){
		$username=$tmpVal;
		// echo "username: ".$username."\n";
	}
	else if (strcasecmp($tmpkey,"password") == 0 ){
		$password=$tmpVal;
		// echo "password: ".$password."\n";
	}
	else{
		$fields[strtolower($tmpkey)]=$tmpVal;
	}

}

$use_radius = $settingObj->getKey( "use_radius", "radius");
$isRadius=false;
if( strtolower($use_radius)== "true" ){
	$isRadius = true;
}

$is_anon=$settingObj->getKey( "anonymous_login", "gateway");
$secret_enable=$settingObj->getKey( "secret_enable", "gateway");

$settingObj=null;
$myfsapi = new fsAPI();

// checking db connection
if (!$myfsapi->myDB->myDB){
	echo "ERROR: Fail to conenct database \n";
	exit();
}

// checking input format

// checking format: mm-dd-yyyy hh:mm
function check_date($v){
	if (!(strpos($v,"-") == 2 && strpos($v,"-", 3) == 5 && strpos($v," ", 6) == 10 && strpos($v,":", 11) == 13)){
		return false;
	}
	return true;
}
// checking format: hh:mm
function check_time($v){
	if (!(strpos($v,":") == 2)){
		return false;
	}
	return true;
}
//							012345678901234567
// checking mac 	XX-XX-XX-XX-XX-XX
function check_mac($v){
	if (!(strpos($v,"-") == 2 && strpos($v,"-", 3) == 5 && strpos($v,"-", 6) ==  8 && strpos($v,"-", 9) == 11 && strpos($v,"-", 12) == 14)){
		return false;
	}
	return true;
}
// check ip XXX.XXX.XXX.XXX
function check_ip($v){

	$arr = Array();
	$arr = split("\.", $v);
	
	if (count($arr) == 4){
		if (!($arr[0] >= 0 && $arr[0] <255 && $arr[1] >= 0 && $arr[1] <255 && $arr[2] >= 0 && $arr[2] <255 && $arr[3] >= 0 && $arr[3] <255)){
			return false;
		}
	}
	else
		return false;
	
	return true;
}

if (strcasecmp($functionName, "update_usr_attributes") == 0){

	$validFieldNameArr = array("timeleft", "edate", "bwquotaul", "bwquota", "bwquotasha");
	
	$validFieldOptionArr = array("forceddisconnect", "resetquota");
	
	// update information
	$updateFields = array();
	
	// option
	$optionFields = array();

	// 20090708 - Set field type
	$bFieldNumeric = array();
	$bFieldNumeric['timeleft'] = 1;
	$bFieldNumeric['edate'] = 0;
	$bFieldNumeric['bwquotaul'] = 1;
	$bFieldNumeric['bwquota'] = 1;
	$bFieldNumeric['bwquotasha'] = 1;
	$bFieldNumeric['pwd'] = 0;

	// checking
	if ($isRadius){
		echo "ERROR: Not Support RADIUS \n";
		exit();
	}
	if (strcasecmp($is_anon, "on") == 0 && strcasecmp($secret_enable, "on") == 0){
		echo "ERROR: Not Support Shared Secret \n";
		exit();
	}
	if (!isset($username)){
		echo "ERROR: Username cannot be empty\n";
		exit();
	}
	if (count($fields) <= 0 && !isset($password)){
		echo "ERROR: Please input valid attribute(s) which want to be updated \n";
		exit();
	}	
	foreach ($fields as $key => $v){
		if (!in_array(strtolower($key), $validFieldNameArr) && !in_array(strtolower($key), $validFieldOptionArr)){
			// not valid field
			sort ($validFieldNameArr);
			echo "ERROR: Please input valid attribute(s) [".implode(",",$validFieldNameArr)."],password, option(s) [".implode(",",$validFieldOptionArr)."] which want to be updated \n";
			exit();
		}
		// checking value
		if (strcasecmp($key, "edate") == 0){
			// checking format: mm-dd-yyyy hh:mm
			
			if (!(check_date($v))){
				echo "ERROR: Please input valid edate format (mm-dd-yyyy hh:mm)\n";
				exit();
			}
			else{
				list($date,$time)    = explode(" ", $v);
				$fields[$key] = datetime_from_php($date, $time);
			}
		}
		else if (strcasecmp($key, "bwquotaul") == 0 || strcasecmp($key, "bwquota") == 0 || strcasecmp($key, "bwquotasha") == 0){
		
			if (strlen($v) == 0 || $v == null || $v == "" || $v <=0){
				echo "ERROR: Please input valid [".$key."] (quota must greater than zero)\n";
				exit();
			}
		
		}
		else if (strcasecmp($key, "forcedDisconnect") == 0 || strcasecmp($key, "resetQuota") == 0 ){
			// Y, N, NULL, <empry string>
			if (!(strtoupper($v) == "Y" || strtoupper($v) == "N" || strtoupper($v) == "NULL" || $v == "")){
				echo "ERROR: Please input valid [".$key."] (Y or N)\n";
				exit();
			}
		}
		
		// divide update inforamtion and option in different array
		if (in_array(strtolower($key), $validFieldNameArr)){
			$updateFields[$key] = $v;
		}
		else if (in_array(strtolower($key), $validFieldOptionArr)){
			$optionFields[$key] = $v;
		}
	}
	
	$result_fields = array();
	
	if (isset($password)){
		// NULL, <empry string>
		if ((strtoupper($password) == "NULL" || $password == "")){
			$updateFields['pwd'] = "";
		}
		else{
			// encrypt password
			$updateFields['pwd'] = $myfsapi->encryptPassword($password);
		}
	}
	
	$result_fields = $myfsapi->update_usr_attributes_with_opt($username, $updateFields, $bFieldNumeric, $optionFields);
	
	switch($result_fields['result']){
		case 0:{
			echo "ERROR: Fail to update";
		}break;
		case 1:{
			echo "Success";
		}break;
		case 2:{
			echo "ERROR: User does not exist";
		}break;
		case 3:{
			echo "ERROR: User is logged in from other EaseGate";
		}break;
		case 4:{
			echo "Success"; // with info
		}break;
		case 5:{
			echo "Finish...\n"; // by update all user
			
			// output
			if ($result_fields['success_count'] > 0){
				echo "Number of user update successfully: ".$result_fields['success_count']."\n";
				echo "Username which is update successfully: ".$result_fields['success_usr_str']."\n";
			}
			
			if ($result_fields['fail_count'] > 0){
				echo "Number of user update unsuccessfully: ".$result_fields['fail_count']."\n";
				echo "Username which is update unsuccessfully: ".$result_fields['fail_usr_str']."\n";
				
			// output fail message
			echo "Message:\n";
			foreach ($result_fields['arr_result'] as $n => $v){
				if ($v != 1){
					echo $n.": ";
					switch($v){
						case 0:{
							echo "ERROR: Fail to update";
						}break;
						case 1:{
							echo "Success";
						}break;
						case 2:{
							echo "ERROR: User does not exist";
						}break;
						case 3:{
							echo "ERROR: User is logged in from other EaseGate";
						}break;
						case 4:{
							echo "Success"; // with info
						}break;
						default:{
							echo "Unknown";
						}break;
					}
					echo "\n";
				}
			
			}
				
			}
			
		}break;
		default:{
			echo "Unknown";
		}break;
	}
	
}
else if (strcasecmp($functionName, "queryLoginDuration") == 0){
	// checking
	if (!isset($username)){
		$username="";
	}
	$dur_fields = array();
	$dur_fields = $myfsapi->queryLoginDuration($username);
	
	// echo "array count:".count($dur_fields)."\n";
	if (count($dur_fields) >0){
		// Output
		foreach($dur_fields as $k => $v){
			echo $v['name'].",".$v['duration']."\n";
		}
	}else{
		echo "User is not logged in.";
	}
}
else if (strcasecmp($functionName, "queryCurrentDataTransfer") == 0){
	// checking
	if (!isset($username)){
		$username="";
	}
	$dur_fields = array();
	$dur_fields = $myfsapi->queryCurrentDataTransfer($username);
	
	// echo "array count:".count($dur_fields)."\n";
	if (count($dur_fields) >0){
		// Output
		foreach($dur_fields as $k => $v){
			if (isset($v['bwUseSHA'])){
				echo $v['name'].",".$v['bwUseDL'].",".$v['bwUseUL'].",".$v['bwUseSHA']."\n";
			}
			else
				echo $v['name'].",".$v['bwUseDL'].",".$v['bwUseUL'].",NA\n";
		}
	}else{
		echo "User is not logged in.";
	}
}
else if (strcasecmp($functionName, "resetQuota") == 0){
	// checking
	if ($isRadius){
		echo "ERROR: Not Support RADIUS \n";
		exit();
	}
	if (!isset($username)){
		echo "ERROR: Username cannot be empty\n";
		exit();
	}
	
	$result = $myfsapi->resetQuota($username, 1);
	
	switch($result){
		case 0:{
			echo "ERROR: Fail to reset";
		}break;
		case 1:{
			echo "Success";
		}break;
		case 2:{
			echo "ERROR: User does not exist";
		}break;
		case 4:{
			echo "ERROR: User is logged in from other EaseGate";
		}break;
		default:{
			echo "Unknown";
		}break;
	}
	
}
else if (strcasecmp($functionName, "disconnectUser") == 0){
	// checking
	if (!isset($username)){
		echo "ERROR: Username cannot be empty\n";
		exit();
	}
	$result_fields = array();
	$result_fields = $myfsapi->disconnectUser($username);
	
	if($result_fields['result'] == 1){
		echo $result_fields['usr_forced_logout_count']." user(s) are forced to logout.\n";		
	}
	else if($result_fields['result'] == 2)
		echo "ERROR: EaseGate is stopped";
	
}
else if (strcasecmp($functionName, "deleteUser") == 0){
	// checking
	if ($isRadius){
		echo "ERROR: Not Support RADIUS \n";
		exit();
	}
	if (strcasecmp($is_anon, "on") == 0 && strcasecmp($secret_enable, "on") == 0){
		echo "ERROR: Not Support Shared Secret \n";
		exit();
	}
	if (!isset($username)){
		echo "ERROR: Username cannot be empty\n";
		exit();
	}
	
	$result_fields = array();
	
	$result_fields = $myfsapi->deleteUser($username);
	
	if (count($result_fields) >0){
		// Output		
		if ($result_fields['usr_forced_logout_count'] > 0)
			echo $result_fields['usr_forced_logout_count']." user(s) are forced to logout before account deletion. \n";
			
		echo $result_fields['usr_deleted_count']." user(s) records are deleted.\n"; 

	}else{
		echo "Unknown";
	}
	
}
else if (strcasecmp($functionName, "checkUserStatus") == 0){
	// checking
	if (!isset($username)){
		echo "ERROR: Username cannot be empty\n";
		exit();
	}
	
	$result_fields = array();
	
	$result_fields = $myfsapi->checkUserStatus($username, 1);
	
	if (count($result_fields) >0){
		// Output
		echo  "Checking List: ".$username." \n";
		
		if($result_fields['online_count'] >0){
			echo $result_fields['online_count']." user(s) online. (".$result_fields['online_usr_str'].") \n";
		}
		
		if($result_fields['offline_count'] >0){
			echo $result_fields['offline_count']." user(s) offline. (".$result_fields['offline_usr_str'].") \n";
		}
		
		if($result_fields['not_exist_count'] >0){
			echo $result_fields['not_exist_count']." user(s) not exist. (".$result_fields['not_exist_str'].") \n";
		}

	}else{
		echo "Unknown";
	}
	
}
else if (strcasecmp($functionName, "addUser") == 0){

	// wont be insert when add user 
	// accumbw, accumbwul, accumbwsha, siteid, ibmsg_glo, ibmsg_per

	$validFieldNameArr = array("macasusr", "timeleft", "btul", "btdl", "bwquota", "attempt", "logins", "sdate", "edate", "bwcount", "eminutes", "startmod", "status", "auto_del", "bwrmethod", "bwrperiod", "lastrbw", "bwrdate", "bwcountul", "bwquotaul", "pagenum", "acl", "reqsignup", "roption", "rsdate", "redate", "weeksch", "resetopt", "macmap", "ipmap", "bwcountsha", "bwquotasha" );

	// 20090708 - Set field type
	$bFieldNumeric = array();
	$bFieldNumeric['macasusr'] = 0;
	$bFieldNumeric['timeleft'] = 1;
	$bFieldNumeric['btul'] = 1;
	$bFieldNumeric['btdl'] = 1;
	$bFieldNumeric['bwquota'] = 1;
	$bFieldNumeric['attempt'] = 1;
	$bFieldNumeric['logins'] = 1;
	$bFieldNumeric['sdate'] = 0;
	$bFieldNumeric['edate'] = 0;
	$bFieldNumeric['bwcount'] = 1;
	$bFieldNumeric['eminutes'] = 1;
	$bFieldNumeric['startmod'] = 1;
	$bFieldNumeric['status'] = 1;
	$bFieldNumeric['auto_del'] = 1;
	$bFieldNumeric['bwrmethod'] = 0;
	$bFieldNumeric['bwrperiod'] = 1;
	$bFieldNumeric['lastrbw'] = 1;
	$bFieldNumeric['bwrdate'] = 1;
	$bFieldNumeric['bwcountul'] = 1;
	$bFieldNumeric['bwquotaul'] = 1;
	$bFieldNumeric['pagenum'] = 1;
	$bFieldNumeric['acl'] = 0;
	$bFieldNumeric['reqsignup'] = 0;
	$bFieldNumeric['roption'] = 1;
	$bFieldNumeric['rsdate'] = 0;
	$bFieldNumeric['redate'] = 0;
	$bFieldNumeric['weeksch'] = 1;
	$bFieldNumeric['resetopt'] = 1;
	$bFieldNumeric['macmap'] = 1;
	$bFieldNumeric['ipmap'] = 1;
	$bFieldNumeric['bwcountsha'] = 1;
	$bFieldNumeric['bwquotasha'] = 1;

	// checking
	if ($isRadius){
		echo "ERROR: Not Support RADIUS \n";
		exit();
	}
	if (strcasecmp($is_anon, "on") == 0 && strcasecmp($secret_enable, "on") == 0){
		echo "ERROR: Not Support Shared Secret \n";
		exit();
	}
	if (strcasecmp($is_anon, "on") == 0){
		echo "ERROR: Not Support Anonymous\n";
		exit();
	}
	if (!isset($username)){
		echo "ERROR: Username cannot be empty\n";
		exit();
	}
	if (!isset($password)){
		echo "ERROR: Password cannot be empty\n";
		exit();
	}
	// if (count($fields) <= 0){
		// echo "ERROR: Please input valid attribute(s) which want to be updated \n";
		// exit();
	// }	
	foreach ($fields as $key => $v){
		if (!in_array(strtolower($key), $validFieldNameArr)){
			// not valid field
			sort ($validFieldNameArr);
			echo "ERROR: Please input valid attribute(s) [".implode(",",$validFieldNameArr)."] which want to be updated \n";
			exit();
		}
		
		// checking value
		if (strcasecmp($key, "edate") == 0 || strcasecmp($key, "sdate") == 0){
			// checking format: mm-dd-yyyy hh:mm
			
			if (!(check_date($v))){
				echo "ERROR: Please input valid [".$key."] format (mm-dd-yyyy hh:mm)\n";
				exit();
			}
			else{
				list($date,$time)    = explode(" ", $v);
				$fields[$key] = datetime_from_php($date, $time);
			}
		}
		else if (strcasecmp($key, "bwquotaul") == 0 || strcasecmp($key, "bwquota") == 0 || strcasecmp($key, "bwquotasha") == 0){
			if (strlen($v) == 0 || $v == null || $v == "" || $v <=0){
				echo "ERROR: Please input valid [".$key."] (quota must greater than zero)\n";
				exit();
			}
		}
		else if (strcasecmp($key, "rsdate") == 0 || strcasecmp($key, "redate") == 0){
			if (!(check_time($v))){
				echo "ERROR: Please input valid [".$key."] format (hh:mm)\n";
				exit();
			}
		}
		else if (strcasecmp($key, "macasusr") == 0 || strcasecmp($key, "acl") == 0 || strcasecmp($key, "reqsignup") == 0){
			// Y, N, NULL, <empry string>
			if (!(strtoupper($v) == "Y" || strtoupper($v) == "N" || strtoupper($v) == "NULL" || $v == "")){
				echo "ERROR: Please input valid [".$key."] (Y or N)\n";
				exit();
			}
		}
		else if (strcasecmp($key, "auto_del") == 0 || strcasecmp($key, "resetopt") == 0 || strcasecmp($key, "roption") == 0 || strcasecmp($key, "ipmap") == 0 || strcasecmp($key, "status") == 0){
			// 1, 0, NULL, <empty string>
			if (!($v == "1" || $v == "0" || $v == "NULL" || $v == "")){
				echo "ERROR: Please input valid [".$key."] (1 or 0)\n";
				exit();
			}
		}
		else if (strcasecmp($key, "timeleft") == 0 || strcasecmp($key, "eminutes") == 0 || strcasecmp($key, "logins") == 0 ){
			// numeric format, NULL, <empty string>
			if (!is_numeric($v) && $v != "NULL" && $v != ""){
				echo "ERROR: Please input valid [".$key."] (integer value or NULL)\n";
				exit();
			}
		}
		else if (strcasecmp($key, "btul") == 0 || strcasecmp($key, "btdl") == 0 || strcasecmp($key, "attempt") == 0 || strcasecmp($key, "bwcount") == 0 || strcasecmp($key, "startmod") == 0 || strcasecmp($key, "bwrperiod") == 0 || strcasecmp($key, "lastrbw") == 0 || strcasecmp($key, "bwrdate") == 0 || strcasecmp($key, "bwcountul") == 0 || strcasecmp($key, "pagenum") == 0 || strcasecmp($key, "weeksch") == 0 || strcasecmp($key, "bwcountsha") == 0){
			// other numeric format
			if (!is_numeric($v)){
				echo "ERROR: Please input valid [".$key."] (integer value)\n";
				exit();
			}
		}
		else if (strcasecmp($key, "bwrmethod") == 0){
			// disable, month, day, NULL, <empty string>
			if (!($v == "disable" || $v == "month" || $v == "day" || $v == "NULL" || $v == "")){
				echo "ERROR: Please input valid [".$key."] (disable or month or day or NULL)\n";
				exit();
			}
		}
		else if (strcasecmp($key, "macmap") == 0){
			// 2, 1, 0, NULL, <empty string>
			if (!($v == "2" || $v == "0" || $v == "0" || $v == "NULL" || $v == "")){
				echo "ERROR: Please input valid [".$key."] (2 or 1 or 0)\n";
				exit();
			}
		}
	}
	
	// other checking
	if (isset($fields['bwrmethod'])){
		if (strcasecmp($fields['bwrmethod'], "day") == 0 || strcasecmp($fields['bwrmethod'], "month") == 0){
			if (!(isset($fields['bwrperiod']) && $fields['bwrperiod'] > 0)){
				echo "ERROR: Please input valid bwrperiod (integer value) when using reset data transfer counter (".$fields['bwrmethod'].")\n";
				exit();
			}
		}
		if (strcasecmp($fields['bwrmethod'], "month") == 0){
			if (!(isset($fields['bwrdate']) && $fields['bwrdate'] > 0 && $fields['bwrdate']  <= 31)){
				echo "ERROR: Please input valid bwrdate ( >0 and <= 31 ) when using reset data transfer counter (month)\n";
				exit();
			}
		}
	}
	
	if (isset($fields['macasusr']) && strcasecmp($fields['macasusr'], "y") == 0){
		if (!check_mac($username) && !check_ip($username)){
				echo "ERROR: Please input valid username (Format: XX-XX-XX-XX-XX-XX <MAC> or XXX.XXX.XXX.XXX <IP 0-254>)when using (Mac as username or IP as username or Passive login)  \n";
				exit();
			}
	}
	
	if ($password == ""){
		if (isset($fields['macasusr']) && strcasecmp($fields['macasusr'], "y") == 0){
			// passive login
			// before already check 
		}
		else{
			echo "ERROR: Password cannot be blank\n";
			exit();
		}
	}
	
	$result = $myfsapi->addUser($username, $password, $fields, $bFieldNumeric);
	
	switch($result){
		case 0:{
			echo "ERROR: Fail to Insert";
		}break;
		case 1:{
			echo "Success";
		}break;
		case 2:{
			echo "ERROR: User already exist";
		}break;
		case 3:{
			echo "Success"; // with info
		}
		default:{
			echo "Unknown";
		}break;
	}
	
}
else{
	echo "ERROR: Function not found\n";
}

?>
