<?php
class db {
  var $myDB;
  var $dsn;
  var $dsn_file;
  
  function db()
  {
	$settingobj = new COM("EGCONFIG.Cfgmgr") or die("transaction.php EGCONFIG.Cfgmgr Object cannot be created!");
	$use_radius = $settingobj->getKey( "use_radius", "radius");
	$this->dsn_file = "";
    if( strtolower($use_radius)== "true" ){
        $this->dsn_file=$settingobj->getKey( "Datasource", "radius");
    }else{
        $this->dsn_file=$settingobj->getKey( "Datasource", "gateway");
    }
    //$settingobj->Release();
    $settingobj=null;

    $dsn_source=fopen($this->dsn_file, "r") or die("Cannot open DSN source file!");

    // prepare dsn string for ODBC connection
    $this->dsn="";

    if(!feof($dsn_source))
      $line=fgets($dsn_source,512);

    // read in each line
    while(!feof($dsn_source)) {
      $line=fgets($dsn_source,512);
      if(trim($line)!="")
        $this->dsn=$this->dsn.$line;
    }
	
	fclose($dsn_source);

    // replace newline with semicolon
    $this->dsn=str_replace("\r\n",";",$this->dsn);
    
    // connect with ODBC
    $this->myDB=odbc_connect($this->dsn,"","");
  }

  function query($q)   //return the result array of required query, $q
  {
    // connect with ODBC
    //$this->myDB=odbc_connect($this->dsn,"","");

    // connected
    if($this->myDB)
      $result=odbc_exec($this->myDB,$q);
    else {
	  $this->myDB=odbc_connect($this->dsn,"","");
	  if($this->myDB)
	    $result=odbc_exec($this->myDB,$q);
	  else
        return false;
	}
 
    return $result;
  }

  function close()
  {
    odbc_close($this->myDB);
  }

	// 20090708 - Add field type checking to determine whether value need quoting in SQL
	function update($table, $fields, $clause, $bFieldNumeric)
	{
    $q = null;
    if (count($fields) > 0) {
      $q = "UPDATE $table SET ";
      foreach ($fields as $key => $value)
				if (strlen($value) > 0 || $value != NULL) {
					if ($bFieldNumeric[$key]) {
						$q .= "$key = $value, ";
					} else {
						$q .= "$key = '$value', ";
					}
				} else {
					$q .= "$key = NULL, ";
				}

      $q = substr($q, 0, strlen($q) - 2);  //trim the ending comma
      $q .= " $clause";
    }
    
    if ($q != null)
      $result = $this->query($q);
    //echo $q;
    return $result;
  }

	// 20090708 - Add field type checking to determine whether value need quoting in SQL
	function insert($table, $fields, $bFieldNumeric)
	{
    $fields_name = "";
    $fields_value = "";

    foreach ($fields as $key => $value) {
      $fields_name .= $key.", ";
      
			if (strlen($value) > 0 || $value != NULL) {
				if ($bFieldNumeric[$key]) {
					$fields_value .= "$value, ";
				} else {
					$fields_value .= "'$value', ";
				}
			} else {
				$fields_value .= "NULL, ";
			}
    }
    
    if ($fields_name != "")
      $fields_name = substr($fields_name, 0, strlen($fields_name) - 2);

    if ($fields_value != "")
      $fields_value = substr($fields_value, 0, strlen($fields_value) - 2);

    $q = "INSERT INTO $table ($fields_name) VALUES ($fields_value)";
    //echo $q;
    $result = db::query($q);
    
    return $result;
  }

  function isexists($table, $clause)
  {
    
    $q = "SELECT * FROM $table WHERE $clause";
    $result = db::query($q);
    
    if($result)
      if( odbc_fetch_row($result) )
        return true;

    return false;
  }

  function get_usr_table()
  {
    $settingobj = new COM("EGCONFIG.Cfgmgr") or die("common_functions.php EGCONFIG.Cfgmgr Object cannot be created!");
    $use_radius = $settingobj->getKey( "use_radius", "radius");
    if( strtolower($use_radius)== "true" ){
        $usr_table = $settingobj->getKey( "Datasource_Tablename", "radius");
    }else{
        $usr_table = $settingobj->getKey( "Datasource_Tablename", "gateway");
    }
    //release COM object
    //$settingobj->Release();
    $settingobj=null;

    return $usr_table;
  }

  function get_plan_table()
  {
    $settingobj = new COM("EGCONFIG.Cfgmgr") or die("common_functions.php EGCONFIG.Cfgmgr Object cannot be created!");
    $plan_table=$settingobj->getKey( "Datasource_Plans_Tablename", "gateway");
    //release COM object
    //$settingobj->Release();
    $settingobj=null;

    return $plan_table;
  }

  function get_transaction_table()    //return PayPal table name from config.ini
  {
    $settingobj = new COM("EGCONFIG.Cfgmgr") or die("common_functions.php EGCONFIG.Cfgmgr Object cannot be created!");
    $transaction_table=$settingobj->getKey( "Datasource_PayPal_Table", "gateway");
    //release COM object
    //$settingobj->Release();
    $settingobj=null;

    return $transaction_table;
  }
  
  function changeDsnFile($new_dsn_file)
  {	
	$this->dsn_file = $new_dsn_file;

    $dsn_source=fopen($this->dsn_file, "r") or die("Cannot open DSN source file!");

    // prepare dsn string for ODBC connection
    $this->dsn="";

    if(!feof($dsn_source))
      $line=fgets($dsn_source,512);

    // read in each line
    while(!feof($dsn_source)) {
      $line=fgets($dsn_source,512);
      if(trim($line)!="")
        $this->dsn=$this->dsn.$line;
    }
	
	fclose($dsn_source);

    // replace newline with semicolon
    $this->dsn=str_replace("\r\n",";",$this->dsn);
	
	// close connection whcih created before
	odbc_close($this->myDB);
    
    // connect with ODBC
    $this->myDB=odbc_connect($this->dsn,"","");
  }
}
?>
