<?
// 20080317 - Create this file to handle the showing of DHCP lease status in DHCP tab
include_once("..\\authserv\\common_functions.php");
include_once("cmvar.php");

// Create COM object and obtain the filename which stores DHCP lease status
$settingObj = new COM("EGCONFIG.Cfgmgr") or die("dhcp_status.php EGCONFIG.Cfgmgr Object cannot be created!");
$dhcpPath = $settingObj->getKey("dhcppath", "gateway");
$dhcpFp = fopen($dhcpPath, "r") or die ("Cannot open DHCP status file!");
?>

<html>
<head>
    <title>DHCP Status</title>
    <style type="text/css">
	<!--
	table {font-family:Arial, sans-serif; font-size:10pt;}
	-->
    </style>
</head>

<body>
    <script type="text/javascript" src="./javascript/loadingBox.js"></script>
    <table width="100%" border="0" cellspacing="0" cellpadding="0">
	<tr>
	    <td width="20%" valign="top"><b><?=get_cm_var('setcfg_dhcp_status_mac')?></b></td>
	    <td width="15%" valign="top"><b><?=get_cm_var('setcfg_dhcp_status_ip')?></b></td>
	    <td width="20%" valign="top"><b><?=get_cm_var('setcfg_dhcp_status_hname')?></b></td>
	    <td width="15%" valign="top"><b><?=get_cm_var('setcfg_dhcp_status_type')?></b></td>
	    <td width="25%" valign="top"><b><?=get_cm_var('setcfg_dhcp_status_expire')?></b></td>
	</tr>

<?
// Read file content
if ($dhcpFp) {
    $fUnknownMac = false;
    $iColumn = 0;
    $sHostName = '';
    $sIp = '';
    $sLeaseDate = '';
    $sLeaseType = '';
    $sMac = '';

    while (!feof($dhcpFp)) {
	$buf = fgets($dhcpFp, 128);

	// Process useful data and print out line by line
	if (strlen($buf) > 19 && $buf[0] == '[' && $buf[18] == ']') {
	    // Handle MAC string
	    $iColumn = 1;
	    if (strstr($buf, "UNKNOWN") != false) {
		$fUnknownMac = true;
		$sMac = '<td width="20%">Unknown</td>';
	    } else {
		$fUnknownMac = false;
		$sMac = '<td width="20%">'.substr($buf, 1, 17).'</td>';
	    }
	} elseif ($iColumn == 1 && strlen($buf) > 6 && strncmp($buf, "IPADDR", 6) == 0) {
	    // Handle IP string
	    $iColumn = 2;
	    $tmpIp = explode('=', $buf, 2);
	    $sIp = '<td width="15%">'.substr($tmpIp[1], 0, -2).'</td>';
	} elseif ($iColumn == 2 && strlen($buf) > 9 && strncmp($buf, "LeaseType", 9) == 0) {
	    // Handle lease type
	    $iColumn = 3;
	    if ($fUnknownMac) {
		$sLeaseType = '<td width="15%"></td>';
	    } else {
		$tmpLeaseType = explode('=', $buf, 2);
		$sLeaseType = '<td width="15%">'.substr($tmpLeaseType[1], 0, -2).'</td>';
	    }
	} elseif ($iColumn == 3 && strlen($buf) > 8 && strncmp($buf, "HostName", 8) == 0) {
	    // Handle host name
	    $iColumn = 4;
	    if ($fUnknownMac) {
		$sHostName = '<td width="20%"></td>';
	    } else {
		$tmpHostName = explode('=', $buf, 2);
		$sHostName = '<td width="20%">'.substr($tmpHostName[1], 0, -2).'</td>';
	    }
	} elseif ($iColumn == 4 && strlen($buf) > 10 && strncmp($buf, "AutoConfig", 10) == 0) {
	    // Handle lease string
	    if (!$fUnknownMac) {
		$timeStr = strtotime(substr($buf, 11, strlen($buf)-13));
		$sLeaseDate = '<td width="25%">'.strftime("%a %b %d %H:%M:%S %Y", $timeStr).'</td>';
	    }
	    echo '
	<tr>'.$sMac.$sIp.$sHostName.$sLeaseType.$sLeaseDate.'</tr>
	    ';
	    $iColumn = 0;
	}
    }
}
?>

    </table>
    <script type="text/javascript">CallParentLoadingBox(false, false);</script>
</body>
</html>

<?
// Close file and release COM object
fclose($dhcpFp);
$settingObj = null;
?>
