<?php

/****************************************************************************
**
** Warning : This file is used by EaseGate API (egapi.exe). Please do not modify.
**
*****************************************************************************/

include_once "..\\cfgmgr\\db_access.php";
include_once '..\\authserv\\common_functions.php';

class fsAPI{

var $usr_table;
var $myDB;

function fsAPI() {
	$this->myDB = new db();
	$this->usr_table = $this->myDB->get_usr_table();
	
	$settingObj = new COM("EGCONFIG.Cfgmgr") or die("dropinQuota.php EGCONFIG.Cfgmgr Object cannot be created!");
	
	$this->session_handling = $settingObj->getKey('session_handling', 'gateway');
	$this->passive_login_mode = $settingObj->getKey('passive_login_mode', 'gateway');
		
	$settingObj=null;
	
}

function queryLoginDuration($username="")
{
	$fields = array();
	
	$cond1="";
	if (isset($username) && strcmp($username, "") != 0){
		$cond1= " AND name ='".$username."'";
	}
	
	$q="SELECT name, reserved2 FROM $this->usr_table WHERE reserved1 IS NOT NULL".$cond1." ORDER BY NAME";
	
	$result=$this->myDB->query($q);
	
    while (odbc_fetch_row($result)) 
    {
		$logintime=odbc_result($result,"reserved2"); // login time
		$name=odbc_result($result,"name");
		
		$fields[$name]['name'] = $name;
		$tmpCalDurStr = calculateDuration($logintime);
		list($timeDiff, $duration) = explode('|', $tmpCalDurStr);
		$fields[$name]['duration'] = $duration;
	}
	
	//$this->myDB->close();
	return $fields;
}

function queryCurrentDataTransfer($username="")
{
	$fields = array();
	
	$myobj = new COM('FSAUTH.Authserv') or die('info.php FSAUTH.Authserv object cannot be created!');
	
	$cond1="";
	if (isset($username) && strcmp($username, "") != 0){
		$cond1= " AND name ='".$username."'";
	}
	
	$q="SELECT name, reserved1, bwcount, bwcountUL, bwcountSHA FROM $this->usr_table WHERE reserved1 IS NOT NULL".$cond1." ORDER BY NAME";
	
	$result=$this->myDB->query($q);
	
    while (odbc_fetch_row($result)) 
    {
		$name=odbc_result($result,"name");
		$macOrIp=odbc_result($result,"reserved1");
		$bwcountDL=odbc_result($result,"bwcount");
		$bwcountUL=odbc_result($result,"bwcountUL");
		$bwcountSHA=odbc_result($result,"bwcountSHA");
		
		$fields[$name]['name'] = $name;
		
		$bwUseDL = 0;
		$bwUseUL = 0;
		$bwUseSHA = 0;		
		
		$bwUseAll=$myobj->QueryBW($macOrIp);
		list($bwUseDL, $bwUseUL,$bwUseSHA) = split('[,]', $bwUseAll);
		
		if ($bwcountSHA == 1 || $bwcountSHA==2){
			$bwUseSHA = $bwUseSHA."KB";
			$fields[$name]['bwUseSHA'] = $bwUseSHA;
			
			$bwUseDL = $bwUseDL."KB";
			$bwUseUL = $bwUseUL."KB";
			
			$fields[$name]['bwUseDL'] = $bwUseDL;
			$fields[$name]['bwUseUL'] = $bwUseUL;
		}
		else{
			if ($bwcountDL == 1||$bwcountDL == 2){
				$bwUseDL = $bwUseDL."KB";
			}
			else{
				if ($bwcountDL == "" && $bwUseDL > 0){
					// using global setting
					$bwUseDL = $bwUseDL."KB";
				}
				else
					$bwUseDL = "NA";
			}
			
			if ($bwcountUL == 1||$bwcountUL == 2){
				$bwUseUL = $bwUseUL."KB";
			}
			else{
				if ($bwcountUL == "" && $bwUseUL > 0){
					// using global setting
					$bwUseUL = $bwUseUL."KB";
				}
				else
					$bwUseUL = "NA";
			}
			$fields[$name]['bwUseDL'] = $bwUseDL;
			$fields[$name]['bwUseUL'] = $bwUseUL;
		}
	}
	$myobj=null;
	
	//$this->myDB->close();
	return $fields;
}

// supportLiveUpdate = 0: not support live update, 1:support live update
// return = 0: fail to update, 1: success, 2: user does not  exist, 3: fail to update by (user is online), 4: fail to update by (other site)
function resetQuota($username="", $supportLiveUpdate=1)
{
	$settingObj = new COM("EGCONFIG.Cfgmgr") or die("dropinQuota.php EGCONFIG.Cfgmgr Object cannot be created!");
	$global_bwcountUL = $settingObj->getKey( "bwcount_ul", "DataTransfer");
	$global_bwcountDL = $settingObj->getKey( "bwcount_dl", "DataTransfer");
	$fs_status=$settingObj->queryService();
	$settingObj = null;
	
	$revCond="";
	if ($supportLiveUpdate == 0){
		$revCond=" AND reserved1 IS NULL";
	}
	
	$rs = $this->myDB->query("SELECT pwd as pw, reserved1, MACasUsr FROM $this->usr_table WHERE name = '$username';");
	
	if(odbc_fetch_row($rs)){
		if(odbc_result($rs,"reserved1") != null && $supportLiveUpdate == 0)
			return 3;
	}
	else{
		// user does not exist
		return 2;
	}
			
	$mac=odbc_result($rs,"reserved1");
	
	// * data transfer allow sha or (dl or ul or both)
	
	// if Data Transfer (Total) is set, then reset all data transfer quota (dl, ul, sha)
	$this->myDB->query("UPDATE $this->usr_table SET accumbwul = NULL, accumbw = NULL, accumbwsha = NULL WHERE name='$username' AND bwcountsha=2".$revCond);
	// 20090422 - Replace operator "not equal to" with "<>" type (DBF does not accept "!=")
	// if Data Transfer (Upload ) is set or global upload quota is set, then reset all data transfer quota (ul, sha)
	if ($global_bwcountUL == "2")
		$this->myDB->query("UPDATE $this->usr_table SET accumbwul = NULL, accumbwsha = NULL  WHERE name = '$username' AND (bwcountul = 2 OR bwcountul IS NULL OR bwcountul = -1) AND (bwcountsha IS NULL OR (bwcountsha<>1 AND bwcountsha<>2))".$revCond);
	else
		$this->myDB->query("UPDATE $this->usr_table SET accumbwul = NULL, accumbwsha = NULL WHERE name = '$username' AND bwcountul = 2 AND (bwcountsha IS NULL OR (bwcountsha<>1 AND bwcountsha<>2))".$revCond);
	
	// if Data Transfer (Download ) is set or global download quota is set, then reset all data transfer quota (dl, sha)
	if ($global_bwcountDL == "2")
		$this->myDB->query("UPDATE $this->usr_table SET accumbw = NULL, accumbwsha = NULL WHERE name = '$username' AND (bwcount = 2 OR bwcount IS NULL OR bwcount = -1) AND (bwcountsha IS NULL OR (bwcountsha<>1 AND bwcountsha<>2))".$revCond);
	else
		$this->myDB->query("UPDATE $this->usr_table SET accumbw = NULL, accumbwsha = NULL WHERE name = '$username' AND bwcount = 2 AND (bwcountsha IS NULL OR (bwcountsha<>1 AND bwcountsha<>2))".$revCond);
		
	if ( $fs_status=="STARTED"){
		$myObj = new COM('EGAUTH.Authserv') or die('transaction.php EGAUTH.Authserv Object cannot be created!');
		if ($supportLiveUpdate == 1 && isset($mac) && $mac!="" ){
			$objresult = $myObj->UpdateBWcount($mac, 1);
		}
		// passive login
		if (strcasecmp(odbc_result($rs,"MACasUsr") ,"y") == 0 && (odbc_result($rs,"pw") == null || odbc_result($rs,"pw") == "")){
			$objresult = $myObj->QueryPassiveLogin();
		}
		$myObj=null;
	}

	return 1;
}

// userString foramt: name1,XXX2,XXX3
// * already logged out user and not exist user also count in success
/* return array (
	usr_forced_logout_count: number of forced logout user
	success_usr_str: forced logout user string
	fail_usr_str: failed user string
	result = 1: success, 2: Fail by EaseGate is stopped
)*/
function disconnectUser($userString)
{

	$fields = array();
	
	// Handle escape chars
	if (get_magic_quotes_gpc()) {
		if (isset($userString)) {
			$userString = stripslashes($userString);
		}
	}

    $arrUserToForcelogout = explode(',', $userString);
    
    $ForcelogoutString=""; // all site
    $current_ForcelogoutString=""; // current site
    $Other_Site_ForcelogoutString=""; // other site
    $Bw_Rule_User_ForcelogoutString=""; // bw rule user 
    
    //print_r($arrUserToForcelogout);
    
    // sorting , for current site's user logout first, then another site
    foreach($arrUserToForcelogout as $val){
	    $arr = explode('|', $val);
	    if (isset($arr[1]) && $arr[1] !=""){
			if ($arr[1] == "BWRuleUsr"){
				if ($Bw_Rule_User_ForcelogoutString != ""){
					$Bw_Rule_User_ForcelogoutString.=",";
				}
				$Bw_Rule_User_ForcelogoutString.=$arr[2];
			}
			else
			{
				if ($Other_Site_ForcelogoutString != ""){
					$Other_Site_ForcelogoutString.=",";
				}
				$Other_Site_ForcelogoutString.=$arr[0];
			}
	    }else{
		    if ($current_ForcelogoutString != ""){
			    $current_ForcelogoutString.=",";
		    }
		    $current_ForcelogoutString.=$arr[0];
	    }
    }
    
    if($current_ForcelogoutString !=""){
	    $ForcelogoutString.=$current_ForcelogoutString;
    }
    
    if($Other_Site_ForcelogoutString!=""){
	    if($current_ForcelogoutString!=""){
		    $ForcelogoutString.=",";
	    }
	    $ForcelogoutString.=$Other_Site_ForcelogoutString;
    }

	$settingObj = new COM("EGCONFIG.Cfgmgr") or die("deleteUser.php EGCONFIG.Cfgmgr Object cannot be created!");
	$fs_status=$settingObj->queryService();
	if ( $fs_status=="STARTED" ) { //can only disconnect user when EaseGate is started
		// create COM object
		$myObj = new COM('EGAUTH.Authserv') or die('transaction.php EGAUTH.Authserv Object cannot be created!');
		if ($ForcelogoutString !=""){
			$objrsult = $myObj->ForceLogout($ForcelogoutString);
		}
		// Special
		if ($Bw_Rule_User_ForcelogoutString != ""){
			$objrsult = $settingObj->RemoveBWRUserEntry($Bw_Rule_User_ForcelogoutString);
		}
		$myObj=null;
		
		// checking 
		$temp_chk_fields = array();
		$temp_chk_fields = $this->checkUserStatus($ForcelogoutString, 0); 
		
		$fields['usr_forced_logout_count'] = $temp_chk_fields['offline_count'];
		$fields['success_usr_str'] = $temp_chk_fields['offline_usr_str'];	
		$fields['fail_usr_str'] = $temp_chk_fields['online_usr_str'];
		$fields['result'] = 1;
	}
	else{
		$fields['result'] = 2;
		$fields['usr_forced_logout_count'] = 0;
	}
	$settingObj=null;
	
	return $fields;
}

// userString foramt: name1,XXX2,XXX3
// * 28-08-09 modify delete passive login user sequence: (disconnect user > delete user > run QueryPassiveLogin > remove entry directly from driver)
//  	Now not allow to delete passive login user when enable Load balancing and current state is Low priority
/* return array (
	usr_forced_logout_count: number of forced logout user
	usr_deleted_count: number of deleted user
	success_usr_str: deleted user string
	fail_usr_str: failed user string
)*/
function deleteUser($userString)
{

	$fields = array();

    $settingObj = new COM("EGCONFIG.Cfgmgr") or die("deleteUser.php EGCONFIG.Cfgmgr Object cannot be created!");
	$myObj=new COM("EGAUTH.Authserv") or die("deleteUser.php EGAUTH.Authserv Object cannot be created!");
		
	$forcelogoutCount = 0;
	$arrUserToDelete=explode(",",$userString);
	$fs_status=$settingObj->queryService();
	
	$temp_fields = array();
	$temp_fields = $this->checkUserStatus($userString, 0);
	
	if($temp_fields['online_count'] >0){
		$temp_logout_fields = array();
		$temp_logout_fields = $this->disconnectUser($temp_fields['online_usr_str']);
		if ($temp_logout_fields['result'] == 1)
			$forcelogoutCount = $temp_logout_fields['usr_forced_logout_count'];
	}
	
	// delete users
	foreach ($arrUserToDelete as $value) {
	
		$q="SELECT pwd as pw, MACasUsr FROM $this->usr_table WHERE name = '$value';";
			
		$rs=$this->myDB->query($q);
		
		if(odbc_fetch_row($rs)){
			$macasUsr = odbc_result($rs,"MACasUsr");
			$pw = odbc_result($rs,"pw");
			
			if (strcasecmp($macasUsr,"y") == 0 && $pw == ""){
				// is passive login
				
				// prevent special case of some user which using other site, but that site can't force logout immediately
				$delQuery="DELETE FROM $this->usr_table WHERE name='$value' and reserved1 is null;";
				
				$delResult=$this->myDB->query($delQuery);
				
				if ( $fs_status=="STARTED" ) { //only run the following lines when EaseGate is started
				
					$macOrIp=0;
					
					if ($this->session_handling == 0){ // check MAC
						if ($this->check_mac($value) == true || $this->passive_login_mode == 1){
							$objrsult = $myObj->QueryPassiveLogin();
							$macOrIp = mac_address_translate($value);
							$myObj->RemoveDrvEntry($macOrIp);
						}
					}
					else{ // check IP
						if ($this->check_ip($value) == true || $this->passive_login_mode == 1){
							$objrsult = $myObj->QueryPassiveLogin();
							// since the bytes of this ip is inverted, we need to reformat it
							$ip = explode(".",$value);
							$IP_str=$ip[3].".".$ip[2].".".$ip[1].".".$ip[0];
							// Because PHP's integer type is signed, and many IP addresses will result in negative integers, you need to use the "%u" formatter of sprintf() or printf() to get the string representation of the unsigned IP address
							$macOrIp = sprintf("%u", ip2long($IP_str));
							$myObj->RemoveDrvEntry($macOrIp);
						}
						
					}
					
				}
			}
			else{
				// normal user
				// prevent special case of some user which using other site, but that site can't force logout immediately
				$delQuery="DELETE FROM $this->usr_table WHERE name='$value' and reserved1 is null;";
				
				$delResult=$this->myDB->query($delQuery);
			}
		}
	}
	
	$myObj=null;
	$settingObj=null;
	
	// checking 
	$temp_chk_fields = array();
	$temp_chk_fields = $this->checkUserStatus($userString, 1);
	
	$fields['usr_forced_logout_count'] = $forcelogoutCount;
	$fields['usr_deleted_count'] = $temp_chk_fields['not_exist_count'];
	$fields['success_usr_str'] = $temp_chk_fields['not_exist_str'];
	$temp_char="";
	if ($temp_chk_fields['online_count'] > 0 && $temp_chk_fields['offline_count'] >0)
		$temp_char=",";
		
	$fields['fail_usr_str'] = $temp_chk_fields['online_usr_str'].$temp_char.$temp_chk_fields['offline_usr_str'];

	return $fields;
}

// option = 0: return (online user string <* not online user will put into 'offline'>), 1: return (online, offline, not exist user string)
/* return array (
	online_count: number of online user
	online_usr_str: online user string
	offline_count: number of offline user
	offline_usr_str: offline user string
	not_exist_count: number of not exist user
	not_exist_str: not exist user string
)*/
function checkUserStatus($userString, $option=0)
{

	$fields = array();

	$arrUser=explode(",",$userString);

	if ($option == 1)
		$query="SELECT name, reserved1 FROM $this->usr_table ";
	else
		$query="SELECT name, reserved1 FROM $this->usr_table WHERE reserved1 IS NOT NULL";	
	
	$result=$this->myDB->query($query);

	$allusers=array();
	while( odbc_fetch_row($result) ) {
		$name=odbc_result($result,"name");
		$reserved1=odbc_result($result,"reserved1");
		$allusers[$name]['name']=$name;
		$allusers[$name]['reserved1']=$reserved1;
	}

	$online_count=0;
	$offline_count=0;
	$not_exist_count=0;
	$online_usr_str="";
	$offline_usr_str="";
	$not_exist_str="";

	foreach( $arrUser as $key => $name )
	{
		if( isset($allusers[$name]['name']) && strcasecmp($allusers[$name]['name'], $name) == 0) {
		
			if (isset($allusers[$name]['reserved1']) && $allusers[$name]['reserved1'] != "" && $allusers[$name]['reserved1'] !=null && $allusers[$name]['reserved1'] >0){
				// user is online
				if ($online_count >0)
					$online_usr_str.=",";
				$online_usr_str.=$name;
				$online_count++;
			}
			else{
				// user is offline 
				if ($offline_count >0)
					$offline_usr_str.=",";
				$offline_usr_str.=$name;
				$offline_count++;
			}
		}
		else{
			if ($option == 0){
				// not a online user
				if ($offline_count >0)
					$offline_usr_str.=",";
				$offline_usr_str.=$name;
				$offline_count++;
			}
			else{
			// user not exist
				if ($not_exist_count >0)
					$not_exist_str.=",";
				$not_exist_str.=$name;
				$not_exist_count++;
			}
		}
	}

	$fields['online_count']= $online_count;
	$fields['offline_count']= $offline_count;
	$fields['not_exist_count']= $not_exist_count;
	$fields['online_usr_str']= $online_usr_str;
	$fields['offline_usr_str']= $offline_usr_str;
	$fields['not_exist_str']= $not_exist_str;

	return $fields;
}

function __destruct(){
	if($this->myDB){
		$this->myDB->close();
	}
}

// 20100423 - Add bFromPlan
// 20090708 - Add bFieldNumeric
// fileds[key]: key must be in lower case
// flagResetBwCount = 1: reset data transfer quota of (reset corresponding data transfer by $fields<bwcountXX>) (mainly for shopping cart use)
// flagIntegrityCheck = 1: have data integrity check in update statement
// return = 0: fail to update, 1: success, 2: fail by (user does not exist), 3: fail by (other site), 4: success (with info)
// * during live update: timeleft not allow updated value less than orginal one, (except unlimit to limited value)
// *									data transfer quota only allow update when that counter = 2, ([Yes and disable...] option)
// * No validation checking on update data transfer counter (eg. behavior: only allow using total or (ul, dl or both) )
// 26-01-2010 add * during expiry month (emonth, eyear) is set, edate and eminutes will not be updated and set to NULL value (behavior: emonth, eyear is super seed edate and emintes)
function update_usr_attributes($username, $fields, $bFieldNumeric, $flagResetBwCount=0, $flagIntegrityCheck=1, $bFromPlan=0)
{
	$q="SELECT * FROM $this->usr_table WHERE name = '$username'";
	$result=$this->myDB->query($q);
	
	$userfields=array();

    if (odbc_fetch_row($result)) {
		// 20071204 - Round all numeric fields
		for ($i = 1; $i <= odbc_num_fields($result); $i++) {
			if ((strtolower(odbc_field_type($result, $i)) == "numeric" || strtolower(odbc_field_type($result, $i)) == "integer") && (odbc_result($result, $i) != NULL || strlen(odbc_result($result, $i)) > 0)) {
			$userfields[strtolower(odbc_field_name($result, $i))] = round(odbc_result($result, $i));
			} else {
			$userfields[strtolower(odbc_field_name($result, $i))] = odbc_result($result, $i);
			}
		}
    }else{
		// user does not exist
		return 2;
	}

	// init
	$newBwCountDl = "-2";
	$newBwCountUl = "-2";
	$newBwCountShare = "-2";
	
	// for checking the user is online
	$userMac = odbc_result($result, "reserved1");	
	if ($userMac == NULL) {
		$userMac = '';
	}
	
	// interpret the update field
	foreach($fields as $k => $v){

		if ($k == "bwquota" || $k == "bwquotaul" || $k == "bwquotasha"){
			if (strlen($fields[$k]) > 0 || $fields[$k] != NULL) {
				$fields[$k] = round($fields[$k]);
			} else {
				$fields[$k] = NULL;
			}
		}
		else if ($k == "bwcount"){
			$newBwCountDl = round($fields["bwcount"]);
			if ($v == -1)
				$fields["bwcount"] = "";
		}
		else if ($k == "bwcountul"){
			$newBwCountUl = round($fields["bwcountul"]);
			if ($v == -1)
				$fields["bwcountul"] = "";
		}
		else if ($k == "bwcountsha"){
			$newBwCountShare = round($fields["bwcountsha"]);
			if ($v == -1)
				$fields["bwcountsha"] = "";
		}
		else{
			// others
		}
		
	}

	$userBwCountDl = round(odbc_result($result, "bwcount"));
	$userBwCountUl = round(odbc_result($result, "bwcountul"));
	$userBwCountShare = round(odbc_result($result, "bwcountsha"));
	$userBwQuotaDl = round(odbc_result($result, "bwquota"));
	$userBwQuotaUl = round(odbc_result($result, "bwquotaul"));
	$userBwQuotaShare = round(odbc_result($result, "bwquotasha"));
	
	if ($userMac != "") {
		// user is online
		
		// check updated counter == orginal counter == 2 ([Yes and disable...] option)
		if (($newBwCountDl !="-2" && $newBwCountDl != 2) || $userBwCountDl != 2){
			$fields["bwquota"] = "unused";
		}
		
		if (($newBwCountUl !="-2" && $newBwCountUl != 2) || $userBwCountUl != 2){
			$fields["bwquotaul"] = "unused";
		}
		
		if (($newBwCountShare !="-2" && $newBwCountShare != 2) || $userBwCountShare != 2){
			$fields["bwquotasha"] = "unused";
		}
	}
	else{
		
		// * -1 or ""(empty string): using global setting, 0: disabled, 1: enabled, 2: enabled plus enforce 
		
		// if (updated data) not using [Yes and disable...] option, set quota to null value
		if ($newBwCountDl != "-2" && $newBwCountDl != 2) {
			$fields["bwquota"] = "";
		}
		// do not update quota when counter !=2
		else if (array_key_exists("bwquota", $fields) && strlen($fields["bwquota"]) > 0 && $fields["bwquota"] != NULL && $newBwCountDl == "-2" && $userBwCountDl != 2) {
			$fields["bwquota"] = "unused";
		}
		
		if ($newBwCountUl != "-2" && $newBwCountUl != 2) {
			$fields["bwquotaul"] = "";
		}
		// do not update quota when counter !=2
		else if (array_key_exists("bwquotaul", $fields) && strlen($fields["bwquotaul"]) > 0 && $fields["bwquotaul"] != NULL && $newBwCountUl == "-2" && $userBwCountUl != 2) {
			$fields["bwquotaul"] = "unused";
		}
		
		if ($newBwCountShare != "-2" && $newBwCountShare != 2) {
			$fields["bwquotasha"] = "";
		}
		// do not update quota when counter !=2
		else if (array_key_exists("bwquotasha", $fields) && strlen($fields["bwquotasha"]) > 0 && $fields["bwquotasha"] != NULL && $newBwCountShare == "-2" && $userBwCountShare != 2) {
			$fields["bwquotasha"] = "unused";
		}
		
		// set accumulative usage to null value, when it (updated data) is disabled (set [No] option) 
		if ($newBwCountDl != "-2" && $newBwCountDl == 0 ) {
			$fields["accumbw"] = "";
		}
		
		if ($newBwCountUl != "-2" && $newBwCountUl == 0 ) {
			$fields["accumbwul"] = "";
		}
		
		if ($newBwCountShare != "-2" && $newBwCountShare == 0 ) {
			$fields["accumbwsha"] = "";
		}
	
	}
	
	$fname_online_exclude = array ("accumbw", "bwcount", "accumbwul", "bwcountul", "accumbwsha", "bwcountsha", "ipmap");
	$fname_offline_exclude = array();

	$field_update = array();

	$file_exclude = array();
	
	if ($userMac!=""){
		// user is online
		$file_exclude = $fname_online_exclude;
	}
	else{
		$file_exclude = $fname_offline_exclude;
	}	
	
	foreach ($file_exclude as $fname) {
	  $fields[$fname] = "unused";
	}

	foreach ($fields as $key => $value) {
		if (strcmp("$value", "unused") != 0) {
			$field_update[$key] = $value;
		}
	}
	
	if ($flagIntegrityCheck == 1){
		//generate SQL clause for data integrity check
		$i = 0;
		$temp = array();
		foreach($userfields as $fname => $fvalue) {
			if (strlen($fvalue) > 0 || $fvalue != NULL) {
				if(is_numeric($fvalue) && $fname != "name" && $fname != "pwd" && $fname != "reserved1" &&
				   $fname != "bwrmethod" && $fname != "macasusr"
				   )
					$temp[$i] = "$fname = ".round($fvalue);
				else
					$temp[$i] = "$fname = '$fvalue'";
			} else{
				$temp[$i] = "$fname IS NULL";
			}

			$i++;
		}
		$clause = implode(" AND ", $temp);
		
	}
	else{
		$clause = "name = '$username'";
	}
	
	if (count($field_update) >0){
	
		// set quota to null value when counter != 2
		if ((array_key_exists("bwcount", $field_update) && $field_update["bwcount"] != 2) || (!array_key_exists("bwcount", $field_update) && $userBwCountDl != 2)) {
			$field_update["bwquota"] = "";
		}
		if ((array_key_exists("bwcountul", $field_update) && $field_update["bwcountul"] != 2) || (!array_key_exists("bwcountul", $field_update) && $userBwCountUl != 2)) {
			$field_update["bwquotaul"] = "";
		}
		if ((array_key_exists("bwcountsha", $field_update) && $field_update["bwcountsha"] != 2) || (!array_key_exists("bwcountsha", $field_update) && $userBwCountShare != 2)) {
			$field_update["bwquotasha"] = "";
		}
		
		$this->myDB->update($this->usr_table, $field_update, "WHERE $clause", $bFieldNumeric);
	}
	else{
		return 0;
	}

	// ----------Mainly for Shopping Cart Behavior-------
	// Save the unchanged quota value to reserved field for later restorage during online udpate
	if ($userMac != "") {
		if ($newBwCountDl != "-2" && $newBwCountDl != 2 && $userBwCountDl == 2) {
			$this->myDB->query("UPDATE $this->usr_table SET reserved13 = $userBwQuotaDl WHERE name = '$username' AND bwcount = 2");
		}
		if ($newBwCountUl != "-2" && $newBwCountUl != 2 && $userBwCountUl == 2) {
			$this->myDB->query("UPDATE $this->usr_table SET reserved14 = $userBwQuotaUl WHERE name = '$username' AND bwcountul = 2");
		}
		if ($newBwCountShare != "-2" && $newBwCountShare != 2 && $userBwCountShare == 2) {
			$this->myDB->query("UPDATE $this->usr_table SET reserved17 = $userBwQuotaShare WHERE name = '$username' AND bwcountsha = 2");
		}
	}
	
	// reset quota with corresponding updated counter
	if ($flagResetBwCount == "1") {
		if ($newBwCountDl == 2) {
			$this->myDB->query("UPDATE $this->usr_table SET accumbw = 0 WHERE name = '$username'");
		}
		if ($newBwCountUl == 2) {
			$this->myDB->query("UPDATE $this->usr_table SET accumbwul = 0 WHERE name = '$username'");
		}
		if ($newBwCountShare == 2) {
			$this->myDB->query("UPDATE $this->usr_table SET accumbwsha = 0 WHERE name = '$username'");
		}
	}
	
	// ----------END-------
	
	// check EaseGate status
    $settingObj = new COM("EGCONFIG.Cfgmgr") or die("editUser.php EGCONFIG.Cfgmgr Object cannot be created!");
    $fs_status = $settingObj->queryService();
	$settingObj = null;
	
	if ($fs_status=="STARTED" && $userMac !=""){
		$this->live_update($username, $flagResetBwCount, $bFromPlan);
	}
	
	//query passive login (when change to [passive login] type or orginal is [passive login] type)
	if ((strcasecmp($userfields['macasusr'],"y") == 0 || (isset($field_update['macasusr']) && strcasecmp($field_update['macasusr'],"y") == 0)) && 
		(( $userfields['pwd']=="") || array_key_exists("pwd",$field_update) && $field_update['pwd']=="")){	
		if ($fs_status=="STARTED") {
			// Run QueryPassiveLogin
			$myobj = new COM("EGAUTH.Authserv") or die("editUser.php EGAUTH.Authserv Object cannot be created!");
			$objrsult = $myobj->QueryPassiveLogin();
			$myobj=null;
			// $settingobj = new COM('EGCONFIG.Cfgmgr') or die;
			// $cmd = realpath("..\\");
			// $cmd .= "\\dispatcher\\QueryPassiveLogin.exe";
			// $settingobj->runCommand($cmd);
			// //$settingobj->Release();
			// $settingobj=null;
			
		}
	}
	return 1;
}

// 20100423 - Add bFromPlan
// 26-01-2010 add expiry month, which is super seed edate, so that it will ignore live update edate field when expiry month (emonth, eyear) is set
// return = 0: fail, 1: success, 2: fail by (EaseGate is stopped), 3: fail by (other site)
function live_update($username, $flagResetBwCount, $bFromPlan)
{
$updatedRet = 0;

$q="SELECT reserved1, reserved12, bwcount, bwcountul, bwcountsha, bwquota, bwquotaul, bwquotasha, accumbw, accumbwul, accumbwsha, btul, btdl FROM $this->usr_table WHERE name = '$username'";

$result=$this->myDB->query($q);
if(!odbc_fetch_row($result))
  return 0;

$mac = odbc_result($result, "reserved1");

// 20071213 - Round other fields also
// 20071212 - Bug fix for bwaccum variables
// 20071127 - Add bandwidth quota sharing related checking
$bwcount_ul = (odbc_result($result, "bwcountul") == ""? 0 : round(odbc_result($result, "bwcountul")));
$bwcount_dl = (odbc_result($result, "bwcount") == ""? 0 : round(odbc_result($result, "bwcount")));
$bwcount_share = (odbc_result($result, "bwcountsha") == ""? 0 : round(odbc_result($result, "bwcountsha")));
$bwquota_ul = (odbc_result($result, "bwquotaul") == ""? 0 : round(odbc_result($result, "bwquotaul")));
$bwquota_dl = (odbc_result($result, "bwquota") == ""? 0 : round(odbc_result($result, "bwquota")));
$bwquota_share = (odbc_result($result, "bwquotasha") == ""? 0 : round(odbc_result($result, "bwquotasha")));
$bwaccum_ul = (odbc_result($result, "accumbwul") == ""? 0 : round(odbc_result($result, "accumbwul")));
$bwaccum_dl = (odbc_result($result, "accumbw") == ""? 0 : round(odbc_result($result, "accumbw")));
$bwaccum_share = (odbc_result($result, "accumbwsha") == ""? 0 : round(odbc_result($result, "accumbwsha")));
$bwquota_ul -= $bwaccum_ul;
$bwquota_dl -= $bwaccum_dl;
$bwquota_share -= $bwaccum_share;

$throttle_ul = ( odbc_result($result, "btul")==""? -1 : round(odbc_result($result, "btul")) );
$throttle_dl = ( odbc_result($result, "btdl")==""? -1 : round(odbc_result($result, "btdl")) );

$settingObj = new COM('EGCONFIG.Cfgmgr') or die('transaction.php EGCONFIG.Cfgmgr Object cannot be created!');
$fs_status=$settingObj->queryService();
$settingObj = null;

// 20070925 - Modify condition and input parameters to perform data transfer quota update
if($mac != "") {
	if ($fs_status=="STARTED"){
		// 20071207 - Obtain config setting object here
		$myObj = new COM('EGAUTH.Authserv') or die('transaction.php EGAUTH.Authserv Object cannot be created!');

		// 20071127 - Add checking of bwcount_share
		// 20071004 - Remove quota conditions
		// update data transfer quota with reset current usage or not
		if ($bwcount_ul == 2 || $bwcount_dl == 2 || $bwcount_share == 2) {
			$objresult = $myObj->UpdateBWcount($mac, $flagResetBwCount);
			$updatedRet = 1;
		}
		
		$myObj = null;
	}
	else{
		// EaseGate is stopped
		$updatedRet = 2;
	}
}
else{
	// user is not online
}

return $updatedRet;
}

function writeLog($file, $log)
{
$fh = fopen($file, "a");

if ($fh) {
  flock($fh, LOCK_EX);
  fwrite($fh, $log."\r\n");
  flock($fh, LOCK_UN);
  fclose($fh);
}
}

// 20090708 - Add field type checking to determine whether value need quoting in SQL
// 08-03-2010 add * during expiry month (emonth, eyear) is set, edate and eminutes will be ignore and set to NULL value (behavior: emonth, eyear is super seed edate and emintes)
function addUser($username, $password, $fields, $bFieldNumeric)
{	
	$q="SELECT * FROM $this->usr_table WHERE name = '$username'";
	$result=$this->myDB->query($q);
	
	if (odbc_fetch_row($result)) {
		// user already exist
		return 2;
	}
	
	$field_name="";
	$field_value="";
	
	$field_name="name, pwd";
	if ($password==""){
		$pwd= "NULL";
		$field_value=" '$username', NULL ";
	}
	else{
		// encrypt password
		$pwd = $this->encryptPassword($password);
		$field_value=" '$username', '$pwd'";
	}
	
	$insertFields = array();
	
	foreach($fields as $k => $v){
		$insertFields[$k] = $v;
	}
	
	// interpret the update field
	foreach($insertFields as $k => $v){
		$field_name .= ", ".strtolower($k);
		if (strtoupper($v) == "NULL" || $v == ""){
			$field_value .=", NULL";
		}
		else if (strtoupper($v) == "Y" || strtoupper($v) == "N"){
			$field_value .=", '".strtoupper($v)."'";
		} elseif ($bFieldNumeric[$k]) {
			$field_value .= ", $v";
		} else {
			$field_value .= ", '$v'";
		}
	}

	$q="INSERT INTO $this->usr_table ($field_name) VALUES ($field_value); ";
	$result=$this->myDB->query($q);
	
	if ($result){
		// check EaseGate status
		$settingObj = new COM("EGCONFIG.Cfgmgr") or die("editUser.php EGCONFIG.Cfgmgr Object cannot be created!");
		$fs_status = $settingObj->queryService();
		$settingObj = null;

		//query passive login (when macasusr = y and pwd = null)
		if ((isset($insertFields['macasusr']) && strcasecmp($insertFields['macasusr'],"y") == 0) && ($password=="")){
			if ($fs_status=="STARTED") {
				// Run QueryPassiveLogin
				$myobj = new COM("EGAUTH.Authserv") or die("editUser.php EGAUTH.Authserv Object cannot be created!");
				$objrsult = $myobj->QueryPassiveLogin();
				$myobj=null;
			}
		}
		return 1;
	}
	else
		return 0;
}


// userString: one username or "*" (all user)
// optionFileds[key]: key must be forcedDisconnect, resetQuota
// forcedDisconnect = 1: before update user attributes, disconnect user first
// resetQuota = 1: after update user attributes, reset quota
/* return array (
	success_usr_str: user string which success to update
	success_count: number of user success to update
	fail_usr_str: user string which fail to update
	fail_count: number of user fail to update
	arr_result[name]: array of update_usr_attributes() result 
	result: update_usr_attributes() result, if userString is "*" (all user) return 5
)*/
function update_usr_attributes_with_opt($userString, $fields, $bFieldNumeric, $optionFileds = NULL)
{
	$result_fields = array();

	// option init
	$forcedDisconnect = 0;
	$resetQuota = 0; 
	// set option
	if ($optionFileds !=NULL){
		foreach ($optionFileds as $key => $v){
			if (strcasecmp($key, "forcedDisconnect") == 0 && strtoupper($v) == "Y"){
				$forcedDisconnect = 1;
			}
			else if (strcasecmp($key, "resetQuota") == 0 && strtoupper($v) == "Y"){
				$resetQuota = 1;
			}
		}
	}
	
	$usrUpdateList = array();
	
	$updateAllUser = false;
	
	$success_count = 0;
	$success_usrString = "";
	$fail_count = 0;
	$fail_usrString = "";
	$ret = 0;
	
	if ($userString == "*" ){
		// all user
		
		$updateAllUser = true;
		$ret = 5;
		
		$q="SELECT name FROM $this->usr_table ";
		$result=$this->myDB->query($q);
		
		$listCount = 0;
		
		while (odbc_fetch_row($result))
		{
			$name=odbc_result($result,"name");
			
			$usrUpdateList[$listCount]= $name;
			$listCount++;
		}
	}
	else{
		// one user
		$usrUpdateList[0]= $userString;
	}
	
	// process
	
	$arr_result = array();
	
	foreach($usrUpdateList as $v){
		if ($forcedDisconnect == 1){
			// checking user status
			$temp_chk_fields = array();
			$temp_chk_fields = $this->checkUserStatus($v, 1);
			
			if ($temp_chk_fields['online_count'] >= 1){ // user is online 
				// disconnect
				$ret_disconnect_fields = $this->disconnectUser($v);
			}
		}
		// update user attributes
		$ret_update = $this->update_usr_attributes($v, $fields, $bFieldNumeric);
		
		if ($ret_update == 1 ){ // success
			if ($resetQuota == 1){
				$ret_reset = $this->resetQuota($v, 1); // reset quota with live update
			}
			
			if ($success_count != 0)
				$success_usrString .= ",";
				
			$success_usrString .= $v;
			$success_count++;
		}
		else{
			// fail
			if ($fail_count != 0)
				$fail_usrString .= ",";
				
			$fail_usrString .= $v;
			$fail_count++;

		}
		
		$arr_result[$v] = $ret_update;
		
		if ($updateAllUser == false){
			$ret = $ret_update;
		}
	}
	
	$result_fields['success_usr_str'] = $success_usrString;
	$result_fields['success_count'] = $success_count;
	$result_fields['fail_usr_str'] = $fail_usrString;
	$result_fields['fail_count'] = $fail_count;
	$result_fields['arr_result'] = $arr_result;
	
	$result_fields['result'] = $ret;
	
	return $result_fields;
}


// copy from callAPI.php (checking format)
//							012345678901234567
// checking mac 	XX-XX-XX-XX-XX-XX
function check_mac($v){
	if (!(strpos($v,"-") == 2 && strpos($v,"-", 3) == 5 && strpos($v,"-", 6) ==  8 && strpos($v,"-", 9) == 11 && strpos($v,"-", 12) == 14)){
		return false;
	}
	return true;
}
// check ip XXX.XXX.XXX.XXX
function check_ip($v){

	$arr = Array();
	$arr = split("\.", $v);
	
	if (count($arr) == 4){
		if (!($arr[0] >= 0 && $arr[0] <255 && $arr[1] >= 0 && $arr[1] <255 && $arr[2] >= 0 && $arr[2] <255 && $arr[3] >= 0 && $arr[3] <255)){
			return false;
		}
	}
	else
		return false;
	
	return true;
}

function encryptPassword($password){
	$settingObj = new COM("EGCONFIG.Cfgmgr") or die("egAPI.php EGCONFIG.Cfgmgr Object cannot be created!");
	$pwd_offload=$settingObj->getKey('pwd_offload', 'gateway');
	$fs_path = $settingObj->getFsPath();
	$def_encrypt_path = $fs_path."dispatcher\\encrypt_pwd.exe";
	$cus_encrypt_path=$settingObj->getKey('encrypt_path', 'gateway');
	$version = $settingObj->getKey('version', 'version');    
	$settingObj = null;

	// encrypt password
	$encrypt_pwd="";
	$encrypt_path ="";

	// 20100503 - Bug fix (Miss checking version)
	if (strcasecmp($pwd_offload, "on") == 0 && (strtolower($version) == 'advanced' || strtolower($version) == 'premium')) {
		$encrypt_path = $cus_encrypt_path;
	}
	else
		$encrypt_path = $def_encrypt_path;
		
	$cmd = "\"".$encrypt_path."\" ".$password;
	
	$sys = new sysfunc();
	$encrypt_pwd = $sys->runCommand($cmd);
	$sys = null;
	
	return $encrypt_pwd;
}

function PHP_getKeyEx($key, $session, $file)
{
	$result ="";
	
	$fp = fopen($file,"r");
	
	if (!$fp) {
		// fail to open file
	}
	else{
		$isMatchSession = false;
		$isMatchKey = false;
		while ( !feof($fp) ) {
			$line = fgets($fp, 1024);
			
			$startSquarePos = stripos($line, "[");
			$endSquarePos = stripos($line, "]");
			
			if ($startSquarePos !== false && $endSquarePos !== false){
				// session
				
				if ($isMatchSession)
					break;
				
				$removeTagArr = array("[", "]", "\r\n");
				$curr_session = str_replace($removeTagArr, "", $line);
				if (strcmp($curr_session, $session) == 0){
					// match session
					$isMatchSession = true;
				}
				continue;
			}
			
			if ($isMatchSession){
				// check is it contain =
				if (strstr($line, "=") != NULL){
					list($current_key, $current_value) = explode('=', $line);
					// echo "current_key=".$current_key."\r\n";
					// echo "current_value=".$current_value."\r\n";
					if (strcmp($current_key, $key) == 0){
						// match key
						$isMatchKey = true;
						$result = str_replace("\r\n", "", $current_value);
						break;
					}
				}
			}
		}
		fclose($fp);
	}
	
	// echo "result=".$result."\r\n";
	
	return $result;
}

function PHP_setKeyEx($value, $key, $session, $file)
{
	$result = false;
	
	$fp = fopen($file,"r");
	
	if (!$fp) {
		// fail to open file
	}
	else{
		$content = "";
		$isMatchSession = false;
		$isMatchKey = false;
		while ( !feof($fp) ) {
			$line = fgets($fp, 1024);
			
			if ($isMatchKey){
				$content .= $line;
				continue;
			}
			
			$startSquarePos = stripos($line, "[");
			$endSquarePos = stripos($line, "]");
			
			if ($startSquarePos !== false && $endSquarePos !== false){
				// session
				
				if ($isMatchSession){
					$content .= $key."=".$value."\r\n";
					$isMatchKey = true;
					$content .= $line;
					continue;
				}
				
				$removeTagArr = array("[", "]", "\r\n");
				$curr_session = str_replace($removeTagArr, "", $line);
				if (strcmp($curr_session, $session) == 0){
					// match session
					$isMatchSession = true;
				}
				$content .= $line;
				continue;
			}
			
			if ($isMatchSession){
				// check is it contain =
				if (strstr($line, "=") != NULL){
					list($current_key, $current_value) = explode('=', $line);
					if (strcmp($current_key, $key) == 0){
						// match key
						$isMatchKey = true;
						// replace 
						$content .= $key."=".$value."\r\n";
						continue;
					}
				}
			}
			
			$content .= $line;
		}
		
		fclose($fp);
		
		if (!$isMatchSession){
			$content .= "[".$session."]\r\n";
			$content .= $key."=".$value."\r\n";
		}
		else if (!$isMatchKey){
			$content .= $key."=".$value."\r\n";
		}
		
		$fp2 = fopen($file,"w");
	
		if (!$fp2) {
			// fail to open file
		}
		else{
			if (fwrite($fp2,$content) !== false){
				$result = true;
			}
			fclose($fp2);
		}
	}
	
	// echo "result=".$result."\r\n";
	
	return $result;
}

}
?>
