<?php
/**
 *  EaseGate languague
 */

// specify the language file directory
//$langdir = "./lang/";

// initialize arrays
$lang_file = array();
$lang_attributes = array();
$available_lang = array();
$region = array();
$charset = array();

// create COM object
$settingobj = new COM("EGCONFIG.Cfgmgr") or die("language.php EGCONFIG.Cfgmgr Object cannot be created!");
$fs_path = $settingobj->getFsPath();
$langdir = $fs_path."authserv\\lang\\";
$usersettingdir = $fs_path."usersetting\\";

// 20090615 - Open buffer to ignore outputting byte order mark to browser
// include default language file first
$lang_file[] = $settingobj->getKey( "default_lang_file", "lang");
ob_start();
require_once $langdir.$lang_file[0];
// include lang pack file
$lang_pack_file = $settingobj->getKey( "lang_pack_file", "lang");
require_once $usersettingdir.$lang_pack_file;
ob_end_clean();

// get default language file attributes
$lang_attributes[] = $settingobj->getKey( "default_lang_file_attributes", "lang");

// skip interpret ; when string contain &#
$pos = 0;
while (1){
	$tmp_p1 = strpos($lang_attributes[0], "&#", $pos);
	if ($tmp_p1 !== false){
		// have
		$tmp_p2 = strpos($lang_attributes[0], ";", $tmp_p1);
		if ($tmp_p2 !== false)
			$pos = $tmp_p2+1;
		else
			break;
	}
	else 
		break;
}
$dla = explode(";",substr($lang_attributes[0], $pos));
$available_lang[] = substr($lang_attributes[0], 0, $pos).$dla[0];    // description

$region[] = explode(",",$dla[1]);   // regions
$charset[] = $dla[2];
$meta_charset = $dla[2]; // default charset
$show_charset = $settingobj->getKey( "show_charset", "lang");  // show charset toggle

// get the number of other language file
$lfnum = $settingobj->getKey( "lang_fileNumber", "lang");

// get attributes of other language file
if($lfnum) {
    for( $i=1; $i<=$lfnum; $i++ ) {
        $lang_file[] = $settingobj->getKey( "lang_file$i", "lang");
        $lang_attributes[] = $settingobj->getKey( "lang_file".$i."_attributes", "lang");
		// skip interpret ; when string contain &#
		$pos = 0;
		while (1){
			$tmp_p1 = strpos($lang_attributes[$i], "&#", $pos);
			if ($tmp_p1 !== false){
				// have
				$tmp_p2 = strpos($lang_attributes[$i], ";", $tmp_p1);
				if ($tmp_p2 !== false)
					$pos = $tmp_p2+1;
				else
					break;
			}
			else 
				break;
		}
		$ola = explode(";",substr($lang_attributes[$i], $pos));
		$available_lang[] = substr($lang_attributes[$i], 0, $pos).$ola[0];    // description
		
        $region[] = explode(",",$ola[1]);   // regions
        $charset[] = $ola[2];               // charset
    }
}

// release the COM object
//$settingobj->Release();
$settingobj=null;

// make sessions
if( isset($_SESSION["LANG"]) )
    $current_lang = $_SESSION["LANG"];
else {
    $current_lang = getBestLang();
    $_SESSION["LANG"] = $current_lang;
}
if( isset($_POST["EaseGateL"]) ) {
    $current_lang = $_POST["EaseGateL"];
    $_SESSION["LANG"] = $_POST["EaseGateL"];
}
// Multiple Languages  
if( isset($_SESSION["LANG"]) && $_SESSION["LANG"] ) {
	// 20090615 - Open buffer to ignore outputting byte order mark to browser
	ob_start();
	include_once $usersettingdir.$lang_file[$_SESSION["LANG"]];
	ob_end_clean();
    $meta_charset=$charset[$_SESSION["LANG"]];
}

// send header content types
// this avoid wrong character encoding for page missed the meta tag
if ($show_charset)
	header("Content-Type: text/html; charset=$meta_charset");

/**
 *  EaseGate language functions
 */

// Use this function to get language variable
function get_var($element)
{
    global $lang;

	// 20090615 - Add decoding step
	if (isset($lang[$element])) {
		return html_entity_decode($lang[$element], ENT_QUOTES);
	} else {
		return "";
	}
}

// 20080401 - Return string instead of echo
/**
 *  Output the language selection box
 *  So that users can choose available language
*/
function language_selection_box()
{
    global $lfnum,$current_lang,$available_lang;
    $retStr = '';
    
    if ($lfnum) {
        $i = 0;
        // use document.forms syntax for PocketPC compatibility. Don't use document.getElementByID
	$retStr = "
	    <form id=\"lang_form\" method=\"POST\">".get_var('language')."
		<select name=\"EaseGateL\" onchange=\"document.forms['lang_form'].submit();\">";

        foreach ($available_lang as $value) {
	    $retStr .= "
		    <option value=\"$i\"";

            if ($i == $current_lang) {
		$retStr .= " selected";
	    }
            $retStr .= ">$value";
            $i++;
        }
	$retStr .= "
		</select>
	    </form>";

	return $retStr;
    }
}

// 20080401 - Return string instead of echo
// output the character encoding set
function metaCharset()
{
    // 20090113 - For determining PayPal lc
    $_SESSION["REGION"] = $GLOBALS["region"][$_SESSION["LANG"]];

    if ($GLOBALS["show_charset"]) {
        return "<meta http-equiv=\"content-type\" content=\"text/html; charset=".$GLOBALS["meta_charset"]."\">";
    }
}

// This function will find out the best language
function getBestLang()
{
    $user_lang = array();

    // analysis header string, the @ sign is used to ignore error for client the does not have HTTP_ACCEPT_LANGUAGE header like PocketPC
    foreach( explode(";",@$_SERVER['HTTP_ACCEPT_LANGUAGE']) as $value )
        foreach( explode(",",$value) as $ivalue )
            if (strcmp(substr($ivalue, 0, 2),"q=") != 0)
                $user_lang[] = $ivalue;

    // compare user locate with regions
    foreach( $user_lang as $langvalue )
        foreach( $GLOBALS["region"] as $key => $value )
            foreach( $value as $ivalue )
				if (strcasecmp($ivalue, $langvalue) == 0) {
					return $key;
				}

    // return default language
    return 0;
}

?>
