<?php
// 20080325 - Refer this for alert messages
require_once "cmvar.php";

$ip = 0;
$internalPort = 0;
$externalPort = 0;
$proto = "";

if(isset($NAT_port_ip1) && isset($NAT_port_ip2) && isset($NAT_port_ip3) && isset($NAT_port_ip4))
  $ip="$NAT_port_ip1.$NAT_port_ip2.$NAT_port_ip3.$NAT_port_ip4";

if(isset($NAT_external_port))
  $externalPort = $NAT_external_port;
  
if(isset($NAT_internal_port))
  $internalPort = $NAT_internal_port;
  
if(isset($NAT_proto_tcp))
  $proto = "TCP";

if(isset($NAT_proto_udp))
  $proto = ($proto=="")? "UDP" : $proto.",UDP";

$ipport_array = isset($ser_ipport_array)? unserialize($ser_ipport_array) : array();
$internalPort_array = isset($ser_internalPort_array)? unserialize($ser_internalPort_array) : array();
$externalPort_array = isset($ser_externalPort_array)? unserialize($ser_externalPort_array) : array();
$proto_array = isset($ser_proto_array)? unserialize($ser_proto_array) : array();
$ipport_delete_array = isset($ser_ipport_delete_array)? unserialize($ser_ipport_delete_array) : array();

  
if ($ip != 0 && $internalPort != 0 && $externalPort != 0 && ($proto=="TCP" || $proto=="UDP" || $proto=="TCP,UDP") )
{ 
  $ipport_array[count($ipport_array)] = $ip;
  $internalPort_array[count($internalPort_array)] = $internalPort;
  $externalPort_array[count($externalPort_array)] = $externalPort;
  $proto_array[count($proto_array)] = $proto;
  
  $ser_ipport_array = serialize($ipport_array);
  $ser_internalPort_array = serialize($internalPort_array);
  $ser_externalPort_array = serialize($externalPort_array);
  $ser_proto_array = serialize($proto_array);
  session_register('ser_ipport_array');
  session_register('ser_internalPort_array');
  session_register('ser_externalPort_array');
  session_register('ser_proto_array');
}

if( isset($delete) )
{
  $temp = explode(",", $delete);
  $ipport_delete_array = array_merge($ipport_delete_array, $temp);  
  $ser_ipport_delete_array = serialize($ipport_delete_array);
  session_register('ser_ipport_delete_array');
}

//function:
function table_new($row) {
		
	// 20080320 - Add id and value tag
	$table = '<table id="tablePortMap" width="100%" border="0" cellspacing="0" cellpadding="0" errPubPort="'.get_cm_var('setcfg_nat_js_alert_pub_port').'">';
	
	//x - row, y - col
	//$row[x][0] - html style class
	//$row[x][y] - field value
	foreach($row as $field) {			
		
		$table .= "<tr class='$field[0]' id='portId' value='$field[5]'>";
		for($i=1; $i<count($field)-1; $i++) {
			$table .= "<td>";	
			$table .= "$field[$i]";
			$table .= "</td>";
		}
		$table .= "</tr>";
		
	}

	$table .= '</table>';
	
	return $table;
}

?>
<html>
<head>
<style type="text/css">
<!--
    table { font-family: Tahoma, sans-serif; font-size: 10pt; }
    .odd { background: #F0F0F0; }
    .even { background: #FFF; }
    .checked { background: #BAEAD6; }
    .add { color: #096; list-style: none; margin: 0px; padding: 0; border-top: 1px solid green; }
    .delete { color: #FF0000; list-style: none; margin: 0px; padding: 0; border-top: 1px solid green;
    #display { color: #000; list-style: none; margin: 0px; padding: 0;}
    #add { color: #096; list-style: none; margin: 0px; padding: 0; border-top: 1px solid green; }
    #display li, #add li { padding-left: 10px; }
    #display span, #add span { width: 350px; float:left; }
    form { margin: 0;}
-->
</style>
</head>
<body>
<table width="100%" border="0" cellspacing="0" cellpadding="0">
<?php
$row = array();
$settingobj = new COM('EGCONFIG.Cfgmgr') or die('framePortMap.php EGCONFIG.Cfgmgr Object cannot be created!');
$count = $settingobj->getKey('NAT_portmap_count', 'NAT');

//original entries
for ($i=0; $i<$count; $i++) {
  $NAT_portmap = $settingobj->getKey('NAT_portmap_'.$i, 'NAT');
  list($proto, $ip, $internalPort, $externalPort) = explode(':', $NAT_portmap);
  
    // 20080320 - Add 6th element
    $row[$i][0] = ($i%2)==0? "even":"odd";
    $row[$i][1] = $ip;
    $row[$i][2] = $internalPort." <- ".$externalPort;
    $row[$i][3] = $proto;
    $row[$i][4] = "<input type='checkbox' name='entry'>";
    $row[$i][5] = $externalPort;
}

//new entries
$count = count($row);
for($i=0; $i<count($ipport_array); $i++) {
    // 20080320 - Add 6th element
    $pos = $i + $count;
    $row[$pos][0] = "add";
    $row[$pos][1] = $ipport_array[$i];
    $row[$pos][2] = $internalPort_array[$i]." <- ".$externalPort_array[$i];
    $row[$pos][3] = $proto_array[$i];
    $row[$pos][4] = "<input type='checkbox' name='entry'>";
    $row[$pos][5] = $externalPort_array[$i];
}

//removed entries
foreach($ipport_delete_array as $pos) {
  $row[$pos][0] = "delete";
  $row[$pos][1] = "# ".$row[$pos][1];
  $row[$pos][4] = "<input type='checkbox' name='entry' disabled>";
}

$settingobj=null;

echo table_new($row);

?>
</table>
</body>
</html>
