<?php

// no cache for browser
header('Cache-Control: no-cache, must-revalidate');

// security check
require_once 'secureLogin.php';
require_once 'cmvar.php';

$settingObj = new COM('EGCONFIG.Cfgmgr') or die('message.php EGCONFIG.Cfgmgr Object cannot be created!');
$fs_status = $settingObj->queryService();
$fsVer = $settingObj->getKey("versionDesc", "version");
$settingObj = null;

$refreshIntv = '-600';
if ($fs_status == 'STARTED') {
	$refreshIntv = '86400';
}

?>
<html>
<head>
<meta http-equiv="refresh" content="<?=$refreshIntv?>; url=message.php" >
<title>message.php</title>
<style type="text/css">
<!--

body { border-top: 3px solid #CCC; }
h1 {
    background: transparent url("./images/message.gif") no-repeat top left;
    margin: 10px 0px 0px 0px;
    width: 148px;
    height: 23px;
}
h1 span { display: none; }
#wrapper {
	min-height: 95px;
	*height: 105px; /* ie only */
	border-top: 3px solid #C9FF72;
	border-bottom: 3px solid #C9FF72;
	border-left: 1px solid #CCC;
	border-right: 1px solid #CCC;
	padding: 3px 10px;
}
#image { float:left; margin-top: 5px;}
#message {
    margin-left: 40px;
    margin-top: 8px;
    padding-bottom: 10px;
    font-family: Tahoma, sans-serif; font-size: 9pt; font-weight: bold; color: #030;
}

-->
</style>
	<script language="javascript" type="text/javascript" src="./javascript/message.js"></script>
	<script language="javascript" type="text/javascript">
		var totalNews = 0;
		var currNews = 0;
		var jsNewsArray = new Array();

		// Redirect to next or previous news
		function ToNews(newsDirect)
		{
			if (newsDirect > 0) {
				currNews++;
				if (currNews > totalNews) {
					currNews = totalNews;
				} else {
					document.getElementById('notify_box_frame_news').contentWindow.location = 'message_news.php?filename=' + jsNewsArray[currNews-1][0] + '&index=' + currNews + '&total=' + totalNews + '&new=' + jsNewsArray[currNews-1][1];
				}
			} else if (newsDirect < 0) {
				currNews--;
				if (currNews <= 0) {
					currNews = 1;
				} else {
					document.getElementById('notify_box_frame_news').contentWindow.location = 'message_news.php?filename=' + jsNewsArray[currNews-1][0] + '&index=' + currNews + '&total=' + totalNews + '&new=' + jsNewsArray[currNews-1][1];
				}
			}
		}
	</script>
</head>
<body>
<h1 title="Message Window"><span>Message Window</span></h1>
<div id="wrapper">
<?php

if ((isset($_SESSION['error'])&&($_SESSION['error']=='true'))||(isset($_SESSION['errorlog'])&&($_SESSION['errorlog']!=''))) {
	echo '
	<div id="image"><img src="./images/critical.gif" width="32" height="32"></div>
	<div id="message">
		An error occurred during the starting of service. Please see the following error log.
		<iframe frameborder="1" scrolling="yes" width="94%" height="60" src="error.php#bottom" marginwidth="0" marginheight="0"></iframe>
	</div>';
} else if (isset($_SESSION['message'])&&($_SESSION['message']!='')) {
	echo '
	<div id="image"><img src="./images/info.gif" width="32" height="32"></div>
	<div id="message">'.$_SESSION['message'].'</div>';
} else {
	echo '
	<div id="image"><img src="./images/network.gif" width="32" height="32"></div>
	<div id="message">Welcome to the EaseGate&trade; Configuration Manager!</div>';
}

?>

</div>
<?php

if ($fs_status == 'STARTED') {
	$bGetNews = FALSE;

	// Determine if time to check for news update
	if (isset($_SESSION['news_time']) && $_SESSION['news_time'] != '') {
		if ((isset($_GET['news']) && $_GET['news']) || (time() - $_SESSION['news_time']) >= $refreshIntv) {
			$bGetNews = TRUE;
		}
	} else {
		$bGetNews = TRUE;
	}

	$firstNewIndex = 0;
	$firstNewNews = '';
	$fileArray = array();
	if ($bGetNews) {
		$newDateArray = array();
		$fsVerDigit = array();
		$fsVerDigit = explode('.', $fsVer);

		// Get news update from server
		$titleStr = @file_get_contents('http://patronsoft.com/EaseGate/cm/v'.$fsVerDigit[0].'/list_news.php');
		$titleArray = array();
		$titleArray = explode('|', $titleStr);
		$dirStr = "..\\news";
		foreach ($titleArray as $dateStr) {
			if ($dateStr != '') {
				$filePath = "$dirStr\\$dateStr";
				if (!file_exists($filePath)) {
					$tmpStr = '';
					if (($tmpStr = @file_get_contents('http://patronsoft.com/EaseGate/cm/v'.$fsVerDigit[0].'/'.$dateStr)) !== FALSE) {
						@file_put_contents($filePath, $tmpStr);
						$newDateArray[$dateStr] = 1;
						if ($firstNewNews == '' || strcmp($dateStr, $firstNewNews) < 0) {
							$firstNewNews = $dateStr;
						}
					}
				}
			}
		}

		// Build list of news entries and delete expired entries
		$dp = @opendir($dirStr);
		if ($dp !== FALSE) {
			$i = 0;
			while ($dirEntry = @readdir($dp)) {
				if (is_dir($dirEntry) || $dirEntry == '.' || $dirEntry == '..') {
					continue;
				}

				$tmpStr1 = array();
				$tmpStr1 = explode('.', $dirEntry);
				if (count($tmpStr1) == 2 && isset($tmpStr1[0]) && isset($tmpStr1[1]) && $tmpStr1[1] == 'php') {
					$tmpStr2 = array();
					$tmpStr2 = explode('-', $tmpStr1[0]);
					if (count($tmpStr2) != 2 || !isset($tmpStr2[0]) || !isset($tmpStr2[1]) || strlen($tmpStr2[0]) != 8 || strtotime($tmpStr2[0]) == FALSE || !is_numeric($tmpStr2[1])) {
						continue;
					}
				} else {
					continue;
				}

				$fileArray[$i++] = $dirEntry;
			}
			closedir($dp);
			sort($fileArray);

			echo '
	<script language="javascript" type="text/javascript">
		totalNews = '.sizeof($fileArray).';
		currNews = totalNews;';
			foreach ($fileArray as $key => $value) {
				echo "
		jsNewsArray[$key] = new Array(2);
		jsNewsArray[$key][0] = '$value';";
				if (isset($newDateArray[$value]) && $newDateArray[$value]) {
					echo "
		jsNewsArray[$key][1] = 1;";
					if (strcmp($value, $firstNewNews) == 0) {
						$firstNewIndex = $key;
					echo "
		currNews = $key + 1;";
					}
				} else {
					echo "
		jsNewsArray[$key][1] = 0;";
				}
			}
			echo "
	</script>\n";
		}

		// Remember last update time
		$_SESSION['news_time'] = time();
	}

	$currTime = time();

	// Display notify box if receive new news or click show button
	if ($firstNewNews != '' || (isset($_GET['news']) && $_GET['news'])) {
		$reallyShow = 0;
		if (isset($_SESSION['last_get_news'])) {
			if (isset($_GET['news']) && $_GET['news'] > $_SESSION['last_get_news']) {
				$_SESSION['last_get_news'] = $_GET['news'];
				$reallyShow = 1;
			}
		} elseif (isset($_GET['news'])) {
			$_SESSION['last_get_news'] = $_GET['news'];
			$reallyShow = 1;
		} else {
			$reallyShow = 1;
		}

		if ($reallyShow) {

?>
	<input type="button" id="news_button" value="<?=get_cm_var('setcfg_message_show_news')?>" style="position:absolute; visibility:hidden; width:80; height:25; left:0; top:0; background-color:#DDD; border:4px groove #18A718; font-family:sans-serif,tahoma; font-size:8pt; color:#030 cursor:pointer; cursor:hand" onclick="this.visibility='hidden';location.replace('message.php?news='+<?=$currTime?>)">
	<span id="notify_box" style="position:absolute; visibility:hidden; width:300; height:100; left:0; top:0; background-color:#DDD; border:4px groove #18A718; font-family:sans-serif,tahoma; font-size:8pt; color:#030">
		<div>
			<img src="./images/close.gif" id="notify_box_pic_close" name="notifyBoxPicClose" style="float:right; cursor:pointer; cursor:hand" alt="Hide news" title="Hide news" onclick="CloseAction('notify_box','news_button')">
			<img src="./images/right.gif" id="notify_box_pic_right" name="notifyBoxPicRight" style="float:right; cursor:pointer; cursor:hand" alt="Next news" title="Next news" onclick="ToNews('1')">
			<div style="float:right"><?=get_cm_var('setcfg_message_next')?></div>
			<img src="./images/left.gif" id="notify_box_pic_left" name="notifyBoxPicLeft" style="float:left; cursor:pointer; cursor:hand" alt="Previous news" title="Previous news" onclick="ToNews('-1')">
			<div style="float:left"><?=get_cm_var('setcfg_message_previous')?></div>
		</div>
		<br>
<?php

		if (sizeof($fileArray) > 0) {
			if ($firstNewNews == '') {

?>
		<iframe id="notify_box_frame_news" name="notifyBoxFrameNews" src="message_news.php?filename=<?=$fileArray[sizeof($fileArray)-1]?>&index=<?=sizeof($fileArray)?>&total=<?=sizeof($fileArray)?>&new=0" frameborder="0" width="300" height="75" marginwidth="0" marginheight="0" style="background-color:#DDD; overflow-x:hidden; font-family:sans-serif,tahoma; font-size:8pt; color:#030" scrolling="yes"></iframe>
<?php

			} else {

?>
		<iframe id="notify_box_frame_news" name="notifyBoxFrameNews" src="message_news.php?filename=<?=$fileArray[$firstNewIndex]?>&index=<?=$firstNewIndex+1?>&total=<?=sizeof($fileArray)?>&new=1" frameborder="0" width="300" height="75" marginwidth="0" marginheight="0" style="background-color:#DDD; overflow-x:hidden; font-family:sans-serif,tahoma; font-size:8pt; color:#030" scrolling="yes"></iframe>
<?php

			}
		} else {

?>
		<iframe id="notify_box_frame_news" name="notifyBoxFrameNews" src="message_news.php?index=0&total=0&new=0" frameborder="0" width="300" height="75" marginwidth="0" marginheight="0" style="background-color:#DDD; overflow-x:hidden; font-family:sans-serif,tahoma; font-size:8pt; color:#030" scrolling="yes"></iframe>
<?php

		}

?>
	</span>
	<script language="javascript" type="text/javascript">
		InitDHTMLAPI();
		SetButtonXY('news_button');
		newsId = setTimeout("GenNotify('notify_box','news_button')", 1000);

		window.onunload = UnloadProc;
		window.onresize = AdjustXY;
		window.onscroll = AdjustXY;
	</script>
<?php

		} else {
?>
	<input type="button" id="news_button" value="Show News" style="position:absolute; visibility:on; width:80; height:25; left:0; top:0; background-color:#DDD; border:4px groove #18A718; font-family:sans-serif,tahoma; font-size:8pt; color:#030 cursor:pointer; cursor:hand" onclick="this.visibility='hidden';location.replace('message.php?news='+<?=$currTime?>)">
	<script language="javascript" type="text/javascript">
		InitDHTMLAPI();
		SetButtonXY('news_button');
		window.onresize = AdjustXY;
		window.onscroll = AdjustXY;
	</script>
<?php
		}
	} else {

?>
	<input type="button" id="news_button" value="Show News" style="position:absolute; visibility:on; width:80; height:25; left:0; top:0; background-color:#DDD; border:4px groove #18A718; font-family:sans-serif,tahoma; font-size:8pt; color:#030 cursor:pointer; cursor:hand" onclick="this.visibility='hidden';location.replace('message.php?news='+<?=$currTime?>)">
	<script language="javascript" type="text/javascript">
		InitDHTMLAPI();
		SetButtonXY('news_button');
		window.onresize = AdjustXY;
		window.onscroll = AdjustXY;
	</script>
<?php

	}
}

?>
</body>
</html>

