<?php
require_once '..\\authserv\\common_functions.php';
require_once '..\\authserv\\eg_lang.php';

//show_charset and meta_charset passed by eg_lang.php
if (isset($show_charset) && $show_charset && isset($meta_charset)){
	// replace header in fslang.php
	header("Content-Type: text/xml; charset=$meta_charset"); // The content-type of the PHP document is set to be "text/xml"
}else{
	// replace header in fslang.php
	header('Content-Type: text/xml'); // The content-type of the PHP document is set to be "text/xml"
}

header("Cache-Control: no-cache, must-revalidate"); //The PHP document is set to "no-cache" to prevent caching
//A date in the past
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");

$responseCase=0;

// specified data is found
$xmlContent="";

$xmlDebugString="";

if (isset($_GET['response_case']))
	$responseCase=$_GET["response_case"]; // The variable is set to be the data sent from the html page

if($responseCase == 1){
	if(isset($_SESSION['last_seek']) && isset($_SESSION['last_timestamp'])){
		$last_seek = $_SESSION['last_seek'];
		$last_timestamp = $_SESSION['last_timestamp'];
		
		$responseState = 1; // OK
		$_SESSION['sess_responseState'] = $responseState;
		$xmlContent.="<responseState>" . $responseState . "</responseState>";

		$logDirArr = array("..\\log");
		$csvPrfx = 'tempdata_';
		$csvSufx = '.csv';
		$csvArr = array();
		$cnt = 0;

		// Extract full path of the CSV files
		foreach ($logDirArr as $l) {
			$fileArr = scandir($l);
			foreach ($fileArr as $f) {
				$filePath = "$l\\$f";
				if (is_file($filePath) && ereg('^'.$csvPrfx.'[0-9]{4}[\.]{1}[0-9]{2}[\.]{1}[0-9]{2}[_]{1}[0-9]{2}[\.]{1}[0-9]{2}[\.]{1}[0-9]{2}'.$csvSufx.'$', $f)) {
					$treatFilePath = str_replace($csvSufx, '', $filePath);
					$getPos = strpos($treatFilePath, $csvPrfx, 1) + strlen($csvPrfx);
					$fileDate = explode('_', substr($treatFilePath, $getPos, strlen($treatFilePath) - $getPos));
					$dateArray = explode('.', $fileDate[0]);
					$timeArray = explode('.', $fileDate[1]);
					$dateTimeStamp = mktime($timeArray[0], $timeArray[1], $timeArray[2], $dateArray[1], $dateArray[2], $dateArray[0]);
					$csvArr[$dateTimeStamp] = $filePath;
				}
			}
		}
		ksort($csvArr);

		// Read CSV files one by one
		$dataArray = array();
		$count = 0;
		$shown = 0;
		$previous_timestamp = 9999999999;

		// NEW==== 
		$glo_content = "";

		foreach ($csvArr as $timestamp => $c) {

			if ($last_timestamp > $timestamp){
				// old file
				continue;
			}

			$fp = fopen($c, 'rt');
			
			if ($last_timestamp == $timestamp){
				// same file, go to previous seek
				$seekStartFrom = $last_seek;	
				if ($seekStartFrom >= 0) {
					fseek($fp, $seekStartFrom);
				}
			}
			if ($fp != FALSE) {
				$meetTitle = 0;

				// 20090302 - Show port numbers for non-well-known protocols
				// 20090106 - Retrieve destination port and convert to protocol if possible
				while (($dataArr = fgetcsv($fp, 2048, ',', "'")) !== FALSE) {
					// * need Skip the title line
					// title will contain one more col (Others)
					
					if (count($dataArr) != 23 && count($dataArr) != 24)
						continue;
					
					$dataArray[] = $dataArr;
					$count++;
				}
				
				$_SESSION['last_seek'] = ftell($fp);
				$xmlContent.="<last_seek>" . $_SESSION['last_seek'] . "</last_seek>";

				fclose($fp);
			}
			
			// show all new
			foreach ($dataArray as $dataArr) {
				$shown++;
				
				$state = $dataArr[0];
				// $src_ip = $dataArr[2];
				// $dest_ip = $dataArr[3];
				$src_port = $dataArr[4];
				$dest_port = $dataArr[5];
				$protocol = $dataArr[15];
				// $username = $dataArr[16];
				// $applied_rule = $dataArr[17];
				// $domain = $dataArr[21];
				// $url = $dataArr[22];
				
				// remove double quote
				$src_ip = substr($dataArr[2], 1, (strlen($dataArr[2]) -2));
				$dest_ip = substr($dataArr[3], 1, (strlen($dataArr[3]) -2));
				$username = substr($dataArr[16], 1, (strlen($dataArr[16]) -2));
				$applied_rule = substr($dataArr[17], 1, (strlen($dataArr[17]) -2));
				$domain = substr($dataArr[21], 1, (strlen($dataArr[21]) -2));
				$url = substr($dataArr[22], 1, (strlen($dataArr[22]) -2));
				
				// interpret
				$proto_str="others";
				if ($protocol == 6){
					$proto_str="TCP";
				}
				else if ($protocol == 17){
					$proto_str="UDP";
				}
				
				if (strcasecmp($dataArr[1], "OUT") == 0){
					// flip src to dest, dest to src
					$ent_src_ip = $dest_ip;
					$ent_dest_ip = $src_ip;
					$ent_src_port = $dest_port;
					$ent_dest_port = $src_port;
				}
				else{
					$ent_src_ip = $src_ip;
					$ent_dest_ip = $dest_ip;
					$ent_src_port = $src_port;
					$ent_dest_port = $dest_port;
				}
				
				$color_case = 0; 
				if(stristr($state, "deny") === FALSE){
					$color_case = 0;
				}
				else{
					$color_case = 1;
				}
				
				$xmlContent.="<record number=\"$shown\">";
				$xmlContent.="<state>".$state."</state>";
				$xmlContent.="<src_ip>".$ent_src_ip."</src_ip>";
				$xmlContent.="<dest_ip>".$ent_dest_ip."</dest_ip>";
				$xmlContent.="<src_port>".$ent_src_port."</src_port>";
				$xmlContent.="<dest_port>".$ent_dest_port."</dest_port>";
				$xmlContent.="<protocol>".$proto_str."(".$protocol.")"."</protocol>";
				$xmlContent.="<username>".$username."</username>";
				$xmlContent.="<applied_rule>".$applied_rule."</applied_rule>";
				$xmlContent.="<domain>".$domain."</domain>";
				if ($url != "" && strlen($url) > 0)
					$xmlContent.="<url>".urlencode($url)."</url>"; // contian & will case error during get node name and node value
				
				$xmlContent.="<color_case>".$color_case."</color_case>";
				$xmlContent.="</record>";
				
			}
			
			$previous_timestamp = $timestamp;
			
			$_SESSION['last_timestamp'] = $previous_timestamp;
			$xmlContent.="<last_timestamp>" . $_SESSION['last_timestamp'] . "</last_timestamp>";
		}
		
	} else{
		$responseState = 2; // Error
		$_SESSION['sess_responseState'] = $responseState;
		$xmlContent="<responseState>" . $responseState . "</responseState>";
	}
}

// The data is outputted as an xml document
// since < ? ? > in php have special meaning, so that using print() instead of echo()
$xmlHeader = "<?xml version=\"1.0\"?>\n";
print $xmlHeader;
echo "<templog>";
echo "<responseCase>" . $responseCase . "</responseCase>";
echo $xmlContent;
echo "</templog>";
?>