/*
 *  The following global variables glo_ElementDisabled[] is to 
 *  hold information about which form element control the 
 *  disable status of which elements, in both simple and 
 *  advanced search form.
 *
 *  It consist of name of element controlling other elements
 *  on the left side of "=". And name of element(s) being controlled on the
 *  right side of the "=". Please note that only "checkbox" and
 *  "select-one" type element is used.
 *  Please note that the syntax for select-one type is a bit complicated
 *  
 *  Legend / naming convention:
 *  fS - (f)orm (S)imple
 *  fA - (f)orm (A)dvanced
 *  fAC - (f)orm (S)imple (C)heckbox
 *  fAT - (f)orm (S)imple (T)ext input
 *  fAS - (f)orm (S)imple (S)election box
 *  fSSAA - (f)orm (S)imple (S)election box (A)ccount (A)ctive 
 *
 *	Procedure to add search item/field in search form:
 *	1. Add HTML code to searchForm.php
 *	2. Add corresponding entries to global variable in searchUser.js if applicable
 *		-glo_ElementDisabled[]
 *		-glo_ElementVisible[]
 *		-glo_FirstLevelElement_Simple[]
 *		-glo_FirstLevelElement_Advanced[]
 *  3. Add approiate code in validateSearchForm()
 *	4. Add php code in searchForm.php to make SQL statement
 */
var glo_ElementDisabled = new Array();
glo_ElementDisabled["fACUN"] = ["fATUN"]; //checkbox "fACUN" control enable of text element "fATUN"
glo_ElementDisabled["fACMAC"] = ["fASMAC"]; //checkbox "fACMAC" (MAC user?) control enable of selection box "fASMAC"
glo_ElementDisabled["fASMAC"] = ["fASMAC1"]; //only first option of selection box "fASMAC" control enable of other elements
glo_ElementDisabled["fASMAC1"] = ["fACMACPL"]; //the first option of selection box "fASMAC" control enable of checkbox "fACMACPL"
glo_ElementDisabled["fACMACPL"] = ["fASMACPL"]; //checkbox "fACMACPL" control enable of another selecion box "fASMACPL"
glo_ElementDisabled["fACAD"] = ["fASAD"]; //checkbox "fACAD" control enable of selection element "fASAD"
glo_ElementDisabled["fACB"] = ["fASB"];
glo_ElementDisabled["fASB"] = ["fASB6"];
glo_ElementDisabled["fASB6"] = ["fACBSU","fACBSD"];
glo_ElementDisabled["fACBSU"] = ["fASBSU","fATBSU"];
glo_ElementDisabled["fACBSD"] = ["fASBSD","fATBSD"];
glo_ElementDisabled["fACDU"] = ["fASDU"];
glo_ElementDisabled["fASDU"] = ["fASDU4"];
glo_ElementDisabled["fASDU4"] = ["fACDUQ"];
glo_ElementDisabled["fACDUQ"] = ["fASDUQ","fATDUQ"];
glo_ElementDisabled["fACDUC"] = ["fASDUC","fATDUC"];
glo_ElementDisabled["fACDD"] = ["fASDD"];
glo_ElementDisabled["fASDD"] = ["fASDD4"];
glo_ElementDisabled["fASDD4"] = ["fACDDQ"];
glo_ElementDisabled["fACDDQ"] = ["fASDDQ","fATDDQ"];
glo_ElementDisabled["fACDDC"] = ["fASDDC","fATDDC"];

glo_ElementDisabled["fSSLl"] = ["fSSLl2","fSSLl3"];
glo_ElementDisabled["fSSLl2"] = ["fSTLd","fSTLt"];
glo_ElementDisabled["fSSLl3"] = ["fSTLd","fSTLt"];

//segment mapping
glo_ElementDisabled["fACSEGMENTMAP"] = ["fASSEGMENTMAP"];
glo_ElementDisabled["fASSEGMENTMAP"] = ["fASSEGMENTMAP1"];
glo_ElementDisabled["fASSEGMENTMAP1"] = ["fACSEGMENT"];
glo_ElementDisabled["fACSEGMENT"] = ["fASSEGMENT"];

/*  
 *  The following global variable glo_ElementVisible[]
 *  store information about which form element's disable/enable
 *  state control visibility of which node.
 *
 *  Element name is on the left side and id of node to
 *  appear or disappear on the right side.
 *  It work by the fact that when an element is disabled,
 *  the node in which the element reside need not be visible.
 *
 *	Naming convention for li node:
 *	us - user status
 *	as - account status
 *	bt - bandwidth throttling
 *	dtc - data transfer counting
 */
var glo_ElementVisible = new Array();
glo_ElementVisible["fACMACPL"] = "us.2.1";

glo_ElementVisible["fACBSU"] = "bt.1.1";
glo_ElementVisible["fACBSD"] = "bt.1.2";
glo_ElementVisible["fACDUQ"] = "dtc.1.1";
glo_ElementVisible["fACDDQ"] = "dtc.3.1";
glo_ElementVisible["fACSEGMENT"] = "segment_search";

/*
 *  The following global variable glo_FirstLevelElement_Advanced[] 
 *	is to hold all the ready form element when advanced 
 *  search form is first loaded. 
 */
var glo_FirstLevelElement_Advanced = new Array();
glo_FirstLevelElement_Advanced[0] = "fACUN";
glo_FirstLevelElement_Advanced[1] = "fACMAC";
glo_FirstLevelElement_Advanced[2] = "fACAD";
glo_FirstLevelElement_Advanced[3] = "fACB";
glo_FirstLevelElement_Advanced[4] = "fACDU";
glo_FirstLevelElement_Advanced[5] = "fACDUC";
glo_FirstLevelElement_Advanced[6] = "fACDD";
glo_FirstLevelElement_Advanced[7] = "fACDDC";
glo_FirstLevelElement_Advanced[8] = "fACSEGMENTMAP";

/*
 *  The following global variable glo_FirstLevelElement_Simple[]
 *	is to hold all the ready form element when simple 
 *  search form is first loaded. 
 */
var glo_FirstLevelElement_Simple = new Array();
glo_FirstLevelElement_Simple[0] = "fSTUN";
glo_FirstLevelElement_Simple[1] = "fSSAS";
glo_FirstLevelElement_Simple[2] = "fSSLl";

function hideSearch(searchMethod) {
	var objectToHide;
	switch (searchMethod) {
		case "frmSimple":
			objectToHide = document.getElementById('simpleSearchBox');
			hideObject(objectToHide);
		break;
		case "frmAdvanced":
			objectToHide = document.getElementById('advancedSearchBox');
			hideObject(objectToHide);
		break;
		default:
		break;
	}
	objectToShow = document.getElementById('btn_showSearch');
	//btn_showSearch cannot use showObject() because it is inline object
	objectToShow.style.display = 'inline';
}

function showSearch(searchMethod) {
	/*  This function is called by four type of button:
	 *  show search, hide, simple search tab, advanced search tab
	 *  Purpose: Perform show/hide stuff when user change search
	 *  method.
	 */
	var objectToHide;
	var objectToShow;
	switch (searchMethod) {
		case "frmSimple":
			//Hide show search box button
			objectToHide = document.getElementById('btn_showSearch');
			hideObject(objectToHide);
			//Show simple search box
			objectToShow = document.getElementById('simpleSearchBox');
			showObject(objectToShow);
		break;
		case "frmAdvanced":
			//Hide show search box button
			objectToHide = document.getElementById('btn_showSearch');
			hideObject(objectToHide);
			//Show advanced search box
			objectToShow = document.getElementById('advancedSearchBox');
			showObject(objectToShow);
		break;
		default:
			alert("invalid object reference");
		break;
	}
}

function hideObject(objToHide) {
	objToHide.style.display = 'none';
}

function showObject(objToShow) {
	objToShow.style.display = 'block';
}

function startSearchOnclick(formName) {
	/*
	 *  This function was called when user click on search button

	 *  Purpose: It perform
	 *  -validate the search form
	 *  -make sql where statement(advanced search only)
	 *  -pack up the all search form data and store it into a 
	 *   single form element
	 *  -submit the search form
	 */
	var readyToSearch = true;
	var formToSubmit;
	var aTempFormElement;
	formToSubmit = document.getElementById(formName);	
	with (formToSubmit) {
		for (var i=0; i<elements.length; i++) {
			readyToSearch &= validateSearchForm(elements[i]);
			if (!readyToSearch) {
				elements[i].select();
				break;
			}
		}
		if (readyToSearch) {
			searchFormData.value = formDataToString(formName); 
			submit();
		}
	}
}

function validateSearchForm(element) {
	/*
	 *  Purpose: Search form validation for both simple 
	 *  and advanced search form
	 */
	var re; 
	var tempYear;
	var formOk = true;
	if (element.disabled == false) {
		switch (element.name) {
			case "fSTUN":
			case "fATUN":
				re = /\s/g;
				//remove all spaces
				element.value = element.value.replace(re, "");
				break;
			case "fSTLd":
			case "fATAAAd":
			case "fATSAd":
				re = /^\d{1,2}-\d{1,2}-\d{4}$/;
				if (re.test(element.value)) {
					tempYear = element.value.split('-');
					if (parseInt(tempYear[2]) < 1971) { //unix time stamp start at 1970
						formOk = false;
					}
				} else {
					formOk = false;
				}
				if (!formOk) {
					alert(glo_Message.js_users_search_form_validation_date);
				}
				break;
			case "fSTLt":
			case "fATAAAt":
			case "fATSAt":
				re = /^\d{1,2}:\d{1,2}$/;
				formOk = re.test(element.value);
				if (!formOk) { //format of time is incorrect
					alert(glo_Message.js_users_search_form_validation_time);
				} else { //format of time is correct
					var arrTime = element.value.split(":");
					//making the number to 2 digit in length
					if (parseInt(arrTime[0]) < 10) {
						arrTime[0] = '0' + parseInt(arrTime[0]);
					}
					if (parseInt(arrTime[1]) < 10) {
						arrTime[1] = '0' + parseInt(arrTime[1]);
					}
					element.value = arrTime.join(":");
				}
				break
			case "fATSA":
			case "fATSLl":
			case "fATBSU":
			case "fATBSD":
			case "fATDUQ":
			case "fATDUC":
			case "fATDDQ":
			case "fATDDC":
			case "fATP":
				formOk = !isNaN(parseInt(element.value)) && parseInt(element.value) >= 0;
				if (!formOk) {
					alert(glo_Message.js_users_search_form_validation_integer);
				}
			default:
				break;
		}
	}
	return formOk;
}

function formDataToString(formId) {
	/*
	 *  Purpose: This function convert all non hidden field data in the specified
	 *  form into a string.
	 *  e.g. field1,text,hello|field2,combobox,false|field3,select-one,1|....	
	 *  The return string can then be stored in another form as single
	 *  hidden field. Thus data in the form can propagate to next page
	 *  when a form submit.	
	 */
	var dataString = "";
	var numOfNonHiddenField = 0;
	var fieldName, fieldType, fieldValue;
	var fieldArray = new Array(3), fieldStringArray = new Array();
	var searchForm = document.getElementById(formId);
	for (var i=0; i<searchForm.elements.length; i++) {
		addField = false;
		with (searchForm) {
			if (elements[i].type != "hidden") { //only convert non-hidden field
				fieldName = elements[i].name;
				switch (elements[i].type) {
					case "text":
						addField = true;
						fieldType = "t";
						if (elements[i].value == "") {
							fieldValue = 'null';
						} else {
							fieldValue = elements[i].value;
						}
						break;
					case "checkbox":
						addField = true;
						fieldType = "c";
						if (elements[i].checked) {
							fieldValue = "t"; //true
						} else {
							fieldValue = "f"; //false
						}
						break;
					case "select-one":
						addField = true;
						fieldType = "so";
						fieldValue = elements[i].selectedIndex;
					break;
					case "radio":
						//this part is not tested as no radio element is present in search form
						//during the time of development
						if (elements[i].checked) {
							//only store value of checked radio field
							fieldValue = elements[i].value;
							addField = true;
							fieldType = "r";
						}
					break;
					default:
					break;
				}
				if (addField) {
					fieldArray[0] = fieldName;
					fieldArray[1] = fieldType;
					fieldArray[2] = fieldValue;
					fieldStringArray[numOfNonHiddenField] = fieldArray.join(",");
					numOfNonHiddenField++;
				}
			}
		}
	}
	dataString = fieldStringArray.join("|");
	return dataString;
}

function init(searchMethod) {
	/*
	 *  This function is called at the end of searchForm.php
	 *  Purpose: Adjust the visibility of different search form
	 *  according to search method.
	 */
	var temp;
	if (typeof(glo_oldSearchFormData) == "undefined") { //first time loading the search form
		document.getElementById('btn_showSearch').style.display = 'none';
		if (searchMethod == "frmAdvanced") {
			//hide uninvoked elements, starting at the first level elements
			adjustFormElementState(glo_FirstLevelElement_Advanced, false); 
			//show advanced search form
			temp = document.getElementById('advancedSearchBox');
			showObject(temp);
		} else { //frmSimple
			//show simple search form
			temp = document.getElementById('simpleSearchBox');
			showObject(temp);
		}
	} else {
		restoreSearchFormData(searchMethod);
		if (searchMethod == "frmAdvanced") { //result of advanced search came back
			//hide uninvoked elements, starting at the first level elements
			adjustFormElementState(glo_FirstLevelElement_Advanced, false);
		}
	}
}

function restoreSearchFormData(searchMethod) {
	/*
	 *   This function is called by setcfg.php?category=u when all 
	 *	 required forms were loaded(including frmSimple, frmAdvanced, 
	 *   userControlForm, userinfoform) and old search form data 
	 *   is available. This function read a global variable glo_oldSearchFormData
	 * 	 and put all the data in it back to corresponding search form. It also store common
	 *   data to all search form listed above.

	 *   Purpose: restore and keep search form data when users use search 
	 *   to perfom action that require reloading of setcfg.php afterward
	 */
	//for formating of searchFormData please refer to comment of formDataToString()
	var fieldStringArray = glo_oldSearchFormData.split("|"); 
	var fieldArray;
	var fieldName, fieldType, fieldValue;
	var formElementToRestore;
	for (var i=0; i< fieldStringArray.length; i++) {
		fieldArray = fieldStringArray[i].split(",");
		fieldName = fieldArray[0];
		fieldType = fieldArray[1];
		fieldValue = fieldArray[2];
		switch (fieldType) {
			case "t": //text
				formElementToRestore = document.getElementById(fieldName);
				if (fieldValue == "null") {
					//String "null" is propagated when the original field is not filled.
					formElementToRestore.value = "";
				} else {
					formElementToRestore.value = fieldValue;
				}
			break;
			case "c": //checkbox
				formElementToRestore = document.getElementById(fieldName);
				if (fieldValue == "t") {
					formElementToRestore.checked = true;
				} else {
					formElementToRestore.checked = false;
				}
			break;
			case "so": //select-one
				formElementToRestore = document.getElementById(fieldName);
				formElementToRestore.selectedIndex = parseInt(fieldValue);
			break;
			case "r": //radio
				radioElement = document.getElementsByName(fieldName);
			for (var j=0; j<radioElement.length; j++) {
				if (radioElement[j].value == fieldValue) {
					radioElement[j].checked = true;
				}
			}
			break;
			default:
			break;
		}
	}
	copySearchFormDataToHiddenField("userControlForm");
	if (searchMethod=="frmSimple") {
		adjustFormElementState(glo_FirstLevelElement_Simple, false);
	} else if (searchMethod=="frmAdvanced") {
		adjustFormElementState(glo_FirstLevelElement_Advanced, false);
	} else {
		alert("debug invalid argument in restoreSearchFormData");
	}
}

function copySearchFormDataToHiddenField(targetFormName) {
	/*
	 * This function is called by restoreSearchFormData().
	 * Purpose: 
	 * To put search criteria data to hidden field of
	 * various form so that it will propagate to next page.
	 */
	//document.forms[targetFormName].elements['page'].value = glo_page;
}
function adjustFormElementState(aFormElementId, parentElementStatus) {
	/*
	 *  This function is called by restoreSearchFormData() and when
	 *  any form element in search form was changed.

	 *  Purpose: To readjust the disable/enable and visibility state of elements
	 *  according to the value of the global variable glo_ElementDisabled[]
	 *  and glo_ElementVisible[].
	 */
	var tempNode;
	var childElementStatus;
	for (var i=0; i<aFormElementId.length; i++) {
		tempNode = document.getElementById(aFormElementId[i]);
		if (!tempNode) {
			//debug purpose
			alert(aFormElementId[i] + " not a node");
		}
		tempNode.disabled = parentElementStatus; //if an element's parent is disabled, so does it
		adjustFormElementVisibility(aFormElementId[i], tempNode.disabled); //change visibility if necessary
		if (tempNode.type == "select-one") {
			/*Selection box control is a bit complicated as different
			  option control different elements and different options
			  can control the same elements.*/
			//disable all its child node first
			if (typeof(glo_ElementDisabled[aFormElementId[i]]) != "undefined") {
				for (var j=0; j<glo_ElementDisabled[aFormElementId[i]].length; j++) {
					adjustFormElementState(glo_ElementDisabled[glo_ElementDisabled[aFormElementId[i]][j]], true);
				}
				if (glo_ElementDisabled[aFormElementId[i]].length > 0) { //checking this may be unnecessary
					childElementStatus = parentElementStatus;//child should be disable if any of its parent is disabled
					if (typeof(glo_ElementDisabled[aFormElementId[i]+(tempNode.selectedIndex+1)]) != "undefined") {
						//adjust its selected dependent node
						adjustFormElementState(glo_ElementDisabled[aFormElementId[i]+(tempNode.selectedIndex+1)], childElementStatus);
					}
				}
			}
		} else { //checkbox
			childElementStatus = !tempNode.checked;
			childElementStatus |= parentElementStatus; //parent may still be disabled event if parent is checked
			if (typeof(glo_ElementDisabled[aFormElementId[i]]) != "undefined") {
				//recursion
				adjustFormElementState(glo_ElementDisabled[aFormElementId[i]], childElementStatus);
			}
		}
	}
}
function searchElementOnclick(obj) {
	/*
	 * This function was called by search form elements
	 * when onchange or onclick event occur.

	 * Purpose: To re-adjust disble/enable of search form 
	 * elements.
	 */
	if (typeof(glo_ElementDisabled[obj.id]) != "undefined") {
		var aElementId = new Array(obj.id); //has to pass an array to adjustFormElementState()
		adjustFormElementState(aElementId, false);
	}
}
function adjustFormElementVisibility(elementId, isDisable) {
	/*
	 *  This function was called by adjustFormElementState()
	 *  Purpose:
	 *  Change the visibility of node according to enabled/disable status
	 *  of form element. The information is stored in glo_ElementVisible[]
	 */
	var obj;
	if (typeof(glo_ElementVisible[elementId]) != "undefined") {
		obj = document.getElementById(glo_ElementVisible[elementId]);
		if (isDisable) {
			//alert("hiding" + glo_ElementVisible[elementId]);
			hideObject(obj);
		} else {
			showObject(obj);
		}
	}
}
