<?php
// 20080523 - Modify deprecated time zone strings, add entries for daylight saving time zones
function SetTimeZone() {
    $TIMEZONE['_DATE_TIMEZONE_DATA_WINDOWS'] = array(
'GMT-12:00'	=> 'Etc/GMT+12',		# (GMT-12:00) Dateline Standard Time
'GMT-11:00'	=> 'Pacific/Samoa',		# (GMT-11:00) Samoa Standard Time
'GMT-10:00'	=> 'Pacific/Honolulu',		# (GMT-10:00) Hawaiian Standard Time
'GMT-09:00'	=> 'Pacific/Gambier',		# (GMT-09:00) Alaskan Standard Time
'GMT-09:00DST'	=> 'America/Anchorage',		# (GMT-09:00) Alaskan Daylight Time
'GMT-08:00'	=> 'Etc/GMT+8',			# (GMT-08:00) Pacific Standard Time
'GMT-08:00DST'	=> 'America/Tijuana',		# (GMT-08:00) Pacific Daylight Time
'GMT-07:00'	=> 'America/Phoenix',		# (GMT-07:00) US Mountain Standard Time
						# (GMT-07:00) Mexico Standard Time 2
						# (GMT-07:00) Mountain Standard Time
'GMT-07:00DST'	=> 'America/Chihuahua',		# (GMT-07:00) Mexico Daylight Time 2
						# (GMT-07:00) Mountain Daylight Time
'GMT-06:00'	=> 'Canada/Saskatchewan',	# (GMT-06:00) Central America Standard Time
						# (GMT-06:00) Central Standard Time
						# (GMT-06:00) Mexico Standard Time
						# (GMT-06:00) Canada Central Standard Time
'GMT-06:00DST'	=> 'America/Mexico_City',	# (GMT-06:00) Central Daylight Time
						# (GMT-06:00) Mexico Daylight Time
'GMT-05:00'	=> 'America/Bogota',		# (GMT-05:00) SA Pacific Standard Time
						# (GMT-05:00) Eastern Standard Time
						# (GMT-05:00) US Eastern Standard Time
'GMT-05:00DST'	=> 'America/New_York',		# (GMT-05:00) Eastern Daylight Time
'GMT-04:00'	=> 'America/Caracas',		# (GMT-04:00) Atlantic Standard Time
						# (GMT-04:00) SA Western Standard Time
						# (GMT-04:00) Pacific SA Standard Time
'GMT-04:00DSTN'	=> 'America/Halifax',		# (GMT-04:00) Atlantic Daylight Time
'GMT-04:00DSTS'	=> 'America/Asuncion',		# (GMT-04:00) Pacific SA Daylight Time
'GMT-03:30'	=> 'America/St_Johns',		# (GMT-03:30) Newfoundland Standard Time (no suitable area, use DST)
'GMT-03:30DST'	=> 'America/St_Johns',		# (GMT-03:30) Newfoundland Daylight Time
'GMT-03:00'	=> 'America/Buenos_Aires',	# (GMT-03:00) E. South America Standard Time
						# (GMT-03:00) SA Eastern Standard Time
						# (GMT-03:00) Greenland Standard Time
'GMT-03:00DSTS'	=> 'America/Sao_Paulo',		# (GMT-03:00) E. South America Daylight Time
'GMT-03:00DSTN'	=> 'America/Godthab',		# (GMT-03:00) Greenland Daylight Time
'GMT-02:00'	=> 'Atlantic/South_Georgia',	# (GMT-02:00) Mid-Atlantic Standard Time
'GMT-02:00DST'	=> 'Atlantic/Cape_Verde',	# (GMT-02:00) Mid-Atlantic Daylight Time (no area observes DST)
'GMT-01:00'	=> 'Atlantic/Cape_Verde',	# (GMT-01:00) Azores Standard Time
						# (GMT-01:00) Cape Verde Standard Time
'GMT-01:00DST'	=> 'Atlantic/Azores',		# (GMT-01:00) Azores Daylight Time
'GMT+00:00'	=> 'Atlantic/Reykjavik',	# (GMT+00:00) Greenwich Standard Time
						# (GMT+00:00) GMT Standard Time
'GMT+00:00DST'	=> 'Europe/London',		# (GMT+00:00) GMT Daylight Time
'GMT+01:00'	=> 'Africa/Kinshasa',		# (GMT+01:00) W. Europe Standard Time
						# (GMT+01:00) Central Europe Standard Time
						# (GMT+01:00) Romance Standard Time
						# (GMT+01:00) Central European Standard Time
						# (GMT+01:00) W. Central Africa Standard Time
'GMT+01:00DST'	=> 'Europe/Amsterdam',		# (GMT+01:00) W. Europe Daylight Time
						# (GMT+01:00) Central Europe Daylight Time
						# (GMT+01:00) Romance Daylight Time
						# (GMT+01:00) Central European Daylight Time
'GMT+02:00'	=> 'Africa/Harare',		# (GMT+02:00) GTB Standard Time
						# (GMT+02:00) E. Europe Standard Time
						# (GMT+02:00) Egypt Standard Time
						# (GMT+02:00) South Africa Standard Time
						# (GMT+02:00) FLE Standard Time
						# (GMT+02:00) Jerusalem Standard Time
'GMT+02:00DST'	=> 'Europe/Athens',		# (GMT+02:00) GTB Daylight Time
						# (GMT+02:00) E. Europe Daylight Time
						# (GMT+02:00) Egypt Daylight Time
						# (GMT+02:00) FLE Daylight Time
'GMT+03:00'	=> 'Africa/Nairobi',		# (GMT+03:00) Arabic Standard Time
						# (GMT+03:00) Arab Standard Time
						# (GMT+03:00) Russian Standard Time
						# (GMT+03:00) E. Africa Standard Time
'GMT+03:00DST'	=> 'Europe/Moscow',		# (GMT+03:00) Arabic Daylight Time
						# (GMT+03:00) Russian Daylight Time
'GMT+03:30'	=> 'Asia/Tehran',		# (GMT+03:30) Iran Standard Time
'GMT+03:30DST'	=> 'Asia/Kabul',		# (GMT+03:30) Iran Daylight Time (DST cancelled in Iran, use Kabul)
'GMT+04:00'	=> 'Asia/Muscat',		# (GMT+04:00) Arabian Standard Time
						# (GMT+04:00) Caucasus Standard Time
'GMT+04:00DST'	=> 'Asia/Baku',			# (GMT+04:00) Caucasus Daylight Time
'GMT+04:30'	=> 'Asia/Kabul',		# (GMT+04:30) Afghanistan Standard Time
'GMT+05:00'	=> 'Asia/Karachi',		# (GMT+05:00) Ekaterinburg Standard Time
						# (GMT+05:00) West Asia Standard Time
'GMT+05:00DST'	=> 'Asia/Yekaterinburg',	# (GMT+05:00) Ekaterinburg Daylight Time
'GMT+05:30'	=> 'Asia/Calcutta',		# (GMT+05:30) India Standard Time
'GMT+05:45'	=> 'Asia/Katmandu',		# (GMT+05:45) Nepal Standard Time
'GMT+06:00'	=> 'Asia/Dhaka',		# (GMT+06:00) N. Central Asia Standard Time
						# (GMT+06:00) Central Asia Standard Time
						# (GMT+06:00) Sri Lanka Standard Time
'GMT+06:00DST'	=> 'Asia/Novosibirsk',		# (GMT+06:00) N. Central Asia Daylight Time
'GMT+06:30'	=> 'Asia/Rangoon',		# (GMT+06:30) Myanmar Standard Time
'GMT+07:00'	=> 'Asia/Bangkok',		# (GMT+07:00) SE Asia Standard Time
						# (GMT+07:00) North Asia Standard Time
'GMT+07:00DST'	=> 'Asia/Krasnoyarsk',		# (GMT+07:00) North Asia Daylight Time
'GMT+08:00'	=> 'Asia/Chongqing',		# (GMT+08:00) China Standard Time
						# (GMT+08:00) North Asia East Standard Time
						# (GMT+08:00) Malay Peninsula Standard Time
						# (GMT+08:00) W. Australia Standard Time
						# (GMT+08:00) Taipei Standard Time
'GMT+08:00DST'	=> 'Asia/Irkutsk',		# (GMT+08:00) North Asia East Daylight Time
'GMT+08:45DST'	=> 'Australia/Eucla',		# (GMT+08:45) (reserved)
'GMT+09:00'	=> 'Asia/Tokyo',		# (GMT+09:00) Tokyo Standard Time
						# (GMT+09:00) Korea Standard Time
						# (GMT+09:00) Yakutsk Standard Time
'GMT+09:00DST'	=> 'Asia/Yakutsk',		# (GMT+09:00) Yakutsk Daylight Time
'GMT+09:30'	=> 'Australia/Darwin',		# (GMT+09:30) Cen. Australia Standard Time
						# (GMT+09:30) AUS Central Standard Time
'GMT+09:30DST'	=> 'Australia/Adelaide',	# (GMT+09:30) Cen. Australia Daylight Time
'GMT+10:00'	=> 'Australia/Brisbane',	# (GMT+10:00) E. Australia Standard Time
						# (GMT+10:00) AUS Eastern Standard Time
						# (GMT+10:00) West Pacific Standard Time
						# (GMT+10:00) Tasmania Standard Time
						# (GMT+10:00) Vladivostok Standard Time
'GMT+10:00DSTS'	=> 'Australia/Sydney',		# (GMT+10:00) AUS Eastern Daylight Time
						# (GMT+10:00) Tasmania Daylight Time
'GMT+10:00DSTN'	=> 'Asia/Vladivostok',		# (GMT+10:00) Vladivostok Daylight Time
'GMT+10:30DST'	=> 'Australia/Lord_Howe',	# (GMT+10:30) South Australian Daylight Time (reserved)
'GMT+11:00'	=> 'Asia/Magadan',		# (GMT+11:00) Central Pacific Standard Time
'GMT+12:00'	=> 'Pacific/Fiji',		# (GMT+12:00) New Zealand Standard Time
						# (GMT+12:00) Fiji Standard Time
'GMT+12:00DST'	=> 'Pacific/Auckland',		# (GMT+12:00) New Zealand Daylight Time
'GMT+13:00'	=> 'Pacific/Tongatapu',		# (GMT+13:00) Tonga Standard Time
'GMT+14:00'	=> 'Pacific/Kiritimati'		# (GMT+14:00) (reserved)
    );

	$settingobj = new COM('EGCONFIG.Cfgmgr') or die('timezone.php EGCONFIG.Cfgmgr Object cannot be created!');
	$zone = $settingobj->GetSystemTimeZone();
	$fspath = $settingobj->getFsPath();
	if(array_key_exists($zone, $TIMEZONE['_DATE_TIMEZONE_DATA_WINDOWS']))
		$settingobj->WriteINI("Date", "date.timezone", $TIMEZONE['_DATE_TIMEZONE_DATA_WINDOWS'][$zone], $fspath."www\\PHP\\php.ini");
	$settingobj = null;
}
?>
