<?php

error_reporting(E_ALL | E_STRICT);
$settingobj = new COM('EGCONFIG.Cfgmgr') or die('setcfg.php EGCONFIG.Cfgmgr Object cannot be created!');

$dsnFile = $settingobj->getKey( 'Datasource', 'gateway');

$group_tablename = $settingobj->getKey('Datasource_group_Tablename', 'gateway');
$member_tablename = $settingobj->getKey('Datasource_member_Tablename', 'gateway');
$ipbundle_tablename = $settingobj->getKey('Datasource_ipbundle_Tablename', 'gateway');
$rule_ip_tablename = $settingobj->getKey('Datasource_rule_ip_Tablename', 'gateway');
$rule_ipbundle_tablename = $settingobj->getKey('Datasource_rule_ipbundle_Tablename', 'gateway');
$rule_user_tablename = $settingobj->getKey('Datasource_rule_user_Tablename', 'gateway');
$rule_group_tablename = $settingobj->getKey('Datasource_rule_group_Tablename', 'gateway');
$rule_port_tablename = $settingobj->getKey('Datasource_rule_port_Tablename', 'gateway');
$access_rule_tablename = $settingobj->getKey('Datasource_access_rule_Tablename', 'gateway');
$bw_rule_tablename = $settingobj->getKey('Datasource_bw_rule_Tablename', 'gateway');
$user_tablename = $settingobj->getKey('Datasource_Tablename', 'gateway');
$web_filter_tablename = $settingobj->getKey('Datasource_web_filter_Tablename', 'gateway');

/**
 * Database connection
 */ 
if ($dsnSource = fopen($dsnFile, 'r')) { 
  $dsn = '';
  if (!feof($dsnSource)) {
    $dbType = fgets($dsnSource, 512);
  }
  while (!feof($dsnSource)) {
    $readLine = trim(fgets($dsnSource, 512));
    if (!empty($readLine)) {
      $dsn .= ($dsn ? ';' : '') . $readLine;
    }
  }
  fclose($dsnSource);
  $db = odbc_connect($dsn, '', '');
} else {
  exit('Cannot open DSN source file');
}



/**
 * Script start
 */
 
 // web filter
$web_filter_list = array();
$result = odbc_exec($db, "SELECT * FROM `$web_filter_tablename`");

// most for dbf, since all of key will become captial letter
while(odbc_fetch_row($result)) {
	$data = array();
	$data['webFilterName'] =odbc_result($result,'filterName');
	$data['description'] =odbc_result($result,'descript');
	$data['filterType'] =odbc_result($result,'filterType');
	
	$web_filter_list[$data['webFilterName']][] = $data;
}

// while ($data = odbc_fetch_array($query)) {
  // $web_filter_list[$data['filterName']][] = $data;
// }
 
$egAccessRule_list = array(); 
$result = odbc_exec($db, "SELECT * FROM `$access_rule_tablename` ORDER BY `seqOrder` ASC");

// most for dbf, since all of key will become captial letter
while(odbc_fetch_row($result)) {
	$data = array();
	$data['ruleName'] =odbc_result($result,'ruleName');
	$data['description'] =odbc_result($result,'descript');
	$data['seqOrder'] =round(odbc_result($result,'seqOrder'));
	$data['isAllow'] =odbc_result($result,'isAllow');
	$data['trafficType'] =odbc_result($result,'traffType');
	$data['isEnable'] =odbc_result($result,'isEnable');
	$data['appliedWebFilter'] =odbc_result($result,'webFltName');
	$data['schedule'] =odbc_result($result,'schedule');
	
	$egAccessRule_list[$data['ruleName']] = $data;
}

// while ($data = odbc_fetch_array($query)) {
  // $egAccessRule_list[$data['ruleName']] = $data;
// }

$ruleip_list = array();
$result = odbc_exec($db, "SELECT * FROM `$rule_ip_tablename`");

// most for dbf, since all of key will become captial letter
while(odbc_fetch_row($result)) {
	$data = array();
	$data['ip'] =odbc_result($result,'ip');
	$data['mask'] =odbc_result($result,'mask');
	$data['type'] =round(odbc_result($result,'type'));
	$data['ruleName'] =odbc_result($result,'ruleName');
	
	$ruleip_list[$data['ruleName']][$data['type']][] = $data;
}
    
// while ($data = odbc_fetch_array($query)) {
  // $ruleip_list[$data['ruleName']][$data['type']][] = $data;
// }

$ruleport_list = array();
$result = odbc_exec($db, "SELECT * FROM `$rule_port_tablename`");       

// most for dbf, since all of key will become captial letter
while(odbc_fetch_row($result)) {
	$data = array();
	$data['fromPort'] =round(odbc_result($result,'fromPort'));
	$data['toPort'] =round(odbc_result($result,'toPort'));
	$data['protoNum'] =round(odbc_result($result,'protoNum'));
	$data['type'] =round(odbc_result($result,'type'));
	$data['ruleName'] =odbc_result($result,'ruleName');
	
	$ruleport_list[$data['ruleName']][$data['type']][] = $data;
}

// while ($data = odbc_fetch_array($query)) {
  // $ruleport_list[$data['ruleName']][$data['type']][] = $data;
// }
    
$ipbundle_list = array();
$result = odbc_exec($db, "SELECT * FROM `$ipbundle_tablename`");

// most for dbf, since all of key will become captial letter
while(odbc_fetch_row($result)) {
	$data = array();
	$data['ipBundleName'] =odbc_result($result,'bundleName');
	$data['start_ip'] =odbc_result($result,'start_ip');
	$data['end_ip'] =odbc_result($result,'end_ip');
	
	$ipbundle_list[$data['ipBundleName']][] = $data;
}

// while ($data = odbc_fetch_array($query)) {
  // $ipbundle_list[$data['ipipBundleName']][] = $data;
// }

$ruleipbundle_list = array();
$result = odbc_exec($db, "SELECT * FROM `$rule_ipbundle_tablename`");

// most for dbf, since all of key will become captial letter
while(odbc_fetch_row($result)) {
	$data = array();
	$data['ipBundleName'] =odbc_result($result,'bundleName');
	$data['type'] =round(odbc_result($result,'type'));
	$data['ruleName'] =odbc_result($result,'ruleName');
	
	if (isset($ipbundle_list[$data['ipBundleName']])) {
		$ruleipbundle_list[$data['ruleName']][$data['type']][] = $data['ipBundleName'];
	}
}

// while ($data = odbc_fetch_array($query)) {
  // if (isset($ipbundle_list[$data['ipipBundleName']])) {
    // $ruleipbundle_list[$data['ruleName']][$data['type']][] = $data['ipipBundleName'];
  // }
// }

// user
$user_list = array();
$result = odbc_exec($db, "SELECT * FROM `$user_tablename`");

// most for dbf, since all of key will become captial letter
while(odbc_fetch_row($result)) {
	$data = array();
	$data['name'] =odbc_result($result,'name');
	
	$user_list[$data['name']][] = $data;
}

// while ($data = odbc_fetch_array($query)) {
  // $user_list[$data['name']][] = $data;
// }

$ruleuser_list = array();
$result = odbc_exec($db, "SELECT * FROM `$rule_user_tablename`");

// most for dbf, since all of key will become captial letter
while(odbc_fetch_row($result)) {
	$data = array();
	$data['userName'] =odbc_result($result,'userName');
	$data['ruleName'] =odbc_result($result,'ruleName');
	
	if (isset($user_list[$data['userName']])) {
		$ruleuser_list[$data['ruleName']][] = $data['userName'];
	}
}

// while ($data = odbc_fetch_array($query)) {
  // if (isset($user_list[$data['userName']])) {
    // $ruleuser_list[$data['ruleName']][] = $data['userName'];
  // }
// }

// group
$group_list = array();
$result = odbc_exec($db, "SELECT * FROM `$group_tablename`");

// most for dbf, since all of key will become captial letter
while(odbc_fetch_row($result)) {
	$data = array();
	$data['groupName'] =odbc_result($result,'groupName');
	$data['description'] =odbc_result($result,'descript');
	
	$group_list[$data['groupName']][] = $data;
}

// while ($data = odbc_fetch_array($query)) {
  // $group_list[$data['groupName']][] = $data;
// }
$rulegroup_list = array();
$result = odbc_exec($db, "SELECT * FROM `$rule_group_tablename`");

// most for dbf, since all of key will become captial letter
while(odbc_fetch_row($result)) {
	$data = array();
	$data['groupName'] =odbc_result($result,'groupName');
	$data['ruleName'] =odbc_result($result,'ruleName');
	
	if (isset($group_list[$data['groupName']])) {
		$rulegroup_list[$data['ruleName']][] = $data['groupName'];
	}
}

// while ($data = odbc_fetch_array($query)) {
  // if (isset($group_list[$data['groupName']])) {
    // $rulegroup_list[$data['ruleName']][] = $data['groupName'];
  // }
// }

include 'ui.temp.php';

?>