<?php

error_reporting(E_ALL | E_STRICT);

require_once "cmvar.php";

$queryName = "";
if (isset($_GET["selectedName"]))
	$queryName = $_GET["selectedName"];
else
	exit();

$settingobj = new COM('EGCONFIG.Cfgmgr') or die('setcfg.php EGCONFIG.Cfgmgr Object cannot be created!');

$dsnFile = $settingobj->getKey( 'Datasource', 'gateway');

$group_tablename = $settingobj->getKey('Datasource_group_Tablename', 'gateway');
$member_tablename = $settingobj->getKey('Datasource_member_Tablename', 'gateway');
$ipbundle_tablename = $settingobj->getKey('Datasource_ipbundle_Tablename', 'gateway');
$rule_ip_tablename = $settingobj->getKey('Datasource_rule_ip_Tablename', 'gateway');
$rule_ipbundle_tablename = $settingobj->getKey('Datasource_rule_ipbundle_Tablename', 'gateway');
$rule_user_tablename = $settingobj->getKey('Datasource_rule_user_Tablename', 'gateway');
$rule_group_tablename = $settingobj->getKey('Datasource_rule_group_Tablename', 'gateway');
$rule_port_tablename = $settingobj->getKey('Datasource_rule_port_Tablename', 'gateway');
$access_rule_tablename = $settingobj->getKey('Datasource_access_rule_Tablename', 'gateway');
$bw_rule_tablename = $settingobj->getKey('Datasource_bw_rule_Tablename', 'gateway');
$user_tablename = $settingobj->getKey('Datasource_Tablename', 'gateway');
$web_filter_tablename = $settingobj->getKey('Datasource_web_filter_Tablename', 'gateway');

$settingobj=null;

/**
 * Database connection
 */
if ($dsnSource = fopen($dsnFile, 'r')) { 
  $dsn = '';
  if (!feof($dsnSource)) {
    $dbType = fgets($dsnSource, 512);
  }
  while (!feof($dsnSource)) {
    $readLine = trim(fgets($dsnSource, 512));
    if (!empty($readLine)) {
      $dsn .= ($dsn ? ';' : '') . $readLine;
    }
  }
  fclose($dsnSource);
  $db = odbc_connect($dsn, '', '');
} else {
  exit('Cannot open DSN source file');
}

$web_filter_list = array();
$result = odbc_exec($db, "SELECT * FROM `$web_filter_tablename`");

while(odbc_fetch_row($result)) {
	$data = array();
	$data['webFilterName'] =odbc_result($result,'filterName');
	$data['description'] =odbc_result($result,'descript');
	$data['filterType'] =odbc_result($result,'filterType');
	
	$web_filter_list[$data['webFilterName']][] = $data;
}
 
$egAccessRule_list = array(); 
$result = odbc_exec($db, "SELECT * FROM `$access_rule_tablename` ORDER BY `seqOrder` ASC");

while(odbc_fetch_row($result)) {
	$data = array();
	$data['ruleName'] =odbc_result($result,'ruleName');
	$data['description'] =odbc_result($result,'descript');
	$data['seqOrder'] =round(odbc_result($result,'seqOrder'));
	$data['isAllow'] =odbc_result($result,'isAllow');
	$data['trafficType'] =odbc_result($result,'traffType');
	$data['isEnable'] =odbc_result($result,'isEnable');
	$data['appliedWebFilter'] =odbc_result($result,'webFltName');
	$data['schedule'] =odbc_result($result,'schedule');
	
	$egAccessRule_list[$data['ruleName']] = $data;
}

$ruleip_list = array();
$result = odbc_exec($db, "SELECT * FROM `$rule_ip_tablename`");

while(odbc_fetch_row($result)) {
	$data = array();
	$data['ip'] =odbc_result($result,'ip');
	$data['mask'] =odbc_result($result,'mask');
	$data['type'] =round(odbc_result($result,'type'));
	$data['ruleName'] =odbc_result($result,'ruleName');
	
	$ruleip_list[$data['ruleName']][$data['type']][] = $data;
}

$ruleport_list = array();
$result = odbc_exec($db, "SELECT * FROM `$rule_port_tablename`");       

while(odbc_fetch_row($result)) {
	$data = array();
	$data['fromPort'] =round(odbc_result($result,'fromPort'));
	$data['toPort'] =round(odbc_result($result,'toPort'));
	$data['protoNum'] =round(odbc_result($result,'protoNum'));
	$data['type'] =round(odbc_result($result,'type'));
	$data['ruleName'] =odbc_result($result,'ruleName');
	
	$ruleport_list[$data['ruleName']][$data['type']][] = $data;
}
    
$ipbundle_list = array();
$result = odbc_exec($db, "SELECT * FROM `$ipbundle_tablename`");

while(odbc_fetch_row($result)) {
	$data = array();
	$data['ipBundleName'] =odbc_result($result,'bundleName');
	$data['start_ip'] =odbc_result($result,'start_ip');
	$data['end_ip'] =odbc_result($result,'end_ip');
	
	$ipbundle_list[$data['ipBundleName']][] = $data;
}

$ruleipbundle_list = array();
$result = odbc_exec($db, "SELECT * FROM `$rule_ipbundle_tablename`");

while(odbc_fetch_row($result)) {
	$data = array();
	$data['ipBundleName'] =odbc_result($result,'bundleName');
	$data['type'] =round(odbc_result($result,'type'));
	$data['ruleName'] =odbc_result($result,'ruleName');
	
	if (isset($ipbundle_list[$data['ipBundleName']])) {
		$ruleipbundle_list[$data['ruleName']][$data['type']][] = $data['ipBundleName'];
	}
}

// user
$user_list = array();
$result = odbc_exec($db, "SELECT * FROM `$user_tablename`");

while(odbc_fetch_row($result)) {
	$data = array();
	$data['name'] =odbc_result($result,'name');
	
	$user_list[$data['name']][] = $data;
}

$ruleuser_list = array();
$result = odbc_exec($db, "SELECT * FROM `$rule_user_tablename`");

while(odbc_fetch_row($result)) {
	$data = array();
	$data['userName'] =odbc_result($result,'userName');
	$data['ruleName'] =odbc_result($result,'ruleName');
	
	if (isset($user_list[$data['userName']])) {
		$ruleuser_list[$data['ruleName']][] = $data['userName'];
	}
}

// group
$group_list = array();
$result = odbc_exec($db, "SELECT * FROM `$group_tablename`");

while(odbc_fetch_row($result)) {
	$data = array();
	$data['groupName'] =odbc_result($result,'groupName');
	$data['description'] =odbc_result($result,'descript');
	
	$group_list[$data['groupName']][] = $data;
}

$rulegroup_list = array();
$result = odbc_exec($db, "SELECT * FROM `$rule_group_tablename`");

while(odbc_fetch_row($result)) {
	$data = array();
	$data['groupName'] =odbc_result($result,'groupName');
	$data['ruleName'] =odbc_result($result,'ruleName');
	
	if (isset($group_list[$data['groupName']])) {
		$rulegroup_list[$data['ruleName']][] = $data['groupName'];
	}
}


$match_rule_list = array();
$count_match = 0;
foreach ($egAccessRule_list as $ruleName => $ruleData){
	$isRuleMatchUserName = false;
	if (isset($ruleuser_list[$ruleName]) || (isset($rulegroup_list[$ruleName]))){
		// user
		if (isset($ruleuser_list[$ruleName])){
			foreach ($ruleuser_list[$ruleName] as $username){
				if ($username == $queryName){
					$isRuleMatchUserName = true;
					break;
				}
			}
		}
		if (!$isRuleMatchUserName){
			// group
			if (isset($rulegroup_list[$ruleName])){
				foreach ($rulegroup_list[$ruleName] as $groupname){
				
					if (isset($member_list[$groupname])){
						foreach ($member_list[$groupname] as $arr){
							if ($arr['userName'] == $queryName){
								$isRuleMatchUserName = true;
								break;
							}
						}
					}
					
					if ($isRuleMatchUserName){
						break;
					}
					
				}
			}
		}
	}
	else{
		// rule not set user/group
		$isRuleMatchUserName = true;
	}
	
	if ($isRuleMatchUserName){
		$match_rule_list[$count_match] = $ruleName;
		$count_match++;
	}
}

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<style type="text/css">
	body, form			{ padding: 0px; margin: 0px; font-family: Arial; }
	a				{ text-decoration: none; }
	.graphicBtn		{ cursor: pointer; font-size: 10pt; font-weight: bold; color: #003300; background: #dddddd; border: 1px solid #18A718; }
</style>
</head>
<body>
<script type="text/javascript" src="ui/combine.js"></script>

<script type="text/javascript">
	var userAgent = navigator.userAgent.toLowerCase();
	var is_opera = userAgent.indexOf('opera') != -1 && opera.version();
	var is_moz = (navigator.product == 'Gecko') && userAgent.substr(userAgent.indexOf('firefox') + 8, 3);
	var is_ie = (userAgent.indexOf('msie') != -1 && !is_opera) && userAgent.substr(userAgent.indexOf('msie') + 5, 3);

	function doane(event) {
		e = event ? event : window.event;
		if (is_ie) {
			e.cancelBubble = true;
		} else {
			e.stopPropagation();
		}
	}
</script>

<script type="text/javascript">
  function collapseAll() {
	<?php
	$count = 1;
	foreach ($egAccessRule_list as $ruleName => $ruleData){
		$count++;
	}
	?>
	var num = <?=$count?>;
    for (var i =1; i < num; i++ ) {
      var obj = document.getElementById('rule_collapse_box_' + i);
  		obj.innerHTML = '&darr;';
  	  collapseExpand.perform('collapse', 'rule_data_' + i, function() {});     
  		obj.title = 'Expand';
    }
  }

</script>


<script type="text/javascript">
	function rule_selectBoxInit(id) {
		var boxObj = document.getElementById('rule_select_box_' + id);
		var checkboxObj = document.getElementById('rule_select_chkbox_' + id);
		boxObj.onclick = function() {
			document.getElementById('rule_select_chkbox_' + id).checked = !document.getElementById('rule_select_chkbox_' + id).checked;
			document.getElementById('rule_select_box_' + id).style.background = document.getElementById('rule_select_chkbox_' + id).checked ? '#eee' : '#fff';
		}
		boxObj.onmouseout = function() {
			if (!checkboxObj.checked) {
				boxObj.style.background = '#fff';
			}
		}
		boxObj.onmouseover = function() {
			boxObj.style.background = '#eee';
		}
		checkboxObj.onclick = function(event) {
			boxObj.style.background = checkboxObj.checked ? '#eee' : '#fff';
			doane(event);
		}
		checkboxObj.onselectstart = function() {
			return false;
		}
		boxObj.onselectstart = function() {
			return false;
		}
	}
</script> 


<!--ModuleHiddenInput start-->
<style type="text/css">
	.ch { background-color: #eee; width: 100px; border: 1px solid #eee; font-size: 12px; }
	.cs { background-color: #fff; width: 100px; border: 1px solid #aaa; font-size: 12px; }
	
	.ch_ip { background-color: #eee; width: 200px; border: 1px solid #eee; font-size: 12px; }
	.cs_ip { background-color: #fff; width: 200px; border: 1px solid #aaa; font-size: 12px; }
	
	.ch_u { background-color: #eee; width: 120px; border: 1px solid #eee; font-size: 12px; }
</style>
<script type="text/javascript">
	var moduleHiddenInput = new ModuleHiddenInput();
</script>
<!--ModuleHiddenInput end-->


<!--Form decoration start-->
<style type="text/css">
	.main_normal		{ height: 15px; line-height: 15px; border: 1px solid white; background: #fff; cursor: pointer; padding: 0px 2px; font-size: 12px; font-weight: normal; }
	.main_click			{ height: 15px; line-height: 15px; border: 1px solid black; background: #fff; cursor: pointer; padding: 0px 2px; font-size: 12px; font-weight: normal; border-bottom: 0px; }
	.main_mouseover		{ height: 15px; line-height: 15px; border: 1px solid black; background: #fff; cursor: pointer; padding: 0px 2px; font-size: 12px; font-weight: normal; }
	.icon_normal		{ margin: 2px 0px 2px 3px; }
	.icon_active		{ margin: 2px 0px 2px 3px; }
	.list_box			{ padding-top: 3px; background: #fff; border: 1px solid black; font-weight: normal; }
	.list_item_normal	{ font-size: 12px; cursor: pointer; padding: 0px 2px; font-weight: normal; }
	.list_item_mouseover{ font-size: 12px; cursor: pointer; padding: 0px 2px; font-weight: normal; background: #eee; }
</style>
<script type="text/javascript">
	var moduleFormDecoration = new ModuleFormDecoration();
</script>
<!--Form decoration end-->


<style type="text/css">
	.rule { width: 750px; font-size: 12px; }
	.rule_state_red { background: #FE7276; }
	.rule_state_green { background: #41DB00; }
	.rule_state_grey { background: #aaa; }
	.rule_statetxt_red { color: #FE7276; }
	.rule_statetxt_green { color: #007C21; }
	.rule_statetxt_grey { color: #777; }
	.rule_chkbx { background: #fff; width: 40px; padding: 4px; border-right: 1px solid #ccc; text-align: center; cursor: move; -moz-user-select: none; }
	.rule_data_left { padding-left: 15px; background: #eee; border-top: 1px solid #ccc; line-height: 18px; }
	.rule_data_right { width: 240px; background: #eee; border-top: 1px solid #ccc; line-height: 18px; }
	.rule_collapse_box { padding: 0px; width: 12px; font-size: 14px; cursor: pointer; color: #777; background: #eee;font-weight: normal;text-align: center; -moz-user-select: none; }
	.rule_chkbx_no_cursor { background: #fff; width: 40px; padding: 4px; border-right: 1px solid #ccc; text-align: center; -moz-user-select: none; }
	.rule_title { background: #fff;}
	
	.ch_not_match { background-color: #fff; width: 100px; border: 1px solid #fff; font-size: 12px; color: #848284;}
	.ch_ip_not_match { background-color: #fff; width: 200px; border: 1px solid #fff; font-size: 12px; color: #848284;}
	.ch_u_not_match { background-color: #fff; width: 120px; border: 1px solid #fff; font-size: 12px; color: #848284;}
	
	.rule_data_left_not_match { padding-left: 15px; background: #fff; border-top: 1px solid #ccc; line-height: 18px; color: #848284;}
	.rule_data_right_not_match { width: 240px; background: #fff; border-top: 1px solid #ccc; line-height: 18px; color: #848284;}
	.rule_chkbx_no_cursor_no_match { background: #DEDFDE; width: 40px; padding: 4px; border-right: 1px solid #ccc; text-align: center; -moz-user-select: none; color: #848284;}
	.rule_title_not_match { background: #DEDFDE; color: #848284;}


</style>

<?php
function schTransStr($str){
	$w = 0;
	$h = 0;

	$message="";

	$weekArr = array('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat');	
	$hourArr = array('00', '01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23');
	$fromMinuteArr = array(':00', ':15', ':30', ':45');
	$toMinuteArr = array(':59', ':14', ':29', ':44');

	$bitAray = array(1,2,4,8);
	$isContinue = false;
	$isFirst = true;

	for ($i=0; $i < strlen($str); $i++){
		$val = hexdec($str[$i]);		
		
		for($j=0; $j<4; $j++){
			if ($val & $bitAray[$j]){
				if ($isContinue == false){
					$isContinue = true;
					
					if ($isFirst == true){
						$isFirst = false;
					}
					else{						
						$message.= ", </span>";
					}
					
					$message.= "<span style='white-space: nowrap;'>".$weekArr[$w]." ".$hourArr[$h].$fromMinuteArr[$j]."~";
				}
			}
			else{
				if ($isContinue == true){
					$isContinue = false;
					$message.= "".$weekArr[$w]." ".$hourArr[$h].$toMinuteArr[$j]."";
				}
			}
		}
		
		$h++;
		
		if ($h == 24){
			$h=0;
			$w++;		
			if ($w == 7){
				$w=6;
				$h=23;
			}
		}		
		
		// special for last
		if ($i == (strlen($str) -1)){
			if ($val & $bitAray[3]){
				if ($isContinue == true){
					$isContinue = false;
					$message.= "".$weekArr[$w]." ".$hourArr[$h].$toMinuteArr[0]."</span>";
				}
			}
		}
	}
	return $message;
}
?>

<!-- Rule-->
<form name = "access_rule_form" action="" method="post" >
<div style="padding: 0px; margin: 0px; width: 750px; border: 1px solid green; border-bottom: 0px;" id="rule_boxset">
  <?php $count = 1; ?>
  <?php foreach ($egAccessRule_list as $ruleName => $ruleData) { ?>
	<?php
		$ruleMatchUser = false;
	
		$chkbx_class_id = "rule_chkbx_no_cursor_no_match";
		$left_class_id = "rule_data_left_not_match";
		$right_class_id = "rule_data_right_not_match";
		$input_class_id = "ch_not_match";
		$input_ip_class_id = "ch_ip_not_match";
		$input_u_class_id = "ch_u_not_match";
		$title_class_id = "rule_title_not_match";
		foreach ($match_rule_list as $val){
			if ($val == $ruleName){
				$chkbx_class_id = "rule_chkbx_no_cursor";
				$left_class_id = "rule_data_left";
				$right_class_id = "rule_data_right";
				$input_class_id = "ch";
				$input_ip_class_id = "ch_ip";
				$input_u_class_id = "ch_u";
				$title_class_id = "rule_title";
				$ruleMatchUser = true;
				break;
			}
		}
	
	?>
  	<div class="rule" id="rule_box_<?=$count?>">
  		<table cellpadding="0" cellspacing="0" border="0" style="border-bottom: 1px solid green; width: 100%; font-size: 12px;">
  			<tr>
  				<td class="<?=$chkbx_class_id?>" id="rule_select_box_<?=$count?>" valign="top">
  					<b><?=$ruleData['seqOrder']?></b><br/>
  				</td>
  				<td style="text-align: left;">
  					<table cellpadding="4" cellspacing="0" border="0" style="width: 100%; font-weight: bold; font-size: 12px;">
  						<tr>
  							<td style="width: 7px;" id="rule_state_box_<?=$count?>" class="rule_state_<? if ($ruleData['isEnable'] == 1) { if ($ruleData['isAllow'] == 1) { ?>green<? } else{ ?>red<? }} else { ?>grey<? } ?>"></td>
  							<td class = "<?=$title_class_id?>">
  								<div style="margin-bottom: 6px; font-weight: bold; font-size: 14px;">
  									<div style="float: right; font-size: 12px;">
  										<span style="font-size: 11px;" id="rule_state_text_<?=$count?>" class="rule_statetxt_<? if ($ruleMatchUser){ if ($ruleData['isEnable'] == 1) { if ($ruleData['isAllow'] == 1) { ?>green<? } else{ ?>red<? }} else { ?>grey<? } } else { ?>grey<? } ?>"><? if ($ruleData['isEnable'] == 1) { ?>[<?=get_cm_var('setcfg_arule_en')?>]<? } else { ?>[<?=get_cm_var('setcfg_arule_dis')?>]<? } ?></span>&nbsp;<?=get_cm_var('setcfg_arule_label_act')?> 
										<?
											$actionStr = "";
											if ($ruleData['isAllow'] == 1)
												$actionStr = get_cm_var('setcfg_arule_act_opt1');
											else if ($ruleData['isAllow'] == 0)
												$actionStr = get_cm_var('setcfg_arule_act_opt2');
												
											$trafficTypeStr = "";
											if ($ruleData['trafficType'] == 0)
												$trafficTypeStr = get_cm_var('setcfg_arule_traffic_opt1');
											if ($ruleData['trafficType'] == 1)
												$trafficTypeStr = get_cm_var('setcfg_arule_traffic_opt2');
											if ($ruleData['trafficType'] == 2)
												$trafficTypeStr = get_cm_var('setcfg_arule_traffic_opt3');
												
										?> <span style="font-weight: normal;"><?=$actionStr?></span>&nbsp;<?=get_cm_var('setcfg_arule_label_traffic')?><span style="font-weight: normal;"><?=$trafficTypeStr?></span>
  									</div>
  									<u><?=$ruleData['ruleName']?></u>
									<input type="hidden" value="<?=$ruleData['ruleName']?>" id="rule_name_<?=$count?>" name="rule_name_<?=$count?>" />
  								</div>
  								<div style="padding-left: 10px;"><?=$ruleData['description']?></div>
								<input type="hidden" value="<?=$ruleData['description']?>" id="rule_description_<?=$count?>" name="rule_description_<?=$count?>" />
  							</td>
  							<td class="rule_collapse_box" id="rule_collapse_box_<?=$count?>" onselectstart="javascript: return false;" onmouseover="javascript: this.style.background='#ddd'; this.style.color='black';" onmouseout="javascript: this.style.background='#eee'; this.style.color='#777';" onclick="javascript: ruleDetailCollapse(this, <?=$count?>);" title="Collapse">
  								&uarr;
  							</td>
  						</tr>
						<?php 
							if (!$ruleMatchUser){
								?>
								<tr><td></td><td align="center" ><span style="background: #FFF;color: #FF0000;"> <?=get_cm_var('qrule_not_applied_rule')?> (<?=$queryName?>) </span></td><td></td></tr>
								<?
							}
						?>
  					</table>
					
					<div id="rule_data_<?=$count?>" style="overflow: hidden;">
  						<table cellpadding="3" cellspacing="0" border="0" style="width: 100%; font-size: 12px;"> 

							<!-- Source IP-->
							<tr>
								<td class="<?=$left_class_id?>" valign="top">
									<div><span style="font-weight: bold;"><?=get_cm_var('setcfg_arule_label_src_ip')?></span><br/>
									<!--ip-->
									<?php $ipCount = 0; ?>
									<?php if (isset($ruleip_list[$ruleName]) && isset($ruleip_list[$ruleName][1])) { ?>
										<div style="padding-left: 10px;">
									<?php foreach ($ruleip_list[$ruleName][1] as $ruleipData) { ?>
										<span style="padding-right: 10px;">
											<input type="text" id="hinput_<?=$count?>_source_<?=$ipCount?>" name="hinput_<?=$count?>_source_<?=$ipCount?>" value="<?=$ruleipData['ip']?> (<?=$ruleipData['mask']?>)" class="<?=$input_ip_class_id?>" title="<?=$ruleipData['ip']?> (<?=$ruleipData['mask']?>)" readonly />
										</span>
										<?php $ipCount++; ?>
									  <?php } ?>
										</div>
									<?php } ?>
									
									<!--ipbundle-->
									<?php $ipbundleCount = 0; ?>
									<?php if (isset($ruleipbundle_list[$ruleName]) && isset($ruleipbundle_list[$ruleName][1])) { ?>
									<?php foreach ($ruleipbundle_list[$ruleName][1] as $bundleName) { ?>  
									<div style="padding-left: 10px;">
										<table>
										<tr><td valign="top">[<?=$bundleName?>]</td>
										<td>
										<input type="hidden" value="<?=$bundleName?>" id="hinput_<?=$count?>_source_ipbundle_<?=$ipbundleCount?>" name="hinput_<?=$count?>_source_ipbundle_<?=$ipbundleCount?>" />
									  <?php if (isset($ipbundle_list[$bundleName])) { ?>
										<?php $countBundle = 0;?>
										<?php foreach ($ipbundle_list[$bundleName] as $bundleData) { ?>
										  <span style="padding-right: 10px;"><?=long2ip($bundleData['start_ip'])?> to <?=long2ip($bundleData['end_ip'])?><?if ($countBundle < (count($ipbundle_list[$bundleName]) -1)) echo ",";?></span>
										  <?php $countBundle++;?>
										<?php } ?>
									  <?php } ?>
										</td></tr>
									  </table>
									</div>
										<?php $ipbundleCount++; ?>
									  <?php } ?>
									<?php } ?>
									<? if ($ipCount == 0 && $ipbundleCount == 0){
										// default
										echo '<div style="padding-left: 10px; height: 20px; font-weight: normal;">'.get_cm_var('setcfg_arule_all_IP').'</div>';
									}
									?>
									</div>
								</td>
							</tr>
							
							<!-- Source Protocol-->
							<tr>
								<td class="<?=$left_class_id?>" valign="top">
									<div><span style="font-weight: bold;"><?=get_cm_var('setcfg_arule_label_src_proto')?></span><br/>
									<?php $portCount = 0; ?>
									<?php if (isset($ruleport_list[$ruleName]) && isset($ruleport_list[$ruleName][1])) { ?>
										<div style="padding-left: 10px;">
									<?php foreach ($ruleport_list[$ruleName][1] as $ruleportData) { ?>
									<?php 
										$srcValStr = "";
										
										if ($ruleportData['protoNum'] == 6){
											$srcValStr = get_cm_var('setcfg_arule_proto_opt1')." (".$ruleportData['fromPort']."-".$ruleportData['toPort'].")";
										}
										else if ($ruleportData['protoNum'] == 17){
											$srcValStr = get_cm_var('setcfg_arule_proto_opt2')." (".$ruleportData['fromPort']."-".$ruleportData['toPort'].")";
										}
										else{
											$srcValStr = get_cm_var('setcfg_arule_proto_opt3')." (".$ruleportData['protoNum'].")";
										}
										
									?>
											<span style="padding-right: 10px;">
												<input type="text" id="hinput_<?=$count?>_sourcep_<?=$portCount?>" name="hinput_<?=$count?>_sourcep_<?=$portCount?>" value="<?=$srcValStr?>" class="<?=$input_class_id?>" title="<?=$srcValStr?>" class="<?=$input_class_id?>" readonly />
											</span>
										<?php $portCount++; ?>
									  <?php } ?>
										</div>
									<?php } ?>
									<? if ($portCount == 0){
										// default
										echo '<div style="padding-left: 10px; font-weight: normal;">'.get_cm_var('setcfg_arule_all_proto').'</div>';
									}
									?>
									</div>
								</td>
							</tr>
							
							<!-- Destination IP-->
							<tr>
								<td class="<?=$left_class_id?>" valign="top">
									<div><span style="font-weight: bold;"><?=get_cm_var('setcfg_arule_label_dest_ip')?></span><br/>
									<!--ip-->
									<?php $ipCount = 0; ?>
									<?php if (isset($ruleip_list[$ruleName]) && isset($ruleip_list[$ruleName][0])) { ?>
										<div style="padding-left: 10px;">
									<?php foreach ($ruleip_list[$ruleName][0] as $ruleipData) { ?>
										<span style="padding-right: 10px;">
											<input type="text" id="hinput_<?=$count?>_dest_<?=$ipCount?>" name="hinput_<?=$count?>_dest_<?=$ipCount?>" value="<?=$ruleipData['ip']?> (<?=$ruleipData['mask']?>)" class="<?=$input_ip_class_id?>" title="<?=$ruleipData['ip']?> (<?=$ruleipData['mask']?>)" readonly />
										</span>
										<?php $ipCount++; ?>
									  <?php } ?>
										</div>
									<?php } ?>
									
									<!--ipbundle-->
									<?php $ipbundleCount = 0; ?>
									<?php if (isset($ruleipbundle_list[$ruleName]) && isset($ruleipbundle_list[$ruleName][0])) { ?>    
									<?php foreach ($ruleipbundle_list[$ruleName][0] as $bundleName) { ?>
									<div style="padding-left: 10px;">
										<table>
										<tr><td valign="top">[<?=$bundleName?>]</td>
										<td>
										<input type="hidden" value="<?=$bundleName?>" id="hinput_<?=$count?>_dest_ipbundle_<?=$ipbundleCount?>" name="hinput_<?=$count?>_dest_ipbundle_<?=$ipbundleCount?>"/>
									  <?php if (isset($ipbundle_list[$bundleName])) { ?>
										<?php $countBundle = 0;?>
										<?php foreach ($ipbundle_list[$bundleName] as $bundleData) { ?>
										  <span style="padding-right: 10px;"><?=long2ip($bundleData['start_ip'])?> to <?=long2ip($bundleData['end_ip'])?><?if ($countBundle < (count($ipbundle_list[$bundleName]) -1)) echo ",";?></span>
										  <?php $countBundle++;?>
										<?php } ?>
									  <?php } ?>
										</td></tr>
									  </table>
									</div>
										<?php $ipbundleCount++; ?>
									  <?php } ?>
									<?php } ?>
									<? if ($ipCount == 0 && $ipbundleCount == 0){
										// default
										echo '<div style="padding-left: 10px; font-weight: normal;">'.get_cm_var('setcfg_arule_all_IP').'</div>';
									}
									?>
									</div>
								</td>
							</tr>
							
							<!-- Destination Protocol-->
							<tr>
								<td class="<?=$left_class_id?>" valign="top">
									<div><span style="font-weight: bold;"><?=get_cm_var('setcfg_arule_label_dest_proto')?></span><br/>
									<?php $portCount = 0; ?>
									<?php if (isset($ruleport_list[$ruleName]) && isset($ruleport_list[$ruleName][0])) { ?>
										<div style="padding-left: 10px;">
									<?php foreach ($ruleport_list[$ruleName][0] as $ruleportData) { ?>
									<?php 
										$destValStr = "";
										
										if ($ruleportData['protoNum'] == 6){
											$destValStr = get_cm_var('setcfg_arule_proto_opt1')." (".$ruleportData['fromPort']."-".$ruleportData['toPort'].")";
										}
										else if ($ruleportData['protoNum'] == 17){
											$destValStr = get_cm_var('setcfg_arule_proto_opt2')." (".$ruleportData['fromPort']."-".$ruleportData['toPort'].")";
										}
										else{
											$destValStr = get_cm_var('setcfg_arule_proto_opt3')." (".$ruleportData['protoNum'].")";
										}
										
									?>
											<span style="padding-right: 10px;">
												<input type="text" id="hinput_<?=$count?>_destp_<?=$portCount?>" name="hinput_<?=$count?>_destp_<?=$portCount?>" value="<?=$destValStr?>" class="<?=$input_class_id?>" title="<?=$destValStr?>" readonly />                     
											</span>
										<?php $portCount++; ?>
									  <?php } ?>
										</div>
									<?php } ?>
									<? if ($portCount == 0){
										// default
										echo '<div style="padding-left: 10px; font-weight: normal;">'.get_cm_var('setcfg_arule_all_proto').'</div>';
									}
									?>
									</div>
								</td>
							</tr>
							
							<!-- User and Group-->
							<tr>
								<td class="<?=$left_class_id?>" valign="top" colspan =2>
									<div><span style="font-weight: bold;"><?=get_cm_var('setcfg_arule_label_user_and_group')?></span><br/>
									<?php $userCount = 0; ?>
									<?php if (isset($ruleuser_list[$ruleName])) { ?>
										<div style="padding-left: 10px;">
									<?php foreach ($ruleuser_list[$ruleName] as $username) { ?>
											<span style="padding-right: 10px;">
												<input type="text" id="hinput_<?=$count?>_user_and_group_<?=$userCount?>" name="hinput_<?=$count?>_user_and_group_<?=$userCount?>" value="<?=$username?> (user)" title="<?=$username?> (user)" class="<?=$input_u_class_id?>" readonly />
											</span>
										<?php $userCount++; ?>
									  <?php } ?>
										</div>
									<?php } ?>
									<?php $groupCount = 0; ?>
									<?php if (isset($rulegroup_list[$ruleName])) { ?>
									  <?php $groupCount = $userCount; ?>
										<div style="padding-left: 10px;">
									<?php foreach ($rulegroup_list[$ruleName] as $groupname) { ?>
											<span style="padding-right: 10px;">
												<input type="text" id="hinput_<?=$count?>_user_and_group_<?=$groupCount?>" name="hinput_<?=$count?>_user_and_group_<?=$groupCount?>" value="<?=$groupname?> (group)" title="<?=$groupname?> (group)" class="<?=$input_u_class_id?>" readonly />
											</span>
										<?php $groupCount++; ?>
									  <?php } ?>
										</div>
									<?php } ?>
									<? if ($userCount == 0 && $groupCount == 0){
										// default
										echo '<div style="padding-left: 10px; font-weight: normal;">'.get_cm_var('setcfg_arule_all_user').'</div>';
									}
									?>
									</div>
								</td>
							</tr>
							
							<!--Schedule-->
							<tr>
								<td class="<?=$left_class_id?>" valign="top" colspan =2>
									<div><span style="font-weight: bold;"><?=get_cm_var('setcfg_arule_label_sch')?></span><br/>
									<?php
										if (strlen($ruleData['schedule']) == 0){
											echo '<div style="padding-left: 10px; font-weight: normal;">'.get_cm_var('setcfg_arule_all_schedule').'</div>';
										}
										else if (substr_count(strtoupper($ruleData['schedule']),"F")==168){
											echo '<div style="padding-left: 10px; font-weight: normal;">'.get_cm_var('setcfg_arule_all_schedule').'</div>';
										}
										else{
											echo '<div style="padding-left: 10px; font-weight: normal;">'.schTransStr($ruleData['schedule']).'</div>';
										}
										echo '<input type="hidden" value="'.$ruleData['schedule'].'" id="schedule_'.$count.'" name="schedule_'.$count.'" />';
									?>
									</div>
								</td>
							</tr>
							
							<!--Web Filter-->
							<tr>
								<td class="<?=$left_class_id?>" valign="top" colspan =2>
									<?
									if (strlen($ruleData['appliedWebFilter']) > 0 ){
									?>
									<div><span style="font-weight: bold;"><?=get_cm_var('setcfg_arule_label_wf')?></span><br/>
									<div style="padding-left: 10px;"><?=$ruleData['appliedWebFilter']?></div>
									<?
									}
									?>
									<input type="hidden" value="<?=$ruleData['appliedWebFilter']?>" id="applied_web_filter_<?=$count?>" name="applied_web_filter_<?=$count?>" />
								</td>
							</tr>
							
  						</table>
  					</div>
					
  				</td>
  			</tr>
  		</table>
  	</div>
  	<?php $count++; ?>
  <?php } ?>
</div>
</form>
<!-- End Rule-->

<!--ModuleCollapseExpand start-->
<script type="text/javascript">
	var collapseExpand = new ModuleCollapseExpand();
	var updateTimer;
	function ruleDetailCollapse(obj, id) {
		var stateExpanded = obj.title == 'Collapse';
		obj.innerHTML = stateExpanded ? '&darr;' : '&uarr;';
		if (stateExpanded) {
			collapseExpand.perform('collapse', 'rule_data_' + id, function() {});
		} else {
			collapseExpand.perform('expand', 'rule_data_' + id, function() {});
		}
		obj.title = stateExpanded ? 'Expand' : 'Collapse';
	}
</script>
<!--ModuleCollapseExpand end-->

<script type="text/javascript">
	collapseAll();
</script>

</body>
</html>