<?php
$content .= "# EaseGate Virtual Hosts Setting - Please do not modify\r\n";
$content .= "\r\n";
$content .= "###########################################\r\n";
$content .= "###\t\t\tVirtual Hosts\t\t\t\t###\r\n";
$content .= "###########################################\r\n";
$content .= "# Change error log level\r\n";
$content .= "LogLevel crit\r\n";
$content .= "# Defines environment variables\r\n";
$content .= "SetEnvIf Request_URI \"\.$\" vhlog\r\n";
$content .= "UseCanonicalName Off\r\n";
$content .= "#Administration port\r\n";
$content .= "Listen $admin_port\r\n";
$content .= "#Authentication port\r\n";
$content .= "Listen $auth_port\r\n";
$content .= "\r\n";
$content .= "<VirtualHost 127.0.0.1:80>\r\n";
$content .= "\tServerAdmin EaseGate@patronsoft.com\r\n";
$content .= "\tServerName 127.0.0.1:80\r\n";
$content .= "\tDocumentRoot \"$fspath/EaseGatedemo\"\r\n";
$content .= "\r\n";
$content .= "\t<IfModule dir_module>\r\n";
$content .= "\t\tDirectoryIndex index.html\r\n";
$content .= "\t</IfModule>\r\n";
$content .= "</VirtualHost>\r\n";
$content .= "\r\n";
$content .= "\r\n";
$content .= "<VirtualHost $internalIP:80>\r\n";
$content .= "\tServerAdmin EaseGate@patronsoft.com\r\n";
$content .= "\tServerName $internalIP:80\r\n";
$content .= "\tDocumentRoot \"$fspath/authserv\"\r\n";
$content .= "\r\n";
$content .= "\tRewriteEngine on\r\n";
$content .= "\tRewriteCond %(REQUEST_FILENAME) !-F\r\n";
$content .= "\tRewriteRule ^/(.+) /EaseGate.php\r\n";
$content .= "\t# Disable directory listing\r\n";
$content .= "\t<Directory \"$fspath/authserv\">\r\n";
$content .= "\t\tOptions -Indexes\r\n";
$content .= "\t</Directory>\r\n";
$content .= "\r\n";
$content .= "\t<IfModule dir_module>\r\n";
$content .= "\t\tDirectoryIndex EaseGate.php\r\n";
$content .= "\t</IfModule>\r\n";
$content .= "</VirtualHost>\r\n";
$content .= "\r\n";
$content .= "\r\n";
$content .= "# demo page (no External connection)\r\n";
$content .= "<VirtualHost $externalIP:80>\r\n";
$content .= "\tServerAdmin EaseGate@patronsoft.com\r\n";
$content .= "\tServerName $externalIP:80\r\n";
$content .= "\tDocumentRoot \"$fspath/EaseGatedemo\"\r\n";
$content .= "\r\n";
$content .= "\t# Disable directory listing\r\n";
$content .= "\t<Directory \"$fspath/EaseGatedemo\">\r\n";
$content .= "\t\tOptions -Indexes\r\n";
$content .= "\t</Directory>\r\n";
$content .= "\r\n";
$content .= "\t<IfModule dir_module>\r\n";
$content .= "\t\tDirectoryIndex index.html\r\n";
$content .= "\t</IfModule>\r\n";
$content .= "</VirtualHost>\r\n";
$content .= "\r\n";
$content .= "\r\n";
$content .= "# cfgmgr (localhost)\r\n";
$content .= "<VirtualHost 127.0.0.1:$admin_port>\r\n";
$content .= "\tServerAdmin EaseGate@patronsoft.com\r\n";
$content .= "\tServerName 127.0.0.1:$admin_port\r\n";
$content .= "\tDocumentRoot \"$fspath/cfgmgr\"\r\n";
$content .= "\r\n";
$content .= "\t<IfModule dir_module>\r\n";
$content .= "\t\tDirectoryIndex setlogin.php\r\n";
$content .= "\t</IfModule>\r\n";
$content .= "</VirtualHost>\r\n";
$content .= "\r\n";
$content .= "\r\n";
$content .= "# cfgmgr (internal)\r\n";
$content .= "<VirtualHost $internalIP:$admin_port>\r\n";
$content .= "\tServerAdmin EaseGate@patronsoft.com\r\n";
$content .= "\tServerName $internalIP:$admin_port\r\n";
$content .= "\tDocumentRoot \"$fspath/cfgmgr\"\r\n";
$content .= "\r\n";
$content .= "\t# Disable directory listing\r\n";
$content .= "\t<Directory \"$fspath/cfgmgr\">\r\n";
$content .= "\t\tOptions -Indexes\r\n";
$content .= "\t</Directory>\r\n";
$content .= "\r\n";
$content .= "\t<IfModule dir_module>\r\n";
$content .= "\t\tDirectoryIndex setlogin.php\r\n";
$content .= "\t</IfModule>\r\n";
$content .= "\t<Files setlogin.php> Order Deny,Allow\r\n";
$content .= "\t\tDeny from all\r\n";
$content .= "\t\tAllow from $internalSubnet/$internalMask\r\n";
$content .= "\t</Files>\r\n";
$content .= "</VirtualHost>\r\n";
$content .= "\r\n";
$content .= "\r\n";
$content .= "# cfgmgr (external)\r\n";
$content .= "<VirtualHost $externalIP:$admin_port>\r\n";
$content .= "\tServerAdmin EaseGate@patronsoft.com\r\n";
$content .= "\tServerName $externalIP:$admin_port\r\n";
$content .= "\tDocumentRoot \"$fspath/cfgmgr\"\r\n";
$content .= "\r\n";
$content .= "\t# Disable directory listing\r\n";
$content .= "\t<Directory \"$fspath/cfgmgr\">\r\n";
$content .= "\t\tOptions -Indexes\r\n";
$content .= "\t</Directory>\r\n";
$content .= "\r\n";
$content .= "\t<IfModule dir_module>\r\n";
$content .= "\t\tDirectoryIndex setlogin.php\r\n";
$content .= "\t</IfModule>\r\n";
$content .= "\t<Files setlogin.php> Order Allow,Deny\r\n";
$content .= "\t\tDeny from all\r\n";
$content .= "\t\tDeny from $internalSubnet/$internalMask\r\n";
$content .= "\t</Files>\r\n";
$content .= "</VirtualHost>\r\n";
$content .= "\r\n";
$content .= "\r\n";
$content .= "# authserv (localhost)\r\n";
$content .= "<VirtualHost 127.0.0.1:$auth_port>\r\n";
$content .= "\tServerAdmin EaseGate@patronsoft.com\r\n";
$content .= "\tServerName 127.0.0.1:$auth_port\r\n";
$content .= "\tDocumentRoot \"$fspath/authserv\"\r\n";
$content .= "\r\n";
$content .= "\t<IfModule dir_module>\r\n";
$content .= "\t\tDirectoryIndex login_form.php\r\n";
$content .= "\t</IfModule>\r\n";
$content .= "</VirtualHost>\r\n";
$content .= "\r\n";
$content .= "\r\n";
$content .= "# authserv (internal)\r\n";
$content .= "<VirtualHost $internalIP:$auth_port>\r\n";
$content .= "\tServerAdmin EaseGate@patronsoft.com\r\n";
$content .= "\tServerName $internalIP:$auth_port\r\n";
$content .= "\tDocumentRoot \"$fspath/authserv\"\r\n";
$content .= "\r\n";
$content .= "\t# Disable directory listing\r\n";
$content .= "\t<Directory \"$fspath/authserv\">\r\n";
$content .= "\t\tOptions -Indexes\r\n";
$content .= "\t</Directory>\r\n";
$content .= "\r\n";
$content .= "\t<IfModule dir_module>\r\n";
$content .= "\t\tDirectoryIndex login_form.php\r\n";
$content .= "\t</IfModule>\r\n";
$content .= "</VirtualHost>\r\n";
$content .= "\r\n";
$content .= "\r\n";
$content .= "###########################################\r\n";
$content .= "### \t\t\tSSL sites\t\t\t\t###\r\n";
$content .= "###########################################\r\n";
$content .= "\r\n";
$content .= "# SSL well-known port\r\n";
$content .= "Listen 443\r\n";
$content .= "# port to redirect ssl request client when user is not authenticate\r\n";
$content .= "Listen $redirect_port\r\n";
$content .= "\r\n";
$content .= "# see http://www.modssl.org/docs/2.8/ssl_reference.html for more info\r\n";
$content .= "SSLMutex default\r\n";
$content .= "SSLSessionCache none\r\n";
$content .= "\r\n";
$content .= "<IfModule rewrite_module>\r\n";
$content .= "\t# rewrite environment\r\n";
$content .= "\tRewriteEngine on\r\n";
$content .= "\tRewriteLog conf/http-https.log\r\n";
$content .= "\tRewriteLogLevel 1\r\n";
$content .= "\r\n";
$content .= "\t# redirect http to https\r\n";
$content .= "\t# If you don't try to access https, then redirect to https\r\n";
$content .= "\tRewriteCond %{SERVER_NAME}\t  !127.0.0.1\r\n";
$content .= "\tRewriteCond %{SERVER_PORT}\t  ^$auth_port$\r\n";
$content .= "\tRewriteRule ^/(.*)\t\t\t  https://%{SERVER_NAME}/$1 [L,R,NE]\r\n";
$content .= "</IfModule>\r\n";
$content .= "\r\n";
$content .= "\r\n";
$content .= "<VirtualHost $internalIP:443>\r\n";
$content .= "\tSSLEngine on\r\n";
$content .= "\tSSLCertificateFile conf/my-server.cert\r\n";
$content .= "\tSSLCertificateKeyFile conf/my-server.key\r\n";
$content .= "\tSSLCACertificateFile conf/ca.crt\r\n";
$content .= "\tServerAdmin EaseGate@patronsoft.com\r\n";
$content .= "\tServerName $internalIP:443\r\n";
$content .= "\tDocumentRoot \"$fspath/authserv\"\r\n";
$content .= "\r\n";
$content .= "\t# Disable directory listing\r\n";
$content .= "\t<Directory \"$fspath/authserv\">\r\n";
$content .= "\t\tOptions -Indexes\r\n";
$content .= "\t</Directory>\r\n";
$content .= "\r\n";
$content .= "\t<IfModule dir_module>\r\n";
$content .= "\t\tDirectoryIndex login_form.php\r\n";
$content .= "\t</IfModule>\r\n";
$content .= "</VirtualHost>\r\n";
$content .= "\r\n";
$content .= "\r\n";
$content .= "<VirtualHost $internalIP:$redirect_port>\r\n";
$content .= "\tSSLEngine on\r\n";
$content .= "\tSSLCertificateFile conf/my-server.cert\r\n";
$content .= "\tSSLCertificateKeyFile conf/my-server.key\r\n";
$content .= "\tServerName $internalIP:$redirect_port\r\n";
$content .= "\t# SSL protocol adjustment\r\n";
$content .= "\tBrowserMatch \".*MSIE.*\" nokeepalive ssl-unclean-shutdown\r\n";
$content .= "\tRewriteEngine on\r\n";
$content .= "\tRewriteLog conf/https-http.log\r\n";
$content .= "\tRewriteLogLevel 1\r\n";
$content .= "\t# We accept common extensions, URLs ending in '/' and a last word without extension\r\n";
$content .= "\tRewriteCond %{REQUEST_FILENAME} ^(.*)/$ [OR]\r\n";
$content .= "\tRewriteCond %{REQUEST_FILENAME} ^(.*)\.* [NC,OR]\r\n";
$content .= "\tRewriteCond %{REQUEST_FILENAME} ^(.*)/[^\./]+$\r\n";
$content .= "\tRewriteRule ^(.*)$ \"http://$internalIP:$auth_port/login_form.php?sslpage=https://%{HTTP_HOST}%{REQUEST_URI}?%{QUERY_STRING}\" [L,R,NE]\r\n";
$content .= "\t# otherwise, send 'forbidden'\r\n";
$content .= "\tRewriteRule ^(.*)$ - [F]\r\n";
$content .= "</VirtualHost>\r\n";
$content .= "\r\n";
$content .= "\r\n";
$content .= "###########################################\r\n";
$content .= "### \t\tPayment Gateway\t\t\t\t###\r\n";
$content .= "###########################################\r\n";
$content .= "\r\n";
$content .= "# Payment Gateway port\r\n";
$content .= "Listen $payment_gateway_port\r\n";
$content .= "\r\n";
$content .= "# Payment Gateway (localhost)\r\n";
$content .= "<VirtualHost 127.0.0.1:$payment_gateway_port>\r\n";
$content .= "\tServerAdmin EaseGate@patronsoft.com\r\n";
$content .= "\tServerName 127.0.0.1:$payment_gateway_port\r\n";
$content .= "\tDocumentRoot \"$fspath/local\"\r\n";
$content .= "\r\n";
$content .= "\t<IfModule dir_module>\r\n";
$content .= "\t\tDirectoryIndex index.php\r\n";
$content .= "\t</IfModule>\r\n";
$content .= "</VirtualHost>\r\n";
$content .= "\r\n";
$content .= "\r\n";
$content .= "# Payment Gateway (internal)\r\n";
$content .= "<VirtualHost $internalIP:$payment_gateway_port>\r\n";
$content .= "\tServerAdmin EaseGate@patronsoft.com\r\n";
$content .= "\tServerName $internalIP:$payment_gateway_port\r\n";
$content .= "\tDocumentRoot \"$fspath/local\"\r\n";
$content .= "\r\n";
$content .= "\t# Disable directory listing\r\n";
$content .= "\t<Directory \"$fspath/local\">\r\n";
$content .= "\t\tOptions -Indexes\r\n";
$content .= "\t</Directory>\r\n";
$content .= "\r\n";
$content .= "\t<IfModule dir_module>\r\n";
$content .= "\t\tDirectoryIndex index.php\r\n";
$content .= "\t</IfModule>\r\n";
$content .= "</VirtualHost>\r\n";
$content .= "\r\n";
$content .= "\r\n";
$content .= "# Payment Gateway (external)\r\n";
$content .= "<VirtualHost $externalIP:$payment_gateway_port>\r\n";
$content .= "\tServerAdmin EaseGate@patronsoft.com\r\n";
$content .= "\tServerName $externalIP:$payment_gateway_port\r\n";
$content .= "\tDocumentRoot \"$fspath/local\"\r\n";
$content .= "\r\n";
$content .= "\t# Disable directory listing\r\n";
$content .= "\t<Directory \"$fspath/local\">\r\n";
$content .= "\t\tOptions -Indexes\r\n";
$content .= "\t</Directory>\r\n";
$content .= "\r\n";
$content .= "\t<IfModule dir_module>\r\n";
$content .= "\t\tDirectoryIndex index.php\r\n";
$content .= "\t</IfModule>\r\n";
$content .= "</VirtualHost>\r\n";
$content .= "\r\n";
$content .= "\r\n";
$content .= "###########################################\r\n";
$content .= "### \t\t\tPrintspot\t\t\t\t###\r\n";
$content .= "###########################################\r\n";
$content .= "\r\n";
$content .= "# Printspot port\r\n";
$content .= "Listen 5792\r\n";
$content .= "Listen 5793\r\n";
$content .= "\r\n";
$content .= "<VirtualHost *:5792>\r\n";
$content .= "\tServerAdmin EaseGate@patronsoft.com\r\n";
$content .= "\tDocumentRoot \"$fspath/local\"\r\n";
$content .= "\r\n";
$content .= "\t# Disable directory listing\r\n";
$content .= "\t<Directory \"$fspath/local\">\r\n";
$content .= "\t\tOptions -Indexes\r\n";
$content .= "\t</Directory>\r\n";
$content .= "\r\n";
$content .= "\t<IfModule dir_module>\r\n";
$content .= "\t\tDirectoryIndex print_form.php\r\n";
$content .= "\t</IfModule>\r\n";
$content .= "</VirtualHost>\r\n";
$content .= "\r\n";
$content .= "\r\n";
$content .= "<VirtualHost *:5793>\r\n";
$content .= "\tServerAdmin EaseGate@patronsoft.com\r\n";
$content .= "\tDocumentRoot \"$fspath/local\"\r\n";
$content .= "\r\n";
$content .= "\t# Disable directory listing\r\n";
$content .= "\t<Directory \"$fspath/local\">\r\n";
$content .= "\t\tOptions -Indexes\r\n";
$content .= "\t</Directory>\r\n";
$content .= "\r\n";
$content .= "\t<IfModule dir_module>\r\n";
$content .= "\t\tDirectoryIndex print_notice.php\r\n";
$content .= "\t</IfModule>\r\n";
$content .= "</VirtualHost>\r\n";
$content .= "\r\n";
$content .= "\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "#\r\n";
$content .= "###########################################\r\n";
$content .= "###\tClient Blacklist Notification\t###\r\n";
$content .= "###########################################\r\n";
$content .= "\r\n";
$content .= "# Blocked redirect port\r\n";
$content .= "Listen 5797\r\n";
$content .= "# Blocked redirect page\r\n";
$content .= "<VirtualHost $internalIP:5797>\r\n";
$content .= "\tServerAdmin EaseGate@patronsoft.com\r\n";
$content .= "\tServerName $internalIP:5797\r\n";
$content .= "\tDocumentRoot \"$fspath/authserv\"\r\n";
$content .= "\r\n";
$content .= "\t# Disable directory listing\r\n";
$content .= "\t<Directory \"$fspath/authserv\">\r\n";
$content .= "\t\tOptions -Indexes\r\n";
$content .= "\t</Directory>\r\n";
$content .= "\r\n";
$content .= "\t<IfModule dir_module>\r\n";
$content .= "\t\tDirectoryIndex blocked_notice.php\r\n";
$content .= "\t</IfModule>\r\n";
$content .= "\r\n";
$content .= "\t# Only allow the notice page to use this port\r\n";
$content .= "\tRewriteEngine on\r\n";
$content .= "\tRewriteLog conf/https-http.log\r\n";
$content .= "\tRewriteLogLevel 1\r\n";
$content .= "\tRewriteCond %{HTTP_HOST}	  !$internalIP\r\n";
$content .= "\tRewriteCond %{HTTP_HOST}	  !$dn [NC]\r\n";
$content .= "\tRewriteRule ^(.*)$ \"http://$internalIP:5803/?bClient=1&bweb=%{HTTP_HOST}%{REQUEST_URI}?%{QUERY_STRING}\" [L,R,NE]\r\n";
$content .= "\r\n";
$content .= "</VirtualHost>\r\n";
$content .= "\r\n";
$content .= "#################################################\r\n";
$content .= "###PayPal Website Payments Pro(Direct Payment)###\r\n";
$content .= "#################################################\r\n";
$content .= "Listen 5798\r\n";
$content .= "<VirtualHost $internalIP:5798>\r\n";
$content .= "\tSSLEngine on\r\n";
$content .= "\tSSLCertificateFile conf/my-server.cert\r\n";
$content .= "\tSSLCertificateKeyFile conf/my-server.key\r\n";
$content .= "\tSSLCACertificateFile conf/ca.crt\r\n";
$content .= "\tServerAdmin EaseGate@patronsoft.com\r\n";
$content .= "\tServerName $internalIP:5798\r\n";
$content .= "\tDocumentRoot \"$fspath/ppal_pro\"\r\n";
$content .= "\r\n";
$content .= "\t<IfModule dir_module>\r\n";
$content .= "\t\tDirectoryIndex direct_payment.php\r\n";
$content .= "\t</IfModule>\r\n";
$content .= "\t\r\n";
$content .= "\t<Files *.*> Order Allow,Deny\r\n";
$content .= "\t\tDeny from all\r\n";
$content .= "\t</Files>\r\n";
$content .= "\t\r\n";
$content .= "\t#allow users to access only direct_payment.php, css and image files\r\n";
$content .= "\t<FilesMatch \"^direct_payment.php$|.(gif|jpe?g|png|css)$\"> Order Allow,Deny\r\n";
$content .= "\t\tAllow from all\r\n";
$content .= "\t</FilesMatch>\r\n";
$content .= "</VirtualHost>\r\n";
$content .= "\r\n";
$content .= "#################################################\r\n";
$content .= "### \t\t\t Load Balancing\t\t\t###\r\n";
$content .= "#################################################\r\n";
$content .= "Listen 5799\r\n";
$content .= "# Configuration Manager [Status tab] through php to get user data which is logged in from other load balancing machine\r\n";
$content .= "<VirtualHost $externalIP:5799>\r\n";
$content .= "\tServerAdmin EaseGate@patronsoft.com\r\n";
$content .= "\tServerName $externalIP:5799\r\n";
$content .= "\tDocumentRoot \"$fspath/cfgmgr\"\r\n";
$content .= "\r\n";
$content .= "\t# Disable directory listing\r\n";
$content .= "\t<Directory \"$fspath/cfgmgr\">\r\n";
$content .= "\t\tOptions -Indexes\r\n";
$content .= "\t</Directory>\r\n";
$content .= "\r\n";
$content .= "\t# Only Allow queryUserStatus.php to use this port \r\n";
$content .= "\t<Files *.php> Order Allow,Deny\r\n";
$content .= "\t\tDeny from all\r\n";
$content .= "\t</Files>\r\n";
$content .= "\r\n";
$content .= "\t<FilesMatch '(queryUserStatus.php)\$'> Order Allow,Deny\r\n";
$content .= "\t\tAllow from ALL\r\n";
$content .= "\t</FilesMatch>\r\n";
$content .= "</VirtualHost>\r\n";
$content .= "\r\n";
$content .= "###########################################\r\n";
$content .= "###\tIP Block List Notification\t###\r\n";
$content .= "###########################################\r\n";
$content .= "\r\n";
$content .= "# Blocked redirect port\r\n";
$content .= "Listen 5803\r\n";
$content .= "# Blocked redirect page\r\n";
$content .= "<VirtualHost $internalIP:5803>\r\n";
$content .= "\tServerAdmin EaseGate@patronsoft.com\r\n";
$content .= "\tServerName $internalIP:5803\r\n";
$content .= "\tDocumentRoot \"$fspath/authserv\"\r\n";
$content .= "\r\n";
$content .= "\t# Disable directory listing\r\n";
$content .= "\t<Directory \"$fspath/authserv\">\r\n";
$content .= "\t\tOptions -Indexes\r\n";
$content .= "\t</Directory>\r\n";
$content .= "\r\n";
$content .= "\t<IfModule dir_module>\r\n";
$content .= "\t\tDirectoryIndex blocked_notice.php\r\n";
$content .= "\t</IfModule>\r\n";
$content .= "\r\n";
$content .= "\t# Only allow the notice page to use this port\r\n";
$content .= "\t<Files *.php> Order Allow,Deny\r\n";
$content .= "\t\tDeny from all\r\n";
$content .= "\t</Files>\r\n";
$content .= "\r\n";
$content .= "\t<Files blocked_notice.php> Order Allow,Deny\r\n";
$content .= "\t\tAllow from ALL\r\n";
$content .= "\t</Files>\r\n";
$content .= "\r\n";
$content .= "\tRewriteEngine on\r\n";
$content .= "\tRewriteLog conf/https-http.log\r\n";
$content .= "\tRewriteLogLevel 1\r\n";
$content .= "\tRewriteCond %{HTTP_HOST}	  !$internalIP\r\n";
$content .= "\tRewriteCond %{HTTP_HOST}	  !$dn [NC]\r\n";
$content .= "\tRewriteRule ^(.*)$ \"http://$internalIP:5803/?bClient=3&bweb=%{HTTP_HOST}%{REQUEST_URI}?%{QUERY_STRING}\" [L,R,NE]\r\n";
$content .= "\r\n";
$content .= "</VirtualHost>\r\n";
$content .= "\r\n";
$content .= "###########################################\r\n";
$content .= "###\tLicense Warning\t###\r\n";
$content .= "###########################################\r\n";
$content .= "\r\n";
$content .= "# Blocked redirect port\r\n";
$content .= "Listen 5805\r\n";
$content .= "# Blocked redirect page\r\n";
$content .= "<VirtualHost $internalIP:5805>\r\n";
$content .= "\tServerAdmin EaseGate@patronsoft.com\r\n";
$content .= "\tServerName $internalIP:5805\r\n";
$content .= "\tDocumentRoot \"$fspath/authserv\"\r\n";
$content .= "\r\n";
$content .= "\t# Disable directory listing\r\n";
$content .= "\t<Directory \"$fspath/authserv\">\r\n";
$content .= "\t\tOptions -Indexes\r\n";
$content .= "\t</Directory>\r\n";
$content .= "\r\n";
$content .= "\t<IfModule dir_module>\r\n";
$content .= "\t\tDirectoryIndex blocked_notice.php\r\n";
$content .= "\t</IfModule>\r\n";
$content .= "\r\n";
$content .= "\t# Only allow the notice page to use this port\r\n";
$content .= "\t<Files *.php> Order Allow,Deny\r\n";
$content .= "\t\tDeny from all\r\n";
$content .= "\t</Files>\r\n";
$content .= "\r\n";
$content .= "\t<Files blocked_notice.php> Order Allow,Deny\r\n";
$content .= "\t\tAllow from ALL\r\n";
$content .= "\t</Files>\r\n";
$content .= "\r\n";
$content .= "\tRewriteEngine on\r\n";
$content .= "\tRewriteLog conf/https-http.log\r\n";
$content .= "\tRewriteLogLevel 1\r\n";
$content .= "\tRewriteCond %{HTTP_HOST}	  !$internalIP\r\n";
$content .= "\tRewriteCond %{HTTP_HOST}	  !$dn [NC]\r\n";
$content .= "\tRewriteRule ^(.*)$ \"http://$internalIP:5803/?bClient=4&bweb=%{HTTP_HOST}%{REQUEST_URI}?%{QUERY_STRING}\" [L,R,NE]\r\n";
$content .= "\r\n";
$content .= "</VirtualHost>\r\n";
$content .= "\r\n";
$content .= "# Default Server Name (By default variable of ServerName is not set in httpd.conf )\r\n";
$content .= "ServerName localhost\r\n";
$content .= "\r\n";
$content .= "# part of httpd-mpm.conf\r\n";
$content .= "# WinNT MPM\r\n";
$content .= "# ThreadsPerChild: constant number of worker threads in the server process\r\n";
$content .= "# MaxRequestsPerChild: maximum  number of requests a server process serves\r\n";
$content .= "<IfModule mpm_winnt_module>\r\n";
$content .= "\tThreadsPerChild 512\r\n";
$content .= "\tMaxRequestsPerChild 0\r\n";
$content .= "</IfModule>\r\n";
$content .= "\r\n";

/*
$content .= "###########################################\r\n";
$content .= "### \t\t\t Infobox\t\t\t###\r\n";
$content .= "###########################################\r\n";
$content .= "\r\n";
$content .= "# Infobox port\r\n";
$content .= "Listen $infobox_port\r\n";
$content .= "# Check Client\'s Infobox Alive\r\n";
$content .= "<VirtualHost $internalIP:$infobox_port>\r\n";
$content .= "\tSSLEngine on\r\n";
$content .= "\tSSLCertificateFile conf/my-server.cert\r\n";
$content .= "\tSSLCertificateKeyFile conf/my-server.key\r\n";
$content .= "\tSSLCACertificateFile conf/ca.crt\r\n";
$content .= "\tServerAdmin EaseGate@patronsoft.com\r\n";
$content .= "\tServerName $internalIP:$infobox_port\r\n";
$content .= "\tDocumentRoot \"$fspath/authserv\"\r\n";
$content .= "\r\n";
$content .= "\t# Disable directory listing\r\n";
$content .= "\t<Directory \"$fspath/authserv\">\r\n";
$content .= "\t\tOptions -Indexes\r\n";
$content .= "\t</Directory>\r\n";
$content .= "\r\n";
$content .= "\t<IfModule dir_module>\r\n";
$content .= "\t\tDirectoryIndex info.php\r\n";
$content .= "\t</IfModule>\r\n";
$content .= "\r\n";
$content .= "\t# Only Allow infobox php to use this port \r\n";
$content .= "\t<Files *.php> Order Allow,Deny\r\n";
$content .= "\t\tDeny from all\r\n";
$content .= "\t</Files>\r\n";
$content .= "\r\n";
$content .= "\t<FilesMatch '(info.php|responseUserInfo.php|responseQueryName.php)\$'> Order Allow,Deny\r\n";
$content .= "\t\tAllow from ALL\r\n";
$content .= "\t</FilesMatch>\r\n";
$content .= "</VirtualHost>\r\n";
$content .= "\r\n";
$content .= "\r\n";
*/

?>
