<?php
	
define('MAXLINELEN', 512);

// no cache for browser
header('Cache-Control: no-cache, must-revalidate');
// security check
require_once 'secureLogin.php';
include_once "sysfunc.php";
include_once 'cmvar.php';	 // for $lang
include_once("..\\authserv\\common_functions.php");
include_once "egAPI.php";

// This function is used to convert an integer to a hexadecimal number
// and organize it to mac format
function fs_create_random_password($len)
{
    $pass = '';
    $lchar = 0;
    $char = 0;
    for($i = 0; $i < $len; $i++) {
        while($char == $lchar) {
            $char = rand(97, 122);
        }
        $pass .= chr($char);
        $lchar = $char;
    }
    return $pass;
}

function fs_create_random_str($prefix, $salt, $length) {
    $totalChar = $length;
    srand((double)microtime()*1000000); // start the random generator
    $str=""; // set the inital variable
    for ($i=0;$i<$totalChar;$i++)  // loop and create string
        $str = $str . substr ($salt, rand() % strlen($salt), 1);

        $str = $prefix.$str;

    return $str;
}

// 20070221 begin spun - added $slip_user argument to pass out the user info	
// function fs_create_bulk_user($username, $password1, $password2, $plan)
function fs_create_bulk_user($username, $password1, $password2, $plan, &$slip_user)
{
    // return status (integer)
    // 0 - no problem, id successfully created
    // 1 - username cannot be empty
    // 2 - duplicated user id found in user database
    // 3 - password cannot be empty
    // 4 - 2 passwords did not match
	// 5 - fail to insert 

    $function_status=99;
    $create_id='yes';

    if ($username =='') {
        $function_status =1;
        $create_id='no';
    } else {
        $q="SELECT count(*) as no FROM ".fs_usr_table()." where name='$username'";
        $result=db_query($q);
        $no = odbc_result($result, 'no');

        if (($no > 0) && ($username !='')) {
            $function_status =2;   //duplicated user id
            $create_id='no';
        } else if (($password1=='') && ($password2=='') && ($username !='') && ($create_id='yes')) {
            $function_status =3; //password not empty
            $create_id='no';
        } else if ((strcmp ($password1 , $password2) <> 0 ) && ($create_id='yes')) {
            $function_status =4; //passwords did not match
            $create_id='no';
        }

        if ($create_id == 'yes') {
		
			// create COM object
            $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');            
            $plan_table=$settingobj->getKey('Datasource_Plans_Tablename', 'gateway');
            $settingobj=null;
		
            $q_plan = "SELECT * FROM ".$plan_table." WHERE PNAME = '".$plan."' ;";
            $result_plan = db_query($q_plan);

	    // 20080425 - Bug fix (add quota sharing part)
            $timeleft = odbc_result($result_plan, 'TIMELEFT');
            $btul = odbc_result($result_plan, 'BTUL');
            $btdl = odbc_result($result_plan, 'BTDL');
            $bwquota = odbc_result($result_plan, 'BWQUOTA');
            $bwcount = odbc_result($result_plan, 'BWCOUNT');
            $bwquotaUL = odbc_result($result_plan, 'BWQUOTAUL');
            $bwcountUL = odbc_result($result_plan, 'BWCOUNTUL');
            $bwquotaSha = odbc_result($result_plan, 'BWQUOTASHA');
            $bwcountSha = odbc_result($result_plan, 'BWCOUNTSHA');
            $sdate = odbc_result($result_plan, 'SDATE');
            $edate = odbc_result($result_plan, 'EDATE');
            $logins = odbc_result($result_plan, 'LOGINS');
            $mins = odbc_result($result_plan, 'EMINUTES');
            $startmod = odbc_result($result_plan, 'STARTMOD');
            $plan_status = odbc_result($result_plan, 'STATUS');
            $bwrmethod = odbc_result($result_plan, 'BWRMETHOD');
            $bwrperiod = odbc_result($result_plan, 'BWRPERIOD');
            $bwrdate = odbc_result($result_plan, 'BWRDATE');
            $printQutoa = round(odbc_result($result_plan, 'pagenum'));
            $acl = odbc_result($result_plan, 'acl');
            $reqsignup = odbc_result($result_plan, 'reqsignup');

			// spun : 20070303 previously missed fields
			$mac_map = odbc_result($result_plan, 'macmap');
			$ip_map = odbc_result($result_plan, 'ipmap');
			//recur_option
			$recur_option = odbc_result($result_plan, 'roption');
			$recur_sdate = odbc_result($result_plan, 'rsdate');			
			$recur_edate = odbc_result($result_plan, 'redate');			
			$week_sch = odbc_result($result_plan, 'weeksch');
			$auto_delete = odbc_result($result_plan, 'auto_del');
			
			$loginsegment = odbc_result($result_plan, 'loginseg');
			$emonth = odbc_result($result_plan, 'emonth');
			$eyear = odbc_result($result_plan, 'eyear');
			

			// 20090708 - Set data type
			$addFields = array();
			$bFieldNumeric = array();
			
		// modify using fsapi to insert record
	    // 20080425 - Bug fix (add quota sharing part)
	    // 20070221 begin spun - printing user info in a slip 		
            if ($timeleft != '') {
                $addFields['timeleft'] = "$timeleft";
                $bFieldNumeric['timeleft'] = 1;
				$slip_user['cb_acc1']= true;
				$slip_user['add_timeleft']=$timeleft ;
			}
            if ($btul != '') {
				$addFields['btul'] = "$btul";
				$bFieldNumeric['btul'] = 1;
				$slip_user['bt_ul_limit'] = $btul;
            }
            if ($btdl != '') {
				$addFields['btdl'] = "$btdl";
				$bFieldNumeric['btdl'] = 1;
				$slip_user['bt_dl_limit'] = $btdl;		
            }
            if ($bwquota != '') {
				$addFields['bwquota'] = "$bwquota";
				$bFieldNumeric['bwquota'] = 1;
				$slip_user['bwquota'] = $bwquota;
            }
            if ($bwcount != '') {
				$addFields['bwcount'] = "$bwcount";
				$bFieldNumeric['bwcount'] = 1;
				$slip_user['bwcount'] = $bwcount;
            }
            if ($bwquotaUL != '') {
				$addFields['bwquotaUL'] = "$bwquotaUL";
				$bFieldNumeric['bwquotaUL'] = 1;
				$slip_user['bwquotaUL'] = $bwquotaUL;
            }
            if ($bwcountUL != '') {
				$addFields['bwcountUL'] = "$bwcountUL";
				$bFieldNumeric['bwcountUL'] = 1;
				$slip_user['bwcountUL'] = $bwcountUL;
            }
            if ($bwquotaSha != '') {
				$addFields['bwquotaSha'] = "$bwquotaSha";
				$bFieldNumeric['bwquotaSha'] = 1;
				$slip_user['bwquotaSha'] = $bwquotaSha;
            }

            // 20100317 - Set zero instead of null
            $bFieldNumeric['bwcountSha'] = 1;
            if ($bwcountSha != '') {
				$addFields['bwcountSha'] = "$bwcountSha";
				$slip_user['bwcountSha'] = $bwcountSha;
			} else {
				$addFields['bwcountSha'] = "0";
            }

            if ($plan_status != '') {
				$addFields['status'] = "$plan_status";
				$bFieldNumeric['status'] = 1;
				//spun: original editUser.php does not print if the a/c is disabled or not, no need
            }
            if ($edate != '') {
				$addFields['edate'] = "$edate";
				$bFieldNumeric['edate'] = 0;
				
				$slip_user['cb_acc3'] = true; 
				$expiryDatetime = array();
				$expiryDatetime = datetime_from_mysql2($edate);	// from  common_functions.php		
				$slip_user['add_exp_date']= $expiryDatetime[0]; 
				$slip_user['add_exp_time']= $expiryDatetime[1];
            }
            if ($sdate != '') {
				$addFields['sdate'] = "$sdate";
				$bFieldNumeric['sdate'] = 0;
								
				// $startDate[$act_date, $act_time] in setcfg_plan.php, 
				$slip_user['bt_acc'] = 2;
				$activeDatetime = array();
				$activeDatetime = datetime_from_mysql2($sdate);
				$slip_user['add_act_date']= $activeDatetime[0]; 
				$slip_user['add_act_time']= $activeDatetime[1];            
            }else if ($sdate == '' && $startmod == 0){ // 0 means Account is active now (must fill in sdate field)
	            // fill in sdate field
	            $startDate=date("D M d H:i:s Y");
				$addFields['sdate'] = "$startDate";
				$bFieldNumeric['sdate'] = 0;
            }
            
            if ($logins != '') {
				$addFields['logins'] = "$logins";
				$bFieldNumeric['logins'] = 1;
				
				// suspend a/c after x logins
				$slip_user['cb_acc2']= true;
				$slip_user['add_login']= $logins;
            }
            if ($mins != '') {
				$addFields['eminutes'] = "$mins";
				$bFieldNumeric['eminutes'] = 1;
				
				// suspend a/c after x mins
				$slip_user['cb_acc4']= true;
				$timeLeft = "";
				switch (true){
					case ($mins/60/24 >=1): $timeLeft= $mins/60/24 ." day"; break;
					case ($mins/60>=1): $timeLeft= $mins/60 ." hour"; break;
					default: $timeLeft = $mins ." min"; break;
				}
				$slip_user['add_days']= $timeLeft;
            }
            if ($startmod != '') {
				$addFields['STARTMOD'] = "$startmod";
				$bFieldNumeric['STARTMOD'] = 1;
				// when a/c is active, $startmod is either of values [0, 1, 2]
				$slip_user['bt_acc'] = $startmod;
            }
            if ($bwrmethod != '') {
				$addFields['bwrmethod'] = "$bwrmethod";
				$bFieldNumeric['bwrmethod'] = 0;
				//spun: original editUser.php does not print when data transfer quota reset
            }
            if ($bwrperiod != '') {
				$addFields['bwrperiod'] = "$bwrperiod";
				$bFieldNumeric['bwrperiod'] = 1;
				//spun: original editUser.php does not print when data transfer quota reset
            }
            if ($bwrdate != '') {
				$addFields['bwrdate'] = "$bwrdate";
				$bFieldNumeric['bwrdate'] = 1;
				//spun: original editUser.php does not print when data transfer quota reset
            }
			$addFields['pagenum'] = "$printQutoa";
			$bFieldNumeric['pagenum'] = 1;
			
			$slip_user['printQuota'] = $printQutoa; 

            //access control list
            if ($acl=='Y') {
                $addFields['acl'] = "Y";
                $bFieldNumeric['acl'] = 0;
            }
            //request signup
            if ($reqsignup=='Y') {
                $addFields['reqsignup'] = "Y";
                $bFieldNumeric['reqsignup'] = 0;
            }

			// spun : 20070303 previously missed fields
			if ($mac_map != '') {
				$addFields['macmap'] = "$mac_map";
				$bFieldNumeric['macmap'] = 1;
				$slip_user['macmap'] = $mac_map;
			}
			if ($ip_map != '') {
				$addFields['ipmap'] = "$ip_map";
				$bFieldNumeric['ipmap'] = 1;
				$slip_user['ipmap'] = $ip_map;
			}			
			if ($recur_option != '' && $recur_option != 0){
				
				if ($recur_sdate != ''){
					$recur_sdate_str = $recur_sdate;
				}else{
					$recur_sdate_str = "NULL";
				}
				
				if ($recur_edate != ''){
					$recur_edate_str = $recur_edate;
				}else{
					$recur_edate_str = "NULL";
				}
				
				$addFields['roption'] = "$recur_option";
				$bFieldNumeric['roption'] = 1;
				$addFields['rsdate'] = "$recur_sdate_str";
				$bFieldNumeric['rsdate'] = 0;
				$addFields['redate'] = "$recur_edate_str";
				$bFieldNumeric['redate'] = 0;
				$addFields['weeksch'] = "$week_sch";
				$bFieldNumeric['weeksch'] = 1;
				
				$stime = $recur_sdate;
	        	$etime = $recur_edate;
				$slip_user['recurring1'] = " ($stime - $etime) ";			
				
				if (($week_sch & 2) != 0) $valid_days[] = get_cm_var('setcfg_mon');
				if (($week_sch & 4) != 0) $valid_days[] = get_cm_var('setcfg_tue');
				if (($week_sch & 8) != 0) $valid_days[] = get_cm_var('setcfg_wed');
				if (($week_sch & 16) != 0) $valid_days[] = get_cm_var('setcfg_thu');
				if (($week_sch & 32) != 0) $valid_days[] = get_cm_var('setcfg_fri');
				if (($week_sch & 64) != 0) $valid_days[] = get_cm_var('setcfg_sat');
				if (($week_sch & 1) != 0) $valid_days[] = get_cm_var('setcfg_sun');						
				if (isset($valid_days)) {					
					$days_str  = join($valid_days, ", ");
					$slip_user['days_str'] = $days_str;
				} else{
					$slip_user['days_str'] = "Nil";
				}
			}
			if ($auto_delete != '') {
				$addFields['auto_del'] = "$auto_delete";
				$bFieldNumeric['auto_del'] = 1;
				// no need for slip printing
            }
			
			if ($loginsegment != ''){
				$addFields['loginseg'] = $loginsegment;
				$bFieldNumeric['loginseg'] = 1;
				$slip_user['loginseg'] = $loginsegment;
			}
			
			if ($emonth != '' && $eyear != ''){
				$addFields['emonth'] = "$emonth";
				$bFieldNumeric['emonth'] = 1;
				$slip_user['emonth'] = $emonth;
				$addFields['eyear'] = "$eyear";
				$bFieldNumeric['eyear'] = 1;
				$slip_user['eyear'] = $eyear;
			}

			// 20090708 - Pass data type array
			$myfsapi = new fsAPI();
			$rs = $myfsapi->addUser($username, $password1, $addFields, $bFieldNumeric);
			
			if ($rs != 1 && $rs != 3){
				$function_status=5;
			}
			else
				$function_status=0;
			
        }
    }
    return $function_status;
}

if(isset($start) && $start=='true') { //start button is clicked
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
    $rsult = $settingobj->stratService();
    //$settingobj->Release();
    $settingobj=null;
} 
else if(isset($stop) && $stop=='true') { //stop button is clicked
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
    $rsult = $settingobj->stopService();
    //$settingobj->Release();
    $settingobj=null;
}

else if(isset($save_d) && $save_d=='true') 
{
    //dispatcher service settings
    $cat='d';
	$settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
	
    function addr_space($gateway_IP0, $subnet_mask0)
    {
        if (!function_exists('mask_field'))  {
            function mask_field($dec_no, $mask)
            {
                // precondition: range of $dec_no 0 to 255, range of $mask {255,254,252,248,240,224,192,128,0}

                $i=8; $m=$mask;
                while (($i>0)&&($m%2==0)) {
                    $m=(int)$m/2;
                    $i--;
                }    
                $bitStr=str_pad(decbin($dec_no),8,'0',STR_PAD_LEFT);
                $bitStr=str_pad(substr($bitStr,0,$i),8,'0',STR_PAD_RIGHT);
                return (bindec($bitStr));
            }
        }

        $IP_fields=split("\.", $gateway_IP0, 4);
        $IP_masks=split("\.", $subnet_mask0, 4);

        $internal_IP0=mask_field($IP_fields[0],$IP_masks[0]);
        $i=1;
        while ($i<4) {
            $internal_IP0=$internal_IP0.".".mask_field($IP_fields[$i],$IP_masks[$i]);
            $i++;
        }
        return($internal_IP0);
    }

    $gateway_IP=$gateway_IP0.".".$gateway_IP1.".".$gateway_IP2.".".$gateway_IP3;
    $subnet_mask=$subnet_mask0.".".$subnet_mask1.".".$subnet_mask2.".".$subnet_mask3;

    if(isset($port))
        $rsult=$settingobj->setKey($port, 'port', 'gateway');

    if(isset($idle_timeout))
        $rsult = $settingobj->setKey($idle_timeout, 'idle_timeout', 'gateway');

    if(isset($sessionlimit))
        $rsult = $settingobj->setKey($sessionlimit, 'sessionlimit', 'gateway');
        
    if(isset($max_conc_user))
        $rsult = $settingobj->setKey($max_conc_user, 'max_conc_user', 'gateway');

    if(isset($gateway_IP))
        $rsult = $settingobj->setKey($gateway_IP, 'gateway_IP', 'gateway');

    if(isset($subnet_mask))
        $rsult = $settingobj->setKey($subnet_mask, 'subnet_mask', 'gateway');
/*
    if(isset($nat))
        $rsult = $settingobj->setKey($nat, 'nat', 'gateway');
*/
    if(isset($netbios))
        $rsult = $settingobj->setKey($netbios, 'netbios', 'gateway');
    
    /*
    // [sphl] 20070216 moved to save_key
    if(isset($dns_suffix))
        $rsult = $settingobj->setKey($dns_suffix, 'dns_suffix', 'gateway');
    */

    if(isset($batch_filePath))
        $rsult = $settingobj->setKey(stripslashes($batch_filePath), 'batch_filePath', 'gateway');


    $bt_ul_limit=null;
    $bt_dl_limit=null;

    // obtain low, medium or high BT value from config.ini

    $outval = $settingobj->getKey('bt_low', 'bw_throttle');

    if($outval!='')       
        $low=$outval;

    $outval = $settingobj->getKey('bt_medium', 'bw_throttle');

    if($outval!='')       
        $medium=$outval;

    $outval = $settingobj->getKey('bt_high', 'bw_throttle');

    if($outval!='')       
        $high=$outval;

    switch($bt_mode)
    {
    case 0:  $bt_ul_limit=0;
        $bt_dl_limit=0;
        break;

    case 1:  $bt_ul_limit=$low;
        $bt_dl_limit=$low;
        break;

    case 2:  $bt_ul_limit=$medium;
        $bt_dl_limit=$medium;
        break;

    case 3:  $bt_ul_limit=$high;
        $bt_dl_limit=$high;
        break;

    case 4:  if (!isset($bt_num) || $bt_num == '')
        $bt_num=0;
        if (!isset($bt_num_down) || $bt_num_down == '')
            $bt_num_down=0;
        $bt_ul_limit=$bt_num;
        $bt_dl_limit=$bt_num_down;
        break;

    default:
        // set to something high so that it won't affect the External access
        echo 'undefined global bandwidth throttling mode';
        $bt_ul_limit=9999;
        $bt_dl_limit=9999;
        break;
    }

    $rsult_ul = $settingobj->setKey($bt_ul_limit, 'bt_ul_limit', 'bw_throttle');
    $rsult_dl = $settingobj->setKey($bt_dl_limit, 'bt_dl_limit', 'bw_throttle');

    if ($bt_ul_limit==0 && $bt_dl_limit==0)
        $rsult = $settingobj->setKey(0, 'bt_mode', 'bw_throttle'); //guard against setting BOTH custom value blank
    else
        $rsult = $settingobj->setKey($bt_mode, 'bt_mode', 'bw_throttle');
		
	if (isset($bt_dynamic)){
		// Dynamic Bandwidth Throttling
		$settingobj->setKey($bt_dynamic, 'bt_dynamic', 'bw_throttle');
		if (strcasecmp($bt_dynamic,'on')==0){
			if (isset($bt_ul_exceed_limit))
				$rsult = $settingobj->setKey($bt_ul_exceed_limit, 'bt_ul_exceed_limit', 'bw_throttle');
				
			if (isset($bt_dl_exceed_limit))
				$rsult = $settingobj->setKey($bt_dl_exceed_limit, 'bt_dl_exceed_limit', 'bw_throttle');
		}
	}

    //****************************************************************************************************
    // Global data transfer setting
    //****************************************************************************************************
    if( isset($bw_setting_dl) && $bw_setting_dl == 0 )
        $settingobj->setKey('0', 'bwcount_dl', 'DataTransfer');
    else {
        if( isset($bwdl_quota_checkbox) && isset($bwdl_quota) ) {
            $settingobj->setKey('2', 'bwcount_dl', 'DataTransfer');
            $settingobj->setKey( $bwdl_quota, 'bwquota_dl', 'DataTransfer');
        } else
            $settingobj->setKey('1', 'bwcount_dl', 'DataTransfer');
    }

    if( isset($bw_setting_ul) && $bw_setting_ul == 0 )
        $settingobj->setKey('0', 'bwcount_ul', 'DataTransfer');
    else {
        if( isset($bwul_quota_checkbox) && isset($bwul_quota) ) {
            $settingobj->setKey('2', 'bwcount_ul', 'DataTransfer');
            $settingobj->setKey($bwul_quota, 'bwquota_ul', 'DataTransfer');
        }
        else
            $settingobj->setKey('1', 'bwcount_ul', 'DataTransfer');
    }
    //****************************************************************************************************
    // End - Global data transfer setting
    //****************************************************************************************************

    $message='Main setting is successfully saved. All changes will take effect when you start EaseGate next time.';
    $saved='true';
    $errorlog='';
    //free COM object
    //$settingobj->Release();
    $settingobj=null;
} //end dispatcher service settings

else if(isset($save_nat) && $save_nat=='true') 
{
    //NAT service settings
    $cat='nat';

    //****************************************************************************************************
    // Proxy ARP
    //****************************************************************************************************
    require_once 'display_list.php';
	$settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
    
    if (isset($ser_display_proxy)&&($ser_display_proxy!=='')) {
        $display_proxy = unserialize($ser_display_proxy);
    }
    if (isset($ser_add_proxy)&&($ser_add_proxy!=='')) {
        $add_proxy = unserialize($ser_add_proxy);
    }

    $str=''; $j=0; $n=0; $m=0;
    $i=0;   
    while ($i < $display_proxy->num_sites) {
        if($display_proxy->site_list[$i]->span{0}!='#') {
            $rsult = $settingobj->setKey($display_proxy->site_list[$i]->span, "ip_addr$n", 'proxyARP');
            $n++;
        }
        $i++;
    }

    $j=$n;
    $i=0;
    while ($i < $add_proxy->num_sites) {
        if (($add_proxy->site_list[$i]->span!=';')&&($add_proxy->site_list[$i]->span{0}!='#')) { 
            $rsult = $settingobj->setKey($add_proxy->site_list[$i]->span, 'ip_addr'.($m+$j), 'proxyARP');
            $m++;
        }
        $i++;
    }

    $proxy_num = $m+$j;
    $rsult = $settingobj->setKey($proxy_num, 'ip_num', 'proxyARP');

    // unset all variables
    $ser_display_proxy=NULL;
    $ser_add_proxy=NULL;

    // clear all entries when disabled
    if( isset($parp) && strcmp($parp, 'off')==0 ) {
        $num = $settingobj->getKey('ip_num', 'proxyARP');
        $rsult = $settingobj->setKey('', 'ip_num', 'proxyARP');
        for( $i=0; $i<$num; $i++ )
            $rsult = $settingobj->setKey('0', 'ip_addr'.$i, 'proxyARP');
    }
	
    if (isset($ser_display_nat_P)&&($ser_display_nat_P!=='')) {
        $display_nat_P = unserialize($ser_display_nat_P);
    }
	if (isset($ser_display_nat_R)&&($ser_display_nat_R!=='')) {
        $display_nat_R = unserialize($ser_display_nat_R);
    }
    if (isset($ser_add_nat_P)&&($ser_add_nat_P!=='')) {
        $add_nat_P = unserialize($ser_add_nat_P);
    }
    if (isset($ser_add_nat_R)&&($ser_add_nat_R!=='')) {
        $add_nat_R = unserialize($ser_add_nat_R);
    }
	
	$nat_IP_S=$nat_IP_S0.".".$nat_IP_S1.".".$nat_IP_S2.".".$nat_IP_S3;
	$nat_IP_E=$nat_IP_E0.".".$nat_IP_E1.".".$nat_IP_E2.".".$nat_IP_E3;
    $subnet_mask=$subnet_mask0.".".$subnet_mask1.".".$subnet_mask2.".".$subnet_mask3;
    
    if(isset($nat_IP_S))
        $rsult = $settingobj->setKey($nat_IP_S, 'NAT_AddrR_ipS', 'NAT');
    if(isset($nat_IP_E))
        $rsult = $settingobj->setKey($nat_IP_E, 'NAT_AddrR_ipE', 'NAT');
    if(isset($subnet_mask))
        $rsult = $settingobj->setKey($subnet_mask, 'NAT_AddrR_SubNet', 'NAT');

    $str=''; $j=0; $n=0; $m=0;
    $i=0;
    
    while ($i < $display_nat_P->num_sites) {
        if($display_nat_P->site_list[$i]->span{0}!='#') {
            $rsult = $settingobj->setKey($display_nat_P->site_list[$i]->span, "Mapping_Internal_IP_$n", 'NAT');
            $rsult = $settingobj->setKey($display_nat_R->site_list[$i]->span, "Mapping_Real_IP_$n", 'NAT');
            $n++;
        }
        $i++;
    }

    $j=$n;
    $i=0;
    while ($i < $add_nat_P->num_sites) {
        if (($add_nat_P->site_list[$i]->span!=';')&&($add_nat_P->site_list[$i]->span{0}!='#')) { 
            $rsult = $settingobj->setKey($add_nat_P->site_list[$i]->span, 'Mapping_Internal_IP_'.($m+$j), 'NAT');
            $rsult = $settingobj->setKey($add_nat_R->site_list[$i]->span, 'Mapping_Real_IP_'.($m+$j), 'NAT');
            $m++;
        }
        $i++;
    }

    $nat_num = $m+$j;
    $rsult = $settingobj->setKey($nat_num, 'NAT_AddrM_Count', 'NAT');
	$rsult = $settingobj->setKey($nat, 'Enable', 'NAT');

    // unset all variables
    $ser_display_nat_P=NULL;
    $ser_display_nat_R=NULL;
    $ser_add_nat_P=NULL;
    $ser_add_nat_R=NULL;
 
    $message='NAT setting is successfully saved. All changes will take effect when you start EaseGate next time.';
    $saved='true';
    $errorlog='';
    //free COM object
    //$settingobj->Release();
    $settingobj=null;
} //end NAT service settings

/**
 *  UI customization settings
 */
else if (isset($save_lang) && $save_lang=='true')
{
    // create COM object
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
    $cat = 'lang';
    $msg= '';

    $langdir = "..\\authserv\\lang\\";
	$usersettingdir = "..\\usersetting\\";
    $defaultLangFile = $settingobj->getKey('default_lang_file', 'lang');
    $lang_pack_file = $settingobj->getKey('lang_pack_file', 'lang');

    /**
    * edit UI settings
    */

    // login page picture
    if (isset($loginpage_pic)){
		$filter_path = realpath("..\\");
		$filter_path = $filter_path."\\config.ini";
		$i=sizeof($loginpage_pic);
		$settingobj->WriteINI("gateway", "loginpage_pic_count", $i, $filter_path);
		$y=0;
		while($y<$i){
			$name="loginpage_pic";
			$name.=$y;
			$settingobj->WriteINI("gateway", $name, $loginpage_pic[$y], $filter_path);
			$y++;
		}
        //$rsult = $settingobj->setKey($parentList[0], 'loginpage_pic_name', 'gateway');
	}
	
	//check if the admin want to randomize the loginpage pic
	if (isset($random)) {
		$filter_path = realpath("..\\");
		$filter_path = $filter_path."\\config.ini";
		$settingobj->WriteINI("gateway", "random", '1', $filter_path);
	}
	else {
		$filter_path = realpath("..\\");
		$filter_path = $filter_path."\\config.ini";
		$settingobj->WriteINI("gateway", "random",'0', $filter_path);
	}
	
	for ($i =0; $i<20; $i++){
		eval ("\$result= isset(\$html".$i.");");
		if ($result){
			eval ("\$html_address[\$i]= \$html".$i.";");
		}else
			$html_address[$i]="";
	}
	
	$x=0;
	while($x<20){
		$html_fname="loginpage_pic_html";
		$html_fname.=$x;
		
		if(isset($html_address[$x])){
			$filter_path = realpath("..\\");
			$filter_path = $filter_path."\\config.ini";
			$settingobj->WriteINI("gateway", $html_fname,$html_address[$x], $filter_path);
		}
		$x++;
	}
	
	if (isset($redirectpage_pic_name))
		if($redirectpage_pic_name==get_cm_var('setcfg_ui_login_pic_no_pic_chosen'))
			$redirectpage_pic_name="";
        $rsult = $settingobj->setKey($redirectpage_pic_name, 'redirectpage_pic_name', 'gateway');
	
	if	(isset($redirectpage_pic_html))
		$rsult = $settingobj->setKey($redirectpage_pic_html, 'redirectpage_pic_name_html', 'gateway');
			
    // infobox
    if (isset($show_infobox))
        $rsult = $settingobj->setKey($show_infobox, 'show_infobox', 'gateway');
    else
        $rsult = $settingobj->setKey('off', 'show_infobox', 'gateway');
    
    if (isset($show_infobox) && isset($check_infobox_closed))
    	$rsult = $settingobj->setKey($check_infobox_closed, 'check_infobox_closed', 'gateway');
    else 
    	$rsult = $settingobj->setKey('off', 'check_infobox_closed', 'gateway');
		
	if (isset($show_infobox) && isset($not_support_popup_option) && $not_support_popup_option == 1){
			$rsult = $settingobj->setKey('1', 'not_support_popup_option', 'gateway');
	}else
		$rsult = $settingobj->setKey('0', 'not_support_popup_option', 'gateway');
    	
	if(isset($infobox_port))
       $rsult=$settingobj->setKey($infobox_port, 'infobox_port', 'gateway');

    if (isset($show_cart))
        $rsult = $settingobj->setKey($show_cart, 'show_cart', 'misc');
    else
        $rsult = $settingobj->setKey('no', 'show_cart', 'misc');

    if (isset($enable_chgpwd))
        $rsult = $settingobj->setKey('1', 'enable_chgpwd', 'misc');
    else
        $rsult = $settingobj->setKey('0', 'enable_chgpwd', 'misc');

    if (isset($time_reminder))
        $rsult = $settingobj->setKey('1', 'time_reminder', 'misc');
    else
        $rsult = $settingobj->setKey('0', 'time_reminder', 'misc');

    if (isset($remindMin))
        $rsult = $settingobj->setKey($remindMin, 'remindMin', 'misc');

    // [sphl] 20070216 moved from Authentication Server
    if(isset($start_up_redirect_option ))
		$rsult = $settingobj->setKey($start_up_redirect_option , 'start_up_redirect_option', 'gateway');
		
	if(isset($start_up_redirect_url))
		$rsult = $settingobj->setKey($start_up_redirect_url, 'start_up_redirect_url', 'gateway');

	if(isset($start_up_redirect_wait ))
		$rsult = $settingobj->setKey($start_up_redirect_wait , 'start_up_redirect_wait', 'gateway');
	
        
        
    // language
    if (isset($show_charset))
        $rsult = $settingobj->setKey('1', 'show_charset', 'lang');
    else
        $rsult = $settingobj->setKey('0', 'show_charset', 'lang');

    // edit language file attributes
    if (isset($_POST['edit']) && $_POST['edit']=='true') {
        $langattr = $_POST['lang_desc'].';'.$_POST['lang_region'].';'.$_POST['lang_charset'];
        if ($select_lang[0]=='0')
            $rsult = $settingobj->setKey($langattr, 'default_lang_file_attributes', 'lang');
        else
            $rsult = $settingobj->setKey($langattr, 'lang_file'.$select_lang[0].'_attributes', 'lang');
    }

    // delete language file(s)
    if (isset($_POST['del']) && $_POST['del']=='true') {
        $deleted = array();
        // delete the file and the infomation stored in config.ini
        foreach ($_POST['select_lang'] as $value) {
            if ($value != '0') {    // ignore the default language file
                $delfile = $settingobj->getKey("lang_file$value", 'lang');
                if (unlink($usersettingdir.$delfile)) {
                    $rsult = $settingobj->setKey('', "lang_file$value", 'lang');
                    $rsult = $settingobj->setKey('', "lang_file$value".'_attributes', 'lang');
                    $deleted[] = $value;
                } else
                    $msg .= "<br>\nDelete $delfile failed!";
            }
        }
        $msg .= "<br>\n".count($deleted).' language file(s) deleted.';

        // rearrange the lang_file information in config.ini
        $savefile = array();
        $saveattr = array();
        $arr = array();
        $lfnum = $settingobj->getKey('lang_fileNumber', 'lang');
        // initialize the array
        for ($i = 1; $i <= $lfnum; $i++)
            $arr[] = $i;
        // compare with the deleted array
        $arr = array_diff($arr, $deleted);
        // get the remaining files information
        foreach ($arr as $value) {
            $savefile[] = $settingobj->getKey("lang_file$value", 'lang');
            $saveattr[] = $settingobj->getKey("lang_file$value".'_attributes', 'lang');
        }
        // clear language file information
        for ($i = 1; $i <= $lfnum; $i++) {
            $rsult = $settingobj->setKey('', "lang_file$i", 'lang');
            $rsult = $settingobj->setKey('', "lang_file$i".'_attributes', 'lang');
        }
        // fill in the information
        foreach ($savefile as $key => $value) {
            $index = $key+1;
            $rsult = $settingobj->setKey($value, "lang_file".$index, 'lang');
            $rsult = $settingobj->setKey($saveattr[$key], "lang_file$index".'_attributes', 'lang');
        }
        // save the number of language files
        $rsult = $settingobj->setKey(count($savefile), 'lang_fileNumber', 'lang');
    }

    $message = 'UI settings are successfully saved.All changes will take effect when you start EaseGate next time'.$msg;

    /**
    * edit default language file content
    */
    if (isset($_POST['editfile']) && $_POST['editfile']=='true') {
        $value=$settingobj->getKey('lang_pack_file', 'lang');
        $value=$usersettingdir.$value;

	// 20090305 - Save an array copy of Custom Lang for later check
	function GetOrgCustLang($path)
	{
		ob_start();
	    include_once $path;
		ob_end_clean();
	    $modLang = array();
		if (isset($lang)){ // make sure $lang set from file $path
			foreach ($lang as $key => $value) {
			$modLang[$key] = array();
			$modLang[$key]['value'] = $value;
			$modLang[$key]['saved'] = 0;
			}
		}
	    return $modLang;
	}
	$orgCustLang = GetOrgCustLang($value);

        if (chmod($value, 0666)) {
            if (($fp = fopen($value,'w+')) == TRUE) {
                fwrite($fp, "<?php\r\n");

				ob_start();
                include_once $langdir.$defaultLangFile;
				ob_end_clean();
                function save_line($element, $val, $fp)
                {
                    global $lang;

					// 20090616 - Compare encoded and slash removed form
					// convert all applicable characters to HTML entities
					$val = str_replace("\\", "\\\\", htmlentities(stripslashes($val), ENT_QUOTES));
                    if( !(isset($lang[$element]) && ($lang[$element] == $val)) ) {
                        // write to file
                        $stringtowrite = "$"."lang['".$element."'] = '".$val."';\r\n";
                        fwrite($fp, $stringtowrite);
                    }

		    // 20090305 - Mark as saved if element exists in Custom Lang
		    global $orgCustLang;
		    if (isset($orgCustLang[$element])) {
			$orgCustLang[$element]['saved'] = 1;
		    }
                }

                function save_cmt($element, $fp)
                {
                    $stringtowrite = "// ".$element."\r\n"; 
                    fwrite($fp, $stringtowrite);    
                }

		// 20100430 - Add login_form_reminder, login_form_link, login_form_term
		// 20090305 - Add anonymous_shared_secret
		// 20081222 - Add block_ip_block_list
		// 20080424 - Delete cookies, add term_condition
		// 20080418 - Add new lines for scratch mode
                save_cmt('login.php', $fp);
                save_line('greeting', $greeting, $fp);
                //save_line('greeting', htmlentities($greeting, ENT_QUOTES), $fp);
                save_line('language', $language , $fp);
                save_line('user_name', $user_name, $fp);
                save_line('anonymous', $anonymous, $fp);    
                save_line('Password', $Password, $fp);
                save_line('user_scratch', $user_scratch, $fp);
                save_line('logged', $logged, $fp);
                save_line('no_usage', $no_usage, $fp);
                save_line('invalid', $invalid, $fp);
                save_line('example', $example, $fp);
                save_line('free_website', $free_website, $fp);
                save_line('term_condition', $term_condition, $fp);
                save_line('invalid_access', $invalid_access, $fp);
                save_line('ok_btn', $ok_btn, $fp);
                save_line('submit_btn', $submit_btn, $fp);
                save_line('sign_up_now', $sign_up_now, $fp);
                save_line('reach_conc_limit', $reach_conc_limit, $fp);
                save_line('login_max_conc', $login_max_conc, $fp);
                save_line('logged_in_other_fs', $logged_in_other_fs, $fp);
                save_line('fail_force_logout_from_other_fs_button', $fail_force_logout_from_other_fs_button, $fp);
				save_line('segment_mismatch', $segment_mismatch, $fp);
		save_line('anonymous_shared_secret', $anonymous_shared_secret, $fp);
		save_line('login_form_reminder', $login_form_reminder, $fp);
		save_line('login_form_link', $login_form_link, $fp);
		save_line('login_form_term', $login_form_term, $fp);

                save_cmt('info.php', $fp);
                save_line('info_title', $info_title, $fp);
                save_line('info_expired', $info_expired, $fp);
                save_line('info_please_logout', $info_please_logout, $fp);  
                save_line('info_please_login_again', $info_please_login_again, $fp);
                save_line('info_access_min_remain', $info_access_min_remain, $fp);
                save_line('info_if_close', $info_if_close, $fp);
                save_line('info_logout', $info_logout, $fp);
                save_line('info_in_browser', $info_in_browser, $fp);
                save_line('info_thank_you', $info_thank_you, $fp);
                save_line('info_logout_btn', $info_logout_btn, $fp);
                save_line('info_cart_btn', $info_cart_btn, $fp);
                save_line('info_chgpwd_btn', $info_chgpwd_btn, $fp);
                save_line('anon_info_access_min_remain', $anon_info_access_min_remain, $fp);
                save_line('info_first_loading_msg', $info_first_loading_msg, $fp);
                save_line('info_loading', $info_loading, $fp);
                save_line('info_logged_in_from_other', $info_logged_in_from_other, $fp);

		// 20100526 - Add fa_title, fa_submit
                save_cmt('signup_form.php', $fp);
                save_line('signup_form', $signup_form, $fp);
                save_line('signup_username', $signup_username, $fp);
                save_line('signup_pwd1', $signup_pwd1, $fp);    
                save_line('signup_pwd2', $signup_pwd2, $fp);
                save_line('signup_submit_btn', $signup_submit_btn, $fp);
		save_line('signup_fa_title', $signup_fa_title, $fp);
		save_line('signup_fa_submit', $signup_fa_submit, $fp);

                save_cmt('chgpwd_form.php', $fp);
                save_line('chgpwd_form', $chgpwd_form, $fp);
                save_line('chgpwd_username', $chgpwd_username, $fp);
                save_line('chgpwd_oldpwd', $chgpwd_oldpwd, $fp);
                save_line('chgpwd_pwd1', $chgpwd_pwd1, $fp);    
                save_line('chgpwd_pwd2', $chgpwd_pwd2, $fp);
                save_line('chgpwd_submit_btn', $chgpwd_submit_btn, $fp);

                save_cmt('fs_chgpwd.php', $fp);
                save_line('chgpwd_ok_header', $chgpwd_ok_header, $fp);
                save_line('chgpwd_ok_link', $chgpwd_ok_link, $fp);
                save_line('chgpwd_fail_header', $chgpwd_fail_header, $fp);  
                save_line('chgpwd_fail_link', $chgpwd_fail_link, $fp);
                save_line('chgpwd_problem_id_empty', $chgpwd_problem_id_empty, $fp);
                save_line('chgpwd_problem_old_pwd_empty', $chgpwd_problem_old_pwd_empty, $fp);
                save_line('chgpwd_problem_new_pwd_empty', $chgpwd_problem_new_pwd_empty, $fp);
                save_line('chgpwd_problem_pwd_mismatch', $chgpwd_problem_pwd_mismatch, $fp);
                save_line('chgpwd_problem_id_not_exists', $chgpwd_problem_id_not_exists, $fp);
                save_line('chgpwd_problem_old_pwd_mismatch', $chgpwd_problem_old_pwd_mismatch, $fp);
                save_line('chgpwd_problem_access_right', $chgpwd_problem_access_right, $fp);

                save_cmt('logout.php', $fp);
                save_line('back_btn', $back_btn, $fp);  
                save_line('login_fail', $login_fail, $fp);
                save_line('login_success', $login_success, $fp);
                //save_line('Timeleft', $Timeleft, $fp);
                save_line('Unlimited', $Unlimited, $fp);
                save_line('Min', $Min, $fp);
                save_line('last_than_one_min', $last_than_one_min, $fp);

                save_cmt('redirect.php', $fp);
                save_line('redirect_title', $redirect_title, $fp);
                save_line('redirect_wait', $redirect_wait, $fp);
                save_line('redirect_msg', $redirect_msg, $fp);

                save_cmt('disconnect.php', $fp);
                save_line('Disconnected', $Disconnected, $fp);
                save_line('signed_success', $signed_success, $fp);

		// 20100519 - Add problem_session_cookies_disabled
                save_cmt('fs_signup.php', $fp);
                save_line('signup_ok_header', $signup_ok_header, $fp);
                save_line('signup_ok_link', $signup_ok_link, $fp);
                save_line('signup_fail_header', $signup_fail_header, $fp);  
                save_line('signup_fail_link', $signup_fail_link, $fp);
                save_line('signup_problem_id_empty', $signup_problem_id_empty, $fp);
                save_line('signup_problem_pwd_empty', $signup_problem_pwd_empty, $fp);
                save_line('signup_problem_pwd_mismatch', $signup_problem_pwd_mismatch, $fp);
                save_line('signup_problem_id_duplicate', $signup_problem_id_duplicate, $fp);
                save_line('signup_problem_field_empty', $signup_problem_field_empty, $fp);
                save_line('signup_block_msg', $signup_block_msg, $fp);
		save_line('signup_problem_session_cookies_disabled', $signup_problem_session_cookies_disabled, $fp);

                save_cmt('welcome.php', $fp);
                save_line('browse_freely', $browse_freely, $fp);
                save_line('not_support_frames', $not_support_frames, $fp);
                save_line('alert', $alert, $fp);    

				// 20100524 - Add cart_anonymous, cart_free_access_not_support
				// 20090428 - Add cart_radius_not_support
                save_cmt('cart.php', $fp);
                save_line('cart_welcome', $cart_welcome, $fp);
                save_line('cart_check_timeleft', $cart_check_timeleft, $fp);
                save_line('cart_check_txn', $cart_check_txn, $fp);  
                save_line('cart_shopping_cart', $cart_shopping_cart, $fp);
                save_line('cart_desc', $cart_desc, $fp);
                save_line('cart_price', $cart_price, $fp);
                save_line('cart_checkout', $cart_checkout, $fp);
                save_line('cart_form_other_site', $cart_form_other_site, $fp);
                save_line('cart_radius_not_support', $cart_radius_not_support, $fp);
				save_line('cart_anonymous', $cart_anonymous, $fp);
				save_line('cart_free_access_not_support', $cart_free_access_not_support, $fp);

                save_cmt('cookies_warning.php', $fp);
                save_line('cookies_warning', $cookies_warning, $fp);

                save_cmt('timeleft.php', $fp);
                save_line('timeleft_header', $timeleft_header, $fp);
                //save_line('timeleft_less_than_1min', $timeleft_less_than_1min, $fp);
                //save_line('timeleft_unlimited', $timeleft_unlimited, $fp);    

				// 20090428 - Add ppal_history_radius_not_support
                save_cmt('paypal_history.php', $fp);
                save_line('ppal_history_title', $ppal_history_title, $fp);
                save_line('ppal_history_col1', $ppal_history_col1, $fp);
                save_line('ppal_history_col2', $ppal_history_col2, $fp);    
                save_line('ppal_history_col3', $ppal_history_col3, $fp);
                save_line('ppal_history_col4', $ppal_history_col4, $fp);
                save_line('ppal_history_col5', $ppal_history_col5, $fp);
                //save_line('ppal_history_col6', $ppal_history_col6, $fp);
                //save_line('ppal_history_col7', $ppal_history_col7, $fp);
                save_line('ppal_history_status_empty', $ppal_history_status_empty, $fp);
                save_line('ppal_history_status_pendingN', $ppal_history_status_pendingN, $fp);
                save_line('ppal_history_status_pendingY', $ppal_history_status_pendingY, $fp);
                save_line('ppal_history_status_completed', $ppal_history_status_completed, $fp);
                save_line('ppal_history_status_refunded', $ppal_history_status_refunded, $fp);
                save_line('wpay_history_status_cancelled', $wpay_history_status_cancelled, $fp);
                save_line('ppal_history_radius_not_support', $ppal_history_radius_not_support, $fp);

                save_cmt('Printing support', $fp);
                save_line('print_support', $print_support, $fp);
                save_line('print_ref_id', $print_ref_id, $fp);
                save_line('print_page_count', $print_page_count, $fp);
                save_line('print_page_left', $print_page_left, $fp);    
                save_line('print_username', $print_username, $fp);
                save_line('print_password', $print_password, $fp);
                save_line('print_error_token', $print_error_token, $fp);
                save_line('print_error_quota', $print_error_quota, $fp);
                save_line('print_error_pwd', $print_error_pwd, $fp);

                save_cmt('Extra Information Fields for Anonymous Login', $fp);
                save_line('extra_field1', $extra_field1, $fp);
                save_line('extra_field2', $extra_field2, $fp);
                save_line('extra_field3', $extra_field3, $fp);
                save_line('extra_field4', $extra_field4, $fp);
                save_line('extra_field5', $extra_field5, $fp);
                save_line('extra_field6', $extra_field6, $fp);
                save_line('extra_field7', $extra_field7, $fp);
                save_line('extra_field8', $extra_field8, $fp);
                save_line('extra_field9', $extra_field9, $fp);
                save_line('extra_field10', $extra_field10, $fp);
                save_line('extra_field_err_empty', $extra_field_err_empty, $fp);
                
                $arr = array('01', '02', '03', '04', '05', '06', '07', '08', '09', '10');

                foreach ($arr as $n) {
                    if(isset(${"extra$n"}))
                        $rsult = $settingobj->setKey(${"extra$n"}, "extra$n", 'lang');
                    else
                        $rsult = $settingobj->setKey('off', "extra$n", 'lang');
                }

                if(isset($Datasource_extra_field_table))
                    $rsult=$settingobj->setKey($Datasource_extra_field_table, 'Datasource_extra_field_table', 'gateway');
                save_cmt('ReqSignUp_form.php', $fp);
                save_line('ReqSignUp_title', $ReqSignUp_title, $fp);
                save_line('ReqSignUp_header', $ReqSignUp_header, $fp);
                save_line('ReqSignUp_submit_btn', $ReqSignUp_submit_btn, $fp);
                
                save_cmt('fs_ReqSignUp.php', $fp);
                save_line('ReqSignUp_extra1', $ReqSignUp_extra1, $fp);
                save_line('ReqSignUp_extra2', $ReqSignUp_extra2, $fp);
                save_line('ReqSignUp_extra3', $ReqSignUp_extra3, $fp);
                save_line('ReqSignUp_extra4', $ReqSignUp_extra4, $fp);
                save_line('ReqSignUp_extra5', $ReqSignUp_extra5, $fp);
                save_line('ReqSignUp_extra6', $ReqSignUp_extra6, $fp);
                save_line('ReqSignUp_extra7', $ReqSignUp_extra7, $fp);
                save_line('ReqSignUp_extra8', $ReqSignUp_extra8, $fp);
                save_line('ReqSignUp_extra9', $ReqSignUp_extra9, $fp);
                save_line('ReqSignUp_extra10', $ReqSignUp_extra10, $fp);
                
                save_line('ReqSignUp_ok_header', $ReqSignUp_ok_header, $fp);
                save_line('ReqSignUp_ok_link', $ReqSignUp_ok_link, $fp);
                save_line('ReqSignUp_fail_header', $ReqSignUp_fail_header, $fp);
                save_line('ReqSignUp_fail_link', $ReqSignUp_fail_link, $fp);
                save_line('ReqSignUp_problem_field_empty', $ReqSignUp_problem_field_empty, $fp);

                foreach ($arr as $n) {
                    if(isset(${"ReqSignUp$n"}))
                        $rsult = $settingobj->setKey(${"ReqSignUp$n"}, "ReqSignUp$n", 'lang');
                    else
                        $rsult = $settingobj->setKey('off', "ReqSignUp$n", 'lang');
                }
				
				save_cmt('Default Instant Keywords', $fp);
				save_line('ikeyRedirect_warn_access_port', $ikeyRedirect_warn_access_port, $fp);
                save_line('ikeyRedirect_warn_access_page', $ikeyRedirect_warn_access_page, $fp);

		save_cmt('Block Page', $fp);
                save_line('block_ip_block_list', $block_ip_block_list, $fp);
                save_line('block_client_blacklist', $block_client_blacklist, $fp);
				
		// 20090305 - Add section indicating Custom Lang entries added by user directly
		save_cmt('User\'s Addition', $fp);
		foreach ($orgCustLang as $key => $subArray) {
		    if ($orgCustLang[$key]['saved'] == 0) {
			save_line($key, $subArray['value'], $fp);
		    }
		}
				
                fwrite($fp, "?>");

                fclose($fp);

		// 20090918 - Save display control of login page text
		$filter_path = realpath("..\\")."\\config.ini";
		if (isset($disable_show_reminder_checkbox)) {
			$settingobj->WriteINI("lang", "disable_show_reminder", '1', $filter_path);
		} else {
			$settingobj->WriteINI("lang", "disable_show_reminder", '0', $filter_path);
		}
		if (isset($disable_show_example_checkbox)) {
			$settingobj->WriteINI("lang", "disable_show_example", '1', $filter_path);
		} else {
			$settingobj->WriteINI("lang", "disable_show_example", '0', $filter_path);
		}
		if (isset($disable_show_link_checkbox)) {
			$settingobj->WriteINI("lang", "disable_show_link", '1', $filter_path);
		} else {
			$settingobj->WriteINI("lang", "disable_show_link", '0', $filter_path);
		}
		if (isset($disable_show_tc_checkbox)) {
			$settingobj->WriteINI("lang", "disable_show_tc", '1', $filter_path);
		} else {
			$settingobj->WriteINI("lang", "disable_show_tc", '0', $filter_path);
		}

                $message.="<br>\nLanguage pack variables are successfully saved.";
            } else
                $message.="<br>\nLanguage pack cannot open.";
        } else
            $message.="<br>\nLanguage pack file is readonly.";
    } // end edit file

    $saved='true';
    $errorlog='';
    //free COM object
    //$settingobj->Release();
    $settingobj=null;
}

//20080724 added the code to support PayPal Website Pro Direct Payment
##KK credit card
else if(isset($save_cc) && $save_cc=='true')
{
    $cat='cc';

	// 20090518 - Remove Start
	$settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
	if (isset($exportCCLog)&&($exportCCLog == true)) {
		include_once("..\\authserv\\common_functions.php");

		$credit_card_log="..\\log\\creditcardlog.csv";
		if (is_file($credit_card_log) == TRUE)
			unlink($credit_card_log);
		if (is_file($credit_card_log) == FALSE) {
			touch ($credit_card_log);
			$log_msg_heading="DATE,USER,STATUS,PLAN,AMT,QTY,ITEM NAME,METHOD\r\n";
			$fileHandler = fopen ($credit_card_log, 'w');
			fwrite ($fileHandler, $log_msg_heading);
			fclose ($fileHandler);
		}

		$buff = file_get_contents($credit_card_log);
		$fileHandler = fopen ($credit_card_log, 'w');

		if (!flock ($fileHandler, LOCK_EX )) // exclusive lock
			$message .= 'Fail to lock the log file. ';

		$ppal_table=$settingobj->getKey('Datasource_PayPal_Table', 'gateway');

		$q="SELECT * from ".$ppal_table.";";

		$result=db_query($q);

		$log_msg_content = '';

		while(odbc_fetch_row($result)) {
			$date=date("M-d H:i",floor(odbc_result($result,'ORDER_DATE')));
			$user=odbc_result($result,'USERNAME');
			$pay_status=odbc_result($result,'PAY_STATUS');
			$plan=odbc_result($result,'PLANNAME');
			$amt=odbc_result($result,'AMOUNT');
			$qty=odbc_result($result,'QUANTITY');
			$item_name=odbc_result($result,'ITEM_NAME');
			$method=odbc_result($result,'METHOD');

			$log_msg_content.=$date.",".$user.",".$pay_status.",".$plan.",".$amt.",".$qty.",".$item_name.",".$method."\r\n";
		}

		fwrite ($fileHandler, $buff.$log_msg_content);
		flock ($fileHandler, LOCK_UN ); // release the lock
		fclose ($fileHandler);

		$message='All credit card log have been exported.';
		$saved='true';
		$errorlog='';
	} else if($payment_select == 'ppal') {
		$rsult=$settingobj->setKey($payment_select, 'payment_method', 'creditcard');

		if(isset($ppal_business))
			$rsult=$settingobj->setKey($ppal_business, 'ppal_business', 'paypal');

		if(isset($ppal_return))
			$rsult=$settingobj->setKey($ppal_return, 'ppal_return', 'paypal');

		if(isset($ppal_cancal_return))
			$rsult=$settingobj->setKey($ppal_cancal_return, 'ppal_cancel_return', 'paypal');

		if(isset($ppal_pending_release))
			$rsult=$settingobj->setKey($ppal_pending_release, 'ppal_pending_release', 'paypal');

		if(isset($ppal_base_currency))
			$rsult=$settingobj->setKey($ppal_base_currency, 'ppal_base_currency', 'paypal');

		if(isset($ppal_notify_url))
			$rsult=$settingobj->setKey($ppal_notify_url, 'ppal_notify_url', 'paypal');

		//##KK 9 DEC ssl port, invoice_start
		if(isset($ssl_port))
			$rsult=$settingobj->setKey($ssl_port, 'ssl_port', 'gateway');

		if(isset($Datasource_PayPal_Table))
			$rsult=$settingobj->setKey($Datasource_PayPal_Table, 'Datasource_PayPal_Table', 'gateway');

		//#######

		$message='Credit card setting is successfully saved. All changes will take effect when you start EaseGate next time.';
		$saved='true';
		$errorlog='';
	}else if ($payment_select == 'ppal_direct') {
	//20080724 added the code to support PayPal Website Pro Direct Payment
		$rsult=$settingobj->setKey($payment_select, 'payment_method', 'creditcard');

		if(isset($ppal_direct_api_username))
			$rsult=$settingobj->setKey($ppal_direct_api_username, 'ppal_direct_api_username', 'paypal_direct');
			
		if(isset($ppal_direct_api_password))
			$rsult=$settingobj->setKey($ppal_direct_api_password, 'ppal_direct_api_password', 'paypal_direct');

		if(isset($ppal_direct_api_signature))
			$rsult=$settingobj->setKey($ppal_direct_api_signature, 'ppal_direct_api_signature', 'paypal_direct');
			
		if(isset($ppal_direct_return))
			$rsult=$settingobj->setKey($ppal_direct_return, 'ppal_return', 'paypal');

		if(isset($ppal_direct_cancel_return))
			$rsult=$settingobj->setKey($ppal_direct_cancel_return, 'ppal_cancel_return', 'paypal');
			
		if(isset($ppal_direct_pending_release))
			$rsult=$settingobj->setKey($ppal_direct_pending_release, 'ppal_pending_release', 'paypal');
			
		if(isset($ppal_direct_currency))
			$rsult=$settingobj->setKey($ppal_direct_currency, 'ppal_base_currency', 'paypal');

		if(isset($ppal_direct_notify_url))
			$rsult=$settingobj->setKey($ppal_direct_notify_url, 'ppal_notify_url', 'paypal');

		if(isset($ppal_direct_ssl_port))
			$rsult=$settingobj->setKey($ppal_direct_ssl_port, 'ssl_port', 'gateway');

		if(isset($ppal_direct_txn_table))
			$rsult=$settingobj->setKey($ppal_direct_txn_table, 'Datasource_PayPal_Table', 'gateway');

		$message='Credit card setting is successfully saved. All changes will take effect when you start EaseGate next time.';
		$saved='true';
		$errorlog='';
	}else if ($payment_select == 'worldpay') {
		$rsult=$settingobj->setKey($payment_select, 'payment_method', 'creditcard');

		if(isset($wpay_instID))
			$rsult=$settingobj->setKey($wpay_instID, 'wpay_instID', 'worldpay');

		if(isset($ppal_return))
			$rsult=$settingobj->setKey($ppal_return, 'ppal_return', 'paypal');

		if(isset($ppal_cancal_return))
			$rsult=$settingobj->setKey($ppal_cancal_return, 'ppal_cancel_return', 'paypal');

		if(isset($wpay_base_currency))
			$rsult=$settingobj->setKey($wpay_base_currency, 'wpay_base_currency', 'worldpay');

		if(isset($wpay_notify_url))
			$rsult=$settingobj->setKey($wpay_notify_url, 'wpay_notify_url', 'worldpay');

		if(isset($wpay_testmode))
			$rsult=$settingobj->setKey($wpay_testmode, 'wpay_testmode', 'worldpay');

		if(isset($ssl_port))
			$rsult=$settingobj->setKey($ssl_port, 'ssl_port', 'gateway');

		if(isset($Datasource_PayPal_Table))
			$rsult=$settingobj->setKey($Datasource_PayPal_Table, 'Datasource_PayPal_Table', 'gateway');

		$message='Credit card setting is successfully saved. All changes will take effect when you start EaseGate next time.';
		$saved='true';
		$errorlog='';
	} else if ($payment_select == 'authorizeNet') {
		$rsult=$settingobj->setKey($payment_select, 'payment_method', 'creditcard');

		if(isset($aNet_id))
			$rsult=$settingobj->setKey($aNet_id, 'aNet_id', 'AuthorizeNet');

		if(isset($ppal_return))
			$rsult=$settingobj->setKey($ppal_return, 'ppal_return', 'paypal');

		if(isset($ppal_cancal_return))
			$rsult=$settingobj->setKey($ppal_cancal_return, 'ppal_cancel_return', 'paypal');

		if(isset($aNet_key))
			$rsult=$settingobj->setKey($aNet_key, 'aNet_key', 'AuthorizeNet');

		if(isset($aNet_hash))
			$rsult=$settingobj->setKey($aNet_hash, 'aNet_hash', 'AuthorizeNet');

		if(isset($aNet_base_currency))
			$rsult=$settingobj->setKey($aNet_base_currency, 'aNet_base_currency', 'AuthorizeNet');

		if(isset($aNet_notify_url))
			$rsult=$settingobj->setKey($aNet_notify_url, 'aNet_notify_url', 'AuthorizeNet');

		if(isset($aNet_testmode))
			$rsult=$settingobj->setKey($aNet_testmode, 'aNet_testmode', 'AuthorizeNet');

		if(isset($Datasource_PayPal_Table))
			$rsult=$settingobj->setKey($Datasource_PayPal_Table, 'Datasource_PayPal_Table', 'gateway');

		$message='Credit card setting is successfully saved. All changes will take effect when you start EaseGate next time.';
		$saved='true';
		$errorlog='';
	} else if($payment_select == 'checkout') {
		$rsult=$settingobj->setKey($payment_select, 'payment_method', 'creditcard');

		if(isset($checkout_merchant_id))
			$rsult=$settingobj->setKey($checkout_merchant_id, 'checkout_merchant_id', 'googleCheckout');

		if(isset($checkout_return))
			$rsult=$settingobj->setKey($checkout_return, 'checkout_return', 'googleCheckout');

		if(isset($checkout_cancel_return))
			$rsult=$settingobj->setKey($checkout_cancel_return, 'checkout_cancel_return', 'googleCheckout');

		if(isset($checkout_base_currency))
			$rsult=$settingobj->setKey($checkout_base_currency, 'checkout_base_currency', 'googleCheckout');

		//##KK 9 DEC ssl port, invoice_start
		if(isset($ssl_port))
			$rsult=$settingobj->setKey($ssl_port, 'ssl_port', 'gateway');

		if(isset($Datasource_PayPal_Table))
			$rsult=$settingobj->setKey($Datasource_PayPal_Table, 'Datasource_PayPal_Table', 'gateway');

		//#######

		$message='Credit card setting is successfully saved. All changes will take effect when you start EaseGate next time.';
		$saved='true';
		$errorlog='';
	} else if ($payment_select == 'user_defined') {
		$rsult=$settingobj->setKey($payment_select, 'payment_method', 'creditcard');

		if(isset($udef_id))
			$rsult=$settingobj->setKey($udef_id, 'id', 'User_defined_payment');

		if(isset($udef_return))
			$rsult=$settingobj->setKey($udef_return, 'ppal_return', 'paypal');

		if(isset($udef_cancel_return))
			$rsult=$settingobj->setKey($udef_cancel_return, 'ppal_cancel_return', 'paypal');

		if(isset($udef_pin1))
			$rsult=$settingobj->setKey($udef_pin1, 'pin1', 'User_defined_payment');

		if(isset($udef_pin2))
			$rsult=$settingobj->setKey($udef_pin2, 'pin2', 'User_defined_payment');

		if(isset($udef_currency))
			$rsult=$settingobj->setKey($udef_currency, 'currency', 'User_defined_payment');

		if(isset($udef_notify_url))
			$rsult=$settingobj->setKey($udef_notify_url, 'notify_url', 'User_defined_payment');

		if(isset($udef_ssl_port))
			$rsult=$settingobj->setKey($udef_ssl_port, 'ssl_port', 'gateway');

		if(isset($udef_txn_table))
			$rsult=$settingobj->setKey($udef_txn_table, 'Datasource_PayPal_Table', 'gateway');

		$message='Credit card setting is successfully saved. All changes will take effect when you start EaseGate next time.';
		$saved='true';
		$errorlog='';
	}
	//$settingobj->Release();
	$settingobj=null;
}
##end credit card

// authentication server services
else if(isset($save_a) && $save_a=='true')
{
    $cat='a';
    $resetAttemptMsg=false;  
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
	
	// NEW
	if (isset($use_active_directory) && $use_active_directory == "on"){
		$rsult = $settingobj->setKey("true", 'use_active_directory', 'gateway');
		$rsult = $settingobj->setKey($active_directory_domain, 'active_directory_domain', 'gateway');
		$rsult = $settingobj->setKey($mark_delete_only, 'mark_delete_only', 'gateway');
	}
	else{
		$enable_proxy_server = "off";
		$rsult = $settingobj->setKey("false", 'use_active_directory', 'gateway');
	}
	
	if ($enable_transparent_proxy == "on" && $enable_proxy_server == "on"){
		$proxy_mode = 2;
	}
	else if ($enable_transparent_proxy == "off" && $enable_proxy_server == "off"){
		$proxy_mode = 0;
	}
	else if ($enable_transparent_proxy == "on" && $enable_proxy_server == "off"){
		$proxy_mode = 3;
	}
	else if ($enable_transparent_proxy == "off" && $enable_proxy_server == "on"){
		$proxy_mode = 1;
	}
	
	if ($enable_transparent_proxy == "on"){
		if(isset($transparent_proxy_port)) {
			$rsult = $settingobj->setKey($transparent_proxy_port, 'transparent_proxy_port', 'gateway');
		}
	}
	if ($enable_proxy_server == "on"){
		if(isset($proxy_server_port)) {
			$rsult = $settingobj->setKey($proxy_server_port, 'proxy_server_port', 'gateway');
		}
	}
	
	$rsult = $settingobj->setKey($proxy_mode, 'proxy_mode', 'gateway');
	
	// END

    if(isset($auth_port)) {
        $rsult = $settingobj->setKey($auth_port, 'auth_port', 'gateway');
        $ssl_status= $settingobj->getKey( 'rewrite_engine', 'gateway');
        if ($ssl_status=='off')
            $rsult = $settingobj->setKey($auth_port, 'ssl_auth_port', 'gateway');

    }

    if(isset($ssl_auth_port)) {
        $a_port= $settingobj->getKey('auth_port', 'gateway');
        $rsult = $settingobj->setKey($ssl_auth_port, 'ssl_auth_port', 'gateway');
        if ($ssl_auth_port==$a_port)
            $rsult = $settingobj->setKey('off', 'rewrite_engine', 'gateway');
        else
            $rsult = $settingobj->setKey('on', 'rewrite_engine', 'gateway');
    }        
	
	if (isset($showDomainUrl)){
		// 20080602 - Write new option domain_name and show_domain_URL in config
		if (isset($domainName) && $domainName != '') {
		$rsult = $settingobj->setKey($domainName, 'gateway_domain', 'gateway');
		} else {
			// 20090330 - Keep saving blank instead of EaseGate.net
			$rsult = $settingobj->setKey('', 'gateway_domain', 'gateway');
		}
		if (isset($showDomainUrl) && $showDomainUrl != '') {
		$rsult = $settingobj->setKey($showDomainUrl, 'show_domain_URL', 'gateway');
		} else {
		$rsult = $settingobj->setKey('0', 'show_domain_URL', 'gateway');
		}
	}

	if (isset($loginpage_pic)){
		$filter_path = realpath("..\\");
		$filter_path = $filter_path."\\config.ini";
		$i=sizeof($loginpage_pic);
		$settingobj->WriteINI("gateway", "loginpage_pic_count", $i, $filter_path);
		$y=0;
		while($y<$i){
			$name="loginpage_pic";
			$name.=$y;
			$settingobj->WriteINI("gateway", $name, $loginpage_pic[$y], $filter_path);
			$y++;
		}
        //$rsult = $settingobj->setKey($parentList[0], 'loginpage_pic_name', 'gateway');
	}
	
	//check if the admin want to randomize the loginpage pic
	if (isset($random)) {
		$filter_path = realpath("..\\");
		$filter_path = $filter_path."\\config.ini";
		$settingobj->WriteINI("gateway", "random", '1', $filter_path);
	}
	else {
		$filter_path = realpath("..\\");
		$filter_path = $filter_path."\\config.ini";
		$settingobj->WriteINI("gateway", "random",'0', $filter_path);
	}
	
	
	if (isset($redirectpage_pic_name))
        $rsult = $settingobj->setKey($redirectpage_pic_name, 'redirectpage_pic_name', 'gateway');
	
	if	(isset($redirectpage_pic_html))
		$rsult = $settingobj->setKey($redirectpage_pic_html, 'redirectpage_pic_name_html', 'gateway');
	
	// 20090518 - Remove Start
    // 20080418 - Add saving scratch mode status
    if (isset($login_opt_rb)) {
	if ($login_opt_rb == 'anonymous') {
	    $rsult = $settingobj->setKey('on', 'anonymous_login', 'gateway');
	    $rsult = $settingobj->setKey('off', 'secret_enable', 'gateway');
	    $rsult = $settingobj->setKey('off', 'scratch_login', 'gateway');
	} elseif ($login_opt_rb == 'secret') {
	    $rsult = $settingobj->setKey('on', 'anonymous_login', 'gateway');
	    $rsult = $settingobj->setKey('on', 'secret_enable', 'gateway');
	    if (isset($ssecret_tablename)) {
		$rsult = $settingobj->setKey($ssecret_tablename, 'Datasource_Shared_Secret_Tablename', 'gateway');
	    }
	    $rsult = $settingobj->setKey('off', 'scratch_login', 'gateway');
	} elseif ($login_opt_rb == 'scratch') {
	    $rsult = $settingobj->setKey('off', 'anonymous_login', 'gateway');
	    $rsult = $settingobj->setKey('off', 'secret_enable', 'gateway');
	    $rsult = $settingobj->setKey('on', 'scratch_login', 'gateway');
	} else {
	    $rsult = $settingobj->setKey('off', 'anonymous_login', 'gateway');
	    $rsult = $settingobj->setKey('off', 'secret_enable', 'gateway');
	    $rsult = $settingobj->setKey('off', 'scratch_login', 'gateway');
	}
    } else {
        $rsult = $settingobj->setKey('off', 'anonymous_login', 'gateway');
        $rsult = $settingobj->setKey('off', 'secret_enable', 'gateway');
	$rsult = $settingobj->setKey('off', 'scratch_login', 'gateway');
    }

    if(isset($maxAttempt))
        $rsult = $settingobj->setKey($maxAttempt, 'max_attempt', 'gateway');  

    //added by Jason 15-03-2004
    if(isset($rewrite_engine)) {
        $a_port= $settingobj->getKey('auth_port', 'gateway');
        $rsult = $settingobj->setKey($rewrite_engine, 'rewrite_engine', 'gateway');
        if ($rewrite_engine=='off')
            $rsult = $settingobj->setKey($a_port, 'ssl_auth_port', 'gateway');
        else
            $rsult = $settingobj->setKey('443', 'ssl_auth_port', 'gateway');
    }

    if(isset($resetAttempt) && $resetAttempt==-1) {
        // open dsn
        $dsn_file=$settingobj->getKey('Datasource', 'gateway');
        $dsn_source=fopen($dsn_file, 'r') or die('Cannot open DSN source file!');

        // prepare dsn string for ODBC connection
        $dsn='';

        if(!feof($dsn_source))
            $line=fgets($dsn_source,512);
        // read in each line
        while(!feof($dsn_source)) {
            $line=fgets($dsn_source,512);
            if(trim($line)!='') 
                $dsn=$dsn.$line;
        }

        // replace newline with semicolon
        $dsn=str_replace("\r\n",';',$dsn);

        // connect with ODBC
        $userDB=odbc_connect($dsn,'','');

        // connected
        if($userDB) {
            // for EaseGate user table, we reset all reserved fields
            $EaseGateusertable=$settingobj->getKey('Datasource_Tablename', 'gateway');
            $query="UPDATE $EaseGateusertable SET attempt=0;";
            $result=odbc_exec($userDB,$query);

            // close the odbc connection
            odbc_close($userDB);
            // inform user
            $message='All user\'s fail attempt value are reset.';
            $saved='true';
            $errorlog='';
        } else {
            // warn user if connection failed
            $message='database connection failed!';
            $saved='false';
            $errorlog='database connection failed!';
        }
        $resetAttemptMsg=true;

        $cat='a';
    }
    if(isset($ssl_cert))
        $rsult = $settingobj->setKey($ssl_cert, 'ssl_cert', 'gateway');
    
    if(isset($restricted_redirect))
        $rsult = $settingobj->setKey($restricted_redirect, 'restricted_redirect', 'gateway');

    //************************************************************************************************
    // Authentication ODBC Handling
	$odbc_selection = 'ODBC';
	
    if(isset($odbc_selection)&&$odbc_selection=='ODBC') {
        
        if(isset($Datasource))
            $rsult = $settingobj->setKey(stripslashes($Datasource), 'Datasource', 'gateway');

        if(isset($Datasource_Tablename))
            $rsult = $settingobj->setKey($Datasource_Tablename, 'Datasource_Tablename', 'gateway');

        if(isset($Datasource_Plans_Tablename))
            $rsult = $settingobj->setKey($Datasource_Plans_Tablename, 'Datasource_Plans_Tablename', 'gateway');

        if(isset($Datasource_Log_Tablename))
            $rsult = $settingobj->setKey($Datasource_Log_Tablename, 'Datasource_Log_Tablename', 'gateway');

        if(isset($Datasource_Anonymous_Tablename))
            $rsult = $settingobj->setKey($Datasource_Anonymous_Tablename, 'Datasource_Anonymous_Tablename', 'gateway');

	    //Scenario 2 (Distributed Network Topology)
	    if(isset($scenario2)){ // Enable Scenario2
	        $rsult = $settingobj->setKey('1', 'scenario2','gateway');                            
	         if(isset($siteID))
	            $rsult = $settingobj->setKey($siteID, 'siteID','gateway');
	            
	        if(isset($Datasource_Msg_Tablename)){
	            $rsult = $settingobj->setKey($Datasource_Msg_Tablename, 'Datasource_msg_Tablename','gateway');
	        }
			
			if(isset($clearMessage)&&($clearMessage==true)){
				if(!isset($Datasource_Msg_Tablename))
					$Datasource_Msg_Tablename=$settingobj->getKey('Datasource_msg_Tablename', 'gateway');
				$query2 = "DELETE FROM $Datasource_Msg_Tablename ;" ;   //clear message table
				$rsult=db_query($query2);
			}
	    }
	    else
	        $rsult = $settingobj->setKey('0', 'scenario2','gateway');
			
    }
    // END - ODBC/RADIUS
    //************************************************************************************************
	
    /*
    // [sphl] 20070216 moved to UI customization page 
    if(isset($start_up_redirect_option ))
		$rsult = $settingobj->setKey($start_up_redirect_option , 'start_up_redirect_option', 'gateway');
		
	if(isset($start_up_redirect_url))
		$rsult = $settingobj->setKey($start_up_redirect_url, 'start_up_redirect_url', 'gateway');

	if(isset($start_up_redirect_wait ))
		$rsult = $settingobj->setKey($start_up_redirect_wait , 'start_up_redirect_wait', 'gateway');
	*/
			
    // 20080502 - Save display Self Sign-up
    if (isset($display_self_sign_up)) {
	$rsult = $settingobj->setKey($display_self_sign_up, 'display_self_sign_up', 'gateway');
    } else {
	$rsult = $settingobj->setKey('OFF', 'display_self_sign_up', 'gateway');
    }

    if(isset($self_sign_up_credit))
        $rsult = $settingobj->setKey($self_sign_up_credit, 'self_sign_up_credit', 'gateway');
    
    if(isset($self_sign_up_plan))
        $rsult = $settingobj->setKey($self_sign_up_plan, 'self_sign_up_plan', 'gateway');

    if(isset($self_sign_up_option))
        $rsult = $settingobj->setKey($self_sign_up_option, 'self_sign_up_option', 'gateway');

    if(isset($redirect_url))
        $rsult = $settingobj->setKey($redirect_url, 'self_sign_up_redirect', 'gateway');

    if(isset($self_signup_filter)) {
        $rsult = $settingobj->setKey($self_signup_filter, 'self_signup_filter', 'gateway');
        if($self_signup_filter == '1')
            $rsult = $settingobj->setKey( '', 'self_signup_period', 'gateway');            
    }

    if(isset($self_signup_period)) {
        if($self_signup_filter == '0')
            $rsult = $settingobj->setKey($self_signup_period, 'self_signup_period', 'gateway');
    }

    if(isset($session_log))
        $rsult = $settingobj->setKey($session_log, 'session_log', 'gateway');
    else
        $rsult = $settingobj->setKey('OFF', 'session_log', 'gateway');

    if(isset($encrypt_path))
        $rsult = $settingobj->setKey(stripslashes($encrypt_path), 'encrypt_path', 'gateway');

    if(isset($pwd_offload))
        $rsult = $settingobj->setKey($pwd_offload, 'pwd_offload', 'gateway');
    else
        $rsult = $settingobj->setKey('off', 'pwd_offload', 'gateway');
        
    //CAPTCHA check
    if(isset($self_sign_up_captcha_check))
        $rsult = $settingobj->setKey($self_sign_up_captcha_check, 'self_sign_up_captcha_check', 'gateway');


    //display following msg when user did NOT set MAX ATTEMPT FIELD
    if(!$resetAttemptMsg) {
        $message='Authentication server setting is successfully saved. All changes will take effect when you start EaseGate next time.';
        $saved='true';
        $errorlog='';
    }
    //free COM object
    //$settingobj->Release();
    $settingobj=null;
}

// configuration manager settings
else if(isset($save_m) && $save_m=='true')
{
	require_once('category.php'); //gather categories information

    $cat='m';
    $RestartMsg = '';
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
    if(isset($user))
        $rsult = $settingobj->setKey($user, 'user', 'gateway');

    if(isset($pass)&&isset($confirmPass)&&($pass===$confirmPass) && $pass!='                    ') {
        $h_pwd = $settingobj->EncryptString($pass);
        $rsult = $settingobj->setKey($h_pwd, 'pass', 'gateway');
    }

    $old_internal = $settingobj->getKey('access_from_internal', 'gateway');
    $old_external = $settingobj->getKey('access_from_external', 'gateway');

    if ((($old_internal == 'off') && isset($access_from_internal)) || (($old_internal == 'ON') && !isset($access_from_internal)) || (($old_external == 'off') && isset($access_from_external)) || (($old_external == 'ON') && !isset($access_from_external)))
        $RestartMsg = 'All changes will take effect when you restart EaseGate .';

    if(isset($access_from_internal))
        $rsult = $settingobj->setKey($access_from_internal, 'access_from_internal', 'gateway');
    else
        $rsult = $settingobj->setKey('off', 'access_from_internal', 'gateway');

    if(isset($access_from_external))
        $rsult = $settingobj->setKey($access_from_external, 'access_from_external', 'gateway');
    else
        $rsult = $settingobj->setKey('off', 'access_from_external', 'gateway');   

    $max_admin_account=$settingobj->getKey('max_admin_account', 'gateway');
    $addErrorMsg = '';
    $addError = false;

    if(isset($mode)&&($mode=='add')) {
        $emptyspace = false;
        $addError = false;
        if ($admin_username == $user) {
            $addErrorMsg = 'Duplicated Account have been added.';
            $emptyspace = true;
            $addError = true;
        } else {
            $i = 0;
            for ($i = 0; $i < $max_admin_account; $i++) {
                $old_admin_username = $settingobj->getKey("admin_username$i", 'gateway');
                if ($old_admin_username == '')
                    $emptyspace = true;
                if ($old_admin_username == $admin_username) {
                    $addErrorMsg = 'Duplicated Account have been added.';
                    $addError = true;
                }
            }
        }

        if ($emptyspace == false) {
            $addErrorMsg = "$addErrorMsg Reach the maximum account number.";
            $addError = true;
        }

        if ($addError == false) {
            $i = 0;
            for ($i = 0; $i < $max_admin_account; $i++) {
                $old_admin_username = $settingobj->getKey("admin_username$i", 'gateway');
                if ($old_admin_username != '')
                    continue;

                if (isset($admin_username))
                    $rsult = $settingobj->setKey($admin_username, "admin_username$i", 'gateway');
                if (isset($admin_password)) {
                    $en_admin_password = $settingobj->EncryptString($admin_password);
                    $rsult = $settingobj->setKey($en_admin_password, "admin_password$i", 'gateway');
                }

                if (isset($parameter)) {
					// change to new saving format which from arr_category[] in category.php 
					$parameterStr = "";
					$count_param = 0;
					
					// first digit is "Administration (to start & stop EaseGate)"
					if ($parameter{0} == 1){
						$parameterStr .= "admin";
						$count_param++;
					}
					
					foreach( $arr_category as $k => $v){
						if ($parameter{$k+1} == '1'){
							if ($count_param == 0 )
								$parameterStr .= $v;
							else
								$parameterStr .= ",".$v;
								
							$count_param++;
						}
					}
					$rsult = $settingobj->setKey($parameterStr, "admin_parameter$i", 'gateway');
                }
                break;
            }
        }
    }

    if (isset($mode)&&($mode=='edit')) {
        if (isset($admin_username)) {
            $i = 0;
            for ($i = 0; $i < $max_admin_account; $i++) {
                $old_admin_username=$settingobj->getKey("admin_username$i", 'gateway');
                if ($old_admin_username != $admin_username)
                    continue;

                if (isset($admin_password)&&$admin_password!='                    ') {
                    $en_admin_password = $settingobj->EncryptString($admin_password);
                    $rsult = $settingobj->setKey( $en_admin_password, "admin_password$i", 'gateway');
                }

                if (isset($parameter)) { 
					// change to new saving format which from arr_category[] in category.php 
					$parameterStr = "";
					$count_param = 0;
					
					// first digit is "Administration (to start & stop EaseGate)"
					if ($parameter{0} == 1){
						$parameterStr .= "admin";
						$count_param++;
					}
					
					foreach( $arr_category as $k => $v){
						if ($parameter{$k+1} == '1'){
							if ($count_param == 0 )
								$parameterStr .= $v;
							else
								$parameterStr .= ",".$v;
								
							$count_param++;
						}
					}
					$rsult = $settingobj->setKey($parameterStr, "admin_parameter$i", 'gateway');
                }
                break;
            }
        }
    }

    if (isset($mode)&&($mode=='del')) {
        $tok = strtok($selected_operator, ',');

        while ($tok != '') {
            $admin_username = $tok;

            if (isset($admin_username)) {
                $i = 0;
                for ($i = 0; $i < $max_admin_account; $i++) {
                    $old_admin_username=$settingobj->getKey("admin_username$i", 'gateway');
                    if ($old_admin_username != $admin_username)
                        continue;

                    $rsult = $settingobj->setKey('', "admin_username$i", 'gateway');
                    $rsult = $settingobj->setKey('', "admin_password$i", 'gateway');
                    $rsult = $settingobj->setKey('', "admin_parameter$i", 'gateway');
                }
            }
            $tok = strtok(',');
        }
    }

    if ($addError == true)
        $message=$addErrorMsg;
    else
        $message="Configuration Manager setting is successfully saved.$RestartMsg";
    $saved='true';
    $errorlog='';
    //free COM object
    //$settingobj->Release();
    $settingobj=null;
}

// add routing table settings
else if(isset($save_r) && $save_r=="true")
{
    $cat = 'r';
    require_once 'display_list.php';

    // unserialize session data
    if (isset($ser_display_route)&&($ser_display_route!=='')) {
        $display_route = unserialize($ser_display_route);
    }
    if (isset($ser_add_route)&&($ser_add_route!=='')) {
        $add_route = unserialize($ser_add_route);
    }

    // initialize variables
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');

    $str=''; $j=0; $n=0; $m=0;
    $i = 0;

    // save change the display data
    while ($i < $display_route->num_sites) {
        if ($display_route->site_list[$i]->name{0}!='#') {
            $str = $display_route->site_list[$i]->name.' '.$display_route->site_list[$i]->line_no.' '.$display_route->site_list[$i]->span;
            $rsult = $settingobj->setKey($str, "return_path$n", 'MNS');

            if($display_route->site_list[$i]->enable_redirect==TRUE)
                $rsult = $settingobj->setKey('1', "Login_enable$n", 'loginPhp');
            else
                $rsult = $settingobj->setKey('0', "Login_enable$n", 'loginPhp');

            $rsult = $settingobj->setKey($display_route->site_list[$i]->redirect_php, "Login_php_Num$n", 'loginPhp');
            $n++;
        }
        $i++;
    }

    // save the add data
    $j = $n;
    $i = 0;
    while ($i < $add_route->num_sites) {
        if (($add_route->site_list[$i]->name!=';')&&($add_route->site_list[$i]->name{0}!='#')) {
            $str = $add_route->site_list[$i]->name.' '.$add_route->site_list[$i]->line_no.' '.$add_route->site_list[$i]->span;
            $rsult = $settingobj->setKey($str, 'return_path'.($m+$j), 'MNS');

            if($add_route->site_list[$i]->enable_redirect==TRUE)
                $rsult = $settingobj->setKey('1', 'Login_enable'.($m+$j), 'loginPhp');
            else
                $rsult = $settingobj->setKey('0', 'Login_enable'.($m+$j), 'loginPhp');

            $rsult = $settingobj->setKey($add_route->site_list[$i]->redirect_php, 'Login_php_Num'.($m+$j), 'loginPhp');
            $m++;
        }
        $i++;
    }

    $num_return_path = $m+$j;
    $rsult = $settingobj->setKey($num_return_path, 'num_return_path', 'MNS');

    // unset all variables
    $ser_display_route=NULL;
    $ser_add_route=NULL;

    //free COM object
    //$settingobj->Release();
    $settingobj=null;

    $message = 'Routing table setting is successfully saved. All changes will take effect when you start EaseGate next time.';
    $saved = 'true';
    $errorlog = '';
}


// session handling settings
else if(isset($save_s) && $save_s=='true')
{
    $cat = 's';
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
    if(isset($session_handling))
        $rsult = $settingobj->setKey($session_handling, 'session_handling', 'gateway');
		
	
	if(isset($passiveLoginMode))
		$rsult = $settingobj->setKey($passiveLoginMode, 'passive_login_mode', 'gateway');

	//free COM object
    //$settingobj->Release();
    $settingobj=null;

    $message = 'Session Handling setting is successfully saved. All changes will take effect when you start EaseGate next time.';
    $saved = 'true';
    $errorlog = '';
}

// dhcp settings
else if(isset($save_dhcp) && $save_dhcp=='true')
{
    $cat='dhcp';
    $alert=false;       
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');

    if(isset($servermode)) {
        $rsult = $settingobj->setKey($servermode, 'dhcpmode', 'gateway');
        require_once 'display_list.php';

        if (isset($ser_display_ignore)&&($ser_display_ignore!=='')) 
                $display_ignore=unserialize($ser_display_ignore);
        if (isset($ser_add_ignore)&&($ser_add_ignore!=='')) 
        $add_ignore=unserialize($ser_add_ignore);

        $str=''; $j=0; $n=0; $m=0;
        $i=0;
        while ($i < $display_ignore->num_sites) {
	    // 20080205 - Obtain IP from name field instead of span in display_ignore list
	    if ($display_ignore->site_list[$i]->name{0} != '#') {
		$rsult = $settingobj->setKey($display_ignore->site_list[$i]->name, "ignore_addr$n", 'DHCP');
		$n++;
	    } else {
		//when deleting exception ip in dhcp, delete the same ip in client pass through as well
		if (isset($ser_display_ip)) {
		    $display_ip = unserialize($ser_display_ip); 
		    $num_sites = $display_ip->num_sites;
		    for ($count = 0; $count < $num_sites; $count++) {
			if (strcmp(substr($display_ignore->site_list[$i]->name, 2, strlen($display_ignore->site_list[$i]->name)-2), $display_ip->site_list[$count]->span) == 0) {

			    for ($j = $count; $j < $num_sites; $j++) {
				if (!empty($display_ip->site_list[$j+1]->span)) {
				    $display_ip->site_list[$j]->span = $display_ip->site_list[$j+1]->span;
				    $rsult = $settingobj->setKey($display_ip->site_list[$j]->span, "ip_$j", 'Client Pass');
				}
			    }
			    $display_ip->num_sites--;

			    $rsult = $settingobj->setKey($display_ip->num_sites , 'num_ip_addr', 'Client Pass');
			    $alert = true;

			    if (isset($display_ip)) {
				$ser_display_ip = serialize($display_ip);
			    }

			}//end if
		    }//end for
		}//end if
	    }//end else

                $i++;
        }
        $j=$n;
        $i=0;
        while ($i<$add_ignore->num_sites) {
	    // 20080205 - Obtain IP from name field instead of span in add_ignore list
	    if (($add_ignore->site_list[$i]->name != ';') && ($add_ignore->site_list[$i]->name{0} != '#')) {
		$rsult = $settingobj->setKey($add_ignore->site_list[$i]->name, 'ignore_addr'.($m+$j), 'DHCP');
		$m++;
	    }
                $i++;
            }

        $num_ignored_addr=$m+$j;

        if(isset($num_ignored_addr))
                $rsult = $settingobj->setKey($num_ignored_addr, 'num_ignored_addr', 'DHCP');

        if(isset($leasetime))
                $rsult = $settingobj->setKey($leasetime, 'leasetime', 'DHCP');  

        // unset all variables
        $ser_display_ignore=NULL;
        $ser_add_ignore=NULL;

        if (isset($ser_display_dhcp)&&($ser_display_dhcp!=='')) 
                $display_dhcp=unserialize($ser_display_dhcp);
        if (isset($ser_add_dhcp)&&($ser_add_dhcp!=='')) 
                $add_dhcp=unserialize($ser_add_dhcp);

        $i=0; $j=0;
        unset($delete_list_dhcp);
        while ($i < $display_dhcp->num_sites) {
                if ($display_dhcp->site_list[$i]->name{0}=='#') { 
                    $delete_list_dhcp[$j]=(int)$display_dhcp->site_list[$i]->line_no; $j++;
                }
                $i++;   
            }
        $num_delete_dhcps=$j;

        $i=0; $j=0;
        unset($add_list_dhcp);
        while ($i < $add_dhcp->num_sites) {
                if (($add_dhcp->site_list[$i]->name!=';')&&($add_dhcp->site_list[$i]->name{0}!='#')) {
                    $add_list_dhcp[$j]=$add_dhcp->site_list[$i]->name.' '.$add_dhcp->site_list[$i]->span; $j++;     
                }
                $i++;
            }
            $num_add_dhcps=$j;

        unset($lines);
        if (isset($add_list_dhcp)||isset($delete_list_dhcp)) {
                if(isset($static_dhcp_path)&&($static_dhcp_path!='')) {
                }else
                    $static_dhcp_path = "..\\StaticDHCP.txt";
                $file_to_read=fopen($static_dhcp_path, 'a');
                fclose($file_to_read);
                $file_to_read=fopen($static_dhcp_path, 'r') or die('Cannot read Static DHCP config file');
                $i=0;
                while (!feof($file_to_read)) { $lines[$i]=fgets($file_to_read, MAXLINELEN); $i++; }
                @fclose($file_to_read);

                $file_to_write=fopen($static_dhcp_path, 'w') or die('Cannot write to Static DHCP config file');

                // Write to file omitting the host keywords to be deleted
                $j=0; $k=0;
                if (isset($delete_list_dhcp)) { 
                    while (($k<$i) && ($j<$num_delete_dhcps)) {
                        if ($k>$delete_list_dhcp[$j])
                            $j++;
                        else if ($k<$delete_list_dhcp[$j]) {
                            fputs($file_to_write, $lines[$k]);
                            $k++;
                        } else {
                            $j++; $k++;
                        }
                    }
                }

                while ($k<$i) {
                    fputs($file_to_write, $lines[$k]);
                    $k++;
                }
                // Append the host keywords to be added at the end of the file
                $k=0; 
                if (isset($add_list_dhcp)) {
                    while ($k<$num_add_dhcps) { 
                        fputs($file_to_write, "\r\n".$add_list_dhcp[$k]); 
                        $k++; 
                    }
                }

                @fclose($file_to_write);  
        }

        // unset all the session variables after saving 
        $ser_add_dhcp=NULL;
        $ser_display_dhcp=NULL;
        if(isset($static_dhcp_path)&&($static_dhcp_path!=''))
            $rsult = $settingobj->setKey(stripslashes($static_dhcp_path), 'static_dhcp_path', 'gateway');
        
    }
    if($alert==true) {
        echo '
        <script type="text/javascript">
            alert ("The newly deleted IP(s) will be removed from the Client pass-through in Session Handling as well!")
        </script>';

        $alert=false;
    }

    // 20080827 - Obtain IP filename from config
    $hostIpFile = $settingobj->getKey('hosts_ips_path', 'allowed hosts');

    // prepare to set the DNS settings
    if(isset($preferred_DNS0)||isset($preferred_DNS1)||isset($preferred_DNS2)||isset($preferred_DNS3)) {
        $preferred_DNS="$preferred_DNS0.$preferred_DNS1.$preferred_DNS2.$preferred_DNS3";

        $last_dns1 = $settingobj->getKey('preferred_DNS', 'gateway');
        $dns2 = $settingobj->getKey('alternate_DNS', 'gateway');
	// 20080827 - Replace hard-coded IP filenames
        // if(strcmp($last_dns1, $preferred_DNS)!=0) {
            // $file_to_read = fopen($hostIpFile, 'r') or die('Cannot read Exception free IP config file');
            // $i=0;
            // while (!feof($file_to_read)) { $lines[$i]=fgets($file_to_read, MAXLINELEN); $i++; }
            // @fclose($file_to_read);

            // $file_to_write = fopen($hostIpFile, 'w') or die('Cannot write to Exception free IP config file');
            // $remove=TRUE;
            // $x=0;
            // while ($x<$i) {
                // if(strncmp($lines[$x], $last_dns1, strlen($last_dns1))==0 && strstr($lines[$x], ';') == FALSE&&$remove){
                    // fwrite($file_to_write, '');
                    // $remove=FALSE;
                // }else 
                    // fwrite($file_to_write, $lines[$x]);

                // $x++;           
            // }      
            // @fclose($file_to_write);  

            // if(strcmp($preferred_DNS, '0.0.0.0')!=0) {
                // $file_to_write = fopen($hostIpFile, 'a') or die('Cannot write to Exception free IP config file');
                // fwrite($file_to_write, "\r\n".$preferred_DNS);
                // @fclose($file_to_write);  
            // }
        // }
        $rsult = $settingobj->setKey($preferred_DNS, 'preferred_DNS', 'gateway');
    }

    if(isset($alternate_DNS0)||isset($alternate_DNS1)||isset($alternate_DNS2)||isset($alternate_DNS3)) {
        $alternate_DNS="$alternate_DNS0.$alternate_DNS1.$alternate_DNS2.$alternate_DNS3";

        $last_dns2 = $settingobj->getKey('alternate_DNS', 'gateway');
        $dns1 = $settingobj->getKey('preferred_DNS', 'gateway');
	// 20080827 - Replace hard-coded IP filenames
        // if(strcmp($last_dns2, $alternate_DNS)!=0) {
            // $file_2_read = fopen($hostIpFile, 'r') or die('Cannot read Exception free IP config file');
            // $i=0;
            // while (!feof($file_2_read)) { $ln[$i]=fgets($file_2_read, MAXLINELEN); $i++; }
            // @fclose($file_2_read);

            // $file_2_write = fopen($hostIpFile, 'w') or die('Cannot write to Exception free IP config file');

            // $remove = TRUE;
            // $x=0;
            // while ($x<$i) {
                // if(strncmp($ln[$x], $last_dns2, strlen($last_dns2))==0 && strstr($ln[$x], ';') == FALSE&&$remove) {
                    // fwrite($file_2_write, '');
                    // $remove=FALSE;
                // } else 
                    // fwrite($file_2_write, $ln[$x]);

                // $x++;           
            // }
            // @fclose($file_2_write);  

            // if(strcmp($alternate_DNS, '0.0.0.0')!=0) {
                // $file_2_write = fopen($hostIpFile, 'a') or die('Cannot write to Exception free IP config file');
                // fwrite($file_2_write, "\r\n".$alternate_DNS);
                // @fclose($file_2_write);  
            // }
        // }

        $rsult = $settingobj->setKey($alternate_DNS, 'alternate_DNS', 'gateway');
    }

    //free COM object
    //$settingobj->Release();
    $settingobj=null;

    $message='DHCP setting is successfully saved. All changes will take effect when you start EaseGate next time.';
    $saved='true';
    $errorlog='';
}

// Exception free sites
else if ((isset($save_e) && $save_e=='true'))
{
    $cat='e';
    // unserialize data
    require_once 'display_list.php';

    if (isset($ser_display)&&($ser_display!==''))
        $display = unserialize($ser_display);
    if (isset($ser_add)&&($ser_add!==''))
        $add = unserialize($ser_add);

    $i=0; $j=0;
    unset($delete_list);
    while ($i < $display->num_sites) {
        if ($display->site_list[$i]->name{0}=='#') {
            $delete_list[$j]=(int)$display->site_list[$i]->line_no;
            $j++;
        }
        $i++;
    }
    $num_delete_sites = $j;

    $i=0; $j=0;
    unset($add_list);
    while ($i < $add->num_sites) {
        if (($add->site_list[$i]->name!=';')&&($add->site_list[$i]->name{0}!='#')) {
            $add_list[$j]=$add->site_list[$i]->name; $j++; 
        }
        $i++;
    }
    $num_add_sites = $j;

    // 20080827 - Obtain information from config
    $settingObj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
    $hostIpFile = $settingObj->getKey('hosts_ips_path', 'allowed hosts');
    $hostKeywordFile = $settingObj->getKey('hosts_keywords_path', 'allowed hosts');
    $settingObj = null;

    // 20080827 - Replace hard-coded keyword filenames
    if (isset($add_list) || isset($delete_list)) {
        $file_to_read = fopen($hostKeywordFile, 'r') or die('Cannot read Exception free site config file');
        $i=0;
        while (!feof($file_to_read)) { $lines[$i]=fgets($file_to_read, MAXLINELEN); $i++; }
        @fclose($file_to_read);

        $file_to_write = fopen($hostKeywordFile, 'w') or die('Cannot write to Exception free site config file');

        // Write to file omitting the host keywords to be deleted
        $j=0; $k=0;
        if (isset($delete_list)) { 
            sort($delete_list); // fixed by dennis, 1st March 2005

            while (($k<$i) && ($j<$num_delete_sites)) {
                if ($k>$delete_list[$j])
                    $j++;
                else if ($k<$delete_list[$j]) {
                    fputs($file_to_write, $lines[$k]);
                    $k++;
                } else {
                    $j++;
                    $k++;
                }
            }
        }

        while ($k<$i) {
            fputs($file_to_write, $lines[$k]);
            $k++;
        }
        // Append the host keywords to be added at the end of the file
        $k=0; 
        if (isset($add_list)) {
            while ($k<$num_add_sites) { 
                fputs($file_to_write, "\r\n".$add_list[$k]); 
                $k++; 
            }
        }

        @fclose($file_to_write);
    }

    // unset all the session variables after saving 
    $ser_add=NULL;
    $ser_display=NULL;


    // AllowedHostsIPs.txt
    if (isset($ser_displayIP))
        $displayIP=unserialize($ser_displayIP);
    if (isset($ser_addIP))
        $addIP=unserialize($ser_addIP);

    $i=0; $j=0;
    unset($delete_listIP);
    while ($i < $displayIP->num_sites) {
        if ($displayIP->site_list[$i]->name{0}=='#') { 
            $delete_listIP[$j]=(int)$displayIP->site_list[$i]->line_no;
            $j++;
        }
        $i++;  
    }
    $num_delete_IPs=$j;

    $i=0; $j=0;
    unset($add_listIP);
    while ($i<$addIP->num_sites) {
        if (($addIP->site_list[$i]->name!=';')&&($addIP->site_list[$i]->name{0}!='#')) {
            $add_listIP[$j]=$addIP->site_list[$i]->name;
            $j++;
        }
        $i++;
    }
    $num_add_IPs = $j;

    // 20080827 - Replace hard-coded IP filenames
    unset($lines);
    if (isset($add_listIP)||isset($delete_listIP)) {
        $file_to_read = fopen($hostIpFile, 'r') or die('Cannot read Exception free IP config file');
        $i=0;
        while (!feof($file_to_read)) { $lines[$i] = fgets($file_to_read, MAXLINELEN); $i++; }
        @fclose($file_to_read);

        $file_to_write = fopen($hostIpFile, 'w')
        or die('Cannot write to Exception free IP config file');

        // Write to file omitting the host keywords to be deleted
        $j=0; $k=0;
        if (isset($delete_listIP)) {

            sort($delete_listIP); // fixed by dennis, 1st March 2005

            while (($k<$i) && ($j<$num_delete_IPs)) {
                if ($k>$delete_listIP[$j])
                    $j++;
                else if ($k<$delete_listIP[$j]) {
                    fputs($file_to_write, $lines[$k]); $k++;
                } else {
                    $j++;
                    $k++;
                }
            }
        }

        while ($k<$i) {
            fputs($file_to_write, $lines[$k]);
            $k++;
        }
        // Append the host IPs to be added at the end of the file
        $k=0;
        if (isset($add_listIP)) {
            while ($k<$num_add_IPs) {
                fputs($file_to_write, "\r\n".$add_listIP[$k]);
                $k++;
            }
        }

        @fclose($file_to_write);
    }

    // unset all the session variables after saving
    $ser_addIP=NULL;
    $ser_displayIP=NULL;


    //end port filtering
    $message='Exception free websites setting is successfully saved. All changes will take effect when you start EaseGate next time.';
    $saved='true';
    $errorlog='';
}

else if(isset($removePeriod))
{
	$myobj = new COM("EGCONFIG.Cfgmgr") or die("addGroup.php EGCONFIG.Cfgmgr Object cannot be created!");
	$myobj->setKey($removePeriod, 'removePeriod', 'misc');
	$fs_path = $myobj->getFsPath();
	$cmd = "\"" . $fs_path . "dispatcher\\removeuser.exe\" " . $removePeriod;
	//$result = $myobj->runCommand($cmd);
	$sys = new sysfunc();
    $result = $sys->runCommand($cmd);
    $sys = null;
	//$myObj->Release();
	$myobj = null;
	
	if(strtolower($result)=="succeed")
		$message= "User(s) removed successfully!!";
	else
		$message= "Failed to remove user(s)!!";
	$saved='true';
	$errorlog='';
	
	$cat="u";
}
else if(isset($reset_bw))
{
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
    // open dsn
    $dsn_file=$settingobj->getKey('Datasource', 'gateway');
    $dsn_source=fopen($dsn_file, 'r') or die('Cannot open DSN source file!');

    // prepare dsn string for ODBC connection
    $dsn='';

    if(!feof($dsn_source)) 
        $line=fgets($dsn_source,512);

    // read in each line
    while(!feof($dsn_source)) {
        $line=fgets($dsn_source,512);

        if(trim($line)!='') 
            $dsn=$dsn.$line;
    }

    // replace newline with semicolon
    $dsn=str_replace("\r\n",';',$dsn);

    // connect with ODBC
    $userDB=odbc_connect($dsn,'','');

    // connected
    if($userDB) {
	// 20080508 - Add total field
        // for EaseGate user table, we reset all reserved fields
        $EaseGateusertable=$settingobj->getKey('Datasource_Tablename', 'gateway');
        $query="UPDATE $EaseGateusertable SET accumbw=null, accumbwUL=null, accumbwSha=null;";
        $result=odbc_exec($userDB,$query);

        // close the odbc connection
        odbc_close($userDB);

        // inform user
        $message='All users\' data transfer counters have been reset.';
        $saved='true';
        $errorlog='';
    } else {
        // warn user if connection failed
        $message='database connection failed!';
        $saved='false';
        $errorlog='database connection failed!';
    }

    //free COM object
    //$settingobj->Release();
    $settingobj=null;

    $cat='u';
}
else if(isset($exportUsageLog)&&($exportUsageLog==true))
{
    include_once("..\\authserv\\common_functions.php");
	
    $usr_usage_log="..\\log\\usrusagelog.csv";
    if (is_file($usr_usage_log) == TRUE)
        unlink($usr_usage_log);
    if (is_file($usr_usage_log) == FALSE) {
        touch ($usr_usage_log);
        $log_msg_heading="Name,IP/MAC,Login time,Logout time,Duration(min),Download Usage,Upload Usage,Total Usage,Login Site\r\n";
        $fileHandler = fopen ($usr_usage_log, 'w');
        fwrite ($fileHandler, $log_msg_heading);
        fclose ($fileHandler);
    }

    $buff = file_get_contents($usr_usage_log);
    $fileHandler = fopen ($usr_usage_log, 'w');

    if (!flock ($fileHandler, LOCK_EX )) // exclusive lock
        $message.='Fail to lock the log file. ';

    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
    $EaseGateuserlogtable=$settingobj->getKey('Datasource_Log_Tablename', 'gateway');

    //free COM object
    //$settingobj->Release();
    $settingobj=null;
    
    $query1= "SELECT name, logintime, logouttime, duration, ipormac, reserved10 as logints, reserved11 as logoutts, bwusage, bwusageul, bwusagesha, siteID
              FROM $EaseGateuserlogtable ORDER BY reserved11";

    $result=db_query($query1);

    $log_msg_content = '';

    while(odbc_fetch_row($result)) {
        $name=odbc_result($result,'name');
        $logintime=odbc_result($result,'logintime');
        $logouttime=odbc_result($result,'logouttime');
        $duration=odbc_result($result,'duration');
        $macIP=odbc_result($result,'ipormac');
        $bwusage=odbc_result($result,'bwusage');
        $bwusageul=odbc_result($result,'bwusageul');
		$bwusagesha=odbc_result($result,'bwusagesha');
		$siteID=odbc_result($result,'siteID');

        // consider whether the long value of the result
        // is equal or larger than (2 to power 33)-1 
        if($macIP>=8589934890) {
            $macIP_str=make_mac_name($macIP);
        } else {
            $macIP_str=long2ip($macIP);

            // since the bytes of this ip is inverted, we need to reformat it
            $tok = strtok($macIP_str,'.');
            $i=0;
            $ip[$i++]=$tok;

            while($tok){
                $tok = strtok('.');
                $ip[$i++]=$tok;
            }

            if( $macIP_str == '255.255.255.255' || !(isset($ip[3])&&$ip[3]!=''&&$ip[3]!='0') )
                $macIP_str=make_mac_name($macIP);
            else
                $macIP_str="$ip[3].$ip[2].$ip[1].$ip[0]";
        }

        if(isset($duration)&&$duration)
            $duration=round($duration);

        $log_msg_content.="$name,$macIP_str,$logintime,$logouttime,$duration,";

        if($bwusage=='')
            $log_msg_content.='N/A,';
        else
            $log_msg_content.=round($bwusage).'KB,';        
		/* // spun: spun 20070312 - only display KB as the unit
		 else if($bwusage<1024)
			$log_msg_content.=$bwusage.'KB,';        
		else if($bwusage<1048576) {
            $bwusageMB = round($bwusage/1024,2);
            $log_msg_content.=$bwusageMB.'MB,';
        } else {
            $bwusageGB = round($bwusage/1024/1024,2);
            $log_msg_content.=$bwusageGB.'GB,';
        }
		*/

        // for upload
        if($bwusageul=='')
            $log_msg_content.="N/A,";
        else 
            $log_msg_content.=round($bwusageul)."KB,'";
		/* // spun: spun 20070312 - only display KB as the unit
	  else if($bwusageul<1024)
            $log_msg_content.=$bwusageul."KB\r\n";
        else if($bwusageul<1048576) {
            $bwusageulMB = round($bwusageul/1024,2);
            $log_msg_content.=$bwusageulMB."MB\r\n";
        } else {
            $bwusageulGB = round($bwusageul/1024/1024,2);
            $log_msg_content.=$bwusageulGB."GB\r\n";
        } */
		//for total
		if($bwusagesha=='')
            $log_msg_content.="N/A,";
        else 
            $log_msg_content.=round($bwusagesha)."KB,";
            
        // for login site
        //* last field (\r\n), if not then (,)
        if ($siteID=="")
        	$log_msg_content.="N/A\r\n";
        else
        	$log_msg_content.=$siteID."\r\n";
	}

    fwrite ($fileHandler, $buff.$log_msg_content);
    flock ($fileHandler, LOCK_UN ); // release the lock
    fclose ($fileHandler);

	if(isset($ClearLog)&&($ClearLog==true)){          
	$query2 = "DELETE FROM $EaseGateuserlogtable ;" ;   //clear userlog table
	$result=db_query($query2);
	}
	
    $cat='u';
    $message='All user\'s usage log have been exported.';
    $saved='true';
    $errorlog='';
}

else if (isset($save_p)&&($save_p=='true')) 
{
    include_once("..\\authserv\\common_functions.php");
    $cat='p';
    if(isset($planname)) {
        $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
        $dsn_file=$settingobj->getKey('Datasource', 'gateway');
        $dsn_source=fopen($dsn_file, 'r') or die('Cannot open DSN source file!');     
        $dsn='';

        if (!feof($dsn_source)) 
            $line=fgets($dsn_source,512);

        while (!feof($dsn_source)) {
            $line=fgets($dsn_source,512);
            if (trim($line)!='') $dsn=$dsn.$line;
        }

        $dsn=str_replace("\r\n",';',$dsn);
        $planDB=odbc_connect($dsn,'','');

        if ($planDB) {
            // obtain low, medium or high BT value from config.ini
            $outval = $settingobj->getKey('bt_low', 'bw_throttle');
            if($outval!='') $low=$outval;

            $outval = $settingobj->getKey('bt_medium', 'bw_throttle');
            if($outval!='') $medium=$outval;
            $outval = $settingobj->getKey('bt_high', 'bw_throttle');
            if($outval!='') $high=$outval;

            $bt_ul_limit=null;
            $bt_dl_limit=null;

            if(!isset($plan_bt_mode))
                $plan_bt_mode=4;   // default is "use Global Setting"
            switch($plan_bt_mode)
            {
            case 0:
                $bt_ul_limit=0;
                $bt_dl_limit=0;
                break;
            case 1:
                $bt_ul_limit=$low;
                $bt_dl_limit=$low;
                break;
            case 2:
                $bt_ul_limit=$medium;
                $bt_dl_limit=$medium;
                break;
            case 3:
                $bt_ul_limit=$high;
                $bt_dl_limit=$high;
                break;
            case 4:
                $bt_ul_limit=null;
                $bt_dl_limit=null;
                break;
            case 5:  // treat as 0 (no throttling) if it is blank
                if (!isset($plan_bt_num) || $plan_bt_num=='')
                    $plan_bt_num=0;
                if (!isset($plan_bt_num_dl) || $plan_bt_num_dl=='')
                    $plan_bt_num_dl=0;
                $bt_ul_limit=$plan_bt_num;
                $bt_dl_limit=$plan_bt_num_dl;
                break;
            }

            $active_acc=0;
            $startDate=null;
            if(isset($bt_act_acc)) {
                switch($bt_act_acc)
                {
                case 0:
                    $active_acc=0;
                    break;  
                case 1:
                    $active_acc=1;      
                    break;
                case 2:
                    $active_acc=2;
                    if (isset($act_date))
                        $startDate=datetime_from_php($act_date, $act_time);
                    break;
                }
            }

            $status=0;
            if(isset($bt_plan_status))
            {
                switch($bt_plan_status)
                {
                case 0:
                    $status=0;
                    break;  
                case 1:
                    $status=1;
                    break;
                }
            }

            $timeleft=null;
            $logins=null;
            $endDate=null;
            $mins=null;

            if(!isset($cb_exp_acc0)) { //not never
                if(isset($cb_exp_acc1))  //timeleft
                {
                    $timeleft=$exp_timeleft;
                }
                if(isset($cb_exp_acc2)) //login
                {
                    $logins=$exp_login;
                }
                if(isset($cb_exp_acc3))  //date
                {
                    $endDate=datetime_from_php($exp_date, $exp_time);
                }
                if(isset($cb_exp_acc4)) {
                    if(strcmp($select_exp_timeleft,'min')==0)
                        $mins=$exp_days;
                    else if (strcmp($select_exp_timeleft,'hour')==0)
                        $mins=$exp_days*60;
                    else
                        $mins=$exp_days*60*24;
                }
            }

            $bwcount=null;
            $bwquota=null;
            $accumbw=null;
            if(isset($plan_bwcount)) {
                switch($plan_bwcount)
                {
                case -1:
                    $bwcount=null;
                    break;
                case 0:
                    $bwcount=0;
                    break;
                case 1:
					$bwcount=1;
                    $accumbw=0;
                    break;
                case 2:
                    $bwcount=2;
                    $bwquota=$plan_bwquota1;
                    $accumbw=0;
                    break;
                }
            }

            $bwcountUL=null;
            $bwquotaUL=null;
            $accumbwUL=null;
            if(isset($plan_bwcountUL)) {
                switch($plan_bwcountUL)
                {
                case -1:
                    $bwcountUL=null;
                    break;
                case 0:
                    $bwcountUL=0;
                    break;
                case 1:
                    $bwcountUL=1;
                    $accumbwUL=0;
                    break;
                case 2:
                    $bwcountUL=2;
                    $bwquotaUL=$plan_bwquota1UL;
                    $accumbwUL=0;
                    break;
                }
            }
			
			$bwcountSHA=null;
            $bwquotaSHA=null;
            $accumbwSHA=null;
            if(isset($plan_bwcountSHA)) {
                switch($plan_bwcountSHA)
                {
                case 0:
                    $bwcountSHA=0;
                    break;
                case 1:
                    $bwcountSHA=1;
                    $accumbwSHA=0;
                    break;
                case 2:
                    $bwcountSHA=2;
                    $bwquotaSHA=$plan_bwquota1SHA;
                    $accumbwSHA=0;
                    break;
                }
            }
			
            //plan recur_option
            if(isset($plans_recur_option) && $plans_recur_option == 1)
            {
                $week_sch = 0;
                if (isset($plans_cb_mon))
                    $week_sch += $plans_cb_mon;
                if (isset($plans_cb_tue))
                    $week_sch += $plans_cb_tue;
                if (isset($plans_cb_wed))
                    $week_sch += $plans_cb_wed;
                if (isset($plans_cb_thr))
                    $week_sch += $plans_cb_thr;
                if (isset($plans_cb_fri))
                    $week_sch += $plans_cb_fri;
                if (isset($plans_cb_sat))
                    $week_sch += $plans_cb_sat;
                if (isset($plans_cb_sun))
                    $week_sch += $plans_cb_sun;
                
                $plans_recur_sdate="";
                $plans_recur_edate="";
                if (isset($plans_recur_stime) && strlen($plans_recur_stime) > 0) {
                    $plans_recur_sdate = $plans_recur_stime;
                }

                if (isset($plans_recur_etime) && strlen($plans_recur_etime) > 0) {
                    $plans_recur_edate = $plans_recur_etime;
                }
            }
            //plan recur_option end

            $EaseGateplantable=$settingobj->getKey('Datasource_Plans_Tablename', 'gateway');
            $query="SELECT * FROM $EaseGateplantable WHERE pname='".$planname."';";
            $result=odbc_exec($planDB,$query);

            if (odbc_fetch_row($result)&&($addplan=='true')) {
                $message='Warning: The plan name chosen has been held. Please choose another one.';
                $saved='true';
                $errorlog='';
            } else {
                if(!isset($plan_usr_abw_rm))
                    $plan_usr_abw_rm = 3;

                switch($plan_usr_abw_rm)
                {
                case 0:
                    $plan_bwrmethod = 'disable';
                    $plan_bwrperiod = 'NULL';
                    $plan_bwrdate = 'NULL';
                    break;
                case 1:
                    if(!is_numeric($plan_usr_abw_rdate)||$plan_usr_abw_rdate<1||$plan_usr_abw_rdate>31)
                        $plan_usr_abw_rdate = 1;
                    if(!isset($plan_usr_abw_rp_1)||$plan_usr_abw_rp_1<1)
                        $plan_usr_abw_rp_1 = 1;

                    $plan_bwrmethod = 'month';
                    $plan_bwrdate = $plan_usr_abw_rdate;
                    $plan_bwrperiod = $plan_usr_abw_rp_1;
                    break;
                case 2:
                    if(!is_numeric($plan_usr_abw_rp_2)||$plan_usr_abw_rp_2<1)
                        $plan_usr_abw_rp_2 = 1;

                    $plan_bwrmethod = 'day';
                    $plan_bwrperiod = $plan_usr_abw_rp_2;
                    $todayTime = time(NULL);
                    $todayDate = getdate($todayTime);
                    $plan_bwrdate = $todayDate['mday'];
                    break;
                case 3:
                default:
                    $plan_bwrmethod = 'NULL';
                    $plan_bwrperiod = 'NULL';
                    $plan_bwrdate = 'NULL';
                    break;
                }

                $msg = '';
                if ($addplan=='true') {
                    $sql = "insert into " . $EaseGateplantable; 
                    $sql .= " (pname, startmod, sdate, timeleft, logins, btul, btdl, eminutes, bwquota, edate, bwcount, status,
                        auto_del, bwrmethod, bwrperiod, bwrdate, bwcountUL, bwquotaUL, pagenum, acl, reqsignup, roption, rsdate, redate, weeksch, bwcountSHA, bwquotaSHA) VALUES ("; 
                    $sql .= "'" . $planname . "', ";
                    if(isset($active_acc))
                        $sql .= "". $active_acc . ", ";
                    else $sql .= "NULL, ";
                    if (strlen($startDate) > 0)
                        $sql .= "'" . $startDate . "', "; 
                    else
                        $sql .= "NULL, ";
                    if (strlen($timeleft) > 0)
                        $sql .= "" . $timeleft . ", "; 
                    else
                        $sql .= "NULL, ";
                    if (strlen($logins) > 0)
                        $sql .= "" . $logins . ", "; 
                    else
                        $sql .= "NULL, ";
                    if (strlen($bt_ul_limit) > 0)
                        $sql .= "" . $bt_ul_limit . ", "; 
                    else
                        $sql .= "NULL, ";
                    if (strlen($bt_dl_limit) > 0)
                        $sql .= "" . $bt_dl_limit . ", "; 
                    else
                        $sql .= "NULL, ";
                    if (strlen($mins) > 0)
                        $sql .= "" . $mins . ", "; 
                    else
                        $sql .= "NULL, ";
                    if (strlen($bwquota) > 0)
                        $sql .= "" . $bwquota . ", "; 
                    else
                        $sql .= "NULL, ";
                    if (strlen($endDate) > 0)
                        $sql .= "'" . $endDate . "', "; 
                    else
                        $sql .= "NULL, ";
					if (strlen($bwcount) > 0)
                        $sql .= "" . $bwcount . ", "; 
                    else
                        $sql .= "NULL, ";

                    if (strlen($status) > 0) 
                        $sql .= "" . $status . ", ";
                    else
                        $sql .= "NULL, ";
                    $sql .= "NULL, ";
                    if(strlen($plan_bwrmethod)>0&&$plan_bwrmethod!="NULL")
                        $sql.="'".$plan_bwrmethod."', ";
                    else
                        $sql.="NULL, ";
                    $sql.=$plan_bwrperiod.", ".$plan_bwrdate.", ";

                    if (strlen($bwcountUL) > 0)
                        $sql .= $bwcountUL.", ";
                    else
                        $sql .= "NULL, ";

                    if (strlen($bwquotaUL) > 0)
                        $sql .= "$bwquotaUL,";
                    else
                        $sql .= 'NULL,';

                    //print quota
                    if (isset($plan_printQuota)) {
                        if ($plan_printQuota)
                            $sql .= round($plan_printQuota).',';
                        else
                            $sql .= "NULL,";
                    } else {
                        $sql .= "NULL,";
                    }
                    //access control list
                    if (isset($plan_acl) && $plan_acl=='y') {
                        $sql .= "'Y',";
                    } else {
                        $sql .= 'NULL,';
                    }
                    //request signup
                    if (isset($plan_signup) && $plan_signup=='y') {
                        $sql .= "'Y'";
                    } else {
                        $sql .= 'NULL';
                    }					
                    
                    if(isset($plans_recur_option) && $plans_recur_option == 1)
                        $sql .= ", $plans_recur_option, '$plans_recur_sdate', '$plans_recur_edate', $week_sch";
                    else
                        $sql .= ", 0, NULL, NULL, 0";

					if (strlen($bwcountSHA) > 0)
                        $sql .= $bwcountSHA.", ";
                    else
                        $sql .= "NULL, ";

                    if (strlen($bwquotaSHA) > 0)
                        $sql .= "$bwquotaSHA,";
                    else
                        $sql .= 'NULL';	
						
                    $sql .= ");";
					
                } else if ($editplan=="true") {
                    $sql = "update " . $EaseGateplantable . " set ";
                    if(isset($active_acc))
                        $sql .= "startmod=" . $active_acc . ", ";
                    else
                        $sql .= "startmod=NULL, ";

                    if (strlen($startDate) > 0)
                        $sql .= "sdate='" . $startDate . "', ";
                    else
                        $sql .= "sdate=NULL, ";

                    if (strlen($timeleft) > 0)
                        $sql .= "timeleft=" . $timeleft . ", ";
                    else
                        $sql .= "timeleft=NULL, ";

                    if (strlen($logins) > 0)
                        $sql .= "logins=" . $logins . ", ";
                    else
                        $sql .= "logins=NULL, ";

                    if (strlen($bt_ul_limit) > 0)
                        $sql .= "btul=" . $bt_ul_limit . ", ";
                    else
                        $sql .= "btul=NULL, ";

                    if (strlen($bt_dl_limit) > 0)
                        $sql .= "btdl=" . $bt_dl_limit . ", ";
                    else
                        $sql .= "btdl=NULL, ";

                    if (strlen($mins) > 0)
                        $sql .= "eminutes=" . $mins . ", ";
                    else
                        $sql .= "eminutes=NULL, ";

                    if (strlen($endDate) > 0)
                        $sql .= "edate='" . $endDate . "', ";
                    else
                        $sql .= "edate=NULL, ";
                    if (strlen($bwcount) > 0)
                        $sql .= "bwcount=" . $bwcount . ", ";
                    else
                        $sql .= "bwcount=NULL, ";
                    if (strlen($bwquota) > 0)
                        $sql .= "bwquota=" . $bwquota . ", ";
                    else
                        $sql .= "bwquota=NULL, ";

                    if (strlen($bwcountUL) > 0)
                        $sql .= "bwcountUL=" . $bwcountUL . ", ";
                    else
                        $sql .= "bwcountUL=NULL, ";

                    if (strlen($bwquotaUL) > 0)
                        $sql .= "bwquotaUL=" . $bwquotaUL . ", ";
                    else
                        $sql .= "bwquotaUL=NULL, ";
                    if (strlen($status) > 0)
                        $sql .= "status=" . $status . ", ";
                    else
                        $sql .= "status=NULL, ";

                    if(strlen($plan_bwrmethod)>0&&$plan_bwrmethod!="NULL")
                        $sql.="bwrmethod='".$plan_bwrmethod."', ";
                    else
                        $sql.="bwrmethod=NULL, ";

                    $sql.="bwrperiod=".$plan_bwrperiod.", bwrdate=".$plan_bwrdate.",";
                    //print quota
                    if (isset($plan_printQuota)) {
                        if ($plan_printQuota)
                            $plan_printQuota = round($plan_printQuota);
                        else
                            $plan_printQuota = 'NULL';
                        $sql .= "pagenum = $plan_printQuota,";
                    } else {
                        $sql .= 'pagenum = NULL,';
                    }
                    //access control list
                    if (isset($plan_acl) && $plan_acl=='y') {
                        $sql .= "acl = 'Y',";
                    } else {
                        $sql .= 'acl = NULL,';
                    }
                    //request signup
                    if (isset($plan_signup) && $plan_signup=='y') {
                        $sql .= "reqsignup = 'Y'";
                    } else {
                        $sql .= 'reqsignup = NULL';
                    }

                    if(isset($plans_recur_option) && $plans_recur_option == 1) {
                        $sql .= ", roption = $plans_recur_option";
                        $sql .= ", rsdate = '$plans_recur_sdate'";
                        $sql .= ", redate = '$plans_recur_edate'";
                        $sql .= ", weeksch = $week_sch";
                    } else {
                        $sql .= ", roption = 0";
                        $sql .= ", rsdate = NULL";
                        $sql .= ", redate = NULL";
                        $sql .= ", weeksch = 0";
                    }
					
					if (strlen($bwcountSHA) > 0)
                        $sql .= "bwcountSHA=" . $bwcountSHA . ", ";
                    else
                        $sql .= "bwcountSHA=NULL, ";

                    if (strlen($bwquotaSHA) > 0)
                        $sql .= "bwquotaSHA=" . $bwquotaSHA ;
                    else
                        $sql .= "bwquotaSHA=NULL ";

                    $sql .= " WHERE pname='".$planname."';";
                    $msg = " The current users under this plan will not be affected.";
                }
                $result=odbc_exec($planDB,$sql);
                odbc_close($planDB);
                $message='User plan information is successfully saved.'.$msg;
                $saved='true';
                $errorlog='';
            }
        }   //end planDB
        else {
            echo 'connection failed!';
        }
        //free COM object
        //$settingobj->Release();
        $settingobj=null;
    }   //end planname
}

else if(isset($listOfPlan))
{
    $cat='p';
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');

    // open dsn
    $dsn_file=$settingobj->getKey('Datasource', 'gateway');
    $dsn_source=fopen($dsn_file, 'r') or die('Cannot open DSN source file!');

    // prepare dsn string for ODBC connection
    $dsn='';

    if(!feof($dsn_source)) 
        $line=fgets($dsn_source,512);

    // read in each line
    while(!feof($dsn_source)) {
        $line=fgets($dsn_source,512);

        if(trim($line)!='') 
            $dsn=$dsn.$line;
    }

    // replace newline with semicolon
    $dsn=str_replace("\r\n",';',$dsn);

    // connect with ODBC
    $planDB=odbc_connect($dsn,'','');

    // connected
    if($planDB) {
        $EaseGateplantable=$settingobj->getKey('Datasource_Plans_Tablename', 'gateway');
				
        $maxitem   = $settingobj->getKey('max_slot_open', 'cart');
				
        $deletedRecord = 0; 
				
        $aPlanToDelete = explode('|', $listOfPlan);
        foreach ($aPlanToDelete as $value) { 
	        	$tieditem = false;
	        	for ($i = 0; $i < $maxitem; $i++){
		        	$tempPlanName = $settingobj->getKey('plan'.$i, 'cart');
		        	if ($tempPlanName == $value ){
		        			$tieditem = true;
		        			break;		        	
	        		}
	        	}
	        	if ($tieditem  ==  false){
	            $query="DELETE FROM $EaseGateplantable WHERE pname='".$value."';";
	            $result=odbc_exec($planDB,$query);
	            $deletedRecord++;
         	 }
        }

        // close the odbc connection
        odbc_close($planDB);
        
        $message = '';

        if ($deletedRecord != count($aPlanToDelete) ){
	        $message= count($aPlanToDelete) - $deletedRecord.' record(s) can not be deleted. <br>';
        }
                
	       if ($deletedRecord == 1)
	           $message.=$deletedRecord.' record is deleted.';
	       else if ($deletedRecord > 1)
	           $message.=$deletedRecord.' records are deleted.';
	       $saved='true';
	       $errorlog='';

    } else { 
        echo 'connection failed!';
    }
    //free COM object
    //$settingobj->Release();
    $settingobj=null;
}

//shopping cart
else if (isset($save_cart)&&($save_cart=='true'))
{
    $cat = 'cart';
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');

    $max_slot_open=$settingobj->getKey('max_slot_open', 'cart');
	
	$low = $settingobj->getKey( "bt_low", "bw_throttle");
	$medium = $settingobj->getKey( "bt_medium", "bw_throttle");
	$high = $settingobj->getKey( "bt_high", "bw_throttle");
	
    $addErrorMsg = '';
    $addError = false;

    if (isset($redirect_cart))
        $rsult = $settingobj->setKey($redirect_cart, 'redirect_cart', 'gateway');

    // 20070924 - Set bandwidth reset counter flag
    if (isset($reset_bw_count_upon_purchase)) {
	$rsult = $settingobj->setKey($reset_bw_count_upon_purchase, 'reset_bw_count_upon_purchase', 'cart');
    }

    // 20071231 - Set data transfer quota action flag
    if (isset($add_replace_bw_quota)) {
	$rsult = $settingobj->setKey($add_replace_bw_quota, 'add_replace_bw_quota', 'cart');
    }

    // 20071231 - Set user suspend behavior flag
    if (isset($overwrite_user_suspend)) {
	$rsult = $settingobj->setKey($overwrite_user_suspend, 'overwrite_user_suspend', 'cart');
    }

    if(isset($mode)&&($mode=='add')) {
        $emptyspace = false;
        $addError = false;

        for ($i = 0; $i < $max_slot_open; $i++) {
            $old_description = $settingobj->getKey("description$i", 'cart');
            if ($old_description == $description) {

		// 20070712 - Correct typo and change color
                $addErrorMsg = '<font color="#FF0000">Error: Duplicated Description Cannot Be Added. Add Cancelled.</font>';

                $addError = true;
            }
        }

		// 20070712 - Check if selected plan is valid
		if ($addError == false && isset($plan) && $useMethod == 2) {
			$planTable = $settingobj->getKey('Datasource_Plans_Tablename', 'gateway');
			$qStr = "SELECT * FROM ".$planTable." WHERE PNAME='".$plan."';";
			$qResult = db_query($qStr);
			$edate = odbc_result($qResult, 'EDATE');
			$eminutes = odbc_result($qResult, 'EMINUTES');
			if ((strlen($edate) > 0 || $edate != NULL) && (strlen($eminutes) > 0 || $eminutes != NULL)) {
			$addErrorMsg = '<font color="#FF0000">Error: '.$plan.' has more than one of the below fields set under "Conditions to suspend this account". Such plan is not allowed to be used in Shopping Cart.<br>- At a specific date and time<br>- After X minutes<br>Save aborted. Please modify the settings of the plan and try again.</font>';
			$addError = true;
			}
		}

        if ($addError == false && isset($description)) {
            $rsult = $settingobj->setKey($max_slot_open + 1, 'max_slot_open', 'cart');

            $i = $max_slot_open;
            $rsult = $settingobj->setKey($description, "description$i", 'cart');

            if (isset($price))
                $rsult = $settingobj->setKey($price, "price$i", 'cart');
				
			$rsult = $settingobj->setKey($useMethod, "useMethod$i", 'cart');
				
			if ($useMethod == 2){ // using plan
				if (isset($plan)) {
					if (strcmp($plan, '_plan_0') == 0)
						$rsult = $settingobj->setKey('', "plan$i", 'cart');
					else
						$rsult = $settingobj->setKey($plan, "plan$i", 'cart');
				}else
					$rsult = $settingobj->setKey('', "plan$i", 'cart');
					
			}
			else if ($useMethod == 1){ // using item attribute
				$rsult = $settingobj->setKey('', "plan$i", 'cart');
			}
			
			// ignore recurring when using topup monthly pass as item attributes
			if (isset($recurring_enable) && !($useMethod == 1) && !isset($attr_enable_8)) {
				$rsult = $settingobj->setKey($recurring_enable, "recurring_enable$i", 'cart');
				if (isset($interval))
					$rsult = $settingobj->setKey($interval, "interval$i", 'cart');
				if (isset($interval_unit))
					$rsult = $settingobj->setKey($interval_unit, "interval_unit$i", 'cart');

				if ((isset($recurring_method)) && ($recurring_method == 'infinite')){
					$rsult = $settingobj->setKey($recurring_method, "recurring_method$i", 'cart');
					$rsult = $settingobj->setKey('', "fixed_number$i", 'cart');
				} else {
					$rsult = $settingobj->setKey($recurring_method, "recurring_method$i", 'cart');
					if (isset($fixed_number))
						$rsult = $settingobj->setKey($fixed_number, "fixed_number$i", 'cart');
				}
			}
			else {
				$rsult = $settingobj->setKey('0', "recurring_enable$i", 'cart');
				$rsult = $settingobj->setKey('', "interval$i", 'cart');
				$rsult = $settingobj->setKey('', "interval_unit$i", 'cart');
				$rsult = $settingobj->setKey('', "recurring_method$i", 'cart');
				$rsult = $settingobj->setKey('', "fixed_number$i", 'cart');
			}
			
			// interpret attribute
			
			$timeleft="";
			$endDate="";
			$mins="";
			$bt_ul_limit="";
            $bt_dl_limit="";			
			$bwquotaUL="";
			$bwquotaDL="";
			$bwquotaSHA="";
			$topup="";
			
			if ($useMethod == 1){ // use item attributes
				if (isset($attr_enable_1)){ // timeleft
					$timeleft = $attr_timeleft;
				}
				
				if (isset($attr_enable_2)){ // edate
					$endDate=datetime_from_php($attr_exp_date, $attr_exp_time);
				}
				
				if (isset($attr_enable_3)){ // After
					if(strcmp($select_after_type,'min')==0)
						$mins=$attr_after_value;
					else if (strcmp($select_after_type,'hour')==0)
						$mins=$attr_after_value*60;
					else
						$mins=$attr_after_value*60*24;
				}
				
				if(isset($attr_enable_4)){ // bandwidth throttling
					switch($select_bt_type)
					{
					case "none":
						$bt_ul_limit=0;
						$bt_dl_limit=0;
						break;
					case "low":
						$bt_ul_limit=$low;
						$bt_dl_limit=$low;
						break;
					case "medium":
						$bt_ul_limit=$medium;
						$bt_dl_limit=$medium;
						break;
					case "high":
						$bt_ul_limit=$high;
						$bt_dl_limit=$high;
						break;
					case "global":
						$bt_ul_limit=-1;
						$bt_dl_limit=-1;
						break;
					case "specify":
						if (!isset($attr_bt_num) || $attr_bt_num=='')
							$attr_bt_num=0;
						if (!isset($attr_bt_num_dl) || $attr_bt_num_dl=='')
							$attr_bt_num_dl=0;
						$bt_ul_limit=$attr_bt_num;
						$bt_dl_limit=$attr_bt_num_dl;
						break;
					}
				}
				
				if (isset($attr_enable_5)){ // upload quota
					$bwquotaUL = $attr_bwquota;
				}
				
				if (isset($attr_enable_6)){ // download quota
					$bwquotaDL = $attr_bwquota_dl;
				}
				
				if (isset($attr_enable_7)){ // total quota
					$bwquotaSHA = $attr_bwquota_sha;
					// ignore upload and download quota
					$bwquotaUL="";
					$bwquotaDL="";
				}
				
				if (isset($attr_enable_8)){ // top up monthly pass
					$topup = $attr_monthly_pass;
					// ignore edate(expiry date) and eminutes (After)
					$endDate ="";
					$mins ="";
				}
			}
			
			// write attribute in ini
			$rsult = $settingobj->setKey($timeleft, "item_attr_timeleft$i", 'cart');
			$rsult = $settingobj->setKey($endDate, "item_attr_edate$i", 'cart');
			$rsult = $settingobj->setKey($mins, "item_attr_eminutes$i", 'cart');
			$rsult = $settingobj->setKey($bt_ul_limit, "item_attr_btul$i", 'cart');
			$rsult = $settingobj->setKey($bt_dl_limit, "item_attr_btdl$i", 'cart');
			$rsult = $settingobj->setKey($bwquotaUL, "item_attr_bwquotaUL$i", 'cart');
			$rsult = $settingobj->setKey($bwquotaDL, "item_attr_bwquota$i", 'cart');
			$rsult = $settingobj->setKey($bwquotaSHA, "item_attr_bwquotaSha$i", 'cart');
			$rsult = $settingobj->setKey($topup, "item_attr_topup$i", 'cart');

            if(isset($segment)) {
                $available_segments = '';
                for ($z = 0; $z < count($segment); ++$z) {
                    $available_segments .= $segment[$z] . ' ';
                }
                $rsult = $settingobj->setKey($available_segments, "segments$i", 'cart');
            } else
                $rsult = $settingobj->setKey('', "segments$i", 'cart');
        }
    }

    if (isset($mode)&&($mode=='edit')) {
        if (isset($existing_description)) {
            // get the description only
            $current_description =  explode(',', $existing_description);

	    // 20070712 - Check if selected plan is valid
	    if ($addError == false && isset($plan) && $useMethod == 2) {
			$planTable = $settingobj->getKey('Datasource_Plans_Tablename', 'gateway');
			$qStr = "SELECT * FROM ".$planTable." WHERE PNAME='".$plan."';";
			$qResult = db_query($qStr);
			$edate = odbc_result($qResult, 'EDATE');
			$eminutes = odbc_result($qResult, 'EMINUTES');
			if ((strlen($edate) > 0 || $edate != NULL) && (strlen($eminutes) > 0 || $eminutes != NULL)) {
				$addErrorMsg = '<font color="#FF0000">Error: '.$plan.' has more than one of the below fields set under "Conditions to suspend this account". Such plan is not allowed to be used in Shopping Cart.<br>- At a specific date and time<br>- After X minutes<br>Save aborted. Please modify the settings of the plan and try again.</font>';
				$addError = true;
			}
	    }
		
	    if ($addError == false) {

		$i = 0;
		for ($i = 0; $i < $max_slot_open; $i++) {
		    $old_description=$settingobj->getKey("description$i", 'cart');
		    if (strcmp($old_description, $current_description[0]) != 0)
			continue;

		    if (isset($description))
			$rsult = $settingobj->setKey($description, "description$i", 'cart');
		    if (isset($price))
			$rsult = $settingobj->setKey($price, "price$i", 'cart');
			
			$rsult = $settingobj->setKey($useMethod, "useMethod$i", 'cart');
			
			if ($useMethod == 2){ // using plan
				if (isset($plan)) {
				if (strcmp($plan, '_plan_0') == 0)
					$rsult = $settingobj->setKey('', "plan$i", 'cart');
				else
					$rsult = $settingobj->setKey($plan, "plan$i", 'cart');
				}else
				$rsult = $settingobj->setKey('', "plan$i", 'cart');
			}
			else if ($useMethod == 1){ // using item attribute
				$rsult = $settingobj->setKey('', "plan$i", 'cart');
			}
			
			// ignore recurring when using topup monthly pass as item attributes
			if (isset($recurring_enable) && !($useMethod == 1 && isset($attr_enable_8))) {
				$rsult = $settingobj->setKey($recurring_enable, "recurring_enable$i", 'cart');
				if (isset($interval))
					$rsult = $settingobj->setKey($interval, "interval$i", 'cart');
				if (isset($interval_unit))
					$rsult = $settingobj->setKey($interval_unit, "interval_unit$i", 'cart');

				if ((isset($recurring_method)) && ($recurring_method == 'infinite')){
					$rsult = $settingobj->setKey($recurring_method, "recurring_method$i", 'cart');
					$rsult = $settingobj->setKey('', "fixed_number$i", 'cart');
				} else {
					$rsult = $settingobj->setKey($recurring_method, "recurring_method$i", 'cart');
					if (isset($fixed_number))
						$rsult = $settingobj->setKey($fixed_number, "fixed_number$i", 'cart');
				}
			}
			else {
				$rsult = $settingobj->setKey('0', "recurring_enable$i", 'cart');
				$rsult = $settingobj->setKey('', "interval$i", 'cart');
				$rsult = $settingobj->setKey('', "interval_unit$i", 'cart');
				$rsult = $settingobj->setKey('', "recurring_method$i", 'cart');
				$rsult = $settingobj->setKey('', "fixed_number$i", 'cart');
			}
			
			// interpret attribute
			
			$timeleft="";
			$endDate="";
			$mins="";
			$bt_ul_limit="";
            $bt_dl_limit="";			
			$bwquotaUL="";
			$bwquotaDL="";
			$bwquotaSHA="";
			$topup="";
			
			if ($useMethod == 1){ // use item attributes
				if (isset($attr_enable_1)){ // timeleft
					$timeleft = $attr_timeleft;
				}
				
				if (isset($attr_enable_2)){ // edate
					$endDate=datetime_from_php($attr_exp_date, $attr_exp_time);
				}
				
				if (isset($attr_enable_3)){ // After
					if(strcmp($select_after_type,'min')==0)
						$mins=$attr_after_value;
					else if (strcmp($select_after_type,'hour')==0)
						$mins=$attr_after_value*60;
					else
						$mins=$attr_after_value*60*24;
				}
				
				if(isset($attr_enable_4)){ // bandwidth throttling
					switch($select_bt_type)
					{
					case "none":
						$bt_ul_limit=0;
						$bt_dl_limit=0;
						break;
					case "low":
						$bt_ul_limit=$low;
						$bt_dl_limit=$low;
						break;
					case "medium":
						$bt_ul_limit=$medium;
						$bt_dl_limit=$medium;
						break;
					case "high":
						$bt_ul_limit=$high;
						$bt_dl_limit=$high;
						break;
					case "global":
						$bt_ul_limit=-1;
						$bt_dl_limit=-1;
						break;
					case "specify":
						if (!isset($attr_bt_num) || $attr_bt_num=='')
							$attr_bt_num=0;
						if (!isset($attr_bt_num_dl) || $attr_bt_num_dl=='')
							$attr_bt_num_dl=0;
						$bt_ul_limit=$attr_bt_num;
						$bt_dl_limit=$attr_bt_num_dl;
						break;
					}
				}
				
				if (isset($attr_enable_5)){ // upload quota
					$bwquotaUL = $attr_bwquota;
				}
				
				if (isset($attr_enable_6)){ // download quota
					$bwquotaDL = $attr_bwquota_dl;
				}
				
				if (isset($attr_enable_7)){ // total quota
					$bwquotaSHA = $attr_bwquota_sha;
					// ignore upload and download quota
					$bwquotaUL="";
					$bwquotaDL="";
				}
				
				if (isset($attr_enable_8)){ // top up monthly pass
					$topup = $attr_monthly_pass;
					// ignore edate(expiry date) and eminutes (After)
					$endDate ="";
					$mins ="";
				}
			}
			
			// write attribute in ini
			$rsult = $settingobj->setKey($timeleft, "item_attr_timeleft$i", 'cart');
			$rsult = $settingobj->setKey($endDate, "item_attr_edate$i", 'cart');
			$rsult = $settingobj->setKey($mins, "item_attr_eminutes$i", 'cart');
			$rsult = $settingobj->setKey($bt_ul_limit, "item_attr_btul$i", 'cart');
			$rsult = $settingobj->setKey($bt_dl_limit, "item_attr_btdl$i", 'cart');
			$rsult = $settingobj->setKey($bwquotaUL, "item_attr_bwquotaUL$i", 'cart');
			$rsult = $settingobj->setKey($bwquotaDL, "item_attr_bwquota$i", 'cart');
			$rsult = $settingobj->setKey($bwquotaSHA, "item_attr_bwquotaSha$i", 'cart');
			$rsult = $settingobj->setKey($topup, "item_attr_topup$i", 'cart');
			
		    if(isset($segment)) {
				$available_segments = '';
				for ($z = 0; $z < count($segment); ++$z) {
					$available_segments .= $segment[$z] . ' ';
				}
				$rsult = $settingobj->setKey($available_segments, "segments$i", 'cart');
		    }
		    break;
		}
            }
        }
    }

    if (isset($mode)&&($mode=='del')) {
            $itemRecord = explode('*', $itemList);

            // since there is an extra '*' and make the itemRecord+1, the for loop need count($itemRecord)-1 
            for($z=0; $z < (count($itemRecord)-1); $z++) {
                // $itemPieces[0] : name (description)
                // $itemPieces[1] : price
                // $itemPieces[2] : plan
                // $itemPieces[3] : recurring_enable
                // $itemPieces[4] : interval
                // $itemPieces[5] : interval_unit
                // $itemPieces[6] : $recurring_method
                // $itemPieces[7] : $fixed_number
                // $itemPieces[8] : $avaliable_segment
				// $itemPieces[9] : $useMethod
				// $itemPieces[10] : $attr_timeleft
				// $itemPieces[11] : $attr_expire_date
				// $itemPieces[12] : $attr_expire_time
				// $itemPieces[13] : $attr_eminutes
				// $itemPieces[14] : $attr_cmb_time
				// $itemPieces[15] : $attr_bt_mode
				// $itemPieces[16] : $attr_btul
				// $itemPieces[17] : $attr_btdl
				// $itemPieces[18] : $attr_bwquota
				// $itemPieces[19] : $attr_bwquota_dl
				// $itemPieces[20] : $attr_bwquota_sha
				// $itemPieces[21] : $attr_monthly_pass
				
                $itemPieces = explode(',', $itemRecord[$z]);

                $description = $itemPieces[0];
                $price = $itemPieces[1];
                $recurring_enable = $itemPieces[3];
                $interval = $itemPieces[4];
                $interval_unit = $itemPieces[5];
                $recurring_method = $itemPieces[6];
                $fixed_number = $itemPieces[7];

                $i = 0;

                for ($i = 0; $i < $max_slot_open; $i++) {
					// find that item from ini

                    $old_description=$settingobj->getKey("description$i", 'cart');
                    if ($old_description != $description)
                        continue;

                    $old_price=$settingobj->getKey("price$i", 'cart');
                    if ($old_price != $price)
                        continue;

                    $old_recurring_enable=$settingobj->getKey("recurring_enable$i", 'cart');
                    if ($old_recurring_enable != $recurring_enable)
                        continue;

                    $old_interval=$settingobj->getKey("interval$i", 'cart');
                    if ($old_interval!= $interval)
                        continue;

                    if ($recurring_enable == '1') {

                        $old_interval_unit=$settingobj->getKey("interval_unit$i", 'cart');

                        if ($old_interval_unit!= $interval_unit)
                            continue;

                        $old_recurring_method=$settingobj->getKey("recurring_method$i", 'cart');
                        if ($old_recurring_method != $recurring_method)
                            continue;
                    }

                    $old_fixed_number=$settingobj->getKey("fixed_number$i", 'cart');
                    if ($old_fixed_number!= $fixed_number)
                        continue;
						
					// set to empty string
                    $rsult = $settingobj->setKey('', "description$i", 'cart');
                    $rsult = $settingobj->setKey('', "price$i", 'cart');
                    $rsult = $settingobj->setKey('', "plan$i", 'cart');
                    $rsult = $settingobj->setKey('', "recurring_enable$i", 'cart');
                    $rsult = $settingobj->setKey('', "interval$i", 'cart');
                    $rsult = $settingobj->setKey('', "interval_unit$i", 'cart');
                    $rsult = $settingobj->setKey('', "recurring_method$i", 'cart');
                    $rsult = $settingobj->setKey('', "fixed_number$i", 'cart');
                    $rsult = $settingobj->setKey('', "segments$i", 'cart');
					$rsult = $settingobj->setKey('', "useMethod$i", 'cart');
					$rsult = $settingobj->setKey('', "item_attr_timeleft$i", 'cart');
					$rsult = $settingobj->setKey('', "item_attr_btul$i", 'cart');
					$rsult = $settingobj->setKey('', "item_attr_btdl$i", 'cart');
					$rsult = $settingobj->setKey('', "item_attr_bwquota$i", 'cart');
					$rsult = $settingobj->setKey('', "item_attr_bwquotaUL$i", 'cart');
					$rsult = $settingobj->setKey('', "item_attr_bwquotaSha$i", 'cart');
					$rsult = $settingobj->setKey('', "item_attr_edate$i", 'cart');
					$rsult = $settingobj->setKey('', "item_attr_eminutes$i", 'cart');
					$rsult = $settingobj->setKey('', "item_attr_topup$i", 'cart');
                } // end for

            } // end outter for
    }

    //free COM object
    //$settingobj->Release();
    $settingobj=null;

    if ($addError == true) {
        $message=$addErrorMsg;
        $saved='true';
        $errorlog='';
    } else {
        $message='Shopping Cart setting is successfully saved.';
        $saved='true';
        $errorlog='';
    }
}

else if(isset($save_key) && $save_key=='true') // instant key
{
    $cat = 'key';
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
	
	if(isset($port))
        $rsult=$settingobj->setKey($port, 'iKey_port', 'gateway');

    // [sphl] 20070216 moved to save_key
    if(isset($dns_suffix))
        $rsult = $settingobj->setKey($dns_suffix, 'dns_suffix', 'gateway');
    
    if(isset($keyword_logout))
        $rsult = $settingobj->setKey($keyword_logout, 'this_logout', 'lang');

    if(isset($keyword_info))
        $rsult = $settingobj->setKey($keyword_info, 'this_info', 'lang');

    if(isset($keyword_cart))
        $rsult = $settingobj->setKey($keyword_cart, 'this_cart', 'lang');

    $addErrorMsg = '';
    $addError = false;

    if(isset($mode)&&($mode=='add')) {
        if(isset($keyword) && isset($url) && isset($last_key_num)) {
            for ($i=0 ;; $i++) {
                $saved_key[$i]=$settingobj->getKey("key_$i", 'lang');
                $saved_url[$i]=$settingobj->getKey("url_$i", 'lang');
                if($saved_key[$i]=='' || $saved_url[$i]=='')
                    break;
                else {
                    if($saved_url[$i]==$url || $saved_key[$i] == $keyword) {
                        $addErrorMsg = 'Duplicated with keyword '.$saved_key[$i].'. Instant Keyword is not saved!';
                        $addError = true;
                        break;
                    }
                }
            }
            if($addError == false) {
                $rsult = $settingobj->setKey($keyword, "key_$last_key_num", 'lang');
                $rsult = $settingobj->setKey($url, "url_$last_key_num", 'lang');
            }
        }
    }

    if (isset($mode)&&($mode=='edit')) {
        if(isset($keyword) && isset($url)) {
            for ($i=0 ;; $i++) {
                if(isset($key_index) && $i!=$key_index) { //skip to compare the rditing key itself
                    $saved_key[$i]=$settingobj->getKey("key_$i", 'lang');
                    $saved_url[$i]=$settingobj->getKey("url_$i", 'lang');
                    if($saved_key[$i]=='' || $saved_url[$i]=='')
                        break;
                    else {
                        if($saved_url[$i]==$url || $saved_key[$i] == $keyword) {
                            $addErrorMsg = 'Duplicated with keyword ' . $saved_key[$i] . '. Instant Keyword is not saved!';
                            $addError = true;
                            break;
                        }
                    }
                }   
            }
            if($addError == false  && isset($key_index) && $key_index>=0) {
                $rsult = $settingobj->setKey($keyword, "key_$key_index", 'lang');
                $rsult = $settingobj->setKey($url, "url_$key_index", 'lang');
            }
        }
    }

    if (isset($mode)&&($mode=='del')) {
        if(isset($last_key_num) && isset($key_index) && $key_index>=0) {
            $tokValue = 0;

            $tok = strtok($selected_item_list, ',');
            $y=0;

            while ($tok != '') { 

                for($x=0;$x<$last_key_num;$x++) 
                {
                    $key=$settingobj->getKey("key_$x", 'lang');

                    if($key == $tok)
                    {
                        for($y=$x;$y<$last_key_num;$y++) 
                        {
                            $tmp = $y+1;
                            $tmpkey=$settingobj->getKey("key_$tmp", 'lang');
                            $tmpurl=$settingobj->getKey("url_$tmp", 'lang');

                            $rsult = $settingobj->setKey($tmpkey, "key_$y", 'lang');
                            $rsult = $settingobj->setKey($tmpurl, "url_$y", 'lang');
                        }
                    }
                }
                $tok = strtok(',');
            }
        }   
    }
    //free COM object
    //$settingobj->Release();
    $settingobj=null;

    $message='Instant keyword setting is successfully saved. All changes will take effect when you start EaseGate next time.' .$addErrorMsg;
    $saved='true';
    $errorlog='';
}

else if (isset($save_bcreate)&&($save_bcreate == 'true')) 
{
    $cat = 'bcreate';
    include_once("..\\authserv\\common_functions.php");

    $success_count = 0;
    $rounds = 0;
    $extra_msg = '';

    $bIsBulk = true; //create bulk accounts?
    $bIsPassRandom = true; //gen random password?
    $bIsPassSerial = false; //gen serial password? only for bulk mode
    $bIsPassFixed = false; //manually specifed password? not available in bulk mode

    $export_file = 'bulkuser.csv';

    $single_name = 'mary'; //for single user creation
    $fixed_pass = 'password'; //for single user creation, fixed password

    // init posted parms
    if (!isset($prefix))
        $prefix = '';
    if (!isset($middle_digits_start) || ($middle_digits_start == ''))
        $middle_digits_start=1;
    if (!isset($middle_digits_end) || ($middle_digits_end == ''))
        $middle_digits_end=1;
    if (!isset($suffix) || ($suffix == ''))
        $suffix = '';
    if (!isset($plan) || ($plan == ''))
        $plan = '';
    if (!isset($password_length) || !is_numeric($password_length))
        $password_length = 10;
	
	if ( isset($slip_enable) &&  ($slip_enable=="on" ) )
		$slip_enable = true;
	else 	
		$slip_enable = false;
		
	if (!isset($users_per_page) || ($users_per_page == ''))
		$users_per_page = 5;		
		
	$settingobj = new COM("EGCONFIG.Cfgmgr") or die("editUser.php EGCONFIG.Cfgmgr Object cannot be created!");
	if ($slip_enable){	
		// slip format options	- from editUser.php /$printOption
		$settingobj->setKey(1, 'enable_slip_preview', 'bulk');
		$settingobj->setKey($users_per_page, 'slip_per_page', 'bulk');
		$settingobj->setKey($slip_format_option, 'slip_format_option', 'users');
		$slip_format = array();
		if ($slip_format_option == 1){ // 
			$settingobj->setKey($slip_title, 'past_slip_title', 'users');
			$settingobj->setKey($slip_title_size, 'past_slip_title_size', 'users');
			$settingobj->setKey($slip_end, 'past_slip_end', 'users');
			$settingobj->setKey($slip_end_size, 'past_slip_end_size', 'users');
			$slip_format['pTitle'] 		= $slip_title;
			$slip_format['pEnd'] 		= $slip_end;
			$slip_format['pTitleSize'] 	= 2*$slip_title_size;
			$slip_format['pEndSize'] 	= 2*$slip_end_size;
		}else{ // using default options
			$slip_format['pTitle'] 		= $settingobj->getKey('default_slip_title', 'users');
	        $slip_format['pTitleSize']	= 2*($settingobj->getKey('default_slip_title_size', 'users'));
	        $slip_format['pEnd'] = $settingobj->getKey('default_slip_end', 'users');
	        $slip_format['pEndSize']  = 2*($settingobj->getKey('default_slip_end_size', 'users'));
		}		
	} else {
		$settingobj->setKey(0, 'enable_slip_preview', 'bulk');
	}
	
	// 20081029 - Obtain login mode status
	$scratch_login = (strtolower($settingobj->getKey('scratch_login', 'gateway') == 'on'))? 'true' : 'false';
	
	$pwdSalt = $settingobj->getKey( "pwd_salt", "prepaidCard");
	$userSalt = $settingobj->getKey( "random_usr_suffix_salt", "prepaidCard");
	
	$settingobj=null;
    // end init

    // main
    $count = 1;
    $digits = $middle_digits_start;
    $output = '';
    $rounds = $middle_digits_end - $middle_digits_start + 1;
    if ($bIsBulk == false) { // for single user creation
        $rounds = 1;  //go only 1 round
        $prefix = $single_name; //make sure prefix is assigned with single_name
    }
    $base = floor(log($middle_digits_end)/log(10))+1 ;
    $dup_name = '';
	
	// 20070221 spun - begin printing user info in a slip 	
	$slip_users = array(); 		
	// 20070221 spun - end printing user info in a slip 	
	
    while ($count <= $rounds ) {
        if ($bIsPassFixed)
            $password = $fixed_pass;
        elseif ($bIsPassRandom){
			if ($scratch_login == 'true')
				$password = fs_create_random_str("", $userSalt, $password_length);
			else
				$password = fs_create_random_str("", $pwdSalt, $password_length);
		}
        elseif ($bIsPassSerial)
            $password = substr($digits+pow(10,$base),1);
		
	// 20081029 - Fill in username depend on login mode
	if ($scratch_login == 'true') {
	    $username = $password;
	} elseif ($bIsBulk == true) {
            $username = $prefix.substr($digits+pow(10,$base),1).$suffix; //substr(x+1000,1) will have effect to add leading zeros
	} else { //single user
            $username = $prefix;
	}
		$slip_user = array();		
        $result = fs_create_bulk_user($username, $password, $password, $plan, $slip_user);
        $digits = $digits + 1;
        if ($result == 0) { //successful - prepare username + password pair to screen				
			// 20070221 begin spun - printing user info in a slip 		
			if ($slip_enable){			
				$slip_users[$success_count] = $slip_user;
				$slip_users[$success_count]['username'] = $username;
				$slip_users[$success_count]['password'] = $password;			
			}
			// 20070221end spun - printing user info in a slip 			
			
            $success_count += 1;
            $output .= $username.','.$password."\r\n";
        } else
            $dup_name .= $username.'<br>';
			
		// 20070221 begin spun - printing user info in a slip 	
		unset($slip_user);
		
        $count = $count + 1;
    }

    if ($rounds != $success_count)
        $extra_msg = ' <br><font color="blue"><br><b>the difference is due to attempts in creating record(s) with the following <br>alreay-existed username(s):</b><br>'.$dup_name.'</font>';
    else
        $extra_msg = '';

    $backup = 0;
    while(is_writeable("..\\".$export_file)==true) { //file name exists
        $filename = substr($export_file, 0, strlen($export_file)-4);
        $extension = substr($export_file, strlen($export_file)-4, strlen($export_file)-1);

        $number = $backup;
        while (strlen($number) != 4)
            $number = '0' .$number;
        $backup_file = $filename . $number .$extension;
        while(is_writeable("..\\".$backup_file)==true) {
            $backup++;
            $number = $backup;
            while (strlen($number) != 4)
                $number = '0' .$number;
            $backup_file = $filename . $number . $extension;
        }
        rename("..\\".$export_file, "..\\".$backup_file);
    }

    //only write to file if there's at least one account created
    if ($success_count > 0) {
        if (is_file($export_file) == FALSE)
            touch ("..\\".$export_file);
        $fileHandler = fopen ("..\\".$export_file, 'w');
        fwrite ($fileHandler, $output);
        fclose ($fileHandler);
    }

    // end main
    $msg = "Number of accounts requested: $rounds<br>";
    $msg .= "Number of accounts created: $success_count<br>";
    $msg .= "$extra_msg<br>";
    $message = "$msg Bulk create account Action Completed.";
    $saved = 'true';
    $errorlog = '';
	
	if ( $slip_enable)	
			include_once("slip.php");// 20070221 end spun - printing user info in a slip 	
}
// printing
else if (isset($save_print)&&($save_print=='true'))
{
    $cat = 'print';

    // get post data
    $print_support = (isset($_POST['print_support']))? $_POST['print_support'] : '0';
    $siteURL = (isset($_POST['siteURL']))? $_POST['siteURL'] : '';
    $security_mode = (isset($_POST['security_mode']))? $_POST['security_mode'] : 'cleartext';
    $siteUID = (isset($_POST['siteUID']))? $_POST['siteUID'] : '';
    $siteAuth = (isset($_POST['siteAuth']))? $_POST['siteAuth'] : '';
    $show_URL_login = (isset($_POST['show_login']))? $_POST['show_login']: '0';
    $show_URL_infobox = (isset($_POST['show_info']))? $_POST['show_info']: '0';

    // process data
    if ($print_support == '0') {
        $siteURL = '';
        $security_mode = 'cleartext';
    }
    if ($security_mode == 'cleartext') {
        $siteUID = '';
        $siteAuth = '';
    }
    
    // save the data
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');

    $rsult = $settingobj->setKey($print_support, 'PrintSupport', 'PrinterOn');
    $rsult = $settingobj->setKey($siteURL, 'SiteURL', 'PrinterOn');
    $rsult = $settingobj->setKey($siteUID, 'SiteUID', 'PrinterOn');
    $rsult = $settingobj->setKey($siteAuth, 'SiteAuth', 'PrinterOn');
    $rsult = $settingobj->setKey($show_URL_login, 'show_URL_login', 'PrinterOn');
    $rsult = $settingobj->setKey($show_URL_infobox, 'show_URL_infobox', 'PrinterOn');

    //free COM object
    //$settingobj->Release();
    $settingobj=null;

    $message = 'Print support settings are saved.';
    $saved = 'true';
    $errorlog = '';
}
// export print log
else if (isset($export_print_log) && ($export_print_log=='true'))
{
    include_once '../authserv/common_functions.php';

    $message = '';
    $print_log_file = '../log/print_log.csv';

    // removed the orginal log file first
    if (is_file($print_log_file)) {
        unlink($print_log_file);
    }

    touch($print_log_file);
    $log_msg_heading = "Logtime,RefId,Username,Status,Page,Format,DestId,InitId\r\n";
    $fileHandler = fopen($print_log_file, 'w');
    fwrite($fileHandler, $log_msg_heading);
    fclose($fileHandler);

    $buff = file_get_contents($print_log_file);
    $fileHandler = fopen ($print_log_file, 'w');

    if (!flock ($fileHandler, LOCK_EX )) // exclusive lock
        $message .= 'Fail to lock the log file.';

    $q = 'SELECT * from '.fs_printlog_table();

    $result = db_query($q);

    $log_msg_content = '';

    while (odbc_fetch_row($result)) {
        $logtime = odbc_result($result,'logtime');
        $refid = odbc_result($result,'refid');
        $username = odbc_result($result,'username');
        $status =odbc_result($result,'stat');
        $page = round(odbc_result($result,'page'));
        $format = odbc_result($result,'format');
        $destid = odbc_result($result,'destid');
        $initid = odbc_result($result,'intid');

        $log_msg_content .= "$logtime,$refid,$username,$status,$page,$format,$destid,$initid\r\n";
    }

    fwrite ($fileHandler, $buff.$log_msg_content);
    flock ($fileHandler, LOCK_UN ); // release the lock
    fclose ($fileHandler);

    $cat = 'print';
    $message .= '<br>All print log have been exported.';
    $saved = 'true';
    $errorlog = '';
}

else if (isset($exportImportDB)&&($exportImportDB=='true')) 
{
    $cat='u';
    include_once("..\\authserv\\common_functions.php");

    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
    $Datasource_Tablename=$settingobj->getKey('Datasource_Tablename', 'gateway');
    $Datasource_Plans_Tablename=$settingobj->getKey('Datasource_Plans_Tablename', 'gateway');
    $Datasource_PayPal_Table=$settingobj->getKey('Datasource_PayPal_Table', 'gateway');
    //$Datasource_Url_Tablename=$settingobj->getKey('Datasource_URL_Log_Tablename', 'gateway');
    
    //free COM object
    //$settingobj->Release();
    $settingobj=null;

    if (isset($table) && $table == 'user')
        $exportImportFile='userdata.csv';
    if (isset($table) && $table == 'plan')
        $exportImportFile='plandata.csv';
    if (isset($table) && $table == 'cc')
        $exportImportFile='ccdata.csv';
    /*if (isset($table) && $table == 'url')
        $exportImportFile='urldata.csv';*/

    if (isset($export)) {
        if (isset($table) && $table == 'user')
            $Datasource = $Datasource_Tablename;
        if (isset($table) && $table == 'plan')
            $Datasource = $Datasource_Plans_Tablename;
        if (isset($table) && $table == 'cc')
            $Datasource = $Datasource_PayPal_Table;
        /*if (isset($table) && $table == 'url')
            $Datasource = $Datasource_Url_Tablename;*/

        $msg = exportDB($exportImportFile, $table, $Datasource);
    } else if (isset($import)) {
        if (isset($table) && $table == 'user')
            $Datasource = $Datasource_Tablename;
        if (isset($table) && $table == 'plan')
            $Datasource = $Datasource_Plans_Tablename;
        if (isset($table) && $table == 'cc')
            $Datasource = $Datasource_PayPal_Table;
        /*if (isset($table) && $table == 'url')
            $Datasource = $Datasource_Url_Tablename;*/

        $msg = importDB($exportImportFile, $table, $Datasource);
				
				if (isset($table) && $table == 'user'){
	        // Check have any mac passive login user
	        $q = "SELECT count(*) as num FROM ".fs_usr_table()." WHERE MACasUsr='Y' and pwd is null";
  				$result = db_query($q);
  				$num = odbc_result($result, "num");
	        if ($num >0){
		        // Run QueryPassiveLogin after import user table and have mac passive login user
					  $settingobj = new COM('EGCONFIG.Cfgmgr') or die;
						$cmd = realpath("..\\");
						$cmd .= "\\dispatcher\\QueryPassiveLogin.exe";
						$settingobj->runCommand($cmd);
						//$settingobj->Release();
						$settingobj=null;
					}
				}
				
    } else if (isset($exportall)) {
        $table = 'user';
        $exportImportFile='userdata.csv';
        $Datasource = $Datasource_Tablename;
        $msg = exportDB($exportImportFile, $table, $Datasource);
        $table = 'plan';
        $exportImportFile='plandata.csv';
        $Datasource = $Datasource_Plans_Tablename;
        $msg .= '<br>'.exportDB($exportImportFile, $table, $Datasource);
        $table = 'cc';
        $exportImportFile='ccdata.csv';
        $Datasource = $Datasource_PayPal_Table;
        $msg .= '<br>'. exportDB($exportImportFile, $table, $Datasource);
        /*$table = 'url';
        $exportImportFile='urldata.csv';
        $Datasource = $Datasource_Url_Tablename;
        $msg = '<br>'. exportDB($exportImportFile, $table, $Datasource);*/
    } else if (isset($importall)) {
        $table = 'user';
        $exportImportFile='userdata.csv';
        $Datasource = $Datasource_Tablename;
        $msg = importDB($exportImportFile, $table, $Datasource);
        $table = 'plan';
        $exportImportFile='plandata.csv';
        $Datasource = $Datasource_Plans_Tablename;
        $msg .= '<br>'.importDB($exportImportFile, $table, $Datasource);
        $table = 'cc';
        $exportImportFile='ccdata.csv';
        $Datasource = $Datasource_PayPal_Table;
        $msg .= '<br>'. importDB($exportImportFile, $table, $Datasource);
        /*$table = 'url';
        $exportImportFile='urldata.csv';
        $Datasource = $Datasource_Url_Tablename;
        $msg = '<br>'. importDB($exportImportFile, $table, $Datasource);*/
				
				// Check have any mac passive login user	        
        $q = "SELECT count(*) as num FROM ".fs_usr_table()." WHERE MACasUsr='Y' and pwd is null";
  			$result = db_query($q);
  			$num = odbc_result($result, "num");
        if ($num >0){
	        // Run QueryPassiveLogin after import user table and have mac passive login user
				  $settingobj = new COM('EGCONFIG.Cfgmgr') or die;
					$cmd = realpath("..\\");
					$cmd .= "\\dispatcher\\QueryPassiveLogin.exe";
					$settingobj->runCommand($cmd);
					//$settingobj->Release();
					$settingobj=null;
				}

    }

    $message=$msg;
    $saved='true';
    $errorlog='';
}

else if(isset($status_forcelogout)) // disconnect
{

	$myfsapi = new fsAPI();
	$result_fields = array();
	$result_fields = $myfsapi->disconnectUser($ForcelogoutString);
	
    $cat = 'sstatus';
    $message = $result_fields['usr_forced_logout_count'].' user(s) are forced to logout';
    $saved = 'true';
    $errorlog= '';
}

else if (isset($save_acl) && $save_acl == 'true') {
    include_once('display_list.php');
    include_once('cmvar.php');
    $cat = 'acl';

    if (isset($ser_display_acl)&&($ser_display_acl!==''))
        $display_acl=unserialize($ser_display_acl);
    if (isset($ser_add_acl)&&($ser_add_acl!==''))
        $add_acl=unserialize($ser_add_acl);

    $str=''; $j=0; $n=0; $m=0;
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
    $i=0;
    while ($i<$display_acl->num_sites && $n < 500) { //maximum number of ACL entries is 500
        //# and checked=true must both meet, or we ignore to delete it
        if ($display_acl->site_list[$i]->span{0}!='#'){
            $rsult = $settingobj->setKey($display_acl->site_list[$i]->span, "acl_addr$n", 'ACL');
            $n++;
        }
        $i++;
    }
    $j=$n;
    $i=0;
    while ($i<$add_acl->num_sites && ($m+$j) < 500) { //maximum number of ACL entries is 500
        $string2=$add_acl->site_list[$i]->span;
        if($add_acl->site_list[$i]->span{0}!='#') {
            $rsult = $settingobj->setKey($add_acl->site_list[$i]->span, 'acl_addr'.($m+$j), 'ACL');
            $m++;
        }
        $i++;
    }

    $num_acl=$m+$j;

    if(isset($num_acl)) {
        $rsult = $settingobj->setKey( $num_acl, 'num_acl', 'ACL');
    }

    //free COM object
    //$settingobj->Release();
    $settingobj=null;

    // unset all variables
    $ser_display_acl=NULL;
    $ser_add_acl=NULL;

    //Port filtering
    if (isset($ser_display_portflt)&&($ser_display_portflt!==''))
        $display_portflt = unserialize($ser_display_portflt);
    if (isset($ser_add_portflt)&&($ser_add_portflt!==''))
        $add_portflt = unserialize($ser_add_portflt);

    $str=''; $j=0; $n=0; $m=0;
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
    $i=0;
    while ($i < $display_portflt->num_sites) {
        if($display_portflt->site_list[$i]->span{0}!='#'){
            $rsult = $settingobj->setKey($display_portflt->site_list[$i]->span, "flt_$n", 'Port Filter');
            $n++;
        }
        $i++;
    }

    $j=$n;
    $i=0;
    while ($i < $add_portflt->num_sites) {
        if($add_portflt->site_list[$i]->checked=='false' || $add_portflt->site_list[$i]->span{0}!='#') {
            if ($add_portflt->site_list[$i]->span{0}=='#') {
                $add_portflt->site_list[$i]->span = substr($add_portflt->site_list[$i]->span, 1, strlen($add_portflt->site_list[$i]->span));
            }
            $rsult = $settingobj->setKey($add_portflt->site_list[$i]->span, 'flt_'.($m+$j), 'Port Filter');
            $m++;
        }
        $i++;
    }

    $flt_num = $m+$j;
    $rsult = $settingobj->setKey($flt_num, 'flt_num', 'Port Filter');

    if (isset($portflt) && strcmp($portflt,'off')==0) {
        $num = $settingobj->getKey('flt_num', 'Port Filter');
        $rsult = $settingobj->setKey('0', 'flt_num', 'Port Filter');

        for ($i=0; $i < $num; $i++)
            $rsult = $settingobj->setKey('', "flt_$i", 'Port Filter');
    }

    //free COM object
    //$settingobj->Release();
    $settingobj=null;

    // unset all variables
    $ser_display_portflt=NULL;
    $ser_add_portflt=NULL;

    //****************************************************************************************************
    // URL tracking setting
    //****************************************************************************************************
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');

    if( isset($url_tracking) && $url_tracking == 0 )
        $settingobj->setKey('0', 'Trace_URL', 'gateway');
    else {
        $settingobj->setKey('1', 'Trace_URL', 'gateway');

	// 20090316 - Tracking type
	if (isset($url_tracking_type) && $url_tracking_type != '') {
	    $settingobj->setKey($url_tracking_type, 'trace_URL_type', 'URLTracking');
	    if ($url_tracking_type == 2) {
		if (isset($url_tracking_port) && $url_tracking_port != '') {
		    $settingobj->setKey($url_tracking_port, 'trace_URL_port', 'URLTracking');
		} else {
		    $settingobj->setKey('', 'trace_URL_port', 'URLTracking');
		}
	    }
	} else {
	    $settingobj->setKey('1', 'trace_URL_type', 'URLTracking');
	}

        if(isset($url_interval) && $url_interval != '')
            $settingobj->setKey($url_interval, 'Trace_URL_Interval', 'gateway');
        else
            $settingobj->setKey('0', 'Trace_URL_Interval', 'gateway');
    }
    $settingobj=null;

    //****************************************************************************************************
    // End - URL tracking setting
    //****************************************************************************************************

    $message = get_cm_var('setcfg_acl_update_message');
    if ($num_acl==500) { //give warning that maximum number of ACL entries is 500
        $message .= ' '.get_cm_var('js_alert_acl_max');
    }
    $saved='true';
    $errorlog='';
}
// Failover
else if(isset($save_fo) && $save_fo=='true') 
{
    //Failover settings
    $cat='fo';
    
     $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
     
     if(!isset($fo_mode))
     	$fo_mode=0;
    	
	if ($fo_mode == 1 || $fo_mode == 2 || $fo_mode == 3){
    	if ($fo_mode == 1){
		    if( $BackUpFSIP1>0 && $BackUpFSIP1<255 && $BackUpFSIP2>0 && $BackUpFSIP2<255 && $BackUpFSIP3>0 && $BackUpFSIP3<255 && $BackUpFSIP4>0 && $BackUpFSIP4<255 ){
			    $settingobj->setKey( $BackUpFSIP1.'.'.$BackUpFSIP2.'.'.$BackUpFSIP3.'.'.$BackUpFSIP4, 'BackUp_IP', 'FSFO' );
		    }
		    if( $BackUpFSNIC1>0 && $BackUpFSNIC1<255 && $BackUpFSNIC2>0 && $BackUpFSNIC2<255 && $BackUpFSNIC3>0 && $BackUpFSNIC3<255 && $BackUpFSNIC4>0 && $BackUpFSNIC4<255 ){
			    $settingobj->setKey( $BackUpFSNIC1.'.'.$BackUpFSNIC2.'.'.$BackUpFSNIC3.'.'.$BackUpFSNIC4, 'BackUp_NIC', 'FSFO' );
		    }
    	}else if ($fo_mode == 2){
		    if( $MainFSIP1>0 && $MainFSIP1<255 && $MainFSIP2>0 && $MainFSIP2<255 && $MainFSIP3>0 && $MainFSIP3<255 && $MainFSIP4>0 && $MainFSIP4<255 ){
			    $settingobj->setKey( $MainFSIP1.'.'.$MainFSIP2.'.'.$MainFSIP3.'.'.$MainFSIP4, 'Main_IP', 'FSFO' );
		    }
		    if( $MainFSNIC1>0 && $MainFSNIC1<255 && $MainFSNIC2>0 && $MainFSNIC2<255 && $MainFSNIC3>0 && $MainFSNIC3<255 && $MainFSNIC4>0 && $MainFSNIC4<255 ){
			    $settingobj->setKey( $MainFSNIC1.'.'.$MainFSNIC2.'.'.$MainFSNIC3.'.'.$MainFSNIC4, 'Main_NIC', 'FSFO' );
		    }
		    if ($fo_BackupMode == 0 || $fo_BackupMode ==1 || $fo_BackupMode ==2 || $fo_BackupMode == 3){
			  	$settingobj->setKey( $fo_BackupMode, 'BackupMode', 'FSFO' );
		    }
    	}else if ($fo_mode == 3){
    		if( $OtherLBFSIP1>0 && $OtherLBFSIP1<255 && $OtherLBFSIP2>0 && $OtherLBFSIP2<255 && $OtherLBFSIP3>0 && $OtherLBFSIP3<255 && $OtherLBFSIP4>0 && $OtherLBFSIP4<255 ){
			    $settingobj->setKey( $OtherLBFSIP1.'.'.$OtherLBFSIP2.'.'.$OtherLBFSIP3.'.'.$OtherLBFSIP4, 'OtherLB_IP', 'FSFO' );
		    }
		    if( $OtherLBFSNIC1>0 && $OtherLBFSNIC1<255 && $OtherLBFSNIC2>0 && $OtherLBFSNIC2<255 && $OtherLBFSNIC3>0 && $OtherLBFSNIC3<255 && $OtherLBFSNIC4>0 && $OtherLBFSNIC4<255 ){
			    $settingobj->setKey( $OtherLBFSNIC1.'.'.$OtherLBFSNIC2.'.'.$OtherLBFSNIC3.'.'.$OtherLBFSNIC4, 'OtherLB_NIC', 'FSFO' );
		    }
			if(isset($machineID))
	            $rsult = $settingobj->setKey($machineID, 'MachineID','FSFO');
	        
            if(isset($Datasource_Msg_Tablename)){
			    $rsult = $settingobj->setKey($Datasource_Msg_Tablename, 'Datasource_msg_Tablename','gateway');
			}
			
			if(isset($clearMessage)&&($clearMessage==true)){
				if(!isset($Datasource_Msg_Tablename))
					$Datasource_Msg_Tablename=$settingobj->getKey('Datasource_msg_Tablename', 'gateway');
				$query2 = "DELETE FROM $Datasource_Msg_Tablename ;" ;   //clear message table
				$rsult=db_query($query2);
			}
    	}
    	
    	if( ($port>=1024 && $port<=9999) || $port=='' )
		    $settingobj->setKey( $port, 'Port', 'FSFO' );
	
	   if( $interval>0 ){
		    $interval = $interval * 1000;
		    $settingobj->setKey( $interval, 'interval', 'FSFO' );
	    }else if ($interval==''){
		    $settingobj->setKey( $interval, 'interval', 'FSFO' );
	   	}
	}
	
    $settingobj->setKey( $fo_mode, 'mode', 'FSFO' );
    $settingobj=null;
}
// In-browser Message
else if(isset($save_ibmsg) && $save_ibmsg=='true') 
{
    $cat='ibmsg';
	
	$maxWithWebLink=20;
    
     $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
	 
	 if (isset($ibmsgOnOff) && $ibmsgOnOff == 1){
		$settingobj->setKey( $ibmsgOnOff, 'iBMsg', 'IB' );
		
		if(isset($infobox_AlwaysOn)){
			$settingobj->setKey( "2", 'iBMsg_infobox_mode', 'IB' );
		}
		else
			$settingobj->setKey( "0", 'iBMsg_infobox_mode', 'IB' );
		
		if (isset($time_reminder)){
			if (isset($remindMin) && $remindMin!= ""){
				$settingobj->setKey( $remindMin, 'iBMsg_RemindMin', 'IB' );
			}
			else{
				// hard code
				$settingobj->setKey( "5", 'iBMsg_RemindMin', 'IB' );
			}
		}
		else{
			$settingobj->setKey( "0", 'iBMsg_RemindMin', 'IB' );
		}
		
		if(isset($cb_redirect)){
			$settingobj->setKey( "1", 'iB_cb_redirect', 'IB' );
			if (isset($interval) && $interval!= ""){
				$settingobj->setKey( $interval, 'iBMsg_interval', 'IB' );
			}
			else{
				// hard code
				$settingobj->setKey( "15", 'iBMsg_interval', 'IB' );
			}
			if (isset($cb_redirect_wait) && $cb_redirect_wait!= ""){
				$settingobj->setKey( $cb_redirect_wait, 'iB_redirect_wait', 'IB' );
			}
			else{
				// hard code
				$settingobj->setKey( "15", 'iB_redirect_wait', 'IB' );
			}
			
			if (isset($cb_redirect_showlink)){
				$settingobj->setKey( $cb_redirect_showlink, 'iB_redirect_showLink', 'IB' );
				if ($cb_redirect_showlink == 2){
					if (isset($cb_redirect_showlink_wait) && $cb_redirect_showlink_wait!= ""){
						$settingobj->setKey( $cb_redirect_showlink_wait, 'iB_redirect_showLink_wait', 'IB' );
					}
					else{
						// hard code
						$settingobj->setKey( "5", 'iB_redirect_showLink_wait', 'IB' );
					}
				}
			}
			else{
				$settingobj->setKey( "0", 'iB_redirect_showLink', 'IB' );
			}
		}
		else
			$settingobj->setKey( "0", 'iB_cb_redirect', 'IB' );
		
		if( ($port>=1024 && $port<=9999) || $port=='' )
		    $settingobj->setKey( $port, 'proxy_port', 'IB' );
			
		if( ($script_port>=1024 && $script_port<=9999) || $script_port=='' )
			$settingobj->setKey( $script_port, 'script_port', 'IB' );
				
		if (isset($banner_Mode)){
			$settingobj->setKey( "1", 'iB_banner_mode', 'IB' );
			
			if(isset($banner_type) && $banner_type=='IMAGE'){
				$settingobj->setKey( "1", 'iB_banner_type', 'IB' );
				
	if (isset($iB_banner_img)){
		$i=sizeof($iB_banner_img);
		$settingobj->setKey( $i, 'iB_banner_img_count', 'IB' );
		$y=0;
		while($y<$i){
			$name="iB_banner_img";
			$name.=$y;
			$settingobj->setKey( $iB_banner_img[$y], $name, 'IB' );
			$y++;
		}
	}
	
	for ($i =0; $i<$maxWithWebLink; $i++){
		eval ("\$result= isset(\$html".$i.");");
		if ($result){
			eval ("\$html_address[\$i]= \$html".$i.";");
		}else
			$html_address[$i]="";
	}
	
	$x=0;
	while($x<$maxWithWebLink){
		$html_fname="iB_banner_img_html";
		$html_fname.=$x;
		
		if(isset($html_address[$x])){
			$settingobj->setKey( $html_address[$x], $html_fname, 'IB' );
		}
		$x++;
	}
	
			}
			else if(isset($banner_type) && $banner_type=='FRAME'){
				$settingobj->setKey( "2", 'iB_banner_type', 'IB' );
				
				// frame
				// hard code
				if ($fr_size_Opt == 1){
					$settingobj->setKey( "728", 'iB_banner_frame_w', 'IB' );
					$settingobj->setKey( "90", 'iB_banner_frame_h', 'IB' );
				}
				else if($fr_size_Opt == 2){
					$settingobj->setKey( "936", 'iB_banner_frame_w', 'IB' );
					$settingobj->setKey( "120", 'iB_banner_frame_h', 'IB' );
				}
				else if($fr_size_Opt == 3){
					$settingobj->setKey( $fr_w, 'iB_banner_frame_w', 'IB' );
					$settingobj->setKey( $fr_h, 'iB_banner_frame_h', 'IB' );
				}
			}
		}
		else{
			$settingobj->setKey( "0", 'iB_banner_mode', 'IB' );
			// $settingobj->setKey( "0", 'iB_banner_frame_w', 'IB' );
			// $settingobj->setKey( "0", 'iB_banner_frame_h', 'IB' );
		}
		
	 }
	 else{
		$settingobj->setKey( "0", 'iBMsg', 'IB' );
	 }
	 
	$RestartMsg = 'All changes will take effect when you restart EaseGate .';
	$message="In-browser Message setting is successfully saved.$RestartMsg";
    $saved='true';
    $errorlog='';
	
    $settingobj=null;
}
else if(isset($updateToken))
{
	$myobj = new COM("EGCONFIG.Cfgmgr") or die("settingok.php EGCONFIG.Cfgmgr Object cannot be created!");
	$fs_path = $myobj->getFsPath();
	$cmd = "\"" . $fs_path . "dispatcher\\UpdateUAToken.exe\" ";
	//$result = $myobj->runCommand($cmd);
	$sys = new sysfunc();
    $result = $sys->runCommand($cmd);
    $sys = null;
	//$myObj->Release();
	$myobj = null;
	
	if(strstr(strtolower($result), "success"))
		$message= "UaToken.csv updated successfully!!";
	else
		$message= "Failed to update uaToken!!";
	$saved='true';
	$errorlog='';
	
	$cat="lang";
}

else if(isset($save_ipbundle) && $save_ipbundle=='true') // ip bundle
{
	$addErrorMsg = '';
    $addError = false;
	
	$subMsg = '';
	$addSubMsg = false;

    $cat = 'ipbundle';
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
	$ipbundle_tablename=$settingobj->getKey('Datasource_ipbundle_Tablename', 'gateway');
	$rule_ipbundle_tablename=$settingobj->getKey('Datasource_rule_ipbundle_Tablename', 'gateway');
	$bw_rule_tablename=$settingobj->getKey('Datasource_bw_rule_Tablename', 'gateway');
    
    if((isset($mode)&&($mode=='add')) || (isset($mode)&&($mode=='edit')) ) {
		if(isset($ipbundle_name)){
			$no = 0;
			if (isset($mode)&&($mode=='add')){
				$q = "SELECT count(*) as no FROM ".$ipbundle_tablename." WHERE bundleName = '".$ipbundle_name."' ;";
				$result = db_query($q);
				$no = odbc_result($result, 'no');
			}
			else if (isset($mode)&&($mode=='edit')){
				$q="DELETE FROM $ipbundle_tablename WHERE bundleName = '$ipbundle_name'; ";
				$result = db_query($q);
			}
			
			if($no > 0){
				// error entry already exist
				$addErrorMsg = "Error IP Bundle($ipbundle_name) already exist";
				$addError = true;
			}
			else{
				$count = 0;
				while(1){
					$from_name = "range_ip_from_".($count+1);
					$to_name = "range_ip_to_".($count+1);
					$range_remove_checkbox = "range_remove_".($count+1);
					if ((isset($_POST[$from_name]) && isset($_POST[$to_name])) || isset($_POST[$range_remove_checkbox])){
					
						if (!isset($_POST[$range_remove_checkbox]) && $_POST[$from_name] != '' && $_POST[$to_name] != ''){
					
							$field_name="bundleName, start_ip, end_ip";		
							$field_value = "'".$ipbundle_name."', '".ip2long($_POST[$from_name])."', '".ip2long($_POST[$to_name])."'";
							
							$q="INSERT INTO $ipbundle_tablename ($field_name) VALUES ($field_value); ";
							
							$result= db_query($q);
						}
					}
					else
						break;
						
					$count++;
				}
				
				$settingobj->UpdateIPBundleEntry($ipbundle_name);
			}
		}
	
    }

    if (isset($mode)&&($mode=='del')) {
        if(isset($last_ipbundle_num) && isset($ipbundle_index) && $ipbundle_index>=0) {

            $tok = strtok($selected_item_list, ',');

            while ($tok != '') {
				// checking 
				$q = "SELECT count(*) as no FROM ".$rule_ipbundle_tablename." WHERE bundleName = '".$tok."' ;";
				$result= db_query($q);
				$no = odbc_result($result, 'no');
				$inAccessRule = false;
				if ($no >0){
					$inAccessRule = true;
				}
				
				$no= 0;
				$q = "SELECT count(*) as no FROM ".$bw_rule_tablename." WHERE bundleName = '".$tok."' ;";
				$result= db_query($q);
				$no = odbc_result($result, 'no');
				$inBWRule = false;
				if ($no >0){
					$inBWRule = true;
				}
				
				if ($inAccessRule && $inBWRule){
					$subMsg .= "IP Bundle (".$tok.") - is used by Access Rules and Bandwidth Rules<br/>&nbsp;";
					$addSubMsg = true;
				}
				else if ($inAccessRule){
					$subMsg .= "IP Bundle (".$tok.") - is used by Access Rules<br/>&nbsp;";
					$addSubMsg = true;
				}
				else if ($inBWRule){
					$subMsg .= "IP Bundle (".$tok.") - is used by Bandwidth Rules<br/>&nbsp;";
					$addSubMsg = true;
				}
				else{
					// OK
					$q="DELETE FROM $ipbundle_tablename WHERE bundleName = '$tok'; ";
					$result= db_query($q);
					
					$settingobj->RemoveIPBundleEntry($tok);
				}
				
				$tok = strtok(',');
            }
        }   
    }
	
	$settingobj=null;
	
	if ($addSubMsg){
		$subMsg = "<br/>Below IP Bundles are not deleted. Please remove the corresponding ip bundle from Access Rules and Bandwidth Rules first.<br/>".$subMsg;
	}
	
	if ($addError == true)
        $message=$addErrorMsg;
    else
		$message='IP Bundle information is successfully saved.'.$subMsg;
    $saved='true';
    $errorlog='';
}

else if(isset($save_group) && $save_group=='true') // group
{
	$addErrorMsg = '';
    $addError = false;
	
	$subMsg = '';
	$addSubMsg = false;

    $cat = 'group';
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
	$group_tablename = $settingobj->getKey('Datasource_group_Tablename', 'gateway');
	$member_tablename = $settingobj->getKey('Datasource_member_Tablename', 'gateway');
	$rule_group_tablename = $settingobj->getKey('Datasource_rule_group_Tablename', 'gateway');
	
    if((isset($mode)&&($mode=='add')) || (isset($mode)&&($mode=='edit')) ) {
		if(isset($group_name)){
			$no = 0;
			
			$q = "SELECT count(*) as no FROM ".$group_tablename." WHERE groupName = '".$group_name."' ;";
			$result = db_query($q);
			$no = odbc_result($result, 'no');
			
			if ($no >0 && isset($mode)&&($mode=='add')){
				// error entry already exist during add
				$addErrorMsg = "Error Group($group_name) already exist";
				$addError = true;
			}
			else if ($no <= 0 && isset($mode)&&($mode=='edit')){
				// error entry do not exist during edit
				$addErrorMsg = "Error Group($group_name) does not exist";
				$addError = true;
			}
			
			if(!$addError){
			
				if (isset($mode)&&($mode=='add')){
					$field_name="groupName, descript";
					
					$description = "";
					if (isset($group_desc)){
						$description = $group_desc;
					}
					
					$field_value = "'".$group_name."', '".$description."'";
					
					$q="INSERT INTO $group_tablename ($field_name) VALUES ($field_value); ";
					
					$result= db_query($q);
				}
				else if (isset($mode)&&($mode=='edit')){
					$description = "";
					if (isset($group_desc)){
						$description = $group_desc;
					}
					
					$q="UPDATE $group_tablename SET descript = '$description' WHERE groupName = '$group_name'; ";
					$result= db_query($q);
					
					$q="DELETE FROM $member_tablename WHERE groupName = '$group_name'; ";
					$result = db_query($q);
					
				}
			
				$count = 0;
				while(1){
					$user_entry_name = "member_".($count+1);
					$member_remove_checkbox = "member_remove_".($count+1);
					if (isset($_POST[$user_entry_name]) || isset($_POST[$member_remove_checkbox])){
					
						if (!isset($_POST[$member_remove_checkbox]) && $_POST[$user_entry_name] != '' && $_POST[$user_entry_name] != 'Not Selected'){
					
							$field_name="groupName, userName";		
							$field_value = "'".$group_name."', '".$_POST[$user_entry_name]."'";
							
							$q="INSERT INTO $member_tablename ($field_name) VALUES ($field_value); ";
							
							$result= db_query($q);
						}
					}
					else
						break;
						
					$count++;
				}
				
				$settingobj->UpdateGroupEntry($group_name);
			}
		}
	
    }

    if (isset($mode)&&($mode=='del')) {
        if(isset($last_group_num) && isset($group_index) && $group_index>=0) {

            $tok = strtok($selected_item_list, ',');

            while ($tok != '') {
				// checking
				$q = "SELECT count(*) as no FROM ".$rule_group_tablename." WHERE groupName = '".$tok."' ;";
				$result= db_query($q);
				$no = odbc_result($result, 'no');
				$inAccessRule = false;
				if ($no >0){
					$inAccessRule = true;
				}
				
				if ($inAccessRule){
					$subMsg .= "Group (".$tok.") - is used by Access Rules<br/>&nbsp;";
					$addSubMsg = true;
				}
				else{
					// OK
					$q="DELETE FROM $group_tablename WHERE groupName = '$tok'; ";
					$result= db_query($q);
					
					$q="DELETE FROM $member_tablename WHERE groupName = '$tok'; ";
					$result= db_query($q);
					
					$settingobj->RemoveGroupEntry($tok);
				}
				
				$tok = strtok(',');
            }
        }   
    }
	
	$settingobj=null;
	
	if ($addSubMsg){
		$subMsg = "<br/>Below User Groups are not deleted. Please remove the corresponding group from Access Rules first.<br/>".$subMsg;
	}
	
	if ($addError == true)
        $message=$addErrorMsg;
    else
		$message='User Group information is successfully saved.'.$subMsg;
	
    $saved='true';
    $errorlog='';
}

else if(isset($status_terminateConn)) // terminate connection
{
	// special for EaseGate use
	function iplong($ip)
	{
		list($ip1,$ip2,$ip3,$ip4) = explode('.', $ip, 4);
		$ip = sprintf("%02x%02x%02x%02x", $ip4,$ip3,$ip2,$ip1);
		
		$ip_long = 0;
		$count = strlen($ip)-1;
		for($i=0; $i<=$count; $i++) {
			$ip_long += hexdec($ip[$count-$i]) * pow(16, $i);
		}
		
		return $ip_long;
	}


	$addErrorMsg = '';
	$addError = false;

	$settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
	
	// print_r($_POST);exit();
	
	if (isset($TerminateConnString)){
		$arrPairResult = explode(',', $TerminateConnString);
		
		foreach($arrPairResult as $arrtemp2){
			$arrResult = explode('|', $arrtemp2);
			
			$l_ip = iplong($arrResult[0]);
			$port = $arrResult[1];
			
			$settingobj->TermianteConnection($l_ip, $port);
		}
		
		// workaround for delay refresh
		Sleep(1);
		
	}
	
	$settingobj = null;
	
	$cat = 'conn';
    $message = 'Terminate connection is successfully';
    $saved = 'true';
    $errorlog= '';
}

else if(isset($save_wf) && $save_wf=='true') // web filter
{
	$addErrorMsg = '';
    $addError = false;
	
	$subMsg = '';
	$addSubMsg = false;

    $cat = 'wf';
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
	
	$web_filter_tablename = $settingobj->getKey('Datasource_web_filter_Tablename', 'gateway');
	$wfilter_content_tablename = $settingobj->getKey('Datasource_web_filter_content_Tablename', 'gateway');
	$access_rule_tablename = $settingobj->getKey('Datasource_access_rule_Tablename', 'gateway');
	
    if((isset($mode)&&($mode=='add')) || (isset($mode)&&($mode=='edit')) ) {
		if(isset($filter_name)){
			$no = 0;
			
			$q = "SELECT count(*) as no FROM ".$web_filter_tablename." WHERE filterName = '".$filter_name."' ;";
			$result = db_query($q);
			$no = odbc_result($result, 'no');
			
			if ($no >0 && isset($mode)&&($mode=='add')){
				// error entry already exist during add
				$addErrorMsg = "Error Filter($filter_name) already exist";
				$addError = true;
			}
			else if ($no <= 0 && isset($mode)&&($mode=='edit')){
				// error entry do not exist during edit
				$addErrorMsg = "Error Filter($filter_name) does not exist";
				$addError = true;
			}
			
			if(!$addError){
			
				if (isset($mode)&&($mode=='add')){
					$field_name="filterName, descript, filterType";
					
					$description = "";
					if (isset($filter_desc)){
						$description = $filter_desc;
					}
					
					$filterType = 0;
					if (isset($filter_action)){
						$filterType = $filter_action;
					}
					
					$field_value = "'".$filter_name."', '".$description."', ".$filterType;
					
					$q="INSERT INTO $web_filter_tablename ($field_name) VALUES ($field_value); ";
					
					$result= db_query($q);
				}
				else if (isset($mode)&&($mode=='edit')){
					$description = "";
					if (isset($filter_desc)){
						$description = $filter_desc;
					}
					
					$filterType = 0;
					if (isset($filter_action)){
						$filterType = $filter_action;
					}
					
					$q="UPDATE $web_filter_tablename SET descript = '$description', filterType = $filterType WHERE filterName = '$filter_name'; ";
					$result= db_query($q);
					
					$q="DELETE FROM $wfilter_content_tablename WHERE filterName = '$filter_name'; ";
					$result = db_query($q);
					
				}
			
				$count = 0;
				while(1){
					$url_content_type = "wf_url_content_type_".($count+1);
					$url_content_string = "wf_url_content_string_".($count+1);
					$url_remove_checkbox = "wf_url_remove_".($count+1);
					if ((isset($_POST[$url_content_type]) && isset($_POST[$url_content_string])) || isset($_POST[$url_remove_checkbox])){
					
						if (!isset($_POST[$url_remove_checkbox]) && $_POST[$url_content_type] != '' && $_POST[$url_content_type] != 'Not Selected'){
							if ($_POST[$url_content_string] != '' && strlen($_POST[$url_content_string]) > 0){
							
								//special option Filter URL [domain (including all the subdomains)]
								if ($_POST[$url_content_type] == 5){
									$tmp_content_type = 0;
									$tmp_content_string = "*.".$_POST[$url_content_string];
									
									// checking duplicate before insert
									$count2 = 0;
									$dupA = false;
									$dupB = false;
									while(1){
										$url_content_type2 = "wf_url_content_type_".($count2+1);
										$url_content_string2 = "wf_url_content_string_".($count2+1);
										$url_remove_checkbox2 = "wf_url_remove_".($count2+1);
										if (isset($_POST[$url_content_type2]) && isset($_POST[$url_content_string2])){
										
											if ($_POST[$url_content_type2] != '' && $_POST[$url_content_type2] != 'Not Selected' && !isset($_POST[$url_remove_checkbox2])){
												if ($_POST[$url_content_type2] == 0){
													if ($_POST[$url_content_string2] == $tmp_content_string){
														$dupA = true;
													}
													else if ($_POST[$url_content_string2] == $_POST[$url_content_string]){
														$dupB = true;
													}
												}
											}
										}
										else{
											break;
										}
										$count2++;
									}
									
									if ($dupA == false){
										$field_name="filterName, type, content";		
										$field_value = "'".$filter_name."', ".$tmp_content_type.",'".$tmp_content_string."'";
										
										$q="INSERT INTO $wfilter_content_tablename ($field_name) VALUES ($field_value); ";
										
										$result= db_query($q);
									}
									
									if ($dupB == false){
										$field_name="filterName, type, content";		
										$field_value = "'".$filter_name."', ".$tmp_content_type.",'".$_POST[$url_content_string]."'";
										
										$q="INSERT INTO $wfilter_content_tablename ($field_name) VALUES ($field_value); ";
										
										$result= db_query($q);
									}
								}
								//special option Filter URL [directory only]
								else if ($_POST[$url_content_type] == 1){
									if (strlen(strrchr($_POST[$url_content_string], '*')) == 1 && strlen(strrchr($_POST[$url_content_string], '/')) == 2){
										$tmp_content_string = $_POST[$url_content_string];
									}
									else if (strlen(strrchr($_POST[$url_content_string], '/')) == 1){
										$tmp_content_string = $_POST[$url_content_string]."*";
									}
									else{
										$tmp_content_string = $_POST[$url_content_string]."/*";
									}
									
									$field_name="filterName, type, content";		
									$field_value = "'".$filter_name."', ".$_POST[$url_content_type].",'".$tmp_content_string."'";
									
									$q="INSERT INTO $wfilter_content_tablename ($field_name) VALUES ($field_value); ";
									
									$result= db_query($q);
									
								}
								else{
									$field_name="filterName, type, content";		
									$field_value = "'".$filter_name."', ".$_POST[$url_content_type].",'".$_POST[$url_content_string]."'";
									
									$q="INSERT INTO $wfilter_content_tablename ($field_name) VALUES ($field_value); ";
									
									$result= db_query($q);
								}
							}
						}
					}
					else
						break;
						
					$count++;
				}
				
				$count = 0;
				while(1){
					$str_content_type = "wf_str_content_type_".($count+1);
					$str_content_string = "wf_str_content_string_".($count+1);
					$str_remove_checkbox = "wf_str_remove_".($count+1);
					if ((isset($_POST[$str_content_type]) && isset($_POST[$str_content_string])) || isset($_POST[$str_remove_checkbox])){
					
						if (!isset($_POST[$str_remove_checkbox]) && $_POST[$str_content_type] != '' && $_POST[$str_content_type] != 'Not Selected'){
							if ($_POST[$str_content_string] != '' && strlen($_POST[$str_content_string]) > 0){
					
								$field_name="filterName, type, content";		
								$field_value = "'".$filter_name."', ".$_POST[$str_content_type].",'".$_POST[$str_content_string]."'";
								
								$q="INSERT INTO $wfilter_content_tablename ($field_name) VALUES ($field_value); ";
								
								$result= db_query($q);
							}
						}
					}
					else
						break;
						
					$count++;
				}
				
				$settingobj->UpdateWebFilterEntry($filter_name);
			}
		}
	
    }

    if (isset($mode)&&($mode=='del')) {
        if(isset($last_webfilter_num) && isset($webfilter_index) && $webfilter_index>=0) {

            $tok = strtok($selected_item_list, ',');

            while ($tok != '') {
				// checking
				$q = "SELECT count(*) as no FROM ".$access_rule_tablename." WHERE webFltName = '".$tok."' ;";
				$result= db_query($q);
				$no = odbc_result($result, 'no');
				$inAccessRule = false;
				if ($no >0){
					$inAccessRule = true;
				}
				
				if ($inAccessRule){
					$subMsg .= "Filter (".$tok.") - is used by Access Rules<br/>&nbsp;";
					$addSubMsg = true;
				}
				else{
					// OK
					$q="DELETE FROM $web_filter_tablename WHERE filterName = '$tok'; ";
					$result= db_query($q);
					
					$q="DELETE FROM $wfilter_content_tablename WHERE filterName = '$tok'; ";
					$result= db_query($q);
					
					$settingobj->RemoveWebFilterEntry($tok);
				}
				
				$tok = strtok(',');
            }
        }   
    }
	
	$settingobj=null;
	
	if ($addSubMsg){
		$subMsg = "<br/>Below Web Filter are not deleted. Please remove the corresponding web filter from Access Rules first.<br/>".$subMsg;
	}
	
	if ($addError == true)
        $message=$addErrorMsg;
    else
		$message='Web Filter information is successfully saved.'.$subMsg;
	
    $saved='true';
    $errorlog='';
}


?>
<html>
<head></head>
<!-- redirect back to setcfg.php -->
<body onLoad="window.location.href='setcfg.php?category=<?= $cat ?>'">
</body>
</html>
